/**
 * 度数の検定
 * カイ二乗検定 １×Ｊ表
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeChisq1xjSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	expectedRatioEqual_Input();

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
};
// セルデータの全消去
function clearAllCellData() {
	var j = 0;
	var iCount = 1;
	var jCount = parseInt(document.getElementById("yoko").value);
	var elmCount = iCount * jCount;

	var freqElms = document.getElementsByClassName("text"); //配列
	var ratioElms = document.getElementsByClassName("text3"); //配列

	var result = confirm("全データを消去します");
	if (result === true) {
		for (j = 0; j < freqElms.length; j++) {
			freqElms[j].value = "";
		}
		errorClearCell(elmCount, "");

		for (j = 0; j < ratioElms.length; j++) {
			ratioElms[j].value = "";
		}
		errorClearCell(elmCount, "3");

		document.getElementById("cell_sum").value = "";
		document.getElementById('CandPArea').value = "";
		inputTextArea(document.getElementById('CandPArea'), 0);
		inputBtnTextClear(document.getElementById('inputBtn1'));
	}
}
// 度数セルデータの消去
function clearFrequencyCellData() {
	var j = 0;
	var freqElms = document.getElementsByClassName("text"); //配列

	var result = confirm("度数データを消去します");
	if (result === true) {
		for (j = 0; j < freqElms.length; j++) {
			freqElms[j].value = "";
		}
	}
	document.getElementById("cell_sum").value = "";
	errorClearCell(freqElms.length, "");

	document.getElementById("CandPArea").value = "";
	inputTextArea(document.getElementById("CandPArea"), 0);
	inputBtnTextClear(document.getElementById("inputBtn1"));

}
// 期待比率セルデータの消去
function clearRatioCellData() {
	var j = 0;
	var ratioElms = document.getElementsByClassName("text3"); //配列

	var result = confirm("期待比率データを消去します");
	if (result === true) {
		for (j = 0; j < ratioElms.length; j++) {
			ratioElms[j].value = "";
		}
	}
	errorClearCell(ratioElms.length, "3");

	document.getElementById("CandPArea").value = "";
	inputTextArea(document.getElementById("CandPArea"), 0);
	inputBtnTextClear(document.getElementById("inputBtn1"));
}
//Nの消去
function clearN() {
	document.getElementById("cell_sum").value = "";
}
//入力チェック
function checkCellData() {
	var i = 1;
	var iCount = 1;
	var jCount = parseInt(document.getElementById("yoko").value);
	var elmCount = iCount * jCount;

	var freqErrorCellNum = 0;
	var ratioErrorCellNum = 0;

	errorClearCell(elmCount, "");
	errorCell(elmCount, "");

	errorClearCell(elmCount, "3");
	errorCell(elmCount, "3");

	for (j = 1; j < elmCount + 1; j++) {
		if (document.getElementById("cell_" + j).value === "") {
			freqErrorCellNum = j;
		}
	}
	for (j = 1; j < elmCount + 1; j++) {
		if (document.getElementById("cell3_" + j).value === "") {
			ratioErrorCellNum = j;
		}
	}
	if ((freqErrorCellNum === 0) && (ratioErrorCellNum === 0)) {
		errorClearCell(elmCount, "");
		errorClearCell(elmCount, "3");
		sum();
		mainCalc_chisq_1xj();
	} else {
		if (freqErrorCellNum > 0) {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + freqErrorCellNum).focus();
		} else if (ratioErrorCellNum > 0) {
			alert("すべての期待比率が入力されていません (^_^)ゞ");
			document.getElementById("cell3_" + ratioErrorCellNum).focus();
		}
	}
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var yoko = document.getElementById("yoko").value;
	if (dd.length > yoko) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i;
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var yoko = parseInt(document.getElementById("yoko").value);
	var err = false;

	if (err === false) {
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < yoko + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var gunAtai = new Array(yoko);
			for (i = 0; i < yoko; i++) {
				gunAtai[i] = 0;
			}

			for (i = 0; i < dd.length; i++) {
				gunAtai[dd[i] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < yoko; i++) {
				strArray.push(gunAtai[i]);
				strArray.push("\t");
			}
			strArray.push("\n");
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
//メインの計算
function mainCalc_chisq_1xj() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var ii = 0;
	var jj = 0;

	var TT = 1;
	var YY = parseInt(document.getElementById("yoko").value, 10);
	var NN = TT * YY;

	var xx = new Array(TT);
	for (i = 0; i < TT; i++) {
		xx[i] = new Array(YY);
	}

	var cellId = 1;
	for (j = 0; j < YY; j++) {
		xx[0][j] = parseInt(document.getElementById("cell_" + cellId).value, 10);
		cellId++;
	}

	var N = 0; //度数の総合計
	for (j = 0; j < YY; j++) {
		N += xx[0][j];
	}

	var Y = []; //行の合計
	Y[0] = 0;
	for (j = 0; j < YY; j++) {
		Y[0] += xx[0][j];
	}

	var MC$;
	var EQ$;

	var strArray = [];

	var x2 = 0;
	var DF = 0;
	var MA;
	var PHI;

	var E = new Array(TT);
	for (i = 0; i < TT; i++) {
		E[i] = new Array(YY);
	}
	var kh = new Array(TT);
	for (i = 0; i < TT; i++) {
		kh[i] = new Array(YY);
	}
	var Z = new Array(TT);
	for (i = 0; i < TT; i++) {
		Z[i] = new Array(YY);
	}

	var khsum = 0;
	cellId = 1;
	for (j = 0; j < YY; j++) {
		kh[0][j] = parseFloat(document.getElementById("cell3_" + cellId).value);
		khsum += kh[0][j];
		cellId++;
	}

	for (j = 0; j < YY; j++) {
		// kh[0][j] = (kh[0][j] / khsum).toFixed(4);
		kh[0][j] = (kh[0][j] / khsum);
	}

	for (j = 0; j < YY; j++) {
		E[0][j] = N * kh[0][j];
		x2 += Math.pow(xx[0][j] - E[0][j], 2) / E[0][j];
	}
	DF = YY - 1;

	strArray.push("「カイ二乗検定の結果」\n（上段実測値,下段期待値）\n");
	for (i = 0; i < TT; i++) {
		for (j = 0; j < YY; j++) {
			strArray.push("--------");
		}
		strArray.push("\n");

		for (j = 0; j < YY; j++) {
			strArray.push(xx[i][j] + "\t\t");
		}
		strArray.push("\n");
		for (j = 0; j < YY; j++) {
			strArray.push(using(E[i][j], 3, 3) + "\t");
		}
		strArray.push("\n");
	}

	var ppStr = pValue_Match_ChiSquareValue(x2, DF);

	strArray.push("\n");
	strArray.push("x2(" + DF + ")=" + using(x2, 4, 3) + "   ,  " + ppStr);
	strArray.push("\n");

	var MC1 = new Array(TT);
	for (i = 0; i < TT; i++) {
		MC1[i] = new Array(YY);
	}
	var MC2 = new Array(TT);
	for (i = 0; i < TT; i++) {
		MC2[i] = new Array(YY);
	}

	strArray.push("\n");
	var sw = document.getElementById("ratio").value;
	if (sw == 1) { //期待比率同等のみ
		if (ppStr != "ns") {
			if (TT == 1) {
				if (YY > 2) {
					strArray.push("==ライアンの名義水準を用いた多重比較==\n");
					strArray.push("  (有意水準 alpha = 0.05 とします)\n");
					strArray.push("----------------------------------------------------\n");
					strArray.push("セル比較\t臨界比\t\t検定\t\t名義水準\n");
					strArray.push("----------------------------------------------------\n");

					for (j = 0; j < YY; j++) {
						for (jj = j + 1; jj < YY; jj++) {
							CN = 0;
							for (l = 0; l < YY; l++) {
								if ((l == j) || (l == jj)) {
									CN = CN + 1;
								} else {
									if ((xx[0][j] > xx[0][l]) && (xx[0][jj] <= xx[0][l])) {
										CN = CN + 1;
									}
									if ((xx[0][j] < xx[0][l]) && (xx[0][jj] >= xx[0][l])) {
										CN = CN + 1;
									}
								}
							}
							NL = 0.1 / (YY * (CN - 1));
							CR = (Math.abs(xx[0][j] - xx[0][jj]) - 1) / Math.sqrt(xx[0][j] + xx[0][jj]);
							if (CR < 1.96) {
								MC$ = "ns  p>.05    ";
								EQ$ = "=";
							} else {
								if (CR > 3.62) {
									MC$ = "*   p<0.0002";
									if (xx[0][j] > xx[0][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									var wP = pValue_to_alphaDash(CR);
									if (wP >= NL) {
										MC$ = "ns  p=" + wP;
										EQ$ = "=";
									}
									if (wP < NL) {
										MC$ = "*   p=" + wP;
										if (xx[0][j] > xx[0][jj]) {
											EQ$ = ">";
										} else {
											EQ$ = "<";
										}
									}
								}
							}
							strArray.push((j + 1) + " " + EQ$ + " " + (jj + 1) + " \t" + using(CR, 2, 2) + " \t" + MC$ + " \t" + using(NL, 1, 5) + "\n");
						}
					}
					strArray.push("----------------------------------------------------\n");
				}
			}
		}
	}

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	if (document.getElementById("RltAdd").checked) {
		document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	} else {
		document.getElementById("RltArea").value = strArray.join("");
	}
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var rcmArray = [];

		rcmArray.push("##### １×Ｊ表(カイ二乗検定)\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		rcmArray.push("levJ = " + YY + "         # ｊの水準数\n");
		rcmArray.push("\n");

		rcmArray.push("dosu <- c(\n  ");
		for (j = 0; j < YY; j++) {
			rcmArray.push(xx[0][j]);
			if (j < YY - 1) {
				rcmArray.push(" ,");
			} else {
				rcmArray.push(" ) # 度数\n");
			}
		}
		rcmArray.push("kitaichi <- c(\n  ");
		for (j = 0; j < YY; j++) {
			rcmArray.push(kh[0][j]);
			if (j < YY - 1) {
				rcmArray.push(" ,");
			} else {
				rcmArray.push(" ) # 期待値\n");
			}
		}
		rcmArray.push("\n");

		var taju = document.getElementById("taju").value;
		rcmArray.push("taju=\"" + taju + "\"  # BH, holm, b\n");

		rcmArray.push("## js-STARからの入力おわり\n");
		rcmArray.push("\n");
		rcmArray.push("# main\n");
		rcmArray.push("N= sum( dosu )\n");
		rcmArray.push("khir= kitaichi/sum(kitaichi) # 期待比率\n");
		rcmArray.push("kchi= khir*N\n");
		rcmArray.push("\n");
		rcmArray.push("# 作図\n");
		rcmArray.push("zhyo= matrix(c(khir,dosu/sum(dosu)), nc=levJ, by=1)\n");
		rcmArray.push("rownames(zhyo)= c(\"期待比率\",\"標本比率\")\n");
		rcmArray.push("maintitle=\"値１(黒) ～値ｊ(白) の比率\"\n");
		rcmArray.push("barplot(t(zhyo), hor=1, main=maintitle, las=1, cex.ax=1.5 )\n");
		rcmArray.push("\n");
		rcmArray.push("# 作表\n");
		rcmArray.push("tx1= matrix( round( c(\n");
		rcmArray.push("  dosu, kchi, dosu/N, khir, dosu/N-khir\n");
		rcmArray.push("  ), 4), nr=levJ, by=0)\n");
		rcmArray.push("rownames(tx1)= paste(\"値\", 1:levJ, sep=\"\" )\n");
		rcmArray.push("colnames(tx1)= c(\" 度数\",\"期待値\",\" 標本比率\",\"期待比率\",\"比率の差\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# CHISQ\n");
		rcmArray.push("kx1 = chisq.test(dosu, p=khir, resc=1 )\n");
		rcmArray.push("kai2= kx1$stat\n");
		rcmArray.push("dof = levJ-1\n");
		rcmArray.push("pch= kx1$p.va\n");
		rcmArray.push("ESw = sqrt( kai2/N )\n");
		rcmArray.push("\n");
		rcmArray.push("crX2= qchisq(0.95, dof )\n");
		rcmArray.push("beta= pchisq(crX2, dof, ncp=ESw^2*N )\n");
		rcmArray.push("powX= round(1-beta, 3 )\n");
		rcmArray.push("\n");
		rcmArray.push("futo=0\n");
		rcmArray.push("if( sum(khir==khir[1])<levJ ) futo=1\n");
		rcmArray.push("tx2= c()\n");
		rcmArray.push("tx2= matrix( round( c(\n");
		rcmArray.push("  kai2, dof, pch, ESw, 1-beta\n");
		rcmArray.push("  ), 4), nr=1 )\n");
		rcmArray.push("if( futo>0 ) goku=\"不等\" else goku=\"同等\"\n");
		rcmArray.push("rownames(tx2)= paste(\"期待比率\",goku, sep=\"\" )\n");
		rcmArray.push("colnames(tx2)= c(\" χ2値\",\" df\",\"   ｐ値\",\" 効果量ｗ\",\" 検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# パワ\n");
		rcmArray.push("NN= c(NA,NA)\n");
		rcmArray.push("if( powX<0.80 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" for( i in (N-1):10000 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" NCP = ESw^2*i # kai2\n");
		rcmArray.push(" beta= pchisq(crX2, dof, ncp=NCP )\n");
		rcmArray.push(" if( beta<0.20 ){ NN=c(i,1-beta,NN); break }\n");
		rcmArray.push("}\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" for( i in (N+1):0 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" NCP = ESw^2*i # kai2\n");
		rcmArray.push(" beta= pchisq(crX2, dof, ncp=NCP )\n");
		rcmArray.push(" if( beta>0.20 ) break\n");
		rcmArray.push(" NN= c(i,1-beta, NN )\n");
		rcmArray.push("}\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("tx4= c()\n");
		rcmArray.push("tx4= matrix( round( c(ESw,0.05,NN[2],NN[1],N), 4), nr=1 )\n");
		rcmArray.push("rownames(tx4)=\"\"\n");
		rcmArray.push("colnames(tx4)= c(\"効果量ｗ\",\"   α\",\"  検出力\",\"次回のＮ\",\"今回のＮ\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 多重比較\n");
		rcmArray.push("okjun= c()\n");
		rcmArray.push("okjun= order(rownames(tx1)[ rank(tx1[,5]) ], decreasing=1 )\n");
		rcmArray.push("\n");
		rcmArray.push("pval=c(); padj=c()\n");
		rcmArray.push("for(i in 1:(levJ-1)){ for(j in (i+1):levJ){\n");
		rcmArray.push("  koch=okjun[i]; aite=okjun[j]\n");
		rcmArray.push("  ds1=dosu[koch]; ds2=dosu[aite]\n");
		rcmArray.push("  kt1=kchi[koch]; kt2=kchi[aite]\n");
		rcmArray.push("  rst = binom.test(ds1, ds1+ds2, p=kt1/(kt1+kt2) )\n");
		rcmArray.push("  pval= c(pval, rst$p.val )\n");
		rcmArray.push("}  }\n");
		rcmArray.push("padj= p.adjust(pval, me=taju )\n");
		rcmArray.push("\n");
		rcmArray.push("tx3= c()\n");
		rcmArray.push("tx3= matrix( round( c(pval, padj), 4), nc=2 )\n");
		rcmArray.push("koch=c(); aite=c(); VS=c()\n");
		rcmArray.push("gyo=0\n");
		rcmArray.push("for(i in 1:(levJ-1)){ for(j in (i+1):levJ){\n");
		rcmArray.push("  koch= c(koch, paste(\"値\", okjun[i], sep=\"\") )\n");
		rcmArray.push("  aite= c(aite, paste(\"値\", okjun[j], sep=\"\") )\n");
		rcmArray.push("  gyo = gyo+1\n");
		rcmArray.push("  yuiP= padj[gyo]\n");
		rcmArray.push("  if( yuiP<0.05 ) tmp=\"> \" else if( yuiP<0.10) tmp=\">=\" else tmp=\"= \"\n");
		rcmArray.push("  VS= c(VS, tmp )\n");
		rcmArray.push("}  }\n");
		rcmArray.push("rownames(tx3)= paste(koch,VS,aite, sep=\"\" )\n");
		rcmArray.push("colnames(tx3)= c(\"    ｐ値\",\" 調整後ｐ値\")\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# ■結果の書き方\n");
		rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray.push("tmp= c()\n");
		rcmArray.push("if( futo>0 ) tmp=\"●●を期待比率とする\"\n");
		rcmArray.push("txt= c()\n");
		rcmArray.push("txt= paste(\"　Table(tx1)は各値の度数集計表である。\n　Table(tx1)において\",tmp,\"カイ二乗検定を行った結果、有意\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("fuki= c()\n");
		rcmArray.push("fuki= paste(\" (χ2(\",dof,\")=\",round(kai2,3),\", p=\",PV(pch),\", w=\",round(ESw,3),\", 1-β=\",powX,\")。\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("if( pch<0.05 ) tmp=\"であった\" else\n");
		rcmArray.push("if( pch<0.10 ) tmp=\"傾向であった\" else tmp=\"ではなかった\"\n");
		rcmArray.push("txt= paste(txt, tmp,fuki, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("if( pch<0.10 & levJ==2 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   tmp=c(); goku=\"傾向がある\"\n");
		rcmArray.push("   if( dosu[1]-khir[1]>0 ) tmp=c(\"大き\",\"小さ\") else tmp=c(\"小さ\",\"大き\")\n");
		rcmArray.push("   if( pch<0.05 ) goku=\"\"\n");
		rcmArray.push("   txt= paste(txt, \"値１の標本比率が期待比率より有意に\",tmp[1],\"く、値２の標本比率が期待比率より有意に\",tmp[2],\"い\",goku,\"ことが見いだされた。\", sep=\"\" )\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("tmp=c()\n");
		rcmArray.push("if( ESw>=0.49 ) tmp=\"大きい\" else\n");
		rcmArray.push("if( ESw>=0.29 ) tmp=\"中程度以上\" else\n");
		rcmArray.push("if( ESw>=0.26 ) tmp=\"ほぼ中程度\" else tmp=\"小さい\"\n");
		rcmArray.push("txt= paste(txt, \"効果量wは便宜的基準 (Cohen, 1992) によると\",tmp,\"と判断される。\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("goku=\"\"; tmp= \"\"; fuki=\"\"\n");
		rcmArray.push("if( pch<0.10 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   fuki=\"検出力（1-β）は\"\n");
		rcmArray.push("   if( powX<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり、信頼性が低い。\" } else\n");
		rcmArray.push("   if( powX<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない。\" else\n");
		rcmArray.push("   if( powX<0.80 ) tmp=\"ほぼ十分といえる。\" else tmp=\"十分である。\"\n");
		rcmArray.push("   if( levJ==2 & ESw<0.26 & powX<0.76 ) goku=\"\"\n");
		rcmArray.push("  }\n");
		rcmArray.push("txt= paste(txt, goku,fuki,tmp, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 多重比較\n");
		rcmArray.push("if( pch<0.10 & levJ>2 ){ #####\n");
		rcmArray.push("if( futo<1 ){ tmp2=\"度数の\"; tmp3=\"度数が多\" } else { tmp2=\"標本・期待比率の差の\"; tmp3=\"標本・期待比率の差が大き\" }\n");
		rcmArray.push("\n");
		rcmArray.push("fuki=c(); tmp=c( rep(\",\",levJ-1), \"\" )\n");
		rcmArray.push("for(j in 1:levJ) fuki=paste(fuki,\"値\",okjun[j],tmp[j], sep=\"\" )\n");
		rcmArray.push("txt= paste(txt, \"\n　正確二項検定を用いた多重比較（α=0.05、両側検定）を行った結果、\", sep=\"\" )\n");
		rcmArray.push("kazu= sum( padj<0.10 )\n");
		rcmArray.push("minP= round(min( padj ), 3 )\n");
		rcmArray.push("\n");
		rcmArray.push("if( kazu<1 ) txt= paste(txt, \"各値の間に有意な度数差は見られなかった（adjusted ps>\",minP,\")。\", sep=\"\" ) else\n");
		rcmArray.push("{ ###\n");
		rcmArray.push(" txt= paste(txt, tmp2,\"大きい順 (\",fuki,\") に記述すると、\", sep=\"\" )\n");
		rcmArray.push(" gyo= 0\n");
		rcmArray.push(" Pari= 1\n");
		rcmArray.push(" for(i in 1:(levJ-1))\n");
		rcmArray.push("   {\n");
		rcmArray.push("    if( Pari==0 ){ txt=paste(txt,\"これ以降にも有意差は見いだされなかった。\",sep=\"\"); break }\n");
		rcmArray.push("    if( i==2 ) mata=\"また、\" else mata=\"\"\n");
		rcmArray.push("    txt= paste(txt, mata,\"値\",okjun[i],\"は\", sep=\"\" )\n");
		rcmArray.push("    nais= levJ-i\n");
		rcmArray.push("    sumi=0; yui=0; minP=1; maxP=0; aite=c()\n");
		rcmArray.push("    Pari= 0\n");
		rcmArray.push(" for(j in (i+1):levJ)\n");
		rcmArray.push("   {\n");
		rcmArray.push("    aite= paste(\"値\",okjun[j], sep=\"\" )\n");
		rcmArray.push("    gyo = gyo+1\n");
		rcmArray.push("    adP = padj[gyo]\n");
		rcmArray.push("    if( adP<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" if( yui==0 ){ keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"か\" }\n");
		rcmArray.push(" if( sumi<2 ) tmp=\"p=\" else tmp=\"ps>\"\n");
		rcmArray.push(" if( yui<1 & sumi>0 ) txt=paste(txt, \"と有意差がなく (adjusted \",tmp,round(minP,3),\")、それ以降の\", sep=\"\" )\n");
		rcmArray.push(" yui= yui+1; if( yui==1 ) maxP=adP\n");
		rcmArray.push(" if( yui>1 ) tmp=\"・\" else tmp=\"\"\n");
		rcmArray.push(" txt=paste(txt, tmp,aite, sep=\"\" )\n");
		rcmArray.push(" if( yui<2 ) tmp=\"p=\" else tmp=\"ps<\"\n");
		rcmArray.push(" if( j==levJ ) txt= paste(txt, \"よりも有意に\",tmp3,keko,\"った (adjusted \",tmp,round(maxP,3),\")。\", sep=\"\" )\n");
		rcmArray.push(" sumi= sumi+1\n");
		rcmArray.push(" Pari= 1\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" if( sumi>0 ) tmp=\"・\" else tmp=\"\"\n");
		rcmArray.push(" txt= paste(txt, tmp,aite, sep=\"\" )\n");
		rcmArray.push(" if( sumi<2 ) tmp=\"p=\" else tmp=\"ps>\"\n");
		rcmArray.push(" if( adP <minP ) minP=adP\n");
		rcmArray.push(" if( j==levJ ) txt= paste(txt, \"と有意差がなかった (adjusted \",tmp,round(minP,3),\")。\", sep=\"\" )\n");
		rcmArray.push(" sumi= sumi+1\n");
		rcmArray.push("}\n");
		rcmArray.push("   }  } # for(i)(j)\n");
		rcmArray.push("} ###\n");
		rcmArray.push("\n");
		rcmArray.push("if( taju==\"BH\" ) tmp=\"Benjamini & Hochberg (1995)\"\n");
		rcmArray.push("if( taju==\"holm\" ) tmp=\"Holm\"\n");
		rcmArray.push("if( taju==\"b\" ) tmp=\"Bonferroni\"\n");
		rcmArray.push("txt= paste(txt, \"\n　以上のp値の調整には\",tmp,\"の方法を用いた。\", sep=\"\" )\n");
		rcmArray.push("} #####\n");
		rcmArray.push("\n");
		rcmArray.push("txt= paste(txt, \"\n\n［引用文献］\n\", sep=\"\" )\n");
		rcmArray.push("if(pch<0.10 & levJ>2 & taju==\"BH\") txt=paste(txt,\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
		rcmArray.push("txt= paste(txt, \"Cohen, J. (1992). A power primer. Psychological Bulletin, 112, 155-159.\n\", sep=\"\" )\n");
		rcmArray.push("H=matrix(0,nr=1)\n");
		rcmArray.push("rownames(H)=\"\"\n");
		rcmArray.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=4)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("##########################\n");
		rcmArray.push("#\n");
		rcmArray.push("#   カイ二乗検定１×Ｊ\n");
		rcmArray.push("#   (１群×Ｊ値の分析)\n");
		rcmArray.push("#\n");
		rcmArray.push("H#########################\n");
		rcmArray.push("tx1 # 度数集計表\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # カイ二乗検定\n");
		rcmArray.push("# 効果量ｗの評価：大=0.5, 中=0.3, 小=0.1\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 # 多重比較（正確二項検定，両側検定）\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 # パワーアナリシス（追試用Ｎの計算）\n");
		rcmArray.push("# ■ NA が表示されたら計算不能\n");
		rcmArray.push("\n");
		rcmArray.push("cat(txt) # 結果の書き方\n");
		rcmArray.push("\n");
		rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# write(txt, file.choose(), ap=T) # 結果のファイル保存\n");
		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

		if (document.getElementById("RltAdd").checked) {
			document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
		} else {
			document.getElementById("RcmArea").value = rcmArray.join("");
		}
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		if (document.getElementById("RltAdd").checked === false) {
			chartClear();
		}

		var parent = document.getElementById("chart");
		var childElementCount = parent.childElementCount;

		var j;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg" + childElementCount;
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (j = 0; j < YY; j++) {
			data[j] = [];
		}
		for (j = 0; j < YY; j++) {
			data[j][0] = ((xx[0][j] / N) * 100).toFixed(4);
			data[j][1] = kh[0][j] * 100;
		}

		var datasetKey = [];
		for (j = 0; j < YY; j++) {
			datasetKey[j] = [];
		}
		var wC = 0;
		for (j = 0; j < YY; j++) {
			datasetKey[j].label = '値' + (j + 1);
			datasetKey[j].data = data[j];

			if (j === 0) {
				wC = 0; //最初の色は000000
			} else {
				wC = (parseInt("F0", 16) / (YY - 1) * j).toFixed(0); //最後の色はF0F0F0
				wC = parseInt(wC, 10);
			}
			datasetKey[j].backgroundColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';
			datasetKey[j].borderColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';

			datasetKey[j].borderWidth = 1;
		}

		var datasetData = [];
		// var dataset = [datas[0], datas[1]];
		for (j = 0; j < YY; j++) {
			datasetData[j] = datasetKey[j];
		}
		var myChart = new Chart(ctx, {
			type: 'horizontalBar',
			data: {
				labels: ['標本比率', '期待比率'],
				datasets: datasetData
			},
			options: {
				title: {
					display: true,
					text: '値 1（黒）～値 ' + YY + '（淡）の比率',
					position: 'top',
					fontSize: 12,
					fontColor: '#000000'
				},
				scales: {
					xAxes: [{
						stacked: true,
						ticks: {
							beginAtZero: true,
							min: 0,
							max: 100
						}
					}],
					yAxes: [{
						stacked: true
					}]
				},
				legend: {
					position: 'bottom'
				}
			}
		});
	}());

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
// 期待比率による分岐
function expectedRatioBranch() {
	var result;
	var YY = parseInt(document.getElementById("yoko").value, 10);

	if (document.getElementById("radio1").checked) {
		for (var i = 9; i < 17; i++) {
			if (document.getElementById("cell3_" + i).style.visibility == "visible") {
				document.getElementById("cell3_" + i).value = (1 / YY).toFixed(4);
			}
		}
	} else {
		clearRatioCellData();
		// expectedRatioUnequal_Input();
	}
}
//期待比率同等の入力
function expectedRatioEqual_Input() {
	var j = 0;
	var YY = parseInt(document.getElementById("yoko").value, 10);

	var ratioElms = document.getElementsByClassName("text3"); //配列

	var sw = document.getElementById("ratio").value;
	if (sw == 1) {
		for (j = 0; j < ratioElms.length; j++) {
			ratioElms[j].value = (1 / YY).toFixed(4);
		}
	}
}
//期待比率不等の入力
function expectedRatioUnequal_Input() {
	clearRatioCellData();
	var i = 0;
	var j = 0;
	var s = 0;
	var cellId = 9; //追加
	var e = 0;	//入力エラーなし：０ あり：１

	var iCount = 1;
	var jCount = parseInt(document.getElementById("yoko").value);

	var elmCount = iCount * jCount; //追加

	while (s < elmCount) {
		results = 0;
		onBgColor(document.getElementById("cell3_" + cellId));

		results = prompt(" 横(列)：" + (j + 1) + "の期待比率を入力してください\n[ * ：１つ戻る][ # ：入力中断]", "");
		if ((results === null) || (results === undefined)) {
			s = elmCount;
			e = 1;
		} else if (results != "*" && results != "#") {
			document.getElementById("cell3_" + cellId).value = results;
			s++;
		}
		offBgColor(document.getElementById("cell3_" + cellId));

		if (results == "*") {
			if (j < 1) {
				j = 0;
				cellId = 9; //追加
				s = 0;
			} else {
				j--;
				cellId--; //追加
				s--;
			}
		} else {
			if (results == "#") {
				s = elmCount;
				e = 1;
			} else {
				j++;
				if (j >= jCount) {
					j = 0;
				}
				cellId++;
			}
		}
	}
	if (e !== 0) {
		alert("入力を中断しました");
	}
}
/**
 * [sum 度数の合計]
 * @return {[type]} [description]
 */
function sum() {
	var j = 0;
	var freqElms = document.getElementsByClassName("text"); //配列

	var wSum = 0;
	for (j = 0; j < freqElms.length; j++) {
		if (freqElms[j].value !== "") {
			wSum += parseInt(freqElms[j].value);
		}
	}
	document.getElementById("cell_sum").value = wSum;
}
/**
 * [changeChisq1xjSetting セルなどの入力フォーム部分を作成]
 */
function changeChisq1xjSetting() {
	var htmArray = [];

	htmArray.push("<div class=\"tateyoko\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("横(列)：<input type=\"number\" class=\"text9\" id=\"yoko\" size=\"10\" maxlength=\"10\"  min=\"3\"  max=\"8\" value=\"6\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeChisq1xjTable();expectedRatioEqual_Input();clearN();\">");
	} else {
		htmArray.push("横(列)：<select name=\"yoko\" id=\"yoko\" class=\"tySelect\" size=\"1\" onchange=\"changeChisq1xjTable();expectedRatioEqual_Input();clearN();\">");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\" selected>6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("</select>");
	}

	htmArray.push("<div>");
	htmArray.push("期待比率：<select name=\"ratio\" id=\"ratio\" class=\"tySelect3\" size=\"1\" onchange=\"ratioBranch();clearN();\">");
	htmArray.push("<option value=\"1\" selected>同等</option>");
	htmArray.push("<option value=\"2\">不等</option>");
	htmArray.push("</select>");
	htmArray.push("</div>");

	htmArray.push("</div>");

	document.getElementById("chisq1xj_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeChisq1xjTable();
}
function changeChisq1xjTable() {
	var j = 0;
	var jCount = parseInt(document.getElementById("yoko").value);

	var htmArray = [];
	var freqCellId = 1;
	var ratioCellId = 1;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi\">度数</td>");

	for (j = 0; j < jCount; j++) {
		htmArray.push("<td class=\"hyou_nyuryoku_1xj\">");
		htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + freqCellId + "\" size=\"3\" max=\"999\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"sum();\">");
		htmArray.push("</td>");
		freqCellId++;
	}

	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi\">期待比率</td>");

	for (j = 0; j < jCount; j++) {
		htmArray.push("<td class=\"hyou_nyuryoku_1xj\">");
		htmArray.push("<input type=\"number\" class=\"text3\" id=\"cell3_" + ratioCellId + "\" size=\"6\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		htmArray.push("</td>");
		ratioCellId++;
	}

	htmArray.push("</tr>");
	htmArray.push("</table>");

	// htmArray.push("<div id=\"n\">");
	// htmArray.push("N = <input type=\"text\" class=\"text2\" size=\"5\" maxlength=\"5\" name=\"N\" id=\"cell_sum\" readonly=\"readonly\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">");
	// htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout3\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"conditionalBranch();copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);sum();\"></span>");
	// htmArray.push("</div>");

	document.getElementById("chisq1xj_table").innerHTML = htmArray.join("");
	htmArray = null;

	// setDragAndDrop();
}
// 比率分岐
function ratioBranch() {
	var sw = document.getElementById("ratio").value;
	if (sw == 1) {
		expectedRatioEqual_Input();
	}
	if (sw == 2) {
		clearRatioCellData();
	}
}
// セル表示設定
function setTF() {
	var i;
	var count = 1;
	var yoko = parseInt(document.getElementById("yoko").value, 10);

	for (i = 1; i < 9; i++) {
		document.getElementById("cell3_" + i).value = '';
	}

	for (i = 1; i < 17; i++) {
		if (count <= yoko) {
			document.getElementById("cell3_" + i).style.visibility = 'visible';
		} else {
			document.getElementById("cell3_" + i).style.visibility = 'hidden';
		}
		if (count >= 8) {
			count = 1;
		} else {
			// count=count+1;
			count++;
		}
	}
}
function saveData_1xj() {
	var i, j;

	var strArray = [];

	var TT = 1;
	var YY = parseInt(document.getElementById("yoko").value);
	// var ratio = parseInt(document.getElementById("ratio").value);
	var ratio = document.getElementById("ratio").selectedIndex;

	//#0
	strArray.push("1xj" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(YY + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(ratio + "\n");
	//#3
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < YY; j++) {
		x = parseInt(document.getElementById("cell_" + cellId).value);
		if (j !== YY - 1) {
			strArray.push(x + "\t");
		} else {
			strArray.push(x);
		}
		cellId++;
	}
	strArray.push("\n");
	//#4
	strArray.push("#" + "\n");
	cellId = 1;
	for (j = 0; j < YY; j++) {
		x = parseFloat(document.getElementById("cell3_" + cellId).value);
		if (j !== YY - 1) {
			strArray.push(x + "\t");
		} else {
			strArray.push(x);
		}
		cellId++;
	}

	var Stream = strArray.join("");

	var fineName = "1xj_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_1xj() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "1xj") {
		var yoko = dd[1];
		yoko = delTopCR(yoko);
		var YY = parseInt(yoko);
		document.getElementById("yoko").value = YY;
		document.getElementById("ratio").selectedIndex = parseInt(dd[2]);
		changeChisq1xjTable();
		var ratio_text = delTopCR(dd[4]);
		var ratio_data = [];
		ratio_data = ratio_text.split("\t");
		for (j = 0; j < YY; j++) {
			document.getElementById("cell3_" + (j + 1)).value = ratio_data[j];
		}
		document.getElementById("CandPArea").value = delTopCR(dd[3]);
	}
}
function simulation_1xj(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var YY = parseInt(document.getElementById("yoko").value);
	var min = 3;
	var max = 8;
	if (YY === 8) {
		YY = Math.floor(Math.random() * (max - min + 1) + min);
		document.getElementById("yoko").value = YY;
		changeChisq1xjTable();
	}
	var ratioElms = document.getElementsByClassName("text3"); //配列

	var kh = [];
	var cellId = 1;
	var _sum = 0;
	for (j = 0; j < YY; j++) {
		kh[j] = parseFloat(document.getElementById("cell3_" + cellId).value, 10);
		_sum += kh[j];
		cellId++;
	}
	cellId = 1;
	for (j = 0; j < YY; j++) {
		kh[j] = kh[j] / _sum;
		document.getElementById("cell3_" + cellId).value = kh[j].toFixed(4);
		cellId++;
	}

	var ratioArray = [];
	var CumulativeRatio = []; //累積比率
	if (document.getElementById("ratio").selectedIndex === 0) {
		expectedRatioEqual_Input();
	} else {
		var ratioElmsFlag = false; //期待比率への入力確認用
		var ratioSum = 0;
		for (j = 0; j < ratioElms.length; j++) {
			if (kh[j] === "" || isNaN(parseFloat(kh[j], 10))) {
				ratioElmsFlag = true;
			}
		}
		if (ratioElmsFlag) {
			for (j = 0; j < ratioElms.length; j++) {
				ratioArray[j] = Math.floor(Math.random() * (max - min + 1) + min);
				ratioSum += ratioArray[j];
			}
			for (j = 0; j < ratioElms.length; j++) {
				ratioElms[j].value = (ratioArray[j] / ratioSum).toFixed(4);
			}
		}
	}

	for (j = 0; j < ratioElms.length; j++) {
		if (j === 0) {
			CumulativeRatio[j] = parseFloat(ratioElms[j].value, 10);
		} else {
			CumulativeRatio[j] = CumulativeRatio[j - 1] + parseFloat(ratioElms[j].value, 10);
		}
	}

	var N = 50;
	if (key_shift) {
		N = prompt("Nを入力してください");
		if (N !== "") {
			if (isNaN(N)) {
				N = 50;
			}
			N = parseInt(N, 10);
		}
	} else {
		if (document.getElementById("cell_sum").value !== "") {
			N = document.getElementById("cell_sum").value;
		} else {
			N = 50;
		}
	}

	var data = [];
	var rand = [];
	var sortedRand = [];
	for (i = 0; i < N; i++) {
		data[i] = 1;
		rand[i] = Math.random();
	}
	sortedRand = rand.sort(compareNumbers);

	for (j = 0; j < ratioElms.length; j++) {
		for (i = 0; i < N; i++) {
			if (CumulativeRatio[j] < sortedRand[i]) {
				data[i]++;
			}
		}
	}

	document.getElementById("CandPArea").value = data.join("\n");

	conditionalBranch();
	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// // inputBtnTextClear(this);
	sum();

	mainCalc_chisq_1xj();
}

// function simulation_1xj_0(event) {
// 	var key_event = event || window.event; //Firefox IE用
// 	var key_shift = (key_event.shiftKey);

// 	var YY = parseInt(document.getElementById("yoko").value);
// 	var min = 3;
// 	var max = 8;
// 	if (YY === 8) {
// 		YY = Math.floor(Math.random() * (max - min + 1) + min);
// 	}
// 	document.getElementById("yoko").value = YY;
// 	document.getElementById("ratio").selectedIndex = 0;

// 	changeChisq1xjTable();
// 	expectedRatioEqual_Input();

// 	var result = "rnd1:" + YY + "*50";
// 	var N = "";
// 	if (key_shift) {
// 		N = prompt("Nを入力してください");
// 		if (N === null) {
// 			result = "rnd1:" + YY + "*50";
// 		}
// 		if (N !== "") {
// 			if (isNaN(N)) {
// 				N = 50;
// 			}
// 			result = "rnd1:" + YY + "*" + parseInt(N, 10);
// 		}
// 	} else {
// 		if (document.getElementById("cell_sum").value !== "") {
// 			result = "rnd1:" + YY + "*" + document.getElementById("cell_sum").value;
// 		} else {
// 			result = "rnd1:" + YY + "*50";
// 		}
// 	}

// 	document.getElementById("CandPArea").value = random_number_generation(result);

// 	conditionalBranch();
// 	copipe('CandPArea', 'text');
// 	inputTextArea(document.getElementById('CandPArea'), 0);
// 	// inputBtnTextClear(this);
// 	sum();

// 	mainCalc_chisq_1xj();
// }