/**
 * 回帰分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	changeRegSetting();
	RoutputSelect();
	RoutputArea();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 独立変数
	var elmCount = NN * (LA + 1);

	var result = confirm("データを消去します");
	if (result == true) {
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = '';
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
}
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 独立変数
	var elmCount = NN * (LA + 1);

	var errorCellNum = 0;
	if (document.getElementById("CandPArea").value == "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value == "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum == 0) {
			errorClearCell(elmCount, "");
			mainCalc_reg();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_reg() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 独立変数

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var xx = new Array(LA + 1);
	for (i = 0; i < LA + 1; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + 1; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var hensu = 0;
	for (i = 0; i < LA; i++) {
		if (document.getElementById("x" + (i + 1)).checked) {
			hensu++;
		}
	}

	//基本統計量
	var M = [];	//平均
	var SD = [];	//標準偏差
	var MA = [];	//最大値
	var MI = [];	//最小値

	strArray.push(" == Means & SDs(SDは標本標準偏差) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA + 1; i++) {
		S = 0;
		SS = 0;
		MA[i] = xx[i][0];
		MI[i] = xx[i][0];

		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
			if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
		}

		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		if (i == 0) {
			strArray.push("Y" + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		} else {
			strArray.push("x" + i + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		}

	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (i = 0; i < LA + 1; i++) {
		if (i == 0) {
			strArray.push("Y" + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
		} else {
			strArray.push("x" + i + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
		}
	}
	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			for (j = 0; j < NN; j++) {
				for (i = 0; i < LA + 1; i++) {
					rcmArray1.push(xx[i][j]);
					if ((i != LA + 1 - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			i = 0;
			rcmArray.push("Y  <- c(");
			for (j = 0; j < NN; j++) {
				rcmArray.push(" " + xx[i][j]);
				if ((j != NN - 1)) rcmArray.push(",");
			}
			rcmArray.push(" )\n");

			for (i = 1; i < LA + 1; i++) {
				rcmArray.push("x" + i + " <- c(");
				for (j = 0; j < NN; j++) {
					rcmArray.push(" " + xx[i][j]);
					if ((j != NN - 1)) rcmArray.push(",");
				}
				rcmArray.push(" )\n");
			}
			rcmArray.push("\n");

			rcmArray.push("dtab <- data.frame(\n");
			rcmArray.push(" Y,\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push(" x" + (i + 1));
				if ((i != LA - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");

			rcmArray.push("Y <- c()\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push("x" + (i + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("####### 回帰分析 #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# パッケージ psych  が必要\n");
		rcmArray2.push("# パッケージ pequod が必要\n");
		rcmArray2.push("# dtab は読み込み済み\n");
		rcmArray2.push("\n");
		rcmArray2.push("## js-STARからの入力:reg\n");
		rcmArray2.push("hensu=" + LA + "  # 独立変数 x の個数\n");
		rcmArray2.push("saiyo <- c(");
		var commaflag = false;
		for (i = 0; i < LA; i++) {
			if (document.getElementById("x" + (i + 1)).checked) {
				if (commaflag) {
					rcmArray2.push(",");
				}
				rcmArray2.push(" " + (i + 1));
				commaflag = true;
			}
		}
		rcmArray2.push(" )   # チェックを入れた x の番号\n");
		rcmArray2.push("\n");

		var MDL = "";
		if (document.getElementById("KOGO_model")) {
			MDL = "Y ~ " + document.getElementById("KOGO_model").value;
		}
		rcmArray2.push("MDL=\"" + MDL + "\"  # 初期値は空。ユーザー作成なら\"\"内に記述\n");
		var KOGO = document.getElementById("KOGO").value;
		rcmArray2.push("kogo=" + KOGO + " # 1=交互作用モデル, 0=主効果モデル\n");
		rcmArray2.push("\n");
		var JK = document.getElementById("JK").value;
		rcmArray2.push("JK=\"" + JK + "\"   # AIC, BIC\n");
		var taju = document.getElementById("taju").value;
		rcmArray2.push("taju=\"" + taju + "\"  # BH, holm, b\n");
		rcmArray2.push("## js-STARの入力おわり\n");
		rcmArray2.push("\n");

		rcmArray2.push("# MDL構築\n");
		rcmArray2.push("saisu= length(saiyo )\n");
		rcmArray2.push("KOGO= kogo\n");
		rcmArray2.push("if( nchar(MDL)==0 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" MDL= paste(\"Y~ x\",saiyo[1], sep=\"\" )\n");
		rcmArray2.push(" if( saisu>1 ) for( i in 2:saisu ) MDL=paste(MDL,\" + x\",saiyo[i],sep=\"\")\n");
		rcmArray2.push(" if( KOGO==1 & saisu>1 ){\n");
		rcmArray2.push(" for( i in 1:(saisu-1) ){ for( j in (i+1):saisu ){\n");
		rcmArray2.push(" MDL= paste(MDL,\" + x\",saiyo[i],\":x\",saiyo[j], sep=\"\" )\n");
		rcmArray2.push("}  }  }  } else {\n");
		rcmArray2.push("saiyo= c()\n");
		rcmArray2.push("MDL=paste(MDL,\" \",sep=\"\" ); tmp=c(\" \",\"+\",\":\" )\n");
		rcmArray2.push("if( regexpr(\":\",MDL)[1]>3 ) KOGO=1 else KOGO=0\n");
		rcmArray2.push("for( i in 1:hensu )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" ari= 0\n");
		rcmArray2.push(" for( j in 1:3 ) if( regexpr(paste(\"x\",i,tmp[j],sep=\"\"),MDL)[1]>0 ) ari=ari+1\n");
		rcmArray2.push(" if( ari>0 ) saiyo=c(saiyo, i )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("saisu= length(saiyo )\n");
		rcmArray2.push("} # if(nchar)\n");
		rcmArray2.push("\n");
		rcmArray2.push("colnames(dtab)= c(\"Y\", paste(\"x\",1:hensu,sep=\"\") )\n");
		rcmArray2.push("N= nrow(dtab)\n");
		rcmArray2.push("rets= c(1, 1+saiyo ) # 採用列\n");
		rcmArray2.push("dx= data.frame(dtab[ ,rets] )\n");
		rcmArray2.push("colnames(dx)= c(\"Y\", paste(\"x\",saiyo,sep=\"\") )\n");
		rcmArray2.push("hk= apply(dtab, 2, mean)\n");
		rcmArray2.push("sd= apply(dtab, 2, sd  )\n");
		rcmArray2.push("mi= apply(dtab, 2, min )\n");
		rcmArray2.push("ma= apply(dtab, 2, max )\n");
		rcmArray2.push("tx1= matrix(round(c(rep(N,1+hensu),hk,sd,mi,ma,hk-sd,hk+sd), 4), nc=7 )\n");
		rcmArray2.push("rownames(tx1)= colnames(dtab)\n");
		rcmArray2.push("colnames(tx1)= c(\"   N\",\"Mean\",\"SD\",\" Min\",\"Max\",\"   M-SD\",\"M+SD\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 中心化\n");
		rcmArray2.push("fch=0\n");
		rcmArray2.push("if( saisu==1 ) KOGO=0\n");
		rcmArray2.push("if( KOGO==1 & saisu>1 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" dc= dx[,1]\n");
		rcmArray2.push(" for( i in 1:saisu ) dc=cbind(dc,dx[,i+1]-hk[ saiyo[i]+1 ] )\n");
		rcmArray2.push(" dc=data.frame(dc); colnames(dc)=colnames(dx)\n");
		rcmArray2.push(" dt= dc\n");
		rcmArray2.push("} else dt=dx\n");
		rcmArray2.push("\n");
		rcmArray2.push("FIGX= function() # 交互作用図\n");
		rcmArray2.push("{\n");
		rcmArray2.push("xL=kx$P[1,]; xH=kx$P[2,]\n");
		rcmArray2.push("yjik= c( min(kx$P), max(kx$P) )\n");
		rcmArray2.push("x= c(-1.2, 1.2)\n");
		rcmArray2.push("Y= c(1,1)\n");

		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("windows()\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("quartz()\n");
		}

		rcmArray2.push("plot(x,Y,ty=\"n\",bty=\"l\",tck=0.03,las=1,ylab=\"従属変数Ｙ\",\n");
		rcmArray2.push("  ylim=yjik,\n");
		rcmArray2.push("  xlab=paste(ko1,\"の低水準(SD=-1.0)・高水準(SD=1.0)\", sep=\"\" ),\n");
		rcmArray2.push("  main=paste(ko1,\"×\",ko2,\"の交互作用(\",ko2,\"低水準=灰, \",ko2,\"高水準=黒)\", sep=\"\" ),\n");
		rcmArray2.push("  cex.lab=1.3, cex.main=1.3\n");
		rcmArray2.push(")\n");
		rcmArray2.push("x= c(-1,1)\n");
		rcmArray2.push("lines(x,c(xL[1],xH[1])); points(x,c(xL[1],xH[1]),pch=21,bg=8,cex=3 )\n");
		rcmArray2.push("lines(x,c(xL[2],xH[2])); points(x,c(xL[2],xH[2]),pch=21,bg=1,cex=3 )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("mds= c(\"偏回帰係数\",\"標準誤差\",\"ｔ値\",\"ｐ値\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 回帰モデリング\n");
		rcmArray2.push("cat(\"■パッケージの読み込み中…\n\")\n");
		rcmArray2.push("library( pequod )\n");
		rcmArray2.push("Mful= glm(MDL, data=dt )\n");
		rcmArray2.push("pnlt= 2\n");
		rcmArray2.push("if( JK==\"BIC\" ) pnlt=log(N)\n");
		rcmArray2.push("Msel= step(Mful, k=pnlt )\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx2=c(); tx3=c(); tx4=c(); tx5=c(); tx6=c() # ←傾斜分析\n");
		rcmArray2.push("xban=c(); kogs=0 # 有意交互作用数\n");
		rcmArray2.push("tx2= Msel$anova\n");
		rcmArray2.push("colnames(tx2)= c(\"項の増減\",\"df\",\"残差増分\",\"  df\",\"残差逸脱度\", JK )\n");
		rcmArray2.push("if( nrow(tx2)==1 ) tx3=MDL else tx3=paste(\"Y~ \",Msel$form[3], sep=\"\" ) \n");
		rcmArray2.push("\n");
		rcmArray2.push("# 選出モデル\n");
		rcmArray2.push("ari= 1 # 選出あり\n");
		rcmArray2.push("if( is.na(charmatch(\"Y~ 1\",tx3))<1 ) ari=0 else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("kx= summary(lm(tx3, data=dt) )\n");
		rcmArray2.push("tx4= kx$coef\n");
		rcmArray2.push("tx4= cbind(tx4, summary(lm(tx3,data.frame(scale(dt)[,])))$coef[,1] )\n");
		rcmArray2.push("tx4= round(tx4, 4 )\n");
		rcmArray2.push("rownames(tx4)[1]=\"(Interc.)\"\n");
		rcmArray2.push("colnames(tx4)= c(\"偏回帰係数\",\"標準誤差\",\"ｔ値\",\"ｐ値\",\"β\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("R2= kx$r.sq; AdjR=kx$adj\n");
		rcmArray2.push("fch=kx$fst[1]; df1=kx$fst[2]; df2=kx$fst[3]\n");
		rcmArray2.push("pch= pf(fch,df1,df2, low=0 )\n");
		rcmArray2.push("f2= R2/(1-R2)\n");
		rcmArray2.push("pow= 1-pf(qf(0.95,df1,df2),df1,df2,ncp=f2*N )\n");
		rcmArray2.push("tx5= matrix(round(c(R2,fch,df1,df2,pch,f2,pow,AdjR),4), nr=1 )\n");
		rcmArray2.push("colnames(tx5)= c(\"R^2\",\"Ｆ値\",\"df1\",\"df2\",\"ｐ値\",\"f^2\",\"1-β\",\"adj_R^2\" )\n");
		rcmArray2.push("rownames(tx5)=\"\"\n");
		rcmArray2.push("if( is.nan(fch)>0 ) ari=0\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( KOGO>0 & nchar(tx3)>7 & ari>0 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("for( i in 1:(saisu-1) ){\n");
		rcmArray2.push("for( j in (i+1):saisu ){\n");
		rcmArray2.push("  ko1=paste(\"x\",saiyo[i],sep=\"\"); ko2=paste(\"x\",saiyo[j],sep=\"\")\n");
		rcmArray2.push("  gyo= charmatch(paste(ko1,\":\",ko2,sep=\"\"), rownames(tx4) )\n");
		rcmArray2.push("  if( is.na(gyo)<1 ) # 作用項のケタ i,j 確定\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" if( tx4[gyo,4]<0.10 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" xban= c(xban,i,j ) # ケタ保存■注意！\n");
		rcmArray2.push(" kogs=kogs+1; if( kogs>1 ) tx6=rbind(tx6,rep(NA,5) )\n");
		rcmArray2.push(" peq= lmres(tx3, data=dt )\n");
		rcmArray2.push(" hyo=c(); tmp=c(); goku=c(\"低\",\"高\")\n");
		rcmArray2.push(" for( k in 1:2 ){\n");
		rcmArray2.push("   if( k==2 ){ tmp=ko1; ko1=ko2; ko2=tmp }\n");
		rcmArray2.push("   kx= summary(simpleSlope(peq,pred=ko1,mod1=ko2) )\n");
		rcmArray2.push("   if( k==1 ) FIGX()\n");
		rcmArray2.push(" for( L in 1:2 ){\n");
		rcmArray2.push("   tmp= round(matrix(c(kx$P[L,],kx$simp[L,c(1,3,4)]),nr=1), 4 )\n");
		rcmArray2.push("   rownames(tmp)= paste(ko1,goku[L],\"の\",ko2,\"低高\", sep=\"\" )\n");
		rcmArray2.push("   hyo= rbind(hyo, tmp )\n");
		rcmArray2.push("   if( k==1 & L==2 ) hyo=rbind(hyo, rep(NA,5) )\n");
		rcmArray2.push(" }  } # for(L)(k)\n");
		rcmArray2.push(" hyo[ ,5]= p.adjust(hyo[,5], me=taju )\n");
		rcmArray2.push(" tx6= rbind(tx6, hyo )\n");
		rcmArray2.push("}  } # if(tx4) if(is.na)\n");
		rcmArray2.push("}  } # for(i)(j)\n");
		rcmArray2.push(" if( kogs>0 ) colnames(tx6)=c(\"低_Y\",\"高_Y\",\"偏回帰ｂ\",\"ｔ値\",\"adj_ｐ\")\n");
		rcmArray2.push("} # if(KOGO)\n");
		rcmArray2.push("} # if(is.na)\n");
		rcmArray2.push("\n");
		rcmArray2.push("MD2=MDL; MD3=c(); rsq=c(); coef=c()\n");
		rcmArray2.push("if( KOGO==1 & saisu>2 & saisu<9 ) # 高次作用 8変数まで\n");
		rcmArray2.push("{\n");
		rcmArray2.push("for(i in 1:(saisu-2)){ for(j in (i+1):(saisu-1)){ for(k in (j+1):saisu){\n");
		rcmArray2.push("  MD2= paste(MD2,\" + x\",saiyo[i],\":x\",saiyo[j],\":x\",saiyo[k], sep=\"\" )\n");
		rcmArray2.push("} } }\n");
		rcmArray2.push("Mf= glm(MD2, data=dc )\n");
		rcmArray2.push("Ms= step(Mf, k=pnlt )\n");
		rcmArray2.push("gyos= nrow(Ms$anova)\n");
		rcmArray2.push("if( gyos==1 ) MD3=MD2 else MD3=paste(Ms$form[2],Ms$form[1],Ms$form[3],sep=\"\" )\n");
		rcmArray2.push("if( is.na(charmatch(\"Y~1\",MD3))<1 ) MD3=c() else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("kx= summary(lm(MD3,data=dc) )\n");
		rcmArray2.push("coef= round(kx$coef, 4 )\n");
		rcmArray2.push("rownames(coef)[1]=\"(Interc.)\"\n");
		rcmArray2.push("colnames(coef)= mds\n");
		rcmArray2.push("\n");
		rcmArray2.push("Fch=kx$fst[1]; Df1=kx$fst[2]; Df2=kx$fst[3]\n");
		rcmArray2.push("Pch= pf(Fch,Df1,Df2, low=0 )\n");
		rcmArray2.push("rsq= matrix(round(c(kx$r.sq,Fch,Df1,Df2,Pch,kx$adj),4), nr=1 )\n");
		rcmArray2.push("colnames(rsq)= c(\"R^2\",\"Ｆ値\",\"df1\",\"df2\",\"ｐ値\",\"adj_R^2\" )\n");
		rcmArray2.push("rownames(rsq)=\"\"\n");
		rcmArray2.push("} # if(is.na)\n");
		rcmArray2.push("} # if(KOGO & saisu)\n");
		rcmArray2.push("\n");

		// rcmArray2.push("tx7=c(); tx8=c()\n");
		// rcmArray2.push("if( is.null(tx4)<1 ){ if( saisu>1 & ari>0 & nrow(tx4)>2 )\n");
		// rcmArray2.push("{\n");
		// rcmArray2.push(" tx7= matrix(round(summary(lmres(Y~.,data=dx))$coll[ ,1],3), nr=1 )\n");
		// rcmArray2.push(" rownames(tx7)=\"\"\n");
		// rcmArray2.push(" colnames(tx7)= colnames(dx)[2:(saisu+1)]\n");
		// rcmArray2.push("}  }\n");
		// rcmArray2.push("tx8= round(cor(dx), 3 )\n");

		rcmArray2.push("noSL= c()\n");
		rcmArray2.push("if( is.nan(fch)<1 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("noSL= summary(Mful)$coef\n");
		rcmArray2.push("if( saisu>1 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" noSL= cbind(noSL, c(NA,summary(lmres(MDL,data=dt))$coll[,1]) )\n");
		rcmArray2.push(" mds= c(mds, \"VIF\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("noSL= round(noSL, 3 )\n");
		rcmArray2.push("colnames(noSL)= mds\n");
		rcmArray2.push("}\n");
		rcmArray2.push("tx8= round(cor(dx), 3 )\n");
		rcmArray2.push("\n");

		rcmArray2.push("# 結果の書き方\n");
		rcmArray2.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray2.push("txt= c()\n");
		rcmArray2.push("if( kogo==2 & max(nchar(rownames(tx4)[-1]))>7  ) txt=paste(txt, \"※ユーザー作成モデルは二次以上の交互作用を想定していません。モデルを再構築してください。\n\", sep=\"\" ) else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("if( KOGO==1 & saisu>1 ) tmp=\"一次交互作用\" else tmp=\"主効果\"\n");
		rcmArray2.push("txt= paste(\"　各変数の基本統計量をTable(tx1)に示す。\n　変数Ｙを従属変数とし，\",saisu,\"個の変数xを独立変数とした\",tmp,\"モデルを構築し，ステップワイズ増減法による回帰分析を行った。初期モデル\",chartr(\"Y~\",\"Ｙ＝\", chartr(\":\",\"×\",MDL) ),\"について，情報量規準\",JK,\"を用いたモデル選択を行った結果，\", sep=\"\" )\n");
		rcmArray2.push("if( is.nan(fch)==1 ) txt=paste(txt, \"説明力が推定不能となり\", sep=\"\" )\n");
		rcmArray2.push("if( ari==0 ) txt=paste(txt, \"有力なモデルは選出されなかった (Table(tx2)参照)。\n\",sep=\"\") else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("if( nrow(tx2)<2 ) txt=paste(txt, \"初期モデルで停止した。\", sep=\"\" )\n");
		rcmArray2.push("if( max(abs(tx4[,5]))>1 ) txt=paste(txt, \"偏回帰係数に異常値が生じた。回帰分析に適さない変数があり，以下の分析結果は信頼性がない。参考までに分析を進めると (採用不可)，\", sep=\"\" )\n");
		rcmArray2.push("txt= paste(txt, chartr(\"Y~\",\"Ｙ＝\",chartr(\":\",\"×\",tx3)),\"が選出された。モデル選択ステップの要約をTable(tx2)に示す。\", sep=\"\")\n");
		rcmArray2.push("fuki= paste(\" (F(\",df1,\",\",df2,\")=\",round(fch,3),\", p=\",PV(pch),\", f^2=\",round(f2,3),\", 1-β=\",round(pow,3),\", adjusted R^2=\",round(AdjR,3),\")。\", sep=\"\" )\n");
		rcmArray2.push("kaig=\"\n　\"\n");
		rcmArray2.push("if( pch<0.05 ) tmp=\"であった\" else \n");
		rcmArray2.push("if( pch<0.10 ) tmp=\"傾向であった\" else { tmp=\"ではない\"; kaig=\"\n　ただし\" }\n");
		rcmArray2.push("txt= paste(txt, kaig,\"モデル決定係数R^2=\",round(R2,3),\"は有意\",tmp,fuki,sep=\"\")\n");
		rcmArray2.push("tmp=\"小さい\"\n");
		rcmArray2.push("if(f2>0.13) tmp=\"ほぼ中程度\"\n");
		rcmArray2.push("if(f2>0.15) tmp=\"中程度以上\"\n");
		rcmArray2.push("if(f2>0.30) tmp=\"やや大きい\"\n");
		rcmArray2.push("if(f2>0.34) tmp=\"大きい\"\n");
		rcmArray2.push("txt= paste(txt, \"効果量f^2は便宜的基準 (Cohen, 1992) によると\",tmp,\"と評価される。\", sep=\"\" )\n");
		rcmArray2.push("tmp=\"十分である\"\n");
		rcmArray2.push("if( pow<0.80 ) tmp=\"やや低いが許容範囲内といえる\"\n");
		rcmArray2.push("if( pow<0.70 ) tmp=\"不十分であり信頼性が低い\"\n");
		rcmArray2.push("txt= paste(txt, \"検出力 (1-β) は\",tmp,\"。\", sep=\"\" )\n");
		rcmArray2.push("if( pch>0.10 ) txt=paste(txt, \"以下，参考までに分析を進める。\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"\n\n　選出モデルにおける独立変数の偏回帰係数とその検定結果をTable(tx4)に示す。\n　結果として，\", sep=\"\" )\n");
		rcmArray2.push("if( KOGO==1 & kogs==0 ) txt=paste(txt, \"有意な一次の交互作用は見られなかった。\",sep=\"\") else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("if( kogs>0 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("txt= paste(txt, \"一次の交互作用については，\", sep=\"\" )\n");
		rcmArray2.push("for( k in 1:kogs )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("i=xban[(k-1)*2+1]; j=xban[(k-1)*2+2]\n");
		rcmArray2.push("X1=paste(\"x\",saiyo[i],sep=\"\"); X2=paste(\"x\",saiyo[j],sep=\"\" ); sayo=paste(X1,\":\",X2,sep=\"\" )\n");
		rcmArray2.push("stat= tx4[charmatch(sayo,rownames(tx4)), ]\n");
		rcmArray2.push("b= round(stat[1],3)\n");
		rcmArray2.push("if( k==1 ) tmp=\" (Table(tx6)参照 or Figure(x#×x#の交互作用)参照)，偏回帰係数の有意性検定 (α=0.15, 両側検定) によると，\" else tmp=\"，\"\n");
		rcmArray2.push("\n");
		rcmArray2.push("Pch= PV(stat[4] )\n");
		rcmArray2.push("if( Pch>0.05 ) keko=\"傾向\" else keko=\"\"\n");
		rcmArray2.push("fuki= paste(\" (b=\",b,\", t(\",df2,\")=\",round(stat[3],3),\", p=\",Pch,\", β=\",round(stat[5],3),\")。単純傾斜分析の結果\",tmp, sep=\"\" )\n");
		rcmArray2.push("goku=\"が\"\n");
		rcmArray2.push("if( k==1 ) tmp=\"\" else if( k==2 ) tmp=\"\n\n　また，\" else if( k==3 ) tmp=\"\n\n　さらに，\" else { tmp=\"\n\n　\"; goku=\"も\" }\n");
		rcmArray2.push("txt= paste(txt, tmp,chartr(\":\",\"×\",sayo),\"の交互作用\",goku,\"有意\",keko,\"であった\",fuki, sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push(" for( L in 1:4 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("ippo=\"\"; goku=\"における\"\n");
		rcmArray2.push("if( L==3 ){ ippo=\"一方，\"; goku=\"においては\"; tmp=X1;X1=X2;X2=tmp }\n");
		rcmArray2.push("if( L==4 ){ ippo=\"\"; goku=\"における\" }\n");
		rcmArray2.push("stat= tx6[(k-1)*6+L+L%/%3, ]\n");
		rcmArray2.push("b=round(stat[3],3); pch=PV(stat[5])\n");
		rcmArray2.push("if( L%%2==1 ) tmp=\"低水準(-1SD)\" else tmp=\"高水準(+1SD)\"\n");
		rcmArray2.push("txt= paste(txt, ippo,X1,tmp,goku,X2,\"の偏回帰係数が有意\", sep=\"\" )\n");
		rcmArray2.push("fuki= paste(\" (b=\",b,\", t(\",df2,\")=\",round(stat[4],3),\", adjusted p=\",pch,\")\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( pch<0.15 ) # α=0.15\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" tmp=\"であり\"; gok1=\"，\"; dais=c(\"小さ\",0,\"大き\")\n");
		rcmArray2.push(" if( L%%2==1 ) gok2=\"く，これに対して\" else gok2=\"かった。\"\n");
		rcmArray2.push(" txt= paste(txt, tmp,fuki,gok1,X2,\"低水準(-1SD)のＹ推定値\",round(stat[1],3),\"よりも\",X2,\"高水準(+1SD)のＹ推定値\",round(stat[2],3),\"が有意に\",dais[sign(b)+2],gok2, sep=\"\" )\n");
		rcmArray2.push("} else {\n");
		rcmArray2.push(" if( L%%2==1 ){ gok1=\"でなく\"; gok2=\"，\" } else { gok1=\"でなかった\"; gok2=\"。\" }\n");
		rcmArray2.push(" txt= paste(txt, gok1,fuki,gok2, sep=\"\" )\n");
		rcmArray2.push("} # if(pch)\n");
		rcmArray2.push("\n");
		rcmArray2.push("} # for(L)\n");
		rcmArray2.push("} # for(k)\n");
		rcmArray2.push(" txt= paste(txt,\"\n\",sep=\"\" )\n");
		rcmArray2.push("} # if(kogs)\n");
		rcmArray2.push("} # if(KOGO & kogs)\n");
		rcmArray2.push("} # if(ari)\n");
		rcmArray2.push("\n");
		rcmArray2.push("sumi=0; yosh=0; mae=9\n");
		rcmArray2.push("for( i in 1:saisu )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("if( is.na(charmatch(i,xban))==1 & ari>0 )  # 主効果，生き\n");
		rcmArray2.push("{\n");
		rcmArray2.push("X= paste(\"x\",saiyo[i],sep=\"\")\n");
		rcmArray2.push("gyo= charmatch(X, rownames(tx4) )\n");
		rcmArray2.push("if( is.na(gyo)<1 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("sumi= sumi+1\n");
		rcmArray2.push("stat=tx4[gyo, ]; pch=PV(stat[4])\n");
		rcmArray2.push("tmp=\"\"\n");
		rcmArray2.push("if( kogs<1 ) kaig=\"\" else { kaig=\"\n　\"; tmp=\"選出モデルにおける\" }\n");
		rcmArray2.push("if( sumi==1 ) txt=paste(txt, kaig,tmp,\"主効果については，\", sep=\"\" )\n");
		rcmArray2.push("if( sumi==2 & yosh==1 ) mata=\"また，\" else mata=\"\"\n");
		rcmArray2.push("fuki= paste(\" (b=\",round(stat[1],3),\", t(\",df2,\")=\",round(stat[3],3),\", p=\",pch,\", β=\",round(stat[5],3),\")\", sep=\"\" )\n");
		rcmArray2.push("if( pch<0.10 )\n");
		rcmArray2.push(" {\n");
		rcmArray2.push("  keko=\"傾向\"; if( pch<0.05 ) keko=\"\"\n");
		rcmArray2.push("  goku=c(\"減少\",0,\"増加\")\n");
		rcmArray2.push("  tmp= paste(\"であり\",fuki,\"，\",X,\"が増加すると有意にＹが\",goku[sign(stat[1])+2],\"することが見いだされた。\", sep=\"\" )\n");
		rcmArray2.push("  yosh= 1\n");
		rcmArray2.push(" } else {\n");
		rcmArray2.push("  keko=\"\"\n");
		rcmArray2.push("  tmp= paste(\"でなかった\",fuki,\"。\", sep=\"\" )\n");
		rcmArray2.push("  yosh= 0\n");
		rcmArray2.push(" }\n");
		rcmArray2.push("if( yosh==mae ) moga=\"も\" else moga=\"が\"\n");
		rcmArray2.push("txt= paste(txt, mata,X,\"の偏回帰係数\",moga,\"有意\",keko,tmp, sep=\"\" )\n");
		rcmArray2.push("mae= yosh\n");
		rcmArray2.push("} # if(is.na)\n");
		rcmArray2.push("} # if(is.na)\n");
		rcmArray2.push("} # for(i)\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( is.null(tx4)<1 ){ if( saisu>1 & ari>0 & nrow(tx4)>2 )\n");
		rcmArray2.push("{\n");
		// rcmArray2.push(" txt= paste(txt, \"\n　多重共線性について各変数のVIF (分散拡大要因) を算出した結果 (Table(tx7)参照)，\", sep=\"\" )\n");
		rcmArray2.push(" txt= paste(txt, \"\n　多重共線性について各変数のVIF (分散拡大要因) を算出した結果 (Table(noSL)参照)，\", sep=\"\" )\n");
		// rcmArray2.push(" VIF= max(tx7)\n");
		rcmArray2.push(" VIF= max(noSL[,5], na.rm=1 )\n");
		rcmArray2.push(" if(VIF>10) tmp=\"危険であり，独立変数間に強い相関が見られる\" else\n");
		rcmArray2.push(" if(VIF> 5) tmp=\"やや危険であり，独立変数間の相関に注意する必要がある\" else\n");
		rcmArray2.push(" if(VIF> 2) tmp=\"独立変数間の相関は許容範囲内と判断される\" else tmp=\"特に危険はないと判断された\"\n");
		rcmArray2.push(" txt= paste(txt, tmp,\" (VIFs<\",PV(VIF),\")。\", sep=\"\" )\n");
		rcmArray2.push("}  }\n");
		rcmArray2.push("if(taju==\"BH\") TAJ=\"Benjamini & Hochberg (1995) の方\" else if(taju==\"b\") TAJ=\"Bonferroni\" else TAJ=\"Holm\"\n");
		rcmArray2.push("if( kogs>0 ) txt=paste(txt, \"\n　なお，以上の分析におけるｐ値の調整には\",TAJ,\"法を用いた。\", sep=\"\" )\n");
		rcmArray2.push("if( ari>0 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("txt= paste(txt, \"\n\n［引用文献］\n\", sep=\"\" )\n");
		rcmArray2.push("if( kogs>0 & taju==\"BH\" ) txt=paste(txt, \"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
		rcmArray2.push("if( is.null(tx5)<1 ) txt= paste(txt,\"Cohen, J. (1992). A power primer. Psychological Bulletin, 112, 155-159.\n\", sep=\"\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("if( KOGO==1 & saisu>2 & saisu<9 & sum(is.nan(rsq))==0 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" txt= paste(txt,\"\n\n⇒なお，二次の交互作用を仮定し分析を試み\",sep=\"\" )\n");
		rcmArray2.push(" kos= 0\n");
		rcmArray2.push(" if( is.null(MD3)<1 ) for( gyo in 2:nrow(coef) ) if( nchar(rownames(coef)[gyo])>7 & coef[gyo,4]<0.05 ) kos=kos+1\n");
		rcmArray2.push(" if( kos>0 ) txt=paste(txt, \"たところ，二次交互作用は\",kos,\"個選出可能でした (\",JK,\"による)。\n　オプションの『二次モデリング』を参照してください。\n\", sep=\"\") else \n");
		rcmArray2.push(" txt=paste(txt, \"ましたが，二次の交互作用は検出されませんでした。上記の分析結果が妥当であると考えられます。\n\", sep=\"\")\n");
		rcmArray2.push("}\n");

		// rcmArray2.push("noSL= c()\n");
		// rcmArray2.push("if( is.nan(fch)<1 )\n");
		// rcmArray2.push("{\n");
		// rcmArray2.push("noSL= summary(Mful)$coef\n");
		// rcmArray2.push("if( saisu>1 )\n");
		// rcmArray2.push("{\n");
		// rcmArray2.push(" noSL= cbind(noSL, c(NA,summary(lmres(MDL,data=dt))$coll[,1]) )\n");
		// rcmArray2.push(" mds= c(mds, \"VIF\" )\n");
		// rcmArray2.push("}\n");
		// rcmArray2.push("noSL= round(noSL, 3 )\n");
		// rcmArray2.push("colnames(noSL)= mds\n");
		// rcmArray2.push("}\n");

		rcmArray2.push("H=matrix(0,nr=1)\n");
		rcmArray2.push("rownames(H)=\"\"\n");
		rcmArray2.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
		rcmArray2.push("MD2= paste(MD2,\"\n\n\")\n");
		rcmArray2.push("}\n");
		rcmArray2.push("\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("############################\n");
		rcmArray2.push("#   回帰分析：\n");
		rcmArray2.push("#   一般化線形モデリング\n");
		rcmArray2.push("#\n");
		rcmArray2.push("#   ステップワイズ増減法\n");
		rcmArray2.push("H###########################\n");
		rcmArray2.push("tx1 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray2.push("\n");
		rcmArray2.push("MDL # 初期モデル\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx2 # 選択ステップの要約\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx3 # 選出モデル\n");
		rcmArray2.push("# ■ Y~ 1 のとき選出モデルなし（→終了）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx5 # モデルR^2(決定係数)の検定\n");
		rcmArray2.push("# 効果量f^2の評価：大=0.35,中=0.15,小=0.02\n");
		rcmArray2.push("# ■NaN は推定不能\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx4 # 偏回帰係数の検定\n");
		rcmArray2.push("# 標準化偏回帰係数(β)= 偏回帰係数/SDy*SDx\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx6 # 単純傾斜分析(両側検定,α=0.15推奨)\n");
		rcmArray2.push("\n");
		// rcmArray2.push("tx7 # VIF（分散拡大要因）\n");
		rcmArray2.push("noSL # 初期モデルの偏回帰係数と分散拡大要因(VIF)\n");

		rcmArray2.push("# VIF<2（良好）, VIF<5（許容）, VIF>10（危険）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx8 # 相関行列\n");
		rcmArray2.push("\n");
		rcmArray2.push("cat(txt) # 結果の書き方\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");

		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("# windows();par(mfrow=c(2,2));plot(Msel,1:4)#回帰診断\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("# quartz();par(mfrow=c(2,2));plot(Msel,1:4)#回帰診断\n");
		}

		rcmArray2.push("# library(psych);describe(dx)      # 尖度,歪度ほか\n");

		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("# windows();scatterplotMatrix(dx)  # 散布図\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("# quartz();scatterplotMatrix(dx)  # 散布図\n");
		}
		rcmArray2.push("# cat(MD2);coef;rsq # 二次の交互作用モデルの分析結果\n");
		// rcmArray2.push("# noSL # 初期モデルの偏回帰係数と分散拡大要因(VIF)\n");
		rcmArray2.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
function changeRegSetting() {
	var h = 2;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");

	// htmArray.push("<ul class=\"menubutton1\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"cellAreaScroll('reg');return false;\"><span id=\"cellAreaScrollBtn\">△短縮</a></span></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	htmArray.push("<table border=\"0\" class=\"codetb2\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeRegTableBranch();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeRegTableBranch();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 10; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"10\" selected>10</option>");
		for (h = 11; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}

		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">独立変数 x の数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	if (thisBrowser.indexOf('ie') == -1) {
		// EV_numver  Explanatory Variable 独立変数
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"EV_number\" size=\"10\" min=\"1\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeRegTableBranch();\">");
	} else {
		htmArray.push("<select id=\"EV_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'独立変数の項目数');changeRegTableBranch();\">");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("reg_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeRegTableBranch();
}
function changeRegTableBranch() {
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 独立変数

	if ((NN >= 10) || (LA + 1 >= 8)) {
		changeRegTable_scroll();
	} else {
		changeRegTable_all();
	}
}
function changeRegTable_all() {
	var i = 0;
	var j = 0;
	var k = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 独立変数
	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	if (LA + 1 >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"cellScroll\" class=\"cellScrolloff\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Y");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		if (LA + 1 < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("x" + (i + 1));
		}
		htmArray.push("</td>");
	}

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_3d\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA + 1; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");

			htmArray.push("</td>");
			cellId++;
		}
	}
	htmArray.push("</table>");
	htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// // htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell5_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("reg_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function changeRegTable_scroll() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 独立変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	if (LA + 1 >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"tb_scroll_main\" class=\"tb_scroll_main\">");

	htmArray.push("<div id=\"divt0\" class=\"divtitle1\">");
	htmArray.push("<div id=\"div1\" class=\"div1\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku01\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_fact_title1\">参加者</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("<div id=\"div2\" class=\"div2\" onscroll=\"div2_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");
	htmArray.push("<tr>");

	htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
	if (LA + 1 < 8) {
		htmArray.push("<div>Y</div>");
	} else {
		htmArray.push("<div style=\"width: 41px;\">Y</div>");
	}
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		if (LA + 1 < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("<div style=\"width: 41px;\">x" + (i + 1) + "</div>");
		}
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"divt1\" class=\"divtitle2\">");
	htmArray.push("<div id=\"div3\" class=\"div3_fixed\" onscroll=\"div3_onscroll();\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_fact_title3\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"div4\" class=\"div4_fixed\" onscroll=\"div4_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		for (i = 0; i < LA + 1; i++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("</div>"); //tb_scroll_main

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("reg_table").innerHTML = htmArray.join("");
	htmArray = null;
	document.getElementById('cellAreaScrollBtn').innerHTML = '▽全体';

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function inputKOGO() {
	var KOGO = parseInt(document.getElementById("KOGO").value);
	if (KOGO === 2) {
		var i = 0;
		var j = 0;
		var k = 0;

		var NN = parseInt(document.getElementById("subjNum").value);
		var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 観測変数

		var htmArray = [];
		var cellId = 1;
		var cellCount = NN * (LA + 1);

		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<div id=\"reg_x" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputFormula(event);\">x" + (LACount + 1) + "</div>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");

		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");

		// htmArray.push("<tr>");
		// for (i = 0; i < 10; i++) {
		// 	htmArray.push("<td class=\"hyou_midashi_NF_title\">");
		// 	htmArray.push("<div id=\"degi" + (i + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputFormula(event);\">" + i + "</div>");
		// 	htmArray.push("</td>");
		// }
		// htmArray.push("</tr>");

		var calc = ["+", ":", "", "", "", "", "", "", ""];
		htmArray.push("<tr>");
		for (i = 0; i < 9; i++) {
			htmArray.push("<td class=\"hyou_midashi_NF_title\">");
			htmArray.push("<div id=\"calc" + (i + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputFormula(event);\">" + calc[i] + "</div>");
			htmArray.push("</td>");
		}
		htmArray.push("<td class=\"hyou_midashi_NF_title\">");
		htmArray.push("<div id=\"calc" + (i + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"delFormula(event);\">Del</div>");
		htmArray.push("</td>");

		htmArray.push("</tr>");
		htmArray.push("</table>");

		htmArray.push("<div class=\"\" name=\"formula\">");
		// htmArray.push("<div class=\"ME_formula\" name=\"formula\">");
		htmArray.push("<span id=\"del_Formula_mark\" class=\"delFormula\" onclick=\"delFormulaAll();\" onmouseover=\"delFormulaOver(this);\" onmouseout=\"delFormulaOut(this);\">×</span>");
		htmArray.push("<span class=\"me_f\"> Y　~　</span>");
		htmArray.push("<input type=\"text\" class=\"me_0\" id=\"KOGO_model\" name=\"KOGO_model\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\">");
		htmArray.push("<div>");

		document.getElementById("reg_x").innerHTML = htmArray.join("");
		htmArray = null;
	} else {
		removeRegX();
	}
}
function removeRegX() {
	var parent_object = document.getElementById("reg_x");
	if (document.getElementById("reg_x1") !== null) {
		for (var i = 0; i < 2; i++) {
			parent_object.removeChild(reg_x.lastChild);
		}
	}
}
// ドラッグ時のハンドラ
function dragHandler(event) {
	// ドラッグ元のテキストをDataTransferオブジェクトに保持
	var orgText = event.target.innerHTML;
	event.dataTransfer.setData("text", orgText);
}
function dragoverHandler(event) {
	event.preventDefault();
	event.target.style.border = "solid 3px #ffaaaa";
}
function dragleaveHandler(event) {
	event.preventDefault();
	event.target.style.border = "solid 1px #999999";
}
// ドロップ時のハンドラ
function dropPlusHandler0(event) {
	var i;
	var dd = [];
	var outputText = "";
	var addTextFlag = false;

	// デフォルト処理のキャンセル
	event.preventDefault();

	var addText = event.dataTransfer.getData("text");
	var orgText = event.target.value;
	// if (addText === "Del") addText = "";
	event.target.value = orgText + addText;

	event.target.style.border = "solid 1px #999999";
}
// ドロップ時のハンドラ
function dropPlusHandler(event) {

	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var i;
	var dd = [];
	var outputText = "";
	var addTextFlag = false;

	// デフォルト処理のキャンセル
	event.preventDefault();

	var addText = event.dataTransfer.getData("text");
	var orgText = event.target.value;
	orgText = orgText.replace(/\s+/g, "");
	orgText = orgText.replace(/\+\+*/g, "+");
	if (orgText.slice(0, 1) == "+") {
		orgText = orgText.slice(1);
	}
	dd = orgText.split("+");

	for (i = 0; i < dd.length; i++) {
		outputText += "+" + dd[i];
	}
	if (key_shift) {
		outputText += "+" + addText;
	} else {
		outputText += addText;
	}
	if (addText === "Del") {
		outputText = "";
	}
	//複数の＋を１つに
	outputText = outputText.replace(/\+\+*/g, "+");
	//先頭の＋を削除
	if (outputText.slice(0, 1) == "+") {
		outputText = outputText.slice(1);
	}
	//先頭の:を削除
	if (outputText.slice(0, 1) == ":") {
		outputText = outputText.slice(1);
	}
	// //末尾の＋を削除
	// if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
	// 	outputText = outputText.slice(0, outputText.length - 1);
	// }
	outputText = outputText.replace(/\+/g, " + ");
	event.target.value = outputText;

	event.target.style.border = "solid 1px #999999";
}
function changeCursol(obj) {
	obj.style.cursor = "default";
}
function inputFormula(event) {
	//イベント処理
	var key_event = event || window.event; //Firefox IE用

	// var key_ctrl = (key_event.ctrlKey);
	var key_shift = (key_event.shiftKey);
	// var key_meta = (key_event.metaKey);

	var orgText = event.target.innerHTML;

	var outputText = "";
	if (key_shift) {
		outputText = document.getElementById("KOGO_model").value + "+" + orgText;
	} else {
		outputText = document.getElementById("KOGO_model").value + orgText;
	}

	//スペースを削除
	outputText = outputText.replace(/\s+/g, "");
	//複数の＋を１つに
	outputText = outputText.replace(/\+\+*/g, "+");
	//先頭の＋を削除
	if (outputText.slice(0, 1) == "+") {
		outputText = outputText.slice(1);
	}
	//末尾の＋を削除
	// if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
	// 	outputText = outputText.slice(0, outputText.length - 1);
	// }
	outputText = outputText.replace(/\+/g, " + ");

	document.getElementById("KOGO_model").value = outputText;
	// }
}
function delFormula(event) {
	//イベント処理
	// var key_event = event || window.event; //Firefox IE用

	// var key_ctrl = (key_event.ctrlKey);
	// var key_shift = (key_event.shiftKey);
	// var key_meta = (key_event.metaKey);

	var outputText = "";
	var wStr = "";

	if (document.getElementById("KOGO_model").value != null) { //ME部分の入力
		wStr = document.getElementById("KOGO_model").value;
		outputText = wStr.substring(0, wStr.length - 1);
		document.getElementById("KOGO_model").value = outputText;
	}
}
function delFormulaAll() {
	document.getElementById("KOGO_model").value = "";
}
function delFormulaOver(obj) {
	obj.style.color = "#666666";
}
function delFormulaOut(obj) {
	obj.style.color = "#cccccc";
}
function simulation_Reg(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 独立変数


	var min, max;
	if ((NN === 10) && (LA === 4)) {
		min = 10;
		max = 50;
		NN = Math.floor(Math.random() * (max - min + 1) + min);

		min = 5;
		max = 7;
		LA = Math.floor(Math.random() * (max - min + 1) + min);

		document.getElementById("subjNum").value = NN;
		document.getElementById("EV_number").value = LA;
		changeRegTable_scroll();
	}

	var result = "rnd1:9*" + NN + "+rnd1:5*" + NN + "*" + LA;

	document.getElementById("CandPArea").value = random_number_generation(result);

	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);

	mainCalc_reg();
}
function saveData_Reg() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);

	//#0
	strArray.push("REG" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#3
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + 1; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "REG_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_REG() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "REG") {
		var NN = crDel(dd[1]);
		var LA = crDel(dd[2]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("EV_number").value = parseInt(LA, 10);
		changeRegTableBranch();

		document.getElementById("CandPArea").value = delTopCR(dd[3]);
	}

}