/**
 * 分散分析
 * Ｑ検定（３水準以上の対応データ）
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeSaSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
function pValue_Qtest(Q, DF) {
	//.05<p<.10 有意傾向
	var P1 = new Array("2.706", "4.605", "6.251", "7.779", "9.236", "10.645", "12.017", "13.362", "14.684", "15.987", "17.275", "18.549", "19.812", "21.064", "22.307", "23.542", "24.769", "25.989", "27.204", "28.412", "29.615", "30.813", "32.007", "33.196", "34.382", "35.563", "36.741", "37.916", "39.088", "40.256", "51.805", "63.167", "74.397");
	//p<.05 ５％水準
	var P2 = new Array("3.841", "5.991", "7.815", "9.488", "11.071", "12.592", "14.067", "15.507", "16.919", "18.307", "19.675", "21.026", "22.362", "23.685", "24.996", "26.296", "27.587", "28.869", "30.144", "31.410", "32.671", "33.924", "35.173", "36.415", "37.653", "38.885", "40.113", "41.337", "42.557", "43.773", "55.759", "67.505", "79.082");
	//p<.01 １％水準
	var P3 = new Array("6.635", "9.210", "11.345", "13.277", "15.086", "16.812", "18.475", "20.090", "21.666", "23.209", "24.725", "26.217", "27.688", "29.141", "30.578", "32.000", "33.409", "34.805", "36.191", "37.566", "38.932", "40.289", "41.638", "42.980", "44.314", "45.642", "46.963", "48.278", "49.588", "50.892", "63.691", "76.154", "88.379");

	var wP1, wP2, wP3;
	var wDF = DF; //自由度
	var wx2 = Q; //Q値

	if (wDF < 30) {
		wP1 = P1[DF - 1];
		wP2 = P2[DF - 1];
		wP3 = P3[DF - 1];
	} else if (wDF < 40) {
		wP1 = P1[29];
		wP2 = P2[29];
		wP3 = P3[29];
	} else if (wDF < 50) {
		wP1 = P1[30];
		wP2 = P2[30];
		wP3 = P3[30];
	} else if (wDF < 60) {
		wP1 = P1[31];
		wP2 = P2[31];
		wP3 = P3[31];
	} else if (wDF >= 60) {
		wP1 = P1[32];
		wP2 = P2[32];
		wP3 = P3[32];
	}

	var ppStr = "";
	if (wx2 > wP3) {
		ppStr = "p<.01";
	} else if (wx2 > wP2) {
		ppStr = "p<.05";
	} else if (wx2 > wP1) {
		ppStr = ".05<p<.10";
	} else {
		ppStr = "ns";
	}

	return ppStr;
}
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_Qtest();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_Qtest() {
	var i = 0;
	var j = 0;
	var NN = 2;
	var AA = "A";
	var LA = 3;

	NN = parseInt(document.getElementById("subjNum").value, 10);
	AA = document.getElementById("factorA_name").value;
	LA = parseInt(document.getElementById("factorA_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = NN;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	var temp;
	if (document.getElementById("CandPArea").value === "") {
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				// xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
				temp = parseInt(document.getElementById("cell_" + cellId).value, 10);
				// 0以下ならば0，そうでなければ1
				if (temp <= 0) {
					temp = 0;
				} else {
					temp = 1;
				}
				xx[i][j] = temp;
				cellId++;
			}
		}
	} else {
		var DData = document.getElementById("CandPArea").value;
		var dd = [];
		dd = DData.split(" ");

		var ddCount = 0;
		for (j = 0; j < NN; j++) {
			for (i = 0; i < LA; i++) {
				temp = parseInt(dd[ddCount], 10);
				// xx[i][j] = parseFloat(dd[ddCount]);
				// 0以下ならば0，そうでなければ1
				if (temp <= 0) {
					temp = 0;
				} else {
					temp = 1;
				}
				xx[i][j] = temp;
				ddCount++;
			}
		}
	}

	var strArray = [];
	var bar = "------------------------------------------------\n";

	var G = [];
	var L = [];

	for (i = 0; i < LA; i++) {
		G[i] = 0;
		for (j = 0; j < NN; j++) {
			G[i] += xx[i][j];
		}
	}
	for (j = 0; j < NN; j++) {
		L[j] = 0;
		for (i = 0; i < LA; i++) {
			L[j] += xx[i][j];
		}
	}

	// 1と0の割合
	var ratio_1 = [];
	var ratio_0 = [];
	for (i = 0; i < LA; i++) {
		ratio_1[i] = G[i] / NN;
		ratio_0[i] = 1 - ratio_1[i];
	}

	var gg = 0;
	var ggg = 0;
	for (i = 0; i < LA; i++) {
		gg += G[i];
		ggg += Math.pow(G[i], 2);
	}
	var ll = 0, lll = 0;
	for (j = 0; j < NN; j++) {
		ll += L[j];
		lll += Math.pow(L[j], 2);
	}

	var Q = (LA - 1) * (LA * ggg - Math.pow(gg, 2)) / (LA * ll - lll);
	var DF = LA - 1;

	var ppStr = pValue_Qtest(Q, DF);

	strArray.push("[Q-Test]\n\n");

	var _str;
	strArray.push("  %");
	for (i = 0; i < LA; i++) {
		_str = "水準" + (i + 1);
		strArray.push("     " + _str);
	}
	strArray.push("\n");
	strArray.push("-----------------------------------------\n");

	strArray.push("  0\t");
	for (i = 0; i < LA; i++) {
		strArray.push(ratio_0[i].toFixed(3) + "\t");
	}
	strArray.push("\n");
	strArray.push("  1\t");
	for (i = 0; i < LA; i++) {
		strArray.push(ratio_1[i].toFixed(3) + "\t");
	}
	strArray.push("\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("x2(" + DF + ")=" + using(Q, 3, 3) + "  " + ppStr + "\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	document.getElementById("RltArea").focus();
}
// 要因Aの水準数セレクトのid subjNum
// 要因Aの名前 1行テキストボックスのid factorA_name
// 要因Aの水準数1行テキストボックスのid factorA_number
function changeSaSetting() {
	var h = 3;
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSaTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因名：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");

	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	//通常のsAの場合は 2 だが，Q検定の場合は 3 以上
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" maxlength=\"10\"  min=\"3\" value=\"3\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'水準数');changeSaTable();\">");
		htmArray.push("<option value=\"3\" selected>3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("sa_setting").innerHTML = htmArray.join("");
	htmArray = null;
	changeSaTable();
}
function changeSaTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	// freqdata3を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");
	// htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("sa_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_sA() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);

	//#0
	strArray.push("sA" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#3
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#4
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sA_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sA() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sA") {
		var NN = crDel(dd[1]);
		var AA = crDel(dd[2]);
		var LA = crDel(dd[3]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		changeSaTable();
		document.getElementById("CandPArea").value = delTopCR(dd[4]);
	}
}

