/**
 * ｔ検定
 * Ts(参加者間)
 *
 *
 *
 */
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

    //フォームを作成
    changeTsSetting();
    // ChangeAsInput(0);

    // デフォルトのタブを選択
    ChangeTab(1, 4);

    //コピペエリアにドラッグ＆ドロップを設定
    setDragAndDrop();

    document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
    var i = 0;
    var LA = 2;
    var NN = [];
    for (i = 0; i < LA; i++) {
        NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
    }

    var elmCount = 0;
    for (i = 0; i < LA; i++) {
        elmCount += NN[i];
    }

    var result = confirm("データを消去します");
    if (result === true) {

        // Asには要因名があるが，Tsにはない
        // document.getElementById("factorA_name").value = "A";

        for (i = 0; i < elmCount; i++) {
            document.getElementById("cell_" + (i + 1)).value = "";
        }
        errorClearCell(elmCount, "");

        document.getElementById("CandPArea").value = "";
        inputTextArea(document.getElementById("CandPArea"), 0);
        inputBtnTextClear(document.getElementById("inputBtn1"));
    }
    document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
    var i = 0;

    var LA = 2;
    var NN = [];

    var elmCount = 0;
    for (i = 0; i < LA; i++) {
        NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
        elmCount += NN[i];
    }

    var errorCellNum = 0;

    if (document.getElementById("CandPArea").value === "") {
        errorClearCell(elmCount, "");
        errorCell(elmCount, "");

        for (i = 0; i < elmCount; i++) {
            if (document.getElementById("cell_" + (i + 1)).value === "") {
                errorCellNum = i + 1;
            }
        }
        if (errorCellNum === 0) {
            errorClearCell(elmCount, "");
            mainCalc_Utest();
        } else {
            alert("すべての数値が入力されていません (^_^)ゞ");
            document.getElementById("cell_" + errorCellNum).focus();
        }
    } else {
        var DData = dataremake5("CandPArea");
        DData = crDel(DData);
        var dd = [];
        dd = DData.split(" ");

        if (elmCount != dd.length) {
            alert("データ数が一致しません");
        } else {
            copipe("CandPArea", "text");
            inputTextArea(document.getElementById("CandPArea"), 0);
            inputBtnTextClear(document.getElementById("inputBtn1"));
            checkCellData();
        }
    }
}
// メイン計算
function mainCalc_Utest() {
    var i = 0;
    var j = 0;
    var ii = 0;

    var LA = 2;
    var NN = [];

    var NX = 0;
    for (i = 0; i < LA; i++) {
        NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
        if (NX < NN[i]) NX = NN[i];
    }

    var xx = new Array(LA);
    for (i = 0; i < LA; i++) {
        xx[i] = new Array(NX);
    }

    var a = [[], []];
    var cellId = 1;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < NN[i]; j++) {
            xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
            cellId++;
            a[i].push(xx[i][j]);
        }
    }

    //平均，標準偏差
    var M = [];
    var SD = [];

    var S = 0;
    var SS = 0;
    for (i = 0; i < LA; i++) {
        S = 0;
        SS = 0;
        for (j = 0; j < NN[i]; j++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);
        }
        M[i] = S / NN[i];
        SD[i] = Math.sqrt(SS / NN[i] - Math.pow(M[i], 2));

        M[i] = parseFloat(M[i].toFixed(2));
        SD[i] = parseFloat(SD[i].toFixed(2));
    }

    //最大値，最小値
    var MAX = [];
    var MIN = [];
    for (i = 0; i < LA; i++) {
        MAX[i] = xx[i][0];
        MIN[i] = xx[i][0];
        for (j = 0; j < NN[i]; j++) {
            if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
            if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
        }
    }

    var N = [0, 0];
    N[0] = a[0].length;
    N[1] = a[1].length;

    var addedArray = a[0].concat(a[1]);

    var sortedArray = addedArray.sort(compareNumbers);
    var rankedArray = [];
    for (i = 0; i < sortedArray.length; i++) {
        rankedArray[i] = i + 1;
    }

    for (i = 1; i < sortedArray.length; i++) {
        if (sortedArray[i] === sortedArray[i - 1]) {
            rankedArray[i] = rankedArray[i - 1];
        }
    }

    var countedArray = [];
    for (i = 0; i < rankedArray.length; i++) {
        countedArray[i] = 0;
        for (j = 0; j < rankedArray.length; j++) {
            if (rankedArray[i] === rankedArray[j]) {
                countedArray[i]++;
            }
        }
    }

    var rerankedArray = [];
    for (i = 0; i < rankedArray.length; i++) {
        rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
    }

    var trankedArray = [[], []];
    for (i = 0; i < sortedArray.length; i++) {
        for (var j1 = 0; j1 < a[0].length; j1++) {
            if (sortedArray[i] === a[0][j1]) {
                trankedArray[0][j1] = rerankedArray[i];
            }
        }
        for (var j2 = 0; j2 < a[1].length; j2++) {
            if (sortedArray[i] === a[1][j2]) {
                trankedArray[1][j2] = rerankedArray[i];
            }
        }
    }

    var R = [0, 0];
    for (j = 0; j < 2; j++) {
        for (i = 0; i < trankedArray[j].length; i++) {
            R[j] = R[j] + trankedArray[j][i];
        }
    }

    var U1 = 0;
    var U2 = 0;
    U1 = N[0] * N[1] + (N[0] * (N[0] + 1) / 2) - R[0];
    U2 = N[0] * N[1] - U1;

    var U = U1;
    if (U1 > U2) U = U2;

    var uM = N[0] * N[1] / 2;
    var uSD = Math.sqrt(N[0] * N[1] * (N[0] + N[1] + 1) / 12);
    var z = parseFloat(Math.abs((U - uM) / uSD).toFixed(2));

    var strArray = [];
    strArray.push("[マン・ホイットニーU検定]\n\n");
    strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
    strArray.push("         N      Mean      S.D.       MAX       MIN\n");
    strArray.push("------------------------------------------------------\n");
    strArray.push(('群１' + N[0].format(" ", 6) + M[0].format(" ", 10) + SD[0].format(" ", 10) + MAX[0].format(" ", 10) + MIN[0].format(" ", 10) + "\n"));
    strArray.push(('群２' + N[1].format(" ", 6) + M[1].format(" ", 10) + SD[1].format(" ", 10) + MAX[1].format(" ", 10) + MIN[1].format(" ", 10) + "\n"));
    strArray.push("------------------------------------------------------\n\n");

    var ppStr = "";
    var PP2 = 0;
    if (N[0] <= 20 && N[1] <= 20) {
        strArray.push('         N    平均順位    統計量U\n');
        strArray.push("-----------------------------------------\n");
        strArray.push('群１' + N[0].format(" ", 6) + R[0].format(" ", 10) + U1.format(" ", 10) + '\n');
        strArray.push('群２' + N[1].format(" ", 6) + R[1].format(" ", 10) + U2.format(" ", 10) + '\n');
        strArray.push("-----------------------------------------\n");
        strArray.push('統計量U  ：' + U.format(" ", 6) + '\n');

        PP2 = U_tables(N[0], N[1], U);
        if (PP2 === 9) {
            strArray.push("データ数が少ないため，計算できません\n");
        } else {
            if (PP2 === 0.01) {
                ppStr = "   ** (p<.01)";
            }
            if (PP2 === 0.05) {
                ppStr = "   *  (p<.05)";
            }
            if (PP2 === 1) {
                ppStr = "   ns (.10<p)";
            }
            strArray.push("両側検定  :" + ppStr + "\n");
        }
    } else {
        var wSD = parseFloat(uSD.toFixed(2));
        strArray.push('平均E(U)  分散V(U)   統計量U    統計量z\n');
        strArray.push("-----------------------------------------\n");
        strArray.push(uM.format(" ", 8) + wSD.format(" ", 10) + U.format(" ", 10) + z.format(" ", 10) + '\n');
        strArray.push("-----------------------------------------\n");

        PP2 = z_tables(z);
        if (PP2 < 0.01) {
            ppStr = "   ** (p<.01)";
        } else if (PP2 < 0.05) {
            ppStr = "   *  (p<.05)";
        } else if (PP2 < 0.10) {
            ppStr = "   +  (.05<p<.10)";
        } else {
            ppStr = "   ns (.10<p)";
        }
        strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
    }

    strArray.push("-----------------------------------------\n");
    strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

    // //出力
    document.getElementById("RltArea").value = strArray.join("");

    strArray = null;

    document.getElementById("RltArea").focus();
}
function changeTsSetting() {
    var h = 3;
    var htmArray = [];

    // htmArray.push("<div class=\"btnlayout\">");
    // htmArray.push("<ul class=\"menubutton\">");
    // htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
    // htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
    // htmArray.push("</ul>");
    // htmArray.push("</div>");

    // freqdata2を使うか要検討 todo
    // htmArray.push("<div class=\"freqdata2\">");
    htmArray.push("<div class=\"tateyoko\">");
    htmArray.push("<table border=\"0\" class=\"codetb\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">群1 参加者数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"A1_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeTsTable();\">");
    } else {
        htmArray.push("<select id=\"A1_subjNum\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'群１：参加者数');changeTsTable();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        for (h = 3; h < 31; h++) {
            htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
        }
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");

    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">群2 参加者数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"A2_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeTsTable();\">");
    } else {
        htmArray.push("<select id=\"A2_subjNum\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'群２：参加者数');changeTsTable();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        for (h = 3; h < 31; h++) {
            htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
        }
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");
    htmArray.push("</table>");
    htmArray.push("</div>");

    document.getElementById("ts_setting").innerHTML = htmArray.join("");
    htmArray = null;

    changeTsTable();
}
function changeTsTable() {
    var i = 0;
    var j = 0;
    var LA = 2;
    var NN = [];

    var cellCount = 0;
    for (i = 0; i < LA; i++) {
        NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
        cellCount += NN[i];
    }

    var htmArray = [];
    var cellId = 1;
    var sCount = 1;

    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("群");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("参加者");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("データ");
    htmArray.push("</td>");
    htmArray.push("</tr>");

    for (i = 0; i < LA; i++) {
        htmArray.push("<tr>");
        htmArray.push("<td ROWSPAN=\"" + NN[i] + "\" class=\"hyou_midashi_3d_title\">");
        htmArray.push("群" + (i + 1));
        htmArray.push("</td>");

        for (j = 0; j < NN[i]; j++) {
            if (j === 0) {
                htmArray.push("<td class=\"hyou_midashi_3d_top\">");
            } else {
                htmArray.push("<td class=\"hyou_midashi_3d\">");
            }
            htmArray.push(sCount);
            htmArray.push("</td>");
            htmArray.push("<td class=\"hyou_nyuryoku\">");
            htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
            htmArray.push("</td>");
            htmArray.push("</tr>");
            cellId++;
            sCount++;
        }
    }

    htmArray.push("</table>");

    // htmArray.push("<div class=\"btnlayout4\">");
    // htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
    // htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
    // htmArray.push("</div>");

    document.getElementById("ts_table").innerHTML = htmArray.join("");
    htmArray = null;

    //ドラッグドロップエリアを書き換えているので再セットする
    // setDragAndDrop();
}
function saveData_Ts() {
    var i, j;

    var strArray = [];

    var LA = 2;
    var NN = [];
    for (i = 0; i < LA; i++) {
        NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
    }

    //#0
    strArray.push("Ts" + "\n");
    //#1
    strArray.push("#" + "\n");
    for (i = 0; i < LA; i++) {
        if (i !== LA - 1) {
            strArray.push(NN[i] + ",");
        } else {
            strArray.push(NN[i]);
        }
    }
    strArray.push("\n");
    //#2
    strArray.push("#" + "\n");
    var cellId = 1;
    var x;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < NN[i]; j++) {
            x = document.getElementById("cell_" + cellId).value;
            strArray.push(x + "\n");
            cellId++;
        }
    }

    var Stream = strArray.join("");
    var fineName = "Ts_Data-" + getDate() + ".txt";

    SaveToFile(fineName, Stream);
}
function dataHeaderProcess_Ts() {
    var readText = document.getElementById("CandPArea").value;
    var dd = [];
    dd = readText.split("#");

    if (crDel(dd[0]) === "Ts") {
        var LA = 2;
        var nn_text = crDel(dd[1]);
        var NN = [];
        NN = nn_text.split(",");
        for (i = 0; i < LA; i++) {
            document.getElementById("A" + (i + 1) + "_subjNum").value = parseInt(NN[i], 10);
        }
        changeTsTable();
        document.getElementById("CandPArea").value = delTopCR(dd[2]);
    }
}