/**
 * 分散分析
 * ABs(２要因参加者間計画)
 *
 *
 *
 */
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

    //フォームを作成
    changeAbsSetting();
    // デフォルトのタブを選択
    ChangeTab(1, 4);

    //コピペエリアにドラッグ＆ドロップを設定
    setDragAndDrop();

};
// セルデータの消去
function clearCellData() {
    var i = 0;
    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);
    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var elmCount = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            elmCount += NN[i][j];
        }
    }

    var result = confirm("データを消去します");
    if (result === true) {
        document.getElementById("factorA_name").value = "A";
        document.getElementById("factorB_name").value = "B";
        for (i = 0; i < elmCount; i++) {
            document.getElementById("cell_" + (i + 1)).value = "";
        }
        errorClearCell(elmCount, "");
    }
}
function checkCellData() {
    var i = 0;
    var j = 0;

    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);

    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var elmCount = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            elmCount += NN[i][j];
        }
    }

    var errorCellNum = 0;

    if (document.getElementById("CandPArea").value === '') {
        errorClearCell(elmCount, "");
        errorCell(elmCount, "");

        for (i = 0; i < elmCount; i++) {
            if (document.getElementById("cell_" + (i + 1)).value === '') {
                errorCellNum = i + 1;
            }
        }
        if (errorCellNum === 0) {
            errorClearCell(elmCount, "");
            mainCalc_ABs();
        } else {
            alert("すべての数値が入力されていません (^_^)ゞ");
            document.getElementById("cell_" + errorCellNum).focus();
        }
    } else {
        var DData = dataremake5("CandPArea");
        DData = crDel(DData);
        var dd = [];
        dd = DData.split(" ");
        if (elmCount != dd.length) {
            alert("データ数が一致しません");
        } else {
            copipe("CandPArea", "text");
            inputTextArea(document.getElementById("CandPArea"), 0);
            inputBtnTextClear(document.getElementById("inputBtn1"));
            checkCellData();
        }
    }
}
// メイン計算
function mainCalc_ABs() {
    var i = 0;
    var j = 0;
    var k = 0;
    var ii = 0;
    var jj = 0;

    AA = document.getElementById("factorA_name").value;
    LA = parseInt(document.getElementById("factorA_number").value, 10);
    BB = document.getElementById("factorB_name").value;
    LB = parseInt(document.getElementById("factorB_number").value, 10);

    AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
    if (AA === '') AA = "A";
    BB = BB.replace(/\s/g, "_"); //半角スペースを＿に変換する
    if (BB === '') BB = "B";

    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var NX = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            if (NX < NN[i][j]) NX = NN[i][j];
        }
    }

    var NA = new Array(LA);
    for (i = 0; i < LA; i++) {
        NA[i] = 0;
        for (j = 0; j < LB; j++) {
            NA[i] += NN[i][j];
        }
    }

    var NB = new Array(LB);
    for (j = 0; j < LB; j++) {
        NB[j] = 0;
        for (i = 0; i < LA; i++) {
            NB[j] += NN[i][j];
        }
    }

    var NAB = new Array(LA);
    for (i = 0; i < LA; i++) {
        NAB[i] = new Array(LB);
    }
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NAB[i][j] = NN[i][j];
        }
    }

    var xx = new Array(LA);
    for (i = 0; i < LA; i++) {
        xx[i] = new Array(LB);
        for (j = 0; j < LB; j++) {
            xx[i][j] = new Array(NX);
        }
    }

    var cellId = 1;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            for (k = 0; k < NN[i][j]; k++) {
                xx[i][j][k] = parseFloat(document.getElementById("cell_" + cellId).value);
                cellId++;
            }
        }
    }

    var M = new Array(LA);
    for (i = 0; i < LA; i++) {
        M[i] = new Array(LB);
    }
    var mm;

    var SD = new Array(LA);
    for (i = 0; i < LA; i++) {
        SD[i] = new Array(LB);
    }
    var sd;

    var AAA = [];
    var BBB = [];
    var FFA$ = [];
    var ADA = [];
    var FFB$ = [];
    var BDB = [];

    var MC$;
    var EQ$;

    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    // 平均・標準偏差
    strArray.push("[ ABs-Type Design ]\n\n");
    strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
    strArray.push("  A= " + AA + "\n");
    strArray.push("  B= " + BB + "\n");
    strArray.push(bar);
    strArray.push("A\tB\tN\t\tMean\t\tS.D.\n");
    strArray.push(bar);

    var S = 0;
    var SS = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            S = 0;
            SS = 0;
            for (k = 0; k < NN[i][j]; k++) {
                S += xx[i][j][k];
                SS += Math.pow(xx[i][j][k], 2);
            }
            M[i][j] = S / NN[i][j];
            mm = using(M[i][j], 5, 4);
            SD[i][j] = Math.sqrt(SS / NN[i][j] - Math.pow(M[i][j], 2));
            sd = using(SD[i][j], 5, 4);
            strArray.push((i + 1) + "\t" + (j + 1) + "\t" + NN[i][j] + "\t" + mm + "\t" + sd + "\n");
        }
        if (i < LA - 1) {
            strArray.push("\n");
        } else {
            strArray.push(bar);
        }
    }

    S = 0;
    SS = 0;
    var OB = 0;
    var E = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            S = S + 1 / NN[i][j];
            OB = OB + NN[i][j];
            SS = SS + M[i][j];
            E = E + Math.pow(SD[i][j], 2) * NN[i][j];
        }
    }

    // var N = LA*LB/S;
    var N = NN[0][0];
    var DH = SS / LA / LB;

    var NhFgag = false;
    var NhCheck = NN[0][0];
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            if (NhCheck != NN[i][j]) {
                NhFgag = true;
            }
        }
    }

    if (NhFgag === true) {
        strArray.push("\nNが不揃いです。\n");
        strArray.push("Unweighted-Mean ANOVAを行います。\n");
        N = LA * LB / S;
        n = using(N, 4, 2);
        strArray.push("Nh=" + n + "(調和平均)と仮定します。\n\n");
    }

    //分散分析
    // S.V    SS    df    MS   F
    // -----------------------------------
    //  A      A    DA    MA    FA    FA$
    //  B      B    DB    MB    FB    FB$
    // AxB     AB   DI    MI    FI    FI$
    // subj    E    DE    ME
    // -----------------------------------
    // Total   T    DT

    // S.V    SS    df    MS    F     p
    // -----------------------------------
    //  A     SSa   DFa   MSa   Fa    Pa
    //  B     SSb   DFb   MSb   Fb    Pb
    // AxB    SSab  DFab  MSab  Fab   Pab
    // subj   SSe   DFe   MSe
    // -----------------------------------
    // Total  SSt   DFt

    //  主効果検定
    strArray.push("\n == Analysis of Variance ==\n\n");
    strArray.push(" A(" + LA + ") = " + AA + "\n");
    strArray.push(" B(" + LB + ") = " + BB + "\n");
    strArray.push(bar);
    strArray.push(" S.V          SS        df       MS        F\n");
    strArray.push(bar);

    var A = 0;
    for (i = 0; i < LA; i++) {
        S = 0;
        for (j = 0; j < LB; j++) {
            S = S + M[i][j];
        }
        A = A + Math.pow((S / LB - DH), 2) * N * LB;
    }

    var B = 0;
    for (j = 0; j < LB; j++) {
        S = 0;
        for (i = 0; i < LA; i++) {
            S = S + M[i][j];
        }
        B = B + Math.pow((S / LA - DH), 2) * N * LA;
    }

    var AB = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            AB = AB + Math.pow((M[i][j] - DH), 2) * N;
        }
    }

    AB = AB - A - B;
    var T = A + B + AB + E;
    var DA = LA - 1;
    var MA = A / DA;
    var DB = LB - 1;
    var MB = B / DB;
    var DI = DA * DB;
    var MI = AB / DI;
    var DE = OB - LA * LB;
    var ME = E / DE;
    var FA = MA / ME;
    var FB = MB / ME;
    var FI = MI / ME;

    var D1 = DA, D2 = DE, Fdata = FA;
    var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

    D1 = DI;
    D2 = DE;
    Fdata = FI;
    var FI$ = pValue_Match_fRatio(D1, D2, Fdata);

    // var a = using(A,12,4);
    // var da = using(DA,4,0);
    // var ma = using(MA,7,4);
    // var fa = using(FA,3,2);

    strArray.push("  A" + using(A, 12, 4) + " " + using(DA, 4, 0) + " " + using(MA, 7, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
    // strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");

    D1 = DA;
    if (FI$ != "ns") {
        for (j = 0; j < LB; j++) {
            S = 0;
            SS = 0;
            for (i = 0; i < LA; i++) {
                S += M[i][j];
                SS += Math.pow(M[i][j], 2);
            }
            A = (SS - Math.pow(S, 2) / LA) * N;
            FF = A / DA / ME;
            Fdata = FF;
            FFA$[j] = pValue_Match_fRatio(D1, D2, Fdata);
            ADA[j] = A / DA;

            // var ss = using(A,6,4);
            // var df = using(DA,4,0);
            // var ms = using(ADA[j],7,4);
            // var ff = using(FF,3,2);

            strArray.push("(A at B" + (j + 1) + " " + using(A, 6, 4) + " " + using(DA, 4, 0) + " " + using(ADA[j], 7, 4) + " " + using(FF, 3, 2) + " " + FFA$[j] + ")\n");
            // strArray.push("(A at B"+(j+1)+" "+ss+" "+df+" "+ms+" "+ff+" "+FFA$[j]+")\n");
        }
        strArray.push(bar);
    }

    D1 = DB;
    Fdata = FB;
    var FB$ = pValue_Match_fRatio(D1, D2, Fdata);

    // var b = using(B,12,4);
    // var db = using(DB,4,0);
    // var mb = using(MB,7,4);
    // var fb = using(FB,3,2);

    strArray.push("  B" + using(B, 12, 4) + " " + using(DB, 4, 0) + " " + using(MB, 7, 4) + " " + using(FB, 3, 2) + " " + FB$ + "\n");
    // strArray.push("  B"+b+" "+db+" "+mb+" "+fb+" "+FB$+"\n");

    //単純主効果検定
    if (FI$ != "ns") {
        for (i = 0; i < LA; i++) {
            S = 0;
            SS = 0;
            for (j = 0; j < LB; j++) {
                S += M[i][j];
                SS += Math.pow(M[i][j], 2);
            }
            B = (SS - Math.pow(S, 2) / LB) * N;
            FF = B / DB / ME;
            Fdata = FF;
            FFB$[i] = pValue_Match_fRatio(D1, D2, Fdata);
            BDB[i] = B / DB;

            // ss = using(B,6,4);
            // df = using(DB,4,0);
            // ms = using(BDB[i],7,4);
            // ff = using(FF,3,2);

            strArray.push("(B at A" + (i + 1) + " " + using(B, 6, 4) + " " + using(DB, 4, 0) + " " + using(BDB[i], 7, 4) + " " + using(FF, 3, 2) + " " + FFB$[i] + ")\n");
            // strArray.push("(B at A"+(i+1)+" "+ss+" "+df+" "+ms+" "+ff+" "+FFB$[i]+")\n");
        }
        strArray.push(bar);
    }

    // var ab = using(AB,11,4);
    // var di = using(DI,4,0);
    // var mi = using(MI,7,4);
    // var fi = using(FI,3,2);
    // var e = using(E,10,4);
    // var de = using(DE,4,0);
    // var me = using(ME,7,4);

    strArray.push(" AxB" + using(AB, 11, 4) + " " + using(DI, 4, 0) + " " + using(MI, 7, 4) + " " + using(FI, 3, 2) + " " + FI$ + "\n");
    strArray.push(" subj" + using(E, 10, 4) + " " + using(DE, 4, 0) + " " + using(ME, 7, 4) + "\n");
    strArray.push(bar);
    // strArray.push(" AxB"+ab+" "+di+" "+mi+" "+fi+" "+FI$+"\n");
    // strArray.push(" subj"+e+" "+de+" "+me+"\n");
    // strArray.push(bar);

    // var t = using(T,10,4);
    var DT = OB - 1;
    // var dt = using(DT,4,0);

    strArray.push("Total" + using(T, 10, 4) + " " + using(DT, 4, 0));
    strArray.push("   +p<.10 *p<.05 **p<.01\n\n");
    // strArray.push("Total"+t+" "+dt);
    // strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

    //効果量
    var eta2 = 0;
    var effectSizeF = 0;

    strArray.push("\n == EffectSize ==\n\n");
    strArray.push("\tpartial η2\teffectsize f\n");
    strArray.push(bar);

    eta2 = DA * FA / (DA * FA + DE);
    effectSizeF = Math.sqrt(eta2 / (1 - eta2));
    strArray.push("  A\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

    eta2 = DB * FB / (DB * FB + DE);
    effectSizeF = Math.sqrt(eta2 / (1 - eta2));
    strArray.push("  B\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

    eta2 = DI * FI / (DI * FI + DE);
    effectSizeF = Math.sqrt(eta2 / (1 - eta2));
    strArray.push(" AxB\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

    strArray.push(bar);
    strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

    //多重比較
    // 多重比較の出力メモ（すべての方法で）
    //  交互作用の有意性に関わらず,
    //  AとBの水準数が２より大きく,主効果が有意だった場合は出力する
    //  2013.1.15 改訂

    var checkedLsd = false;
    var checkedHsd = false;
    var checkedBonf = false;
    var checkedHolm = false;

    checkedLsd = document.getElementById("LSD").checked;
    checkedHsd = document.getElementById("HSD").checked;
    checkedBonf = document.getElementById("BONF").checked;
    checkedHolm = document.getElementById("HOLM").checked;

    //多重比較 LSD法
    if (checkedLsd) {
        var T2;
        var LSD;
        var lsdd;
        if (FI$ != "ns") {
            if (LA > 2) {
                T2 = tvalue(DE);
                me = using(ME, 6, 4);

                LSD = T2 * Math.sqrt(2 * ME / N);
                lsdd = using(LSD, 8, 4);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(" (LSD=" + lsdd + ")\n");
                        strArray.push(bar);
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                if (Math.abs(M[i][j] - M[ii][j]) > LSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
                            }
                        }
                        strArray.push(bar);
                    }
                }
            }
            if (LB > 2) {
                T2 = tvalue(DE);
                me = using(ME, 6, 4);

                LSD = T2 * Math.sqrt(2 * ME / N);
                lsdd = using(LSD, 8, 4);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(" (LSD=" + lsdd + ")\n");
                        strArray.push(bar);
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                if (Math.abs(M[i][j] - M[i][jj]) > LSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
                            }
                        }
                        strArray.push(bar);
                    }
                }
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            T2 = tvalue(DE);
            me = using(ME, 6, 4);

            LSD = T2 * Math.sqrt(2 * ME / N / LB);
            lsdd = using(LSD, 8, 4);

            strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(" (LSD=" + lsdd + ")\n");
            strArray.push(bar);
            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    if (Math.abs(AAA[i] - AAA[ii]) > LSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
                }
            }
            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            T2 = tvalue(DE);
            me = using(ME, 6, 4);
            LSD = T2 * Math.sqrt(2 * ME / N / LA);
            lsdd = using(LSD, 7, 4);

            strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
            strArray.push(" (MSe=" + me + ", * p<.05)\n");
            strArray.push(" (LSD=" + lsdd + ")\n");
            strArray.push(bar);
            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    if (Math.abs(BBB[j] - BBB[jj]) > LSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
                }
            }
            strArray.push(bar);
        }
    }

    //多重比較 HSD(Tukey-kramer)
    if (checkedHsd) {
        var Q2;
        var HSD;
        var hsd;
        if (FI$ != "ns") {
            if (LA > 2) {
                Q2 = st_qValue(LA, DE);
                me = using(ME, 6, 4);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(bar);
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                HSD = Q2 * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[ii][j])) / Math.SQRT2;
                                hsd = using(HSD, 8, 4);

                                if (Math.abs(M[i][j] - M[ii][j]) > HSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
            if (LB > 2) {
                Q2 = st_qValue(LB, DE);
                me = using(ME, 6, 4);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(bar);
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                HSD = Q2 * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[i][jj])) / Math.SQRT2;
                                hsd = using(HSD, 8, 4);

                                if (Math.abs(M[i][j] - M[i][jj]) > HSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            Q2 = st_qValue(LA, DE);
            me = using(ME, 6, 4);

            strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    HSD = Q2 * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii])) / Math.SQRT2;
                    hsd = using(HSD, 8, 4);

                    if (Math.abs(AAA[i] - AAA[ii]) > HSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                }
            }
            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            Q2 = st_qValue(LB, DE);
            me = using(ME, 6, 4);

            strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    HSD = Q2 * Math.sqrt(ME * (1 / NB[j] + 1 / NB[jj])) / Math.SQRT2;
                    hsd = using(HSD, 8, 4);

                    if (Math.abs(BBB[j] - BBB[jj]) > HSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                }
            }
            strArray.push(bar);
        }
    }

    //多重比較 Bonferroni法
    if (checkedBonf) {
        var kumi = 0;
        var TB = 0;
        var alpha_d = 0;

        var BONF;
        var bonf;

        if (FI$ != "ns") {
            if (LA > 2) {
                me = using(ME, 6, 4);

                kumi = kumiawase(LA, 2);
                TB = bonf_tValue(kumi, DE);
                alpha_d = using(0.05 / kumi, 2, 4);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
                        strArray.push(bar);
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                BONF = TB * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[ii][j]));
                                bonf = using(BONF, 7, 4);

                                if (Math.abs(M[i][j] - M[ii][j]) > BONF) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
            if (LB > 2) {
                me = using(ME, 6, 4);

                kumi = kumiawase(LB, 2);
                TB = bonf_tValue(kumi, DE);
                alpha_d = using(0.05 / kumi, 2, 4);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
                        strArray.push(bar);
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                BONF = TB * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[i][jj]));
                                bonf = using(BONF, 7, 4);

                                if (Math.abs(M[i][j] - M[i][jj]) > BONF) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            me = using(ME, 6, 4);

            kumi = kumiawase(LA, 2);
            TB = bonf_tValue(kumi, DE);
            alpha_d = using(0.05 / kumi, 2, 4);

            strArray.push(" == Multiple Comparisons by Bonferroni ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4 + "\n"));
            }
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    BONF = TB * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
                    bonf = using(BONF, 7, 4);

                    if (Math.abs(AAA[i] - AAA[ii]) > BONF) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                }
            }
            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            me = using(ME, 6, 4);
            kumi = kumiawase(LB, 2);
            TB = bonf_tValue(kumi, DE);
            alpha_d = using(0.05 / kumi, 2, 4);

            strArray.push(" == Multiple Comparisons by Bonferroni ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    BONF = TB * Math.sqrt(ME * (1 / NB[j] + 1 / NB[jj]));
                    bonf = using(BONF, 7, 4);

                    if (Math.abs(BBB[j] - BBB[jj]) > BONF) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                }
            }
            strArray.push(bar);
        }
    }

    //多重比較 Holm
    if (checkedHolm) {
        var TL = [];
        var TLN = []; //順番を保存
        var HMC$ = [];
        var alpha_d = [];

        var tlcount = 0;

        var kumi = 0;

        var temp, temp2, temp3, temp4;

        var kflag = 1; //１のとき棄却する 0だと検定終了

        if (FI$ != "ns") {
            if (LA > 2) {
                kumi = kumiawase(LA, 2);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        tlcount = 0;
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                TL[tlcount] = Math.abs(M[i][j] - M[ii][j]) / Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[ii][j]));
                                TLN[tlcount] = tlcount;
                                tlcount++;
                            }
                        }

                        //TL値の小さい順に並び替え（同時にTLN値も）
                        // var temp;
                        // var temp2;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TL[jk] < TL[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                }
                            }
                        }

                        //TL値を計算
                        kflag = 1; //１のとき棄却する 0だと検定終了
                        for (ik = kumi; ik > 0; ik--) {
                            if (kflag) {
                                if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                                    HMC$[ik - 1] = " *  ";
                                } else {
                                    HMC$[ik - 1] = "n.s.";
                                    kflag = 0; //検定終了 以降はすべて保留
                                }
                            } else {
                                HMC$[ik - 1] = "n.s.";
                            }
                            alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
                        }

                        //TLN値の小さい順に並び替え
                        // var temp3;
                        // var temp4;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TLN[jk] < TLN[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    temp3 = HMC$[jk];
                                    temp4 = alpha_d[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    HMC$[jk] = HMC$[jk - 1];
                                    alpha_d[jk] = alpha_d[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                    HMC$[jk - 1] = temp3;
                                    alpha_d[jk - 1] = temp4;
                                }
                            }
                        }
                        me = using(ME, 6, 4);

                        strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe=" + me + ", * p<.05)\n");
                        strArray.push(bar);

                        tlcount = 0;
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                if (HMC$[tlcount] == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                } else {
                                    EQ$ = "=";
                                }
                                strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                                tlcount++;
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
            if (LB > 2) {
                kumi = kumiawase(LB, 2);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        tlcount = 0;
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                TL[tlcount] = Math.abs(M[i][j] - M[i][jj]) / Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[i][jj]));
                                TLN[tlcount] = tlcount;
                                tlcount++;
                            }
                        }

                        //TL値の小さい順に並び替え（同時にTLN値も）
                        // var temp;
                        // var temp2;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TL[jk] < TL[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                }
                            }
                        }

                        //TL値を計算
                        kflag = 1; //１のとき棄却する 0だと検定終了
                        for (ik = kumi; ik > 0; ik--) {
                            if (kflag) {
                                if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                                    HMC$[ik - 1] = " *  ";
                                } else {
                                    HMC$[ik - 1] = "n.s.";
                                    kflag = 0; //検定終了 以降はすべて保留
                                }
                            } else {
                                HMC$[ik - 1] = "n.s.";
                            }
                            alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
                        }

                        //TLN値の小さい順に並び替え
                        // var temp3;
                        // var temp4;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TLN[jk] < TLN[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    temp3 = HMC$[jk];
                                    temp4 = alpha_d[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    HMC$[jk] = HMC$[jk - 1];
                                    alpha_d[jk] = alpha_d[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                    HMC$[jk - 1] = temp3;
                                    alpha_d[jk - 1] = temp4;
                                }
                            }
                        }
                        me = using(ME, 6, 4);

                        strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe=" + me + ", * p<.05)\n");
                        strArray.push(bar);

                        tlcount = 0;
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                if (HMC$[tlcount] == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                } else {
                                    EQ$ = "=";
                                }
                                strArray.push("  B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                                tlcount++;
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            kumi = kumiawase(LA, 2);
            me = using(ME, 6, 4);

            strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
            strArray.push(" (MSe=" + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
            }
            strArray.push(bar);

            tlcount = 0;
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    TL[tlcount] = Math.abs(AAA[i] - AAA[ii]) / Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
                    TLN[tlcount] = tlcount;
                    tlcount++;
                }
            }

            //TL値の小さい順に並び替え（同時にTLN値も）
            // var temp;
            // var temp2;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TL[jk] < TL[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                    }
                }
            }

            //TL値を計算
            kflag = 1; //１のとき棄却する 0だと検定終了
            for (ik = kumi; ik > 0; ik--) {
                if (kflag) {
                    if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                        HMC$[ik - 1] = " *  ";
                    } else {
                        HMC$[ik - 1] = "n.s.";
                        kflag = 0; //検定終了 以降はすべて保留
                    }
                } else {
                    HMC$[ik - 1] = "n.s.";
                }
                alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
            }

            //TLN値の小さい順に並び替え
            // var temp3;
            // var temp4;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TLN[jk] < TLN[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        temp3 = HMC$[jk];
                        temp4 = alpha_d[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        HMC$[jk] = HMC$[jk - 1];
                        alpha_d[jk] = alpha_d[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                        HMC$[jk - 1] = temp3;
                        alpha_d[jk - 1] = temp4;
                    }
                }
            }

            tlcount = 0;
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    if (HMC$[tlcount] == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    } else {
                        EQ$ = "=";
                    }
                    strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                    tlcount++;
                }
            }

            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            kumi = kumiawase(LB, 2);
            me = using(ME, 6, 4);

            strArray.push(" == Multiple Comparisons by Holm ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);

            tlcount = 0;
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    TL[tlcount] = Math.abs(BBB[j] - BBB[jj]) / Math.sqrt(ME * (1 / NB[j] + 1 / NB[jj]));
                    TLN[tlcount] = tlcount;
                    tlcount++;
                }
            }

            //TL値の小さい順に並び替え（同時にTLN値も）
            // var temp;
            // var temp2;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TL[jk] < TL[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                    }
                }
            }

            //TL値を計算
            kflag = 1; //１のとき棄却する 0だと検定終了
            for (ik = kumi; ik > 0; ik--) {
                if (kflag) {
                    if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                        HMC$[ik - 1] = " *  ";
                    } else {
                        HMC$[ik - 1] = "n.s.";
                        kflag = 0; //検定終了 以降はすべて保留
                    }
                } else {
                    HMC$[ik - 1] = "n.s.";
                }
                alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
            }

            //TLN値の小さい順に並び替え
            // var temp3;
            // var temp4;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TLN[jk] < TLN[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        temp3 = HMC$[jk];
                        temp4 = alpha_d[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        HMC$[jk] = HMC$[jk - 1];
                        alpha_d[jk] = alpha_d[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                        HMC$[jk - 1] = temp3;
                        alpha_d[jk - 1] = temp4;
                    }
                }
            }

            tlcount = 0;
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    if (HMC$[tlcount] == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    } else {
                        EQ$ = "=";
                    }
                    strArray.push("  B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                    tlcount++;
                }
            }
            strArray.push(bar);
        }
    }

    strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

    //グラフの設定
    var gCheck = document.getElementById("RltArea").value;
    gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

    //出力
    document.getElementById("RltArea").value = strArray.join("");
    strArray = null;

    //Ｒプログラム出力
    (function () {
        var rcmArray1 = [];
        var rcmArray2 = [];
        var spc = "          ";

        rcmArray1.push("####### 分散分析ＡＢｓ(２要因参加者間)：主分析 #######\n");
        rcmArray1.push("\n");
        rcmArray1.push("# パッケージ car   が必要\n");
        rcmArray1.push("# パッケージ psych が必要\n");
        rcmArray1.push("\n");
        rcmArray1.push("## js-STARからの入力:ABs\n");
        rcmArray1.push("levA = " + LA + spc + "# level of A\n");
        rcmArray1.push("levB = " + LB + spc + "# level of B\n");
        rcmArray1.push("n    = c( # データ数\n");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                rcmArray1.push(" " + NN[i][j]);
                if ((i != LA - 1) || (j != LB - 1)) rcmArray1.push(",");
            }
            rcmArray1.push("\n");
        }
        rcmArray1.push(")");

        rcmArray1.push("\n");
        rcmArray1.push("data = c(\n");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                for (k = 0; k < NN[i][j]; k++) {
                    rcmArray1.push(" " + xx[i][j][k]);
                    if ((i != LA - 1) || (j != LB - 1) || (k != NN[i][j] - 1)) rcmArray1.push(",");
                }
                if ((i != LA - 1) || (j != LB - 1)) {
                    rcmArray1.push("\n");
                }
            }
        }
        rcmArray1.push("\n )\n");
        rcmArray1.push("\n");

        var taju = document.getElementById("taju").value;
        rcmArray1.push("taju=\"" + taju + "\"  # BH, holm, b\n");
        rcmArray1.push("## js-STARの入力おわり\n");
        rcmArray1.push("\n");

        rcmArray1.push("## スタック\n");
        rcmArray1.push("A=c(); B=c(); gyo=0\n");
        rcmArray1.push("for(i in 1:levA){\n");
        rcmArray1.push("for(j in 1:levB){ gyo=gyo+1\n");
        rcmArray1.push("for(L in 1:n[gyo]){ A=c(A,i); B=c(B,j) }\n");
        rcmArray1.push("  }  }\n");
        rcmArray1.push("A=factor(A); B=factor(B)\n");
        rcmArray1.push("N= sum(n)\n");
        rcmArray1.push("s= gl(N, 1 )\n");
        rcmArray1.push("ABs= data.frame(A,B,s, data )\n");
        rcmArray1.push("\n");
        rcmArray1.push("## 基本統計\n");
        rcmArray1.push("Title=\"ＡxＢの平均とSD(不偏分散の平方根)\"\n");
        rcmArray1.push("nams= matrix(c(\"A\",\"B\",\"B\",\"A\"),nc=2)\n");
        rcmArray1.push("levs= c(levA, levB )\n");
        rcmArray1.push("library( car )\n");
        rcmArray1.push("library( psych )\n");
        rcmArray1.push("\n");
        rcmArray1.push("tx0=c(); txD=c(); mds=c()\n");
        rcmArray1.push("for( i in 1:levA ){ tx0=c(tx0,rep(NA,5)); txD=rbind(txD,rep(NA,5)); mds=c(mds,\"\")\n");
        rcmArray1.push("for( j in 1:levB ){\n");
        rcmArray1.push("  kx= describe(subset(ABs,A==i & B==j)$data )\n");
        rcmArray1.push("  tx0= c(tx0, kx$n,kx$mean,kx$sd,kx$min,kx$max )\n");
        rcmArray1.push("  mds= c(mds, paste(\"A.\",i,\"_B.\",j, sep=\"\") )\n");
        rcmArray1.push("  txD= rbind(txD, as.numeric(kx[1,c(5,10:13)]) )\n");
        rcmArray1.push("}  }\n");
        rcmArray1.push("tx0= matrix(round(tx0,4), nc=5,by=1 )\n");
        rcmArray1.push("tx0= tx0[-1,]\n");
        rcmArray1.push("rownames(tx0)= mds[-1]\n");
        rcmArray1.push("colnames(tx0)= c(\"   n\",\"    Mean\",\"     SD\",\"   Min\",\"   Max\" )\n");
        rcmArray1.push("txD= round(txD[-1,], 2)\n");
        rcmArray1.push("rownames(txD)= rownames(tx0)\n");
        rcmArray1.push("colnames(txD)= c(\"Median\",\"Range\",\"歪度\",\"尖度\",\"SE\" )\n");
        rcmArray1.push("hk= tx0[,2][ is.na(tx0[,2])==0 ]\n");
        rcmArray1.push("sd= tx0[,3][ is.na(tx0[,3])==0 ]\n");
        rcmArray1.push("\n");
        rcmArray1.push("# 作図\n");
        rcmArray1.push("mitsdo= c(0:(levB-1))*10*log(1:levB) # バーの斜線密度\n");
        rcmArray1.push("mitsdo= rep( mitsdo, levA )          # Ａ水準数だけ反復\n");
        rcmArray1.push("kankak= c( 1, rep(0, levB-1) ) # バーの間隔（左端=1, 以下=0）\n");
        rcmArray1.push("kankak= rep( kankak, levA )    # Ａ水準の数だけ反復\n");
        rcmArray1.push("bai = 2\n");
        rcmArray1.push("shoh= min(min(hk),0) # 最小平均か,ゼロ\n");
        rcmArray1.push("dais= max(sd)        # 最大ＳＤ\n");
        rcmArray1.push("yjik=c(shoh+dais*bai*sign(shoh), max(hk)+dais*bai) # ｙ軸の範囲\n");
        rcmArray1.push("\n");
        rcmArray1.push("for( L in 1:2 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push("if( L==1 ) Sd=sd else { Sd=txD[,5][is.na(txD[,5])==0]; Title=\"ＡxＢの平均とSE(標準誤差)\" }\n");

        if (navigator.platform.indexOf("Win") != -1) {
            rcmArray1.push("windows()\n");
        }
        if (navigator.platform.indexOf("Mac") != -1) {
            rcmArray1.push("quartz()\n");
        }

        rcmArray1.push("antx= barplot(hk, yli=yjik, # ｘ軸の範囲指定しない\n");
        rcmArray1.push("  las=1, tck=0.02, # ｙ軸の目盛デザイン\n");
        rcmArray1.push("  col=1, den=mitsdo,\n");
        rcmArray1.push("  spa=kankak,      # バーの間隔\n");
        rcmArray1.push("  names.arg=c( rep(paste(\"B\",1:levB,sep=\"\"),levA) ),\n");
        rcmArray1.push("  xlab=\"\", ylab=\"平　均\",\n");
        rcmArray1.push("  sub=paste(\"Ｂ1(左端) ～Ｂ\",levB,\"　in　Ａ1(左端から\",levB,\"本で１水準) ～Ａ\",levA, sep=\"\" ),\n");
        rcmArray1.push("  main=Title,\n");
        rcmArray1.push("  cex.main=1.5, cex.sub=1.2, cex.lab=1.2 )\n");
        rcmArray1.push("arrows(antx,hk, antx,hk+Sd*sign(hk), lwd=L,ang=90,len=0.12 ) # len=水平長さ\n");
        rcmArray1.push("if(L==2) arrows(antx,hk,antx,hk-Sd*sign(hk),lwd=L,ang=90,len=0.12 )\n");
        rcmArray1.push("}\n");
        rcmArray1.push("\n");
        rcmArray1.push("# Type3\n");
        rcmArray1.push("TsF= function(ss,d1,d2,MS,adj=0)\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" ms=ss/d1; fc=ms/MS\n");
        rcmArray1.push(" pc= pf(fc,d1,d2,low=0)\n");
        rcmArray1.push(" if(adj==1) pc=p.adjust(pc,me=taju)\n");
        rcmArray1.push(" et= fc*d1/(fc*d1+d2)\n");
        rcmArray1.push(" matrix(round(c(ss,d1,ms,fc,pc,et),4),nc=6 )\n");
        rcmArray1.push("}\n");
        rcmArray1.push("NAM= c(\"主効果Ａ\",\"主効果Ｂ\",\"交互作用Ａ×Ｂ\" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("kx0= lm(data~A*B,ABs,contrasts=list(A=contr.sum,B=contr.sum) )\n");
        rcmArray1.push("ty3= Anova(kx0, type=3 )\n");
        rcmArray1.push("SS= ty3$S[2:5]\n");
        rcmArray1.push("DF= ty3$D[2:5]\n");
        rcmArray1.push("MS= SS/DF\n");
        rcmArray1.push("D2= c(rep(DF[4],3),NA )\n");
        rcmArray1.push("ms= c(rep(MS[4],3),NA )\n");
        rcmArray1.push("tx1= TsF(SS,DF,D2,ms )\n");
        rcmArray1.push("Fch=tx1[,4]; Pch=tx1[,5]; eta=tx1[,6]\n");
        rcmArray1.push("rownames(tx1)= c(NAM[1:2],\" Ａ×Ｂ\",\"   ｓ\" )\n");
        rcmArray1.push("colnames(tx1)= c(\"TypeⅢ_SS \",\"df \", \"MS \", \"Ｆ \", \"ｐ \",\"  ηp2 \" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("kx= Anova(kx0, type=2 )\n");
        rcmArray1.push("ss= kx$S[1:4]\n");
        rcmArray1.push("ty2= TsF(ss,DF,D2,ms )\n");
        rcmArray1.push("rownames(ty2)= rownames(tx1)\n");
        rcmArray1.push("colnames(ty2)= c(\"TypeⅡ_SS \",colnames(tx1)[2:6] )\n");
        rcmArray1.push("\n");
        rcmArray1.push("# 分散均一\n");
        rcmArray1.push("tx8=c(); Bst=c();Bpv=c();Bdf=c()\n");
        rcmArray1.push("kx= bartlett.test(ABs$data~rep(1:(levA*levB),n) )\n");
        rcmArray1.push("Bst=kx$stat; Bdf=kx$para; Bpv=kx$p.va\n");
        rcmArray1.push("tx8= matrix(round(c(Bst,Bdf,Bpv),4), nc=3 )\n");
        rcmArray1.push("rownames(tx8)=\"Bartlett Test\"\n");
        rcmArray1.push("colnames(tx8)= c(\"    χ2\",\"  df\",\"     ｐ\" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("# パワ\n");
        rcmArray1.push("d1=DF[1:3]; d2=D2[1:3]\n");
        rcmArray1.push("ESf= sqrt(eta[1:3]/(1-eta[1:3]) )\n");
        rcmArray1.push("Pow= 1-pf(qf(0.95,d1,d2),d1,d2,ESf^2*N )\n");
        rcmArray1.push("\n");
        rcmArray1.push("BETA= function(i){ d1=DF[L];d2=i-levA*levB;pf(qf(0.95,d1,d2),d1,d2,ESf[L]^2*i) }\n");
        rcmArray1.push("NN=c(NA,NA,NA)\n");
        rcmArray1.push("for( L in 1:3 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" pow=Pow[L]; nn=NA\n");
        rcmArray1.push(" if( pow<0.80 )\n");
        rcmArray1.push("   {\n");
        rcmArray1.push("    for(i in (N-1):10000) if( BETA(i)<0.20 ){ nn=c(i,nn); break }\n");
        rcmArray1.push("    NN[L]= nn[1]\n");
        rcmArray1.push("   } else {\n");
        rcmArray1.push("    for(i in (N+1):2){ if( BETA(i)>0.20 ) break else nn=c(i,nn) }\n");
        rcmArray1.push("    NN[L]= nn[1]\n");
        rcmArray1.push("   }\n");
        rcmArray1.push("}\n");
        rcmArray1.push("tx2= c()\n");
        rcmArray1.push("tx2= matrix(round(c(ESf,Pow,N,N,N,NN),4), nr=3 )\n");
        rcmArray1.push("rownames(tx2)= rownames(tx1)[1:3]\n");
        rcmArray1.push("colnames(tx2)= c(\"効果量ｆ\",\" 検出力\",\" 今回のＮ\",\"次回のＮ\" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("## 主効果\n");
        rcmArray1.push("hkA=c();mcA=c(); hkB=c();mcB=c(); nam=nams[1,]\n");
        rcmArray1.push("plSD= c()\n");
        rcmArray1.push("for( L in 1:2 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" kx= anova(lm(ABs[,4]~ABs[,L]))\n");
        rcmArray1.push(" plSD= c(plSD, sqrt(kx$M[2]),plDF=kx$D[2] )\n");
        rcmArray1.push(" HK=c(); MC=c()\n");
        rcmArray1.push(" for(i in 1:levs[L])\n");
        rcmArray1.push("   {\n");
        rcmArray1.push("    dt=subset(ABs[,4],ABs[,L]==i )\n");
        rcmArray1.push("    HK=c(HK, length(dt),mean(dt),sd(dt) )\n");
        rcmArray1.push("   }\n");
        rcmArray1.push(" HK= rbind(matrix(round(HK,4),nr=3),rep(NA,levs[L]) )\n");
        rcmArray1.push(" rownames(HK)= c(\"ｎ\",\"Mean\",\"S.D.\",\"-----\" )\n");
        rcmArray1.push(" colnames(HK)= paste(nam[L],1:levs[L], sep=\"\" )\n");
        rcmArray1.push(" if( levs[L]>2 )\n");
        rcmArray1.push("   {\n");
        rcmArray1.push("    MC= round(pairwise.t.test(ABs[,4],ABs[,L],p.ad=taju)$p.v, 4 )\n");
        rcmArray1.push("    rownames(MC)= paste(nam[L],2:levs[L], sep=\"\" )\n");
        rcmArray1.push("    colnames(MC)= paste(nam[L],1:(levs[L]-1), sep=\"\" )\n");
        rcmArray1.push("   }\n");
        rcmArray1.push(" if(L==1){ hkA=HK; mcA=MC } else { hkB=HK; mcB=MC }\n");
        rcmArray1.push("} # for(L)\n");
        rcmArray1.push("plSD= matrix(plSD,nc=2,by=1 )\n");
        rcmArray1.push("rownames(plSD)= NAM[1:2]\n");
        rcmArray1.push("colnames(plSD)= c(\"pooled_SD\",\"   DF\")\n");
        rcmArray1.push("TesA=function(水準=0,相手=0)\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" tch= abs(hkA[2,水準]-hkA[2,相手])/( sqrt(1/hkA[1,水準]+1/hkA[1,相手])*plSD[1,1] )\n");
        rcmArray1.push(" df2= plSD[1,2]\n");
        rcmArray1.push(" nPV= pt(tch,df2,low=0)*2\n");
        rcmArray1.push(" cat(paste(\"t(\",df2,\")=\",round(tch,4),\", non-adjusted p=\",round(nPV,4),\"(両側)\n\", sep=\"\") )\n");
        rcmArray1.push("}\n");
        rcmArray1.push("TesB=function(水準=0,相手=0)\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" tch= abs(hkB[2,水準]-hkB[2,相手])/( sqrt(1/hkB[1,水準]+1/hkB[1,相手])*plSD[2,1] )\n");
        rcmArray1.push(" df2= plSD[2,2]\n");
        rcmArray1.push(" nPV= pt(tch,df2,low=0)*2\n");
        rcmArray1.push(" cat(paste(\"t(\",df2,\")=\",round(tch,4),\", non-adjusted p=\",round(nPV,4),\"(両側)\n\", sep=\"\") )\n");
        rcmArray1.push("}\n");
        rcmArray1.push("\n");
        rcmArray1.push("\n");
        rcmArray1.push("# ■結果の書き方\n");
        rcmArray1.push("PV= function(x) floor(x*1000)/1000\n");
        rcmArray1.push("txt=c()\n");
        rcmArray1.push("if( sum(sd==0)>0 ) txt=\"※分散=0 の群があります。全データが同じ値です。以下の分析は信頼性がありません。\n\n\"\n");
        rcmArray1.push("txt= paste(txt,\"　各群の○○得点について基本統計量をTable(tx0) or Fig.■に示す。\n　２要因の参加者間分散分析（TypeⅢ_SS使用）を行った結果 (Table(tx1)参照)，\", sep=\"\" )\n");
        rcmArray1.push("Tari=0 # 多重あり\n");
        rcmArray1.push("\n");
        rcmArray1.push("yui=c()\n");
        rcmArray1.push("for( L in 1:3 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" pch= Pch[L]\n");
        rcmArray1.push(" if( L<3 ) goku=\"，\" else goku=\"。\"\n");
        rcmArray1.push(" fuki= paste(\" (F(\",DF[L],\",\",DF[4],\")=\",round(Fch[L],3),\", p=\",PV(pch),\", ηp2=\",round(eta[L],3),\", 1-β=\",PV(Pow[L]),\")\",goku, sep=\"\" )\n");
        rcmArray1.push(" if(pch<0.05){ yui=c(yui,L); if(L<3) tmp=\"であり\" else tmp=\"であった\" } else\n");
        rcmArray1.push(" if(pch<0.10){ yui=c(yui,L); if(L<3) tmp=\"傾向であり\" else tmp=\"傾向であった\" } else\n");
        rcmArray1.push("             { if(L<3) tmp=\"でなく\" else tmp=\"でなかった\" }\n");
        rcmArray1.push(" txt= paste(txt, NAM[L],\"が有意\",tmp,fuki, sep=\"\" )\n");
        rcmArray1.push("}\n");
        rcmArray1.push("\n");
        rcmArray1.push("# 検出力\n");
        rcmArray1.push("kazu=length(yui); yosh=0; mae=0\n");
        rcmArray1.push("if( kazu>0 ){ for(i in 1:kazu){\n");
        rcmArray1.push(" pwr= Pow[yui[i]]\n");
        rcmArray1.push(" if( pwr>0.80 ){ tmp=\"十分である。\"; yosh=1 } else\n");
        rcmArray1.push(" if( pwr>0.76 ){ tmp=\"ほぼ十分といえる。\"; yosh=1 } else\n");
        rcmArray1.push(" if( pwr>0.70 ){ tmp=\"やや低いが0.70以上あり不十分ではない。\"; yosh=0 } else { tmp=\"不十分であり，信頼性が低い。\"; yosh=0 }\n");
        rcmArray1.push(" if( i>1 & mae==yosh ) goku=\"も\" else goku=\"は\"\n");
        rcmArray1.push(" mae= yosh\n");
        rcmArray1.push(" if( i==1 ){ mata=\"\n　\"; fuki=\" (1-β) \" } else { mata=\"\"; fuki=\"\" }\n");
        rcmArray1.push(" txt= paste(txt, mata,NAM[yui[i]],\"の検出力\",fuki,goku,tmp, sep=\"\" )\n");
        rcmArray1.push("}  }\n");
        rcmArray1.push("\n");
        rcmArray1.push("# 分散均一性\n");
        rcmArray1.push("if( min(Pch, na.rm=1)<0.10 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" fuki= paste(\" (χ2(\",Bdf,\")=\",round(Bst,3),\", p=\",PV(Bpv),\")。\", sep=\"\" )\n");
        rcmArray1.push(" if( Bpv>0.05 ) tmp=\"有意でないことを確認した\" else tmp=\"有意であった\"\n");
        rcmArray1.push(" txt= paste(txt, \"\n　参加者間の分散の均一性についてBartlett検定を行った結果 (Table(tx8)参照)，\",tmp,fuki, sep=\"\" )\n");
        rcmArray1.push(" if( Bpv<0.05 ) txt=paste(txt, \"以下，参考までに分析を進める。\n\", sep=\"\" )\n");
        rcmArray1.push("}\n");
        rcmArray1.push("txt=paste(txt,\"\n\",sep=\"\" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("# 主効果\n");
        rcmArray1.push("Pari= 0\n");
        rcmArray1.push("for( L in 1:2 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push("pch= Pch[L]\n");
        rcmArray1.push("if( pch<0.10 & Pch[3]>0.05 )\n");
        rcmArray1.push("{\n");
        rcmArray1.push(" Mari=0\n");
        rcmArray1.push(" if(L==1){ HK=hkA[2,]; hyo=mcA; nn=hkA[1,] } else { HK=hkB[2,]; hyo=mcB; nn=hkB[1,] }\n");
        rcmArray1.push(" levL=levs[L]; nam=nams[L,]\n");
        rcmArray1.push(" if(Pari==0) goku=\"\" else goku=\"は\"\n");
        rcmArray1.push(" txt= paste(txt, \"\n　\",NAM[L],\"について\",goku,\"，\", sep=\"\" )\n");
        rcmArray1.push(" Pari= Pari+1\n");
        rcmArray1.push(" if( levL==2 )\n");
        rcmArray1.push("   {\n");
        rcmArray1.push("    if( HK[1]>HK[2] ) tmp=\"大き\" else tmp=\"小さ\"\n");
        rcmArray1.push("    if( pch<0.05 ) goku=\"かった。\" else goku=\"い傾向があった。\"\n");
        rcmArray1.push("    txt= paste(txt, nam[1],\"1の平均\",round(HK[1],3),\"が\",nam[1],\"2の平均\",round(HK[2],3),\"よりも有意に\",tmp,goku, sep=\"\" )\n");
        rcmArray1.push("   } else {\n");
        rcmArray1.push("    Tari= 1\n");
        rcmArray1.push("    if( Mari==0 ) txt=paste(txt, \"プールドSDを用いたｔ検定による多重比較 (α=0.05, 両側検定) を行った結果，\", sep=\"\" )\n");
        rcmArray1.push("    Mari= 1\n");
        rcmArray1.push("    kazu= sum(hyo<0.10, na.rm=1 )\n");
        rcmArray1.push("    if( kazu<1 ) txt=paste(txt,\"どの２群の平均の差も有意でなかった (adjusted ps>\",PV(min(hyo,na.rm=1)),\")。\", sep=\"\" ) else\n");
        rcmArray1.push("      { #★\n");
        rcmArray1.push("sumi= 0\n");
        rcmArray1.push("for(x in 1:(levL-1)){ for(y in (x+1):levL){\n");
        rcmArray1.push("   adP= hyo[ y-1, x ]\n");
        rcmArray1.push("   if( adP<0.10 )\n");
        rcmArray1.push("     {\n");
        rcmArray1.push("      keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"\"\n");
        rcmArray1.push("      tx= plSD[L,]\n");
        rcmArray1.push("      fuki= paste(\" (t(\",tx[2],\")=\",round(abs(HK[x]-HK[y])/(sqrt(1/nn[x]+1/nn[y])*tx[1]),3),\", adjusted p=\",PV(adP),\")\", sep=\"\" )\n");
        rcmArray1.push("      sumi= sumi+1\n");
        rcmArray1.push("      if( HK[x]>HK[y] ) mds=\"大き\" else mds=\"小さ\"\n");
        rcmArray1.push("      if( sumi<kazu ){ tmp=\"り\";goku=\"，\" } else { tmp=\"った\";goku=\"。\" }\n");
        rcmArray1.push("      if( adP<0.05 ) if(sumi<kazu) tmp=\"く\" else tmp=\"かった\"\n");
        rcmArray1.push("      txt= paste(txt, nam[1],x,\"の平均\",round(HK[x],3),\"が\",nam[1],y,\"の平均\",round(HK[y],3),\"よりも有意に\",mds,keko,tmp,fuki,goku, sep=\"\" )\n");
        rcmArray1.push("     }\n");
        rcmArray1.push("}  } # for(x)(y)\n");
        rcmArray1.push("        } #★\n");
        rcmArray1.push("     } # if(levL)\n");
        rcmArray1.push("} # if(pch)\n");
        rcmArray1.push("} # for(L)\n");
        rcmArray1.push("txt= paste(txt,\"\n\",sep=\"\" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("if( taju==\"BH\" ) TAJ=\"Benjamini & Hochberg (1995) \"\n");
        rcmArray1.push("if( taju==\"holm\" ) TAJ=\"Holm\"\n");
        rcmArray1.push("if( taju==\"b\" ) TAJ=\"Bonferroni\"\n");
        rcmArray1.push("if( Tari>0 ) txt= paste(txt, \"\n　以上のp値の調整には\",TAJ,\"の方法を用いた。\n\", sep=\"\" )\n");
        rcmArray1.push("if( Tari>0 & taju==\"BH\" ){ txt= paste(txt,\"\n\n［引用文献］\n\",\n");
        rcmArray1.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" ) }\n");
        rcmArray1.push("if( Pch[3]<0.10 ){ tmp=\"するか判断\";if( Pch[3]<0.05 ) tmp=\"\"\n");
        rcmArray1.push("txt=paste(txt,\"\n\n⇒js-STARの第二枠『\",NAM[3],\"が有意のときに…』を実行\",tmp,\"してください。\n\",sep=\"\" ) }\n");
        rcmArray1.push("H=matrix(0,nr=1)\n");
        rcmArray1.push("rownames(H)=\"\"\n");
        rcmArray1.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
        rcmArray1.push("\n");
        rcmArray1.push("\n");
        rcmArray1.push("options(digits=5)\n");
        rcmArray1.push("options(scipen=5)\n");
        rcmArray1.push("###############################\n");
        rcmArray1.push("#\n");
        rcmArray1.push("#   分散分析 ＡＢｓ-design\n");
        rcmArray1.push("#   ２要因  参加者間計画\n");
        rcmArray1.push("#\n");
        rcmArray1.push("H##############################\n");
        rcmArray1.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
        rcmArray1.push("# 歪度,尖度,SEなどは『オプション』参照\n");
        rcmArray1.push("\n");
        rcmArray1.push("tx1 # 分散分析ＡＢｓ\n");
        rcmArray1.push("    # 効果量ηp2 は偏イータ２乗\n");
        rcmArray1.push("\n");
        rcmArray1.push("tx2 # 効果量ｆ,検出力(1-β),追試用Ｎ\n");
        rcmArray1.push("# 効果量ｆの評価：大=0.40, 中=0.25, 小=0.10\n");
        rcmArray1.push("# 「次回のＮ」は α=0.05, 検出力=0.80 を想定\n");
        rcmArray1.push("\n");
        rcmArray1.push("tx8 # 分散の均一性の検定\n");
        rcmArray1.push("\n");
        rcmArray1.push("hkA;mcA # 主効果Ａの平均と多重比較の調整後ｐ値\n");
        rcmArray1.push("\n");
        rcmArray1.push("hkB;mcB # 主効果Ｂの平均と多重比較の調整後ｐ値\n");
        rcmArray1.push("\n");
        rcmArray1.push("cat(txt) # 結果の書き方\n");
        rcmArray1.push("\n");
        rcmArray1.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
        if (navigator.platform.indexOf("Win") != -1) {
            rcmArray1.push("windows();boxplot(data~A*B,ABs) # 箱ひげ図\n");
        }
        if (navigator.platform.indexOf("Mac") != -1) {
            rcmArray1.push("quartz();boxplot(data~A*B,ABs) # 箱ひげ図\n");
        }
        rcmArray1.push("# ty2  # TypeⅡ_SS\n");
        rcmArray1.push("# txD  # Median,歪度,尖度,SEなど\n");
        rcmArray1.push("# plSD # 主効果Ａ・ＢのプールドSD\n");
        rcmArray1.push("# TesA(水準=1, 相手=2 ) # 主効果Aの２水準ｔ検定\n");
        rcmArray1.push("# TesB(水準=1, 相手=2 ) # 主効果Bの２水準ｔ検定\n");
        rcmArray1.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
        rcmArray1.push("\n");
        rcmArray1.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
        rcmArray1.push("\n");

        document.getElementById("RcmArea").value = rcmArray1.join("");
        rcmArray = null;

        rcmArray1.push("####### 分散分析ＡＢｓ(２要因参加者間)：交互作用 #######\n");
        rcmArray2.push("tkAB=c();AatB=c();BatA=c(); plSD=c()\n");
        rcmArray2.push("if( Pch[3]<0.10 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push("ss=c()\n");
        rcmArray2.push("for(j in 1:levB)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" kx= anova(lm(data~A, subset(ABs,B==j) ))\n");
        rcmArray2.push(" ss= c(ss, kx$S[1] )\n");
        rcmArray2.push(" plSD= c(plSD, sqrt(kx$M[2]),kx$D[2] )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("for(i in 1:levA)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" kx= anova(lm(data~B, subset(ABs,A==i) ))\n");
        rcmArray2.push(" ss= c(ss, kx$S[1] )\n");
        rcmArray2.push(" plSD= c(plSD, sqrt(kx$M[2]),kx$D[2] )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("d1= rep(DF[1:2], c(levB,levA) )\n");
        rcmArray2.push("d2= rep(DF[4],levB+levA )\n");
        rcmArray2.push("ms= rep(MS[4],levB+levA )\n");
        rcmArray2.push("hx= TsF(ss,d1,d2,ms, adj=1 )\n");
        rcmArray2.push("tkAB= rbind(tkAB, hx[1:levB,],rep(NA,6),hx[(levB+1):(levB+levA),],tx1[4,] )\n");
        rcmArray2.push("rownames(tkAB)= c(paste(\"A at_B\",1:levB,sep=\"\"),\"\",paste(\"B at_A\",1:levA,sep=\"\"),\"  ｓ\" )\n");
        rcmArray2.push("colnames(tkAB)= c(\"SS\",\"df\",\"MS\",\"Ｆ\",\"adjust_p\",\"   ηp2\" )\n");
        rcmArray2.push("\n");
        rcmArray2.push("plSD= matrix(round(plSD,4), nc=2,by=1 )\n");
        rcmArray2.push("rownames(plSD)= rownames(tkAB)[c(-(levB+1),-nrow(tkAB))]\n");
        rcmArray2.push("colnames(plSD)= c(\"pooled_SD\",\"   DF\" )\n");
        rcmArray2.push("\n");
        rcmArray2.push("# 多重比較\n");
        rcmArray2.push("yuiA=c(); AatB=c()\n");
        rcmArray2.push("for( j in 1:levB ) if( hx[j,5]<0.15 ) yuiA=c(yuiA, j )\n");
        rcmArray2.push("kazA= length(yuiA)\n");
        rcmArray2.push("if( kazA>0 & levA>2 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" mds=c()\n");
        rcmArray2.push(" for( z in 1:kazA )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiA[z]\n");
        rcmArray2.push(" dt= subset(ABs, B==sjn )\n");
        rcmArray2.push(" kx= pairwise.t.test(dt$data, dt$A, p.ad=taju)$p.va\n");
        rcmArray2.push(" AatB= rbind(AatB, round(kx,4) )\n");
        rcmArray2.push(" mds= c(mds, paste(\"A\",2:levA,\" at_B\",sjn, sep=\"\") )\n");
        rcmArray2.push(" if(z<kazA){ AatB=rbind(AatB, rep(NA,levA-1) ); mds=c(mds,\"\") }\n");
        rcmArray2.push("}\n");
        rcmArray2.push(" rownames(AatB)= mds\n");
        rcmArray2.push(" colnames(AatB)= paste(\"A\",1:(levA-1), sep=\"\" )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("\n");
        rcmArray2.push("yuiB=c(); BatA=c()\n");
        rcmArray2.push("for( i in 1:levA ) if( hx[levB+i,5]<0.15 ) yuiB=c(yuiB, i )\n");
        rcmArray2.push("kazB= length(yuiB)\n");
        rcmArray2.push("if( kazB>0 & levB>2 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" mds=c()\n");
        rcmArray2.push(" for( z in 1:kazB )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiB[z]\n");
        rcmArray2.push(" dt= subset(ABs, A==sjn )\n");
        rcmArray2.push(" kx= pairwise.t.test(dt$data,dt$B, p.ad=taju)$p.va\n");
        rcmArray2.push(" BatA= rbind(BatA, round(kx,4) )\n");
        rcmArray2.push(" mds= c(mds, paste(\"B\",2:levB,\" at_A\",sjn, sep=\"\") )\n");
        rcmArray2.push(" if(z<kazB){ BatA=rbind(BatA, rep(NA,levB-1) ); mds=c(mds,\"\") }\n");
        rcmArray2.push("}\n");
        rcmArray2.push(" rownames(BatA)= mds\n");
        rcmArray2.push(" colnames(BatA)= paste(\"B\",1:(levB-1), sep=\"\" )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("\n");
        rcmArray2.push("\n");
        rcmArray2.push("# ■結果の書き方\n");
        rcmArray2.push("HKx= function(a,b) round(tx0[(a-1)*(levB+1)+b, 1:2], 3 )\n");
        rcmArray2.push("TstT=function(A水準=0,A相手=0,atB=0, B水準=0,B相手=0,atA=0)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" if(A水準>0 & A相手>0){ h1=HKx(A水準,atB); h2=HKx(A相手,atB); atL=atB }\n");
        rcmArray2.push(" if(B水準>0 & B相手>0){ h1=HKx(atA,B水準); h2=HKx(atA,B相手); atL=levB+atA }\n");
        rcmArray2.push(" tch= abs(h1[2]-h2[2])/( sqrt(1/h1[1]+1/h2[1])*plSD[atL,1] )\n");
        rcmArray2.push(" df2= plSD[atL,2]\n");
        rcmArray2.push(" nPV= pt(tch,df2,low=0)*2\n");
        rcmArray2.push(" cat(paste(\"t(\",df2,\")=\",round(tch,4),\", non-adjusted p=\",round(nPV,4),\"(両側)\n\", sep=\"\") )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("mds=\"単純主効果\"\n");
        rcmArray2.push("Tari= 1\n");
        rcmArray2.push("txt= paste(txt, \"\n　有意性を示した\",NAM[3],\"について\",mds,\"検定 (α=0.15) を行った (Table(tkAB)参照)。\n　その結果，\",mds,\"Aは，\", sep=\"\" )\n");
        rcmArray2.push("\n");
        rcmArray2.push("if( kazA<1 ) txt=paste(txt,\"Bのいずれの水準においても有意でなかった (adjusted ps>\",PV(min(hx[1:levB,5])),\")。\", sep=\"\" ) else\n");
        rcmArray2.push("{ #####\n");
        rcmArray2.push("for(j in 1:kazA)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiA[j]\n");
        rcmArray2.push(" tmp= hx[sjn, 4:6]\n");
        rcmArray2.push(" fuki= paste(\" (F(\",DF[1],\",\",DF[4],\")=\",round(tmp[1],3),\", adjusted p=\",PV(tmp[2]),\", ηp2=\",round(tmp[3],3),\")\", sep=\"\" )\n");
        rcmArray2.push(" if( j==2 ) mata=\"また\" else mata=\"\"\n");
        rcmArray2.push(" if(j<kazA){ gok1=\"であり\"; gok2=\"，\" } else { gok1=\"であった\"; gok2=\"。\" }\n");
        rcmArray2.push(" txt= paste(txt, mata,\"B\",sjn,\"において有意\",gok1,fuki,gok2, sep=\"\" )\n");
        rcmArray2.push("} # for(j)\n");
        rcmArray2.push("\n");
        rcmArray2.push("if( levA==2 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" for(j in 1:kazA)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiA[j]\n");
        rcmArray2.push(" hk1= HKx(1,sjn); hk2=HKx(2,sjn)\n");
        rcmArray2.push(" if( hk1[2]>hk2[2] ) tmp=\"大きい\" else tmp=\"小さい\"\n");
        rcmArray2.push(" if(j==1) mata=\"\n　したがって，\" else if(j==2) mata=\"また\" else mata=\"\"\n");
        rcmArray2.push(" if(j<kazA) goku=\"，\" else goku=\"が見いだされた。\"\n");
        rcmArray2.push(" txt= paste(txt, mata,\"B\",sjn,\"においてA1の平均\",hk1[2],\"がA2の平均\",hk2[2],\"よりも\",tmp,\"こと\",goku, sep=\"\" )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("} else { # if(levA)\n");
        rcmArray2.push(" txt= paste(txt, \"\n　プールドSDを用いたｔ検定による多重比較 (α=0.05, 両側検定) を行った結果，\", sep=\"\" )\n");
        rcmArray2.push(" yuis= sum(AatB<0.05, na.rm=1 )\n");
        rcmArray2.push(" sumi= 0\n");
        rcmArray2.push(" for(j in 1:kazA)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiA[j]\n");
        rcmArray2.push(" if(j==2) mata=\"また，\" else mata=\"\"\n");
        rcmArray2.push(" txt= paste(txt, mata,\"B\",sjn,\"において，\", sep=\"\" )\n");
        rcmArray2.push(" st=(j-1)*levA+1; ed=st+levA-2\n");
        rcmArray2.push(" minP= min(AatB[st:ed,], na.rm=1 )\n");
        rcmArray2.push(" if( minP>=0.10 ) txt=paste(txt, \"どの水準の間にも有意な平均の差は見られなかった (adjusted ps>\",PV(minP),\")。\", sep=\"\" ) else\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" for(x in 1:(levA-1)){ for(y in (x+1):levA){\n");
        rcmArray2.push(" adP= AatB[ levA*(j-1)+y-1, x ]\n");
        rcmArray2.push(" if( adP<0.10 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"\"\n");
        rcmArray2.push(" hk1=HKx(x,sjn); hk2=HKx(y,sjn)\n");
        rcmArray2.push(" tx= plSD[sjn,]\n");
        rcmArray2.push(" tch= abs(hk1[2]-hk2[2])/( sqrt(1/hk1[1]+1/hk2[1])*tx[1] )\n");
        rcmArray2.push(" fuki= paste(\" (t(\",tx[2],\")=\",round(tch,3),\", adjusted p=\",PV(adP),\")\", sep=\"\" )\n");
        rcmArray2.push(" if( hk1[2]>hk2[2] ) tmp=\"大き\" else tmp=\"小さ\"\n");
        rcmArray2.push(" sumi= sumi+1\n");
        rcmArray2.push(" if( sumi<yuis ){ gok1=\"り\";gok2=\"，\" } else { gok1=\"った\";gok2=\"。\" }\n");
        rcmArray2.push(" if( adP<0.05 ) if( sumi<yuis ) gok1=\"く\" else gok1=\"かった\"\n");
        rcmArray2.push(" txt= paste(txt, \"A\",x,\"の平均\",hk1[2],\"がA\",y,\"の平均\",hk2[2],\"よりも有意に\",tmp,keko,gok1,fuki,gok2, sep=\"\" )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("}  } # for(x)(y)\n");
        rcmArray2.push("} # if(minP)\n");
        rcmArray2.push("} # for(j)\n");
        rcmArray2.push("} # if(levA)\n");
        rcmArray2.push("} # if(kazA)\n");
        rcmArray2.push("\n");
        rcmArray2.push("if( kazA<1 & kazB<1 ) goku=\"も，\" else goku=\"は，\"\n");
        rcmArray2.push("txt= paste(txt, \"\n　一方，\",mds,\"B\",goku, sep=\"\" )\n");
        rcmArray2.push("if( kazB<1 ) txt=paste(txt,\"Aのいずれの水準においても有意でなかった (adjusted ps>\",PV(min(hx[(levB+1):(levB+levA),5])),\")。\", sep=\"\" ) else\n");
        rcmArray2.push("{ #####\n");
        rcmArray2.push("for(j in 1:kazB)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiB[j]\n");
        rcmArray2.push(" tmp= hx[sjn+levB, 4:6]\n");
        rcmArray2.push(" fuki= paste(\" (F(\",DF[2],\",\",DF[4],\")=\",round(tmp[1],3),\", adjusted p=\",PV(tmp[2]),\", ηp2=\",round(tmp[3],3),\")\", sep=\"\" )\n");
        rcmArray2.push(" if( j==2 ) mata=\"また\" else mata=\"\"\n");
        rcmArray2.push(" if(j<kazB){ gok1=\"であり\"; gok2=\"，\" } else { gok1=\"であった\"; gok2=\"。\" }\n");
        rcmArray2.push(" txt= paste(txt, mata,\"A\",sjn,\"において有意\",gok1,fuki,gok2, sep=\"\" )\n");
        rcmArray2.push("} # for(j)\n");
        rcmArray2.push("\n");
        rcmArray2.push("if( levB==2 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" for(j in 1:kazB)\n");
        rcmArray2.push("   {\n");
        rcmArray2.push("    sjn= yuiB[j]\n");
        rcmArray2.push("    hk1=HKx(sjn,1); hk2=HKx(sjn,2)\n");
        rcmArray2.push("    if( hk1[2]>hk2[2] ) tmp=\"大きい\" else tmp=\"小さい\"\n");
        rcmArray2.push("    if(j==1) mata=\"\n　したがって，\" else if(j==2) mata=\"また\" else mata=\"\"\n");
        rcmArray2.push("    if(j<kazB) goku=\"，\" else goku=\"が見いだされた。\"\n");
        rcmArray2.push("    txt= paste(txt, mata,\"A\",sjn,\"においてB1の平均\",hk1[2],\"がB2の平均\",hk2[2],\"よりも\",tmp,\"こと\",goku, sep=\"\" )\n");
        rcmArray2.push("   }\n");
        rcmArray2.push("} else { # if(levB)\n");
        rcmArray2.push(" txt= paste(txt, \"\n　プールドSDを用いたｔ検定による多重比較 (α=0.05, 両側検定) を行った結果，\", sep=\"\" )\n");
        rcmArray2.push(" yuis= sum(BatA<0.05, na.rm=1 )\n");
        rcmArray2.push(" sumi= 0\n");
        rcmArray2.push(" for(j in 1:kazB)\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" sjn= yuiB[j]\n");
        rcmArray2.push(" if(j==2) mata=\"また，\" else mata=\"\"\n");
        rcmArray2.push(" txt= paste(txt, mata,\"A\",sjn,\"において，\", sep=\"\" )\n");
        rcmArray2.push(" st=(j-1)*levB+1; ed=st+levB-2\n");
        rcmArray2.push(" minP= min(BatA[st:ed,], na.rm=1 )\n");
        rcmArray2.push(" if( minP>=0.10 ) txt=paste(txt, \"どの水準の間にも有意な平均の差は見られなかった (adjusted ps>\",PV(minP),\")。\", sep=\"\" ) else\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" for(x in 1:(levB-1)){ for(y in (x+1):levB){\n");
        rcmArray2.push(" adP= BatA[ levB*(j-1)+y-1, x ]\n");
        rcmArray2.push(" if( adP<0.10 )\n");
        rcmArray2.push("{\n");
        rcmArray2.push(" keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"\"\n");
        rcmArray2.push(" hk1=HKx(sjn,x); hk2=HKx(sjn,y)\n");
        rcmArray2.push(" tx= plSD[levB+sjn,]\n");
        rcmArray2.push(" tch= abs(hk1[2]-hk2[2])/( sqrt(1/hk1[1]+1/hk2[1])*tx[1] )\n");
        rcmArray2.push(" fuki= paste(\" (t(\",tx[2],\")=\",round(tch,3),\", adjusted p=\",PV(adP),\")\", sep=\"\" )\n");
        rcmArray2.push(" if( hk1[2]>hk2[2] ) tmp=\"大き\" else tmp=\"小さ\"\n");
        rcmArray2.push(" sumi= sumi+1\n");
        rcmArray2.push(" if( sumi<yuis ){ gok1=\"り\";gok2=\"，\" } else { gok1=\"った\";gok2=\"。\" }\n");
        rcmArray2.push(" if( adP<0.05 ) if( sumi<yuis ) gok1=\"く\" else gok1=\"かった\"\n");
        rcmArray2.push(" txt= paste(txt, \"B\",x,\"の平均\",hk1[2],\"がB\",y,\"の平均\",hk2[2],\"よりも有意に\",tmp,keko,gok1,fuki,gok2, sep=\"\" )\n");
        rcmArray2.push("}\n");
        rcmArray2.push("}  } # for(x)(y)\n");
        rcmArray2.push("} # if(minP)\n");
        rcmArray2.push("} # for(j)\n");
        rcmArray2.push("} # if(levA)\n");
        rcmArray2.push("} # if(kazB)\n");
        rcmArray2.push("if( Tari>0 ) txt=paste(txt, \"\n　以上のp値の調整には\",TAJ,\"の方法を用いた。\n\", sep=\"\" )\n");
        rcmArray2.push("} # if(Pch)\n");
        rcmArray2.push("\n");
        rcmArray2.push("if( Tari>0 & taju==\"BH\" ) txt= paste(txt, \"\n［引用文献］\n\",\n");
        rcmArray2.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
        rcmArray2.push("\n");
        rcmArray2.push("options(digits=5)\n");
        rcmArray2.push("options(scipen=5)\n");
        rcmArray2.push("###############################\n");
        rcmArray2.push("#   分散分析 ＡＢｓ-design\n");
        rcmArray2.push("#   ２要因  参加者間計画\n");
        rcmArray2.push("#\n");
        rcmArray2.push("#    交互作用Ａ×Ｂの分析\n");
        rcmArray2.push("H##############################\n");
        rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
        rcmArray2.push("# 歪度,尖度,SEなどは『オプション』参照\n");
        rcmArray2.push("\n");
        rcmArray2.push("tx1 # 分散分析ＡＢｓ\n");
        rcmArray2.push("    # 効果量ηp2 は偏イータ２乗\n");
        rcmArray2.push("\n");
        rcmArray2.push("tx2 # 効果量ｆ,検出力(1-β),追試用Ｎ\n");
        rcmArray2.push("# 効果量ｆの評価：大=0.40, 中=0.25, 小=0.10\n");
        rcmArray2.push("# 「次回のＮ」は α=0.05, 検出力=0.80 を想定\n");
        rcmArray2.push("\n");
        rcmArray2.push("tx8 # 分散の均一性の検定\n");
        rcmArray2.push("\n");
        rcmArray2.push("hkA;mcA # 主効果Ａの平均と多重比較の調整後ｐ値\n");
        rcmArray2.push("\n");
        rcmArray2.push("hkB;mcB # 主効果Ｂの平均と多重比較の調整後ｐ値\n");
        rcmArray2.push("\n");
        rcmArray2.push("###### ここから交互作用の分析 ######\n");
        rcmArray2.push("\n");
        rcmArray2.push("tkAB # ＡxＢの単純主効果検定（α=0.15推奨）\n");
        rcmArray2.push("AatB # A at_B の多重比較（数値は調整後ｐ値）\n");
        rcmArray2.push("BatA # B at_A の多重比較（数値は調整後ｐ値）\n");
        rcmArray2.push("\n");
        rcmArray2.push("cat(txt) # 結果の書き方\n");
        rcmArray2.push("\n");
        rcmArray2.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
        if (navigator.platform.indexOf("Win") != -1) {
            rcmArray2.push("windows();boxplot(data~A*B,ABs) # 箱ひげ図\n");
        }
        if (navigator.platform.indexOf("Mac") != -1) {
            rcmArray2.push("quartz();boxplot(data~A*B,ABs) # 箱ひげ図\n");
        }
        rcmArray2.push("# ty2  # TypeⅡ_SS\n");
        rcmArray2.push("# txD  # Median,歪度,尖度,SEなど\n");
        rcmArray2.push("# plSD # 単純主効果A,BのプールドSD\n");
        rcmArray2.push("# TstT(A水準=1, A相手=2, atB=1 ) # A at_B のｔ検定\n");
        rcmArray2.push("# TstT(B水準=1, B相手=2, atA=1 ) # B at_A のｔ検定\n");
        rcmArray2.push("# write(txt,file.choose(),ap=T)  # 結果のファイル保存\n");
        rcmArray2.push("\n");
        rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
        rcmArray2.push("\n");

        document.getElementById("RcmArea2").value = rcmArray2.join("");
        rcmArray = null;

    }());	//Ｒプログラムここまで

    //グラフ描画
    (function () {
        chartClear();

        var i, j;
        var g;

        var chartImg = document.createElement('canvas');
        chartImg.id = "ChartImg0";
        var ctx = document.getElementById("chart").appendChild(chartImg);

        var graphType = document.getElementById("graphSelect").value;
        var legendName = document.getElementById("legendSelect").value;

        var data;
        var datasetKey = [];
        if (legendName === 'A') {
            data = new Array(LA);
            for (i = 0; i < LA; i++) {
                data[i] = new Array(LB);
            }
            for (i = 0; i < LA; i++) {
                for (j = 0; j < LB; j++) {
                    data[i][j] = Math.round(M[i][j] * 10) / 10;
                }
            }

            for (i = 0; i < LA + 1; i++) {
                datasetKey[i] = [];
            }
        }
        if (legendName === 'B') {
            data = new Array(LB);
            for (j = 0; j < LB; j++) {
                data[j] = new Array(LA);
            }
            for (j = 0; j < LB; j++) {
                for (i = 0; i < LA; i++) {
                    data[j][i] = Math.round(M[i][j] * 10) / 10;
                }
            }

            for (j = 0; j < LB + 1; j++) {
                datasetKey[j] = [];
            }
        }

        var max_y = M[0][0];
        var min_y = 0;
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                if (max_y < M[i][j]) max_y = Math.round(M[i][j] * 10) / 10;
                if (min_y > M[i][j]) min_y = Math.round(M[i][j] * 10) / 10;
            }
        }
        var _myMax = gCheck.match(/max:\d+/);
        if (_myMax !== null) {
            var myMax = _myMax[0].match(/\d+/);
            max_y = parseFloat(myMax, 10);
        }
        var _myMin = gCheck.match(/min:\d+/);
        if (_myMin !== null) {
            var myMin = _myMin[0].match(/\d+/);
            min_y = parseFloat(myMin, 10);
        }

        //カラーユニバーサルデザイン推奨配色セット制作委員会
        //https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
        var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

        // 複合グラフを作成する
        datasetKey[0].label = ''; //ラベルを空白にする

        var start;
        var end;
        // 折れ線グラフ
        if (graphType === 'line') {
            if (legendName === 'A') {
                start = 1;
                end = LA + 1;
            }
            if (legendName === 'B') {
                start = 1;
                end = LB + 1;
            }
            for (g = start; g < end; g++) {
                datasetKey[g].label = legendName + g;
                datasetKey[g].data = data[g - 1];
                datasetKey[g].backgroundColor = chartClrAry[(g - 1) % chartClrAry.length];
                datasetKey[g].borderColor = chartClrAry[(g - 1) % chartClrAry.length];
                datasetKey[g].pointBorderWidth = 3;
                datasetKey[g].borderWidth = 1;
                datasetKey[g].lineTension = 0;
                datasetKey[g].type = graphType; //折れ線グラフを指定				// datasetKey[i].type = 'line'; //折れ線グラフを指定
            }
        }

        // 棒グラフ
        if (graphType === 'bar') {
            if (legendName === 'A') {
                start = 0;
                end = LA;
            }
            if (legendName === 'B') {
                start = 0;
                end = LB;
            }
            for (g = start; g < end; g++) {
                datasetKey[g].label = legendName + (g + 1);
                datasetKey[g].data = data[g];
                datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length];
                datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
                datasetKey[g].pointBorderWidth = 3;
                datasetKey[g].borderWidth = 1;
                datasetKey[g].lineTension = 0;
                datasetKey[g].type = graphType; //折れ線グラフを指定
            }
        }

        var labelData = [];
        if (legendName === 'A') {
            for (j = 0; j < LB; j++) {
                labelData.push('B' + (j + 1));
            }
        }
        if (legendName === 'B') {
            for (i = 0; i < LA; i++) {
                labelData.push('A' + (i + 1));
            }
        }

        var datasetData = [];
        for (g = 0; g < end; g++) {
            datasetData[g] = datasetKey[g];
        }

        var myChart = new Chart(ctx, {
            type: 'bar', //最初に棒グラフを指定
            data: {
                labels: labelData,
                datasets: datasetData
            },
            options: {
                scales: {
                    xAxes: [{
                        maxBarThickness: 30,
                        ticks: {
                        }
                    }],
                    yAxes: [{
                        ticks: {
                            suggestedMin: min_y,
                            suggestedMax: max_y
                        }
                    }]
                },
                legend: {
                    position: 'right',
                    display: true,
                    labels: { //空白ラベルだったら表示しない
                        filter: function (items, chart) {
                            return items.text != '';
                        },
                    }
                },
                title: {
                    display: true,
                    text: 'Mean'
                }
            }
        });

        //箱ひげ図
        var addData = [];
        var myData = [];
        var arrayCol = [];

        if (legendName === 'A') {
            for (i = 0; i < LA; i++) {
                myData[i] = [];
            }

            for (j = 0; j < LB; j++) {
                for (i = 0; i < LA; i++) {
                    arrayCol = [];
                    for (k = 0; k < NN[i][j]; k++) {
                        arrayCol.push(xx[i][j][k]);
                    }
                    myData[i].push(arrayCol);
                }
            }
        }
        if (legendName === 'B') {
            for (j = 0; j < LB; j++) {
                myData[j] = [];
            }

            for (i = 0; i < LA; i++) {
                for (j = 0; j < LB; j++) {
                    arrayCol = [];
                    for (k = 0; k < NN[i][j]; k++) {
                        arrayCol.push(xx[i][j][k]);
                    }
                    myData[j].push(arrayCol);
                }
            }
        }

        chartImg = document.createElement('canvas');
        chartImg.id = "ChartImg1";
        ctx = document.getElementById("chart").appendChild(chartImg);

        if (legendName === 'A') {
            start = 0;
            end = LA;
        }
        if (legendName === 'B') {
            start = 0;
            end = LB;
        }

        datasetKey = [];
        for (g = 0; g < end; g++) {
            datasetKey[g] = [];
        }

        for (g = 0; g < end; g++) {
            datasetKey[g].label = legendName + (g + 1);
            datasetKey[g].data = myData[g];
            datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length] + '33';
            datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
            datasetKey[g].borderWidth = 1;
            datasetKey[g].outlierRadius = 3;
            datasetKey[g].itemRadius = 3;
            datasetKey[g].outlierColor = '#999999';
        }

        labelData = [];
        if (legendName === 'A') {
            for (j = 0; j < LB; j++) {
                labelData.push('B' + (j + 1));
            }
        }
        if (legendName === 'B') {
            for (i = 0; i < LA; i++) {
                labelData.push('A' + (i + 1));
            }
        }

        datasetData = [];
        for (g = 0; g < end; g++) {
            datasetData[g] = datasetKey[g];
        }

        var myChart2 = new Chart(ctx, {
            type: 'boxplot',
            data: {
                labels: labelData,
                datasets: datasetData
            },
            options: {
                responsive: true,
                scales: {
                    yAxes: [{
                        ticks: {
                            suggestedMin: min_y,
                            suggestedMax: max_y
                        }
                    }]
                },
                legend: {
                    position: 'right',
                },
                title: {
                    display: true,
                    text: 'Boxplot'
                }
            }
        });
    }());	//グラフ描画ここまで

    var RltAreaObj = document.getElementById("RltArea");
    RltAreaObj.focus();
    RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
    RltAreaObj.scrollTop = 0;
}
/**
 * [changeAbsSetting id="abs_setting"の書き換え]
 *
 * 要因Aの名前 1行テキストボックスのid factorA_name
 * 要因Aの水準数1行テキストボックスのid factorA_number
 * 要因Bの名前 1行テキストボックスのid factorB_name
 * 要因Bの水準数1行テキストボックスのid factorB_number
 *
 */
function changeAbsSetting() {
    var htmArray = [];

    // freqdata2を使うか要検討 todo
    // htmArray.push("<div class=\"freqdata2\">");
    htmArray.push("<div class=\"tateyoko\">");
    htmArray.push("<table border=\"0\" class=\"codetb\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因A 名＿前：</td>");
    htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");

    htmArray.push("</tr>");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因A 水準数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAbsSetting2();\">");
    } else {
        htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 水準数');changeAbsSetting2();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\">5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");
    htmArray.push("</table>");

    htmArray.push("<table border=\"0\" class=\"codetb3\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因B 名＿前：</td>");
    htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorB_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"B\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn2');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn2');\"><span id=\"cellClrBtn2\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorB_name','cellClrBtn2');\" >×</span></td>");

    htmArray.push("</tr>");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因B 水準数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorB_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAbsSetting2();\">");
    } else {
        htmArray.push("<select id=\"factorB_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因B 水準数');changeAbsSetting2();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\">5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");
    htmArray.push("</table>");

    htmArray.push("</div>");

    document.getElementById("abs_setting").innerHTML = htmArray.join("");
    htmArray = null;

    changeAbsSetting2();
}
function changeAbsSetting2() {
    var i = 0;
    var j = 0;
    var h = 3;
    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);

    var htmArray = [];

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<table border=\"0\" class=\"codetb5\">");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                htmArray.push("<tr>");
                htmArray.push("<td class=\"codetbL\">A" + (i + 1) + " B" + (j + 1) + " 参加者数：</td>");
                htmArray.push("<td class=\"codetbR\">");
                htmArray.push("<input type=\"number\" class=\"text9\" id=\"A" + (i + 1) + "B" + (j + 1) + "_subjNum\"" + " size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAbsTable();\">");

                htmArray.push("</td>");
                htmArray.push("</tr>");
            }
        }
        htmArray.push("</table>");
    } else {
        htmArray.push("<table border=\"0\" class=\"codetb5\">");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                htmArray.push("<tr>");
                htmArray.push("<td class=\"codetbL\">A" + (i + 1) + " B" + (j + 1) + " 参加者数：</td>");
                htmArray.push("<td class=\"codetbR\">");
                htmArray.push("<select id=\"A" + (i + 1) + "B" + (j + 1) + "_subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 第" + (i + 1) + "水準 要因B 第" + (j + 1) + "水準 参加者数');changeAbsTable();\">");
                htmArray.push("<option value=\"2\" selected>2</option>");

                for (h = 3; h < 31; h++) {
                    htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
                }

                htmArray.push("<option value=\"-1\">他</option>");
                htmArray.push("</select>");
                htmArray.push("</td>");
                htmArray.push("</tr>");
            }
        }
        htmArray.push("</table>");
    }

    document.getElementById("abs_setting2").innerHTML = htmArray.join("");
    htmArray = null;

    changeAbsTable();
}
function changeAbsTable() {
    var i = 0;
    var j = 0;
    var k = 0;
    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);
    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var htmArray = [];
    var cellId = 1;
    var sCount = 1;

    var cellCount = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            cellCount += NN[i][j];
        }
    }

    var NA = new Array(LA);
    for (i = 0; i < LA; i++) {
        NA[i] = 0;
        for (j = 0; j < LB; j++) {
            NA[i] += NN[i][j];
        }
    }

    // htmArray.push("<div class=\"freqdata3\">");
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("要因A");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("要因B");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("参加者");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("データ");
    htmArray.push("</td>");
    htmArray.push("</tr>");

    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            for (k = 0; k < NN[i][j]; k++) {
                htmArray.push("<tr>");
                if ((j === 0) && (k === 0)) {
                    htmArray.push("<td ROWSPAN=\"" + NA[i] + "\" class=\"hyou_midashi_3d_title\">");
                    htmArray.push("A" + (i + 1));
                    htmArray.push("</td>");
                }
                if (k === 0) {
                    htmArray.push("<td ROWSPAN=\"" + NN[i][j] + "\" class=\"hyou_midashi_3d_title\">");
                    htmArray.push("B" + (j + 1));
                    htmArray.push("</td>");
                }

                if (k === 0) {
                    htmArray.push("<td class=\"hyou_midashi_3d_top\">");
                } else {
                    htmArray.push("<td class=\"hyou_midashi_3d\">");
                }
                htmArray.push(sCount);
                htmArray.push("</td>");

                htmArray.push("<td class=\"hyou_nyuryoku\">");
                htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
                htmArray.push("</td>");
                cellId++;
                sCount++;
                htmArray.push("</tr>");
            }
        }
    }
    htmArray.push("</table>");

    document.getElementById("abs_table").innerHTML = htmArray.join("");
    htmArray = null;
}
function saveData_ABs() {
    var i, j, k;

    var strArray = [];

    var AA = document.getElementById("factorA_name").value;
    var LA = parseInt(document.getElementById("factorA_number").value, 10);
    var BB = document.getElementById("factorB_name").value;
    var LB = parseInt(document.getElementById("factorB_number").value, 10);

    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
        }
    }

    //#0
    strArray.push("ABs" + "\n");
    //#1
    strArray.push("#" + "\n");
    strArray.push(AA + "\n");
    //#2
    strArray.push("#" + "\n");
    strArray.push(LA + "\n");
    //#3
    strArray.push("#" + "\n");
    strArray.push(BB + "\n");
    //#4
    strArray.push("#" + "\n");
    strArray.push(LB + "\n");
    //#5
    strArray.push("#" + "\n");
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            if (i !== LA - 1 || j !== LB - 1) {
                strArray.push(NN[i][j] + ",");
            } else {
                strArray.push(NN[i][j]);
            }
        }
    }
    strArray.push("\n");
    //#6
    strArray.push("#" + "\n");
    var x;
    var cellId = 1;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            for (k = 0; k < NN[i][j]; k++) {
                x = document.getElementById("cell_" + cellId).value;
                strArray.push(x + "\n");
                cellId++;
            }
        }
    }

    var Stream = strArray.join("");
    var fineName = "ABs_Data-" + getDate() + ".txt";

    SaveToFile(fineName, Stream);
}
function dataHeaderProcess_ABs() {
    var readText = document.getElementById("CandPArea").value;
    var dd = [];
    dd = readText.split("#");

    if (crDel(dd[0]) === "ABs") {
        var AA = crDel(dd[1]);
        var LA = crDel(dd[2]);
        var BB = crDel(dd[3]);
        var LB = crDel(dd[4]);

        var nn_text = crDel(dd[5]);
        var _NN = [];
        _NN = nn_text.split(",");

        var NN = new Array(LA);
        for (i = 0; i < LA; i++) {
            NN[i] = new Array(LB);
        }

        var countN = 0;
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                NN[i][j] = _NN[countN];
                countN++;
            }
        }

        document.getElementById("factorA_name").value = AA;
        document.getElementById("factorA_number").value = parseInt(LA, 10);
        document.getElementById("factorB_name").value = BB;
        document.getElementById("factorB_number").value = parseInt(LB, 10);
        changeAbsSetting2();
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value = parseInt(NN[i][j], 10);
            }
        }
        changeAbsTable();
        document.getElementById("CandPArea").value = delTopCR(dd[6]);
    }
}
function simulation_Abs(event) {
    var key_event = event || window.event; //Firefox IE用
    var key_shift = (key_event.shiftKey);

    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);
    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }
    var nCount = 0;
    var Nflag = true; // NNの値が2であるかの判定，すべて2のときTure
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            nCount += parseInt(NN[i][j], 10);
            if (NN[i][j] !== 2) Nflag = false;
        }
    }

    var min, max;
    if ((LA === 2) && (LB === 2) && (Nflag)) {
        min = 2;
        max = 5;
        LA = Math.floor(Math.random() * (max - min + 1) + min);
        LB = Math.floor(Math.random() * (max - min + 1) + min);

        document.getElementById("factorA_number").value = LA;
        document.getElementById("factorB_number").value = LB;
        changeAbsSetting2();

        min = 5;
        max = 30;
        var rndN = 2;
        nCount = 0;
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                rndN = Math.floor(Math.random() * (max - min + 1) + min);
                document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value = rndN;
                nCount += rndN;
            }
        }

        changeAbsTable();
    }

    var result = "rnd1:9*" + nCount;

    document.getElementById("CandPArea").value = random_number_generation(result);

    copipe('CandPArea', 'text');
    inputTextArea(document.getElementById('CandPArea'), 0);

    mainCalc_ABs();
}