/**
 * ｔ検定
 * sT(参加者内)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeStSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		// sAには要因名があるが，sTにはない
		// document.getElementById("factorA_name").value = "A";

		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sT();
			//ノンパラ
			mainCalc_wilcoxon();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sT() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = "A";
	var LA = 2;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = []; //平均
	var S2 = []; //分散
	var SD = []; //標準偏差

	var D_M = 0; //水準１と水準２の差の平均
	var D_S2 = 0; //水準１と水準２の差の分散
	var D_SD = 0; //水準１と水準２の差の標準偏差

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ 対応のあるｔ検定(paired t-Test) ]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push(bar);
	strArray.push("          N      Mean      S.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN;
		S2[i] = SS / NN - Math.pow(M[i], 2);
		SD[i] = Math.sqrt(S2[i]);

		M[i] = parseFloat(M[i].toFixed(2));
		S2[i] = parseFloat(S2[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));

		strArray.push(('水準' + (i + 1) + NN.format(" ", 6) + M[i].format(" ", 10) + SD[i].format(" ", 10) + '\n'));
	}


	S = 0;
	for (j = 0; j < NN; j++) {
		S += xx[0][j] - xx[1][j];
	}
	D_M = S / NN;

	var D = 0;
	var DD = 0;
	for (j = 0; j < NN; j++) {
		D = xx[0][j] - xx[1][j];
		DD += Math.pow(D - D_M, 2);
	}
	D_S2 = DD / NN;
	D_SD = Math.sqrt(D_S2);

	D_M = parseFloat(D_M.toFixed(2));
	D_S2 = parseFloat(D_S2.toFixed(2));
	D_SD = parseFloat(D_SD.toFixed(2));

	strArray.push(bar);
	strArray.push((' 差  ' + NN.format(" ", 6) + D_M.format(" ", 10) + D_SD.format(" ", 10) + '\n'));
	strArray.push(bar);

	//自由度
	var DF = NN - 1;
	//T値
	var T = Math.abs(D_M / (D_SD / Math.sqrt(NN - 1)));
	T = parseFloat(T.toFixed(4));
	var PP2 = t_table(DF, T);

	var ppStr = "";
	if (PP2 === 0.01) {
		ppStr = "   ** (p<.01)";
	}
	if (PP2 === 0.05) {
		ppStr = "   *  (p<.05)";
	}
	if (PP2 === 0.10) {
		ppStr = "   +  (.05<p<.10)";
	}
	if (PP2 === 1) {
		ppStr = "   ns (.10<p)";
	}

	strArray.push((' t(' + DF + ')= ' + T + ' , ' + ppStr + '\n'));
	strArray.push(bar);
	// strArray.push('※ S.D.は標本標準偏差\n');
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n\n");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("##### 対応のあるｔ検定／参加者内\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ psych          が必要\n");
		rcmArray.push("# パッケージ exactRankTests が必要\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		for (i = 0; i < LA; i++) {
			rcmArray.push("g" + (i + 1) + " <- c(");
			for (j = 0; j < NN; j++) {
				rcmArray.push(xx[i][j]);
				if (j < NN - 1) rcmArray.push(", ");
			}
			rcmArray.push(") # 水準" + (i + 1) + "\n");
		}
		rcmArray.push("\n");
		var shinrai = document.getElementById("shinrai").value;
		rcmArray.push("shinrai= " + shinrai + " # 信頼水準\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARから入力おわり\n");
		rcmArray.push("\n");
		rcmArray.push("# main\n");
		rcmArray.push("Title=\"平均と標準偏差(不偏分散の平方根)\"\n");
		rcmArray.push("n1=length(g1)\n");
		rcmArray.push("N=n1; n2=n1\n");
		rcmArray.push("hk= c(mean(g1), mean(g2)) # 平均\n");
		rcmArray.push("sd= c(  sd(g1),   sd(g2)) # s.d.\n");
		rcmArray.push("mi= c( min(g1),  min(g2))\n");
		rcmArray.push("ma= c( max(g1),  max(g2))\n");
		rcmArray.push("library(psych)\n");
		rcmArray.push("library(exactRankTests)\n");
		rcmArray.push("txD= c()\n");
		rcmArray.push("txD= rbind(describe(g1)[c(5,10:13)],describe(g2)[c(5,10:13)], describe(g1-g2)[c(5,10:13)] )\n");
		rcmArray.push("rownames(txD)= c(\"水準１\",\"水準２\",\"　差\" )\n");
		rcmArray.push("colnames(txD)= c(\"Median\",\"Range\",\"歪度\",\"尖度\",\"SE\" )\n");
		rcmArray.push("\n");
		rcmArray.push("## 作図\n");
		rcmArray.push("levA= 2                   # 水準数\n");
		rcmArray.push("suij= rep( 1:2 )          # 水準番号\n");
		rcmArray.push("xjik= c(1-0.3, levA+0.3)  # ｘ軸の範囲\n");
		rcmArray.push("bai=2                     # ｙ軸の拡幅倍率\n");
		rcmArray.push("shoh= min(min(hk),0)      # 最小平均か，ゼロ\n");
		rcmArray.push("dais= max(sd)             # 最大ＳＤ\n");
		rcmArray.push("yjik=c(shoh+dais*bai*sign(shoh), max(hk)+dais*bai) # ｙ軸の範囲\n");
		rcmArray.push("\n");
		rcmArray.push("for( L in 1:2 )\n");
		rcmArray.push("{\n");
		rcmArray.push("if( L==1 ) Sd=sd else { Sd=txD[1:2,5]; Title=\"平均とSE(標準誤差)\" }\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray.push("windows()\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray.push("quartz()\n");
		}
		rcmArray.push("plot( suij, hk,\n");
		rcmArray.push("      bty=\"l\", xli=xjik, yli=yjik,\n");
		rcmArray.push("      tck=0.03, las=1,\n");
		rcmArray.push("      xlab=\"水準番号\", ylab=\"平　均\",\n");
		rcmArray.push("      xaxt=\"n\", # ｘ軸ラベル非表示\n");
		rcmArray.push("      main=Title, cex.main=1.5,cex.lab=1.2 )\n");
		rcmArray.push("axis(side=1,  # 軸を描く場所（下）\n");
		rcmArray.push("     at= 1:2, # 目盛の場所\n");
		rcmArray.push("     labels=c(\"水準1\",\"水準2\"),cex.axis=1.2 )\n");
		rcmArray.push("arrows(suij,hk, suij,hk+Sd,    # アンテナを先に描く\n");
		rcmArray.push("       lwd=L,ang=90,len=0.15 ) # 矢羽の角度と長さ\n");
		rcmArray.push("arrows(suij,hk,suij,hk-Sd,lwd=L,ang=90,len=0.15 ) # 下向き\n");
		rcmArray.push("lines (suij,hk, lwd=2,col=1 ) # 描点を結ぶ\n");
		rcmArray.push("points(suij,hk, pch=21,cex=4,bg=1 )\n");
		rcmArray.push("}\n");
		rcmArray.push("\n");
		rcmArray.push("## 平均\n");
		rcmArray.push("tx0= c()\n");
		rcmArray.push("tx0= matrix(round(c(n1,n2,N,hk,mean(g1-g2),sd,sd(g1-g2),mi,min(g1-g2),ma,max(g1-g2)),4), nr=3 )\n");
		rcmArray.push("rownames(tx0)= rownames(txD)\n");
		rcmArray.push("colnames(tx0)= c(\"  Ｎ\",\"    Mean\",\"      SD\",\"    Min.\",\"    Max.\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 両側\n");
		rcmArray.push("kx1= t.test(g1,g2, paired=1,conf=shinrai )\n");
		rcmArray.push("Tch= abs(kx1$stat)\n");
		rcmArray.push("dof= kx1$para\n");
		rcmArray.push("Pch= kx1$p.va\n");
		rcmArray.push("ESd= Tch*sqrt( 1/N )\n");
		rcmArray.push("\n");
		rcmArray.push("cr1= qt(0.025,dof )\n");
		rcmArray.push("cr2= qt(0.975,dof )\n");
		rcmArray.push("NCP= ESd*sqrt( N )\n");
		rcmArray.push("Pow= pt(cr1,dof,NCP)+pt(cr2,dof,NCP,low=0)\n");
		rcmArray.push("tx1= matrix(round( c(Tch,dof,Pch,ESd,Pow), 4),nr=1,by=1 )\n");
		rcmArray.push("rownames(tx1)=\"対応あり\"\n");
		rcmArray.push("colnames(tx1)= c(\"  ｔ値\",\" df\",\"    ｐ値\",\"効果量dz\",\" 検出力\" )\n");
		rcmArray.push("\n");
		rcmArray.push("NN= c(NA,NA) # パワ\n");
		rcmArray.push("if( Pow<0.80 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" for( i in (N-1):10000 )\n");
		rcmArray.push("   {\n");
		rcmArray.push("    ncp= ESd*sqrt( i )\n");
		rcmArray.push("    pow= pt(qt(0.975,i-1),i-1,ncp,low=0 )\n");
		rcmArray.push("    if( pow>0.80 ){ NN=c(i,pow,NN); break }\n");
		rcmArray.push("   }\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" for( i in (N+1):0 )\n");
		rcmArray.push("   {\n");
		rcmArray.push("    ncp= ESd*sqrt( i )\n");
		rcmArray.push("    pow= pt(qt(0.975,i-1),i-1,ncp,low=0 )\n");
		rcmArray.push("    if( pow<0.80 ) break\n");
		rcmArray.push("    NN= c(i,pow, NN)\n");
		rcmArray.push("   }\n");
		rcmArray.push("}\n");
		rcmArray.push("tx5= c()\n");
		rcmArray.push("tx5= matrix( round( c(ESd,0.05,NN[2],NN[1],N), 4), nr=1 )\n");
		rcmArray.push("rownames(tx5)=\"\"\n");
		rcmArray.push("colnames(tx5)= c(\"効果量dz\",\"   α\",\"  検出力\",\"次回のＮ\",\"今回のＮ\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tx9= c() # 区間推定\n");
		rcmArray.push("cnf= kx1$conf[1:2]\n");
		rcmArray.push("tx9= matrix( round( c(hk[1]-hk[2],cnf), 4), nc=3,by=1 )\n");
		rcmArray.push("rownames(tx9)=\"平均の差\"\n");
		rcmArray.push("colnames(tx9)= c(\"点推定\",paste(shinrai*100,\"％信頼下限\",sep=\"\"),\"    上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# 片側\n");
		rcmArray.push("if( hk[1]-hk[2]>0 ) H1=\"g\" else H1=\"l\"\n");
		rcmArray.push("\n");
		rcmArray.push("kx4=c(); tx4=c()\n");
		rcmArray.push("kx4= t.test(g1,g2, paired=1, conf=shinrai, al=H1 )\n");
		rcmArray.push("pow= pt(qt(0.90,df=dof),df=dof,ncp=NCP,low=0 )\n");
		rcmArray.push("tx4= matrix(round(c(Tch,dof,kx4$p.va,ESd,pow),4),nr=1,by=1)\n");
		rcmArray.push("rownames(tx4)=\"対応あり\"\n");
		rcmArray.push("colnames(tx4)= colnames(tx1)\n");
		rcmArray.push("\n");
		rcmArray.push("tx8= c() # 区間推定\n");
		rcmArray.push("tx8= matrix( round(c(hk[1]-hk[2],kx4$conf[1:2]),4), nc=3,by=1 )\n");
		rcmArray.push("rownames(tx8)=\"平均の差\"\n");
		rcmArray.push("colnames(tx8)= c(\"点推定\",paste(shinrai*100,\"％信頼下限\",sep=\"\"),\"    上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("ds1=sum(g1-g2>0); ds2=sum(g1-g2<0)\n");
		rcmArray.push("hx= matrix(c(ds1,ds2), nr=1 )\n");
		rcmArray.push("rownames(hx)= paste(\"N=\",ds1+ds2,\"(タイを除外)\", sep=\"\" )\n");
		rcmArray.push("colnames(hx)= c(\"水準1>水準2\",\"水準1<水準2\")\n");
		rcmArray.push("kx= matrix(binom.test(ds1, ds1+ds2)$p.va, nr=1 )\n");
		rcmArray.push("rownames(kx)=\"正確二項検定(両側)\"\n");
		rcmArray.push("colnames(kx)=\"ｐ値\"\n");
		rcmArray.push("signTab=hx; signP=kx\n");
		rcmArray.push("\n");
		rcmArray.push("# ■結果の書き方\n");
		rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray.push("txt=c()\n");
		rcmArray.push("if( sum(sd==0)>0 ) txt=\"※分散=0 の水準があります。全データが同じ値です。以下の分析は信頼性がありません。\n\n\"\n");
		rcmArray.push("txt= paste(txt, \"　各水準の○○得点について基本統計量をTable(tx0) or Fig.■に示す。\n　ｔ検定を行った結果，両水準の平均の差は有意\", sep=\"\" )\n");
		rcmArray.push("ciLU= round(d.ci(ESd,n1=N), 3 )\n");
		rcmArray.push("ci95= paste(\" [95%CI \",ciLU[1],\" - \",ciLU[3],\"]\", sep=\"\" )\n");
		rcmArray.push("fuki= paste(\" (t=\",round(Tch,3),\", df=\",dof,\", p=\",PV(Pch),\", dz=\",round(ESd,3),ci95,\", 1-β=\",round(Pow,3),\", 両側検定)\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("goku=\"，\"\n");
		rcmArray.push("if( Pch<0.05 ) tmp=\"であり\" else\n");
		rcmArray.push("if( Pch<0.10 ) tmp=\"傾向であり\" else { tmp=\"でなかった\"; goku=\"。\" }\n");
		rcmArray.push("txt=paste(txt, tmp,fuki,goku, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("if( Pch<0.10 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   if( hk[1]>hk[2] ) goku=\"大き\" else goku=\"小さ\"\n");
		rcmArray.push("   tmp=\"い傾向があった。\"\n");
		rcmArray.push("   if( Pch<0.05 ) tmp=\"かった。\"\n");
		rcmArray.push("   txt= paste(txt, \"水準１の平均が水準２よりも有意に\",goku,tmp, sep=\"\" )\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("tmp=\"\"; goku=\"\"\n");
		rcmArray.push("if( Pch<0.10 )\n");
		rcmArray.push("  {\n");
		rcmArray.push("   if( Pow<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり，信頼性が低い。\" } else\n");
		rcmArray.push("   if( Pow<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない。\" else\n");
		rcmArray.push("   if( Pow<0.80 ) tmp=\"ほぼ十分といえる。\" else tmp=\"十分である。\"\n");
		rcmArray.push("   txt= paste(txt, goku,\"検出力 (1-β) は\",tmp, sep=\"\" )\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("goku=\"と推定される。\"; fuki=\"\"\n");
		rcmArray.push("if( Pch<0.10 & sum(cnf<0)!=1 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" diff= min(abs(cnf))\n");
		rcmArray.push(" if( diff>1 ){ tmp=\"以上\"; posa=floor(diff) } else { tmp=\"近い差\"; posa=1 }\n");
		rcmArray.push(" if( diff<0.80 ) goku=\"とはいえない。\"\n");
		rcmArray.push(" fuki= paste(\"であり，実質的に最小差は\",posa,\"ポイント\",tmp,\"を生じる\", sep=\"\" )\n");
		rcmArray.push("}\n");
		rcmArray.push("txt= paste(txt, \"\n　平均の差の\",shinrai*100,\"％信頼区間は\",round(cnf[1],3),\" - \",round(cnf[2],3),fuki,goku, sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("txt= paste(txt, \"\n\n⇒両水準の差の分布が正規分布ではない場合，または検定結果が有意でなかった場合，下の記述を参照してください。\n\", sep=\"\" )\n");
		rcmArray.push("library(psych)\n");
		rcmArray.push("library(exactRankTests)\n");
		rcmArray.push("kx= wilcox.exact(g1,g2, pair=1 )\n");
		rcmArray.push("pc= kx$p.va\n");
		rcmArray.push("fuki= paste(\" (V=\",kx$stat,\", p=\",PV(pc),\", 両側検定)。\n\", sep=\"\" )\n");
		rcmArray.push("if( pc<0.05 ) tmp=\"であった\" else \n");
		rcmArray.push("if( pc<0.10 ) tmp=\"傾向であった\" else tmp=\"でなかった\"\n");
		rcmArray.push("txt= paste(txt, \"\n　Wilcoxonの符号化順位検定 (signed rank test) を行った結果，両水準の順位の差は有意\",tmp,fuki, sep=\"\" )\n");
		rcmArray.push("Dai= sum( sign(g1-g2)>0 )\n");
		rcmArray.push("Sho= sum( sign(g1-g2)<0 )\n");
		rcmArray.push("Tie= N-Dai-Sho\n");
		rcmArray.push("pch= binom.test(Dai, Dai+Sho)$p.va\n");
		rcmArray.push("Sign1x2= matrix(c(Dai,Sho,Tie), nr=1,by=1 )\n");
		rcmArray.push("rownames(Sign1x2)= paste(\"N=\",N, sep=\"\" )\n");
		rcmArray.push("colnames(Sign1x2)= c(\"水準1>水準2\",\"　水準1<水準2\",\"　タイ\")\n");
		rcmArray.push("txt= paste(txt, \"\n　正確二項検定を用いたサイン検定の結果 (オプション(Sign1x2)参照)，\", sep=\"\" )\n");
		rcmArray.push("tmp= c(\"水準１\",\"水準２\")\n");
		rcmArray.push("if( pch<0.10 )\n");
		rcmArray.push("{\n");
		rcmArray.push(" keko=\"傾向がある\"; if( pch<0.05 ) keko=\"\"\n");
		rcmArray.push(" if( Dai<Sho ) tmp=tmp[2:1]\n");
		rcmArray.push(" txt= paste(txt, tmp[1],\"の値が\",tmp[2],\"の値より大きかった参加者数が，その逆の参加者数よりも有意に多い\",keko,\"ことが見いだされた\", sep=\"\" )\n");
		rcmArray.push("} else {\n");
		rcmArray.push(" txt= paste(txt, \"水準１の値が大きかった参加者数と水準２の値が大きかった参加者数に有意な差は見られなかった\", sep=\"\" )\n");
		rcmArray.push("}\n");
		rcmArray.push("txt= paste(txt, \" (p=\",PV(pch),\", 両側検定)。\n\", sep=\"\" )\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("#################################\n");
		rcmArray.push("#  対応のあるｔ検定  片側検定\n");
		rcmArray.push("#   (参加者内ｔ検定)\n");
		rcmArray.push("#\n");
		rcmArray.push("#  対立仮説： 平均1＞平均2\n");
		rcmArray.push("#          or 平均1＜平均2\n");
		rcmArray.push("#################################\n");
		rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 # ｔ検定（paired t-test）\n");
		rcmArray.push("    # 効果量dz＝ 平均の差／差のSD\n");
		rcmArray.push("\n");
		rcmArray.push("tx8 # 平均の差の信頼区間推定\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("################################\n");
		rcmArray.push("#  対応のあるｔ検定  両側検定\n");
		rcmArray.push("#   (参加者内ｔ検定)\n");
		rcmArray.push("#\n");
		rcmArray.push("#  対立仮説：平均1≠平均2\n");
		rcmArray.push("################################\n");
		rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
		rcmArray.push("# 歪度,尖度,SEなどは『オプション』参照\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 # ｔ検定（paired t-test）\n");
		rcmArray.push("    # 効果量dz＝ 平均の差／差のSD\n");
		rcmArray.push("\n");
		rcmArray.push("tx9 # 平均の差の信頼区間推定\n");
		rcmArray.push("\n");
		rcmArray.push("tx5 # 追試用パワーアナリシス\n");
		rcmArray.push("# αと検出力は次回の想定値\n");
		rcmArray.push("\n");
		rcmArray.push("cat(txt) # 結果の書き方\n");
		rcmArray.push("\n");
		rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# txD # Median,歪度,尖度,SEなど\n");
		rcmArray.push("# Sign1x2 # サイン検定の度数集計表\n");
		rcmArray.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = parseFloat(M[i].toFixed(1), 10);
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = parseFloat(M[i].toFixed(1), 10);
			if (min_y > M[i]) min_y = parseFloat(M[i].toFixed(1), 10);
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}

		// 複合グラフを作成する
		// 棒グラフ
		datasetKey[0].label = ''; //ラベルを空白にする

		// 折れ線グラフ
		datasetKey[1].label = '水準';
		datasetKey[1].data = data;
		datasetKey[1].backgroundColor = chartClrAry[0];
		datasetKey[1].borderColor = chartClrAry[0];
		datasetKey[1].pointBorderWidth = 3;
		datasetKey[1].borderWidth = 1;
		datasetKey[1].lineTension = 0;
		datasetKey[1].type = 'line'; //折れ線グラフを指定

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('水準' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < 2; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];
		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RcmArea").focus();
}

function changeStSetting() {
	var h = 3;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeStTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeStTable();\">");
		// htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onfocus=\"setSelectNum(0);\" onchange=\"addSelectItem5(this,'参加者数');changeStTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">2</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("st_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeStTable();
}
function changeStTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");
	// htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("st_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
// Wilcoxon検定
function mainCalc_wilcoxon() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = "A";
	var LA = 2;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var a = [[], []];
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			a[i].push(xx[i][j]);
		}
	}

	//平均，標準偏差  ＃＃現在は出力してはいない
	var M = [];
	var SD = [];

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		M[i] = parseFloat(M[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));
	}

	//最大値，最小値
	var MAX = [];
	var MIN = [];
	for (i = 0; i < LA; i++) {
		MAX[i] = xx[i][0];
		MIN[i] = xx[i][0];
		for (j = 0; j < NN; j++) {
			if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
			if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
		}
	}

	var N = 0;
	N = a[0].length;

	var addedArray = a[0].concat(a[1]);

	var diffencedArray = [];
	var diffencedArray2 = [];

	for (i = 0; i < N; i++) {
		diffencedArray.push(a[0][i] - a[1][i]);
	}

	diffencedArray2 = diffencedArray.filter(function (x) {
		if (x !== 0) {
			return true;
		}
	});

	// 差が0を除いたデータ数
	var wN = diffencedArray2.length;

	var diffencedArray3 = diffencedArray2.map(function (x) {
		return Math.abs(x);
	});

	var sortedArray = diffencedArray3.sort(compareNumbers);

	var rankedArray = [];
	for (i = 0; i < sortedArray.length; i++) {
		rankedArray[i] = i + 1;
	}

	for (i = 1; i < sortedArray.length; i++) {
		if (sortedArray[i] === sortedArray[i - 1]) {
			rankedArray[i] = rankedArray[i - 1];
		}
	}

	var countedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		countedArray[i] = 0;
		for (j = 0; j < rankedArray.length; j++) {
			if (rankedArray[i] === rankedArray[j]) {
				countedArray[i]++;
			}
		}
	}

	var rerankedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
	}

	var signrankedArray = [];
	for (j = 0; j < diffencedArray2.length; j++) {
		for (i = 0; i < sortedArray.length; i++) {
			if (sortedArray[i] == Math.abs(diffencedArray2[j])) {
				signrankedArray[j] = rerankedArray[i];
			}
		}
	}

	var signrankedArray2 = [[], []];
	for (i = 0; i < diffencedArray2.length; i++) {
		if (diffencedArray2[i] > 0) {
			signrankedArray2[0].push(signrankedArray[i]);
		} else {
			signrankedArray2[1].push(signrankedArray[i]);
		}
	}

	var T1 = 0;
	var T2 = 0;
	for (i = 0; i < signrankedArray2[0].length; i++) {
		T1 = T1 + signrankedArray2[0][i];
	}
	for (i = 0; i < signrankedArray2[1].length; i++) {
		T2 = T2 + signrankedArray2[1][i];
	}

	var T = T1;
	if (T1 > T2) T = T2;

	var wM = wN * (wN + 1) / 4;
	var wSD = Math.sqrt(wN * (wN + 1) * (2 * wN + 1) / 24);
	wSD = parseFloat(wSD.toFixed(2));

	var z = Math.abs((T - wM) / wSD);
	z = Math.floor((z * 100)) / 100;

	var strArray = [];
	strArray.push("[ウィルコクソン符号順位検定]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push("           N      Mean      S.D.       MAX       MIN\n");
	strArray.push("------------------------------------------------------\n");
	strArray.push(('水準１' + wN.format(" ", 6) + M[0].format(" ", 10) + SD[0].format(" ", 10) + MAX[0].format(" ", 10) + MIN[0].format(" ", 10) + "\n"));
	strArray.push(('水準２' + wN.format(" ", 6) + M[1].format(" ", 10) + SD[1].format(" ", 10) + MAX[1].format(" ", 10) + MIN[1].format(" ", 10) + "\n"));
	strArray.push("------------------------------------------------------\n\n");

	var ppStr = "";
	var PP2 = 0;

	strArray.push('データ数（差≠0）：' + wN.format(" ", 5) + '\n');
	strArray.push("-----------------------------------------\n");
	strArray.push('順位和（+）：' + T1.format(" ", 11) + '\n');
	strArray.push('順位和（-）：' + T2.format(" ", 11) + '\n');
	strArray.push('順位和：' + T.format(" ", 16) + '\n');
	strArray.push("-----------------------------------------\n");

	if (wN <= 25) {
		PP2 = W_tables(wN, T);
		if (PP2 === 9) {
			strArray.push("データ数が少ないため，計算できません\n");
		} else {
			if (PP2 === 0.01) {
				ppStr = "   ** (p<.01)";
			}
			if (PP2 === 0.05) {
				ppStr = "   *  (p<.05)";
			}
			if (PP2 === 1) {
				ppStr = "   ns (.10<p)";
			}
			strArray.push("両側検定  :" + ppStr + "\n");
		}

	} else {
		strArray.push('平均値：' + wM.format(" ", 15) + '\n');
		strArray.push('標準偏差：' + wSD.format(" ", 13) + '\n');
		strArray.push('統計量ｚ：' + z.format(" ", 13) + '\n');
		strArray.push("-----------------------------------------\n");

		PP2 = z_tables(z);
		if (PP2 < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP2 < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP2 < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}
		strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
	}

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	// //出力
	document.getElementById("RltArea").value += strArray.join("");

	strArray = null;

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
function saveData_sT() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = parseInt(document.getElementById("cell_" + cellId).value);
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sT_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function saveData_sT() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	//#0
	strArray.push("sT" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sT_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sT() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sT") {
		var NN = crDel(dd[1]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		changeStTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}
function simulation_sT(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var NN = parseInt(document.getElementById("subjNum").value, 10);

	var min = 5;
	var max = 30;
	if (NN === 2) {
		NN = Math.floor(Math.random() * (max - min + 1) + min);
	}
	document.getElementById("subjNum").value = NN;

	changeStTable();

	var result = "rnd1:9*" + (NN * 2);

	document.getElementById("CandPArea").value = random_number_generation(result);

	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// inputBtnTextClear(this);

	mainCalc_sT();
	mainCalc_wilcoxon();
}