/**
 * ユーティリティ
 * クロス集計
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeCrossSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// minとmaxが空である
		var min, max;
		if ((document.getElementById("min").value != "") && (document.getElementById("max").value != "")) {
			min = parseInt(document.getElementById("min").value, 10);
			max = parseInt(document.getElementById("max").value, 10);
			// min<maxである
			if (min >= max) {
				err = true;
				alert("最小値＜最大値ではありません");
			}
		} else {
			err = true;
			alert("最小値・最大値が入力されていません");
		}

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得
		if (KK == -1) {
			err = true;
			alert("データが行列形式ではありません");
		}

		// データがmin以上max以下である
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) == false) {
				if ((parseInt(dd[i], 10) < min) || (parseInt(dd[i], 10) > max)) {
					err = true;
					alert("最小値と最大値の間にないデータがあります");
					break;
				}
			} else {
				err = true;
				alert("数値ではないデータがあります");
				break;
			}
		}

		if (err == false) {
			mainCalc_cross();
		}
	}
}
function mainCalc_cross() {
	var i = 0;
	var j = 0;

	var min = parseInt(document.getElementById("min").value);
	var max = parseInt(document.getElementById("max").value);

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var ddCount = 0;
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			xx[i][j] = parseInt(dd[ddCount], 10);
			ddCount++;
		}
	}

	var crossCount = new Array(max + 1);
	for (i = 0; i < max + 1; i++) {
		crossCount[i] = new Array(max + 1);
	}

	var strArray = [];
	for (jj = 0; jj < KK - 1; jj++) {
		for (jjj = jj + 1; jjj < KK; jjj++) {

			// 集計値をすべて0
			for (i = 0; i < max + 1; i++) {
				for (j = 0; j < max + 1; j++) {
					crossCount[i][j] = 0;
				}
			}

			for (i = 0; i < NN; i++) {
				crossCount[xx[i][jj]][xx[i][jjj]]++;
			}

			if (document.getElementById("HeaderFlag").checked) {
				strArray.push("変数" + (jj + 1) + "（行）×変数" + (jjj + 1) + "（列）\n");
				strArray.push("\t");
				for (j = min; j < max + 1; j++) {
					strArray.push("\t" + j);
				}
				strArray.push("\n");

				strArray.push("\t");
				for (j = min; j < max + 1; j++) {
					strArray.push("\t-");
				}
				strArray.push("\n");
			}

			for (i = min; i < max + 1; i++) {
				if (document.getElementById("HeaderFlag").checked) {
					strArray.push(i + "\t:\t");
				}
				for (j = min; j < max + 1; j++) {
					strArray.push(crossCount[i][j]);
					strArray.push("\t");
				}
				strArray.push("\n");
			}
			strArray.push("\n");
		}
	}
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;
}
function changeCrossSetting() {
	var htmArray = [];

	htmArray.push("<div class=\"btnlayout4\">");
	htmArray.push("<div class=\"tateyoko\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("出力の下限値：<input type=\"number\" class=\"text9\" id=\"min\" size=\"10\" maxlength=\"10\" min=\"0\"  max=\"100\" value=\"0\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
		htmArray.push("　出力の上限値：<input type=\"number\" class=\"text9\" id=\"max\" size=\"10\" maxlength=\"10\" min=\"1\"  max=\"100\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
	} else {
		htmArray.push("最小値：<select name=\"tate\" id=\"min\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
		htmArray.push("<option value=\"0\" selected>1</option>");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"10\">10</option>");
		htmArray.push("<option value=\"11\">11</option>");
		htmArray.push("<option value=\"12\">12</option>");
		htmArray.push("<option value=\"13\">13</option>");
		htmArray.push("<option value=\"14\">14</option>");
		htmArray.push("<option value=\"15\">15</option>");
		htmArray.push("<option value=\"16\">16</option>");
		htmArray.push("<option value=\"17\">17</option>");
		htmArray.push("<option value=\"18\">18</option>");
		htmArray.push("<option value=\"19\">19</option>");
		htmArray.push("</select>");
		htmArray.push("　最大値：<select name=\"yoko\" id=\"max\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"10\" selected>10</option>");
		htmArray.push("<option value=\"11\">11</option>");
		htmArray.push("<option value=\"12\">12</option>");
		htmArray.push("<option value=\"13\">13</option>");
		htmArray.push("<option value=\"14\">14</option>");
		htmArray.push("<option value=\"15\">15</option>");
		htmArray.push("<option value=\"16\">16</option>");
		htmArray.push("<option value=\"17\">17</option>");
		htmArray.push("<option value=\"18\">18</option>");
		htmArray.push("<option value=\"19\">19</option>");
		htmArray.push("<option value=\"20\">20</option>");
		htmArray.push("</select>");
	}
	htmArray.push("</div>"); //<div class="tateyoko">

	htmArray.push("<div>");
	htmArray.push("<input type=\"checkbox\" id=\"HeaderFlag\" name=\"HeaderFlag\" value=\"HeaderFlag\" checked><label for=\"HeaderFlag\">見出しを出力</label>");
	htmArray.push("</div>");


	htmArray.push("</div>"); //<div class="btnlayout4">

	document.getElementById("cross_setting").innerHTML = htmArray.join("");
	htmArray = null;

}