/**
 * ユーティリティ
 * 欠損値処理
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得
		if (KK == -1) {
			err = true;
			alert("データが行列形式ではありません");
		}
		if (NN < 2) {
			err = true;
			alert("参加者が２名未満です");
		} else if (KK < 1) {
			err = true;
			alert("項目数が１未満です");
		}

		if (err == false) {
			mainCalc_na();
		}
	}
}
function mainCalc_na() {
	var i = 0;
	var j = 0;

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	// var xx = new Array(NN);
	// for (i = 0; i < NN; i++) {
	// 	xx[i] = new Array(KK);
	// }

	var DData = dataremake5("DataArea");
	var rowStr = [];
	rowStr = DData.split("\n");

	//処理前の値
	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	//処理後の値
	var yy = new Array(NN);
	for (i = 0; i < NN; i++) {
		yy[i] = new Array(KK);
	}

	//項目ごとの平均
	var itemAvg = new Array(KK);
	for (i = 0; i < KK; i++) {
		itemAvg[i] = 0;
	}

	//項目ごとの中央値
	var itemMedian = new Array(KK);
	for (j = 0; j < KK; j++) {
		itemMedian[j] = 0;
	}

	//参加者×項目ごとの得点率
	var scoreAvg = new Array(NN);
	for (i = 0; i < NN; i++) {
		scoreAvg[i] = new Array(KK);
	}
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			scoreAvg[i][j] = 0;
		}
	}

	//項目ごとのデータ数（総参加者数－欠損数）
	var itemDataCount = new Array(KK);
	for (j = 0; j < KK; j++) {
		itemDataCount[j] = 0;
	}

	//参加者ごとのデータ数（総項目数－欠損数）
	var subjectDataCount = new Array(NN);
	for (i = 0; i < NN; i++) {
		subjectDataCount[i] = 0;
	}

	//欠損値処理
	var defaultMissingValue_number = parseInt(document.getElementById("defaultMissingValue_select").value);
	var defaultMissingValue = "";
	switch (defaultMissingValue_number) {
		case 0:
			defaultMissingValue = "NA";
			break;
		case 1:
			defaultMissingValue = ".";
			break;
		case 2:
			defaultMissingValue = "";
			break;
		case 3:
			defaultMissingValue = "0";
			break;
		case 4:
			defaultMissingValue = "9";
			break;
		case 5:
			defaultMissingValue = "-1";
			break;
		case 10:
			defaultMissingValue = document.getElementById("etcDefMisValue").value;
			break;
		default:
			defaultMissingValue = "";
	}

	//処理前の値の代入 欠損値データおよびundefinedの場合は，NAにする
	var wAry = [];
	for (i = 0; i < NN; i++) {
		rowStr[i] = rowStr[i].replace(/^\s+|\s+$/g, "");
		wAry = rowStr[i].split(" ");

		for (j = 0; j < KK; j++) {
			if (wAry[j] === void 0) {
				xx[i][j] = "NA";
			} else if (wAry[j] == defaultMissingValue) {
				xx[i][j] = "NA";
			} else {
				xx[i][j] = wAry[j];
			}
		}
	}

	//項目ごとのデータ数（総参加者数－欠損数）
	for (j = 0; j < KK; j++) {
		for (i = 0; i < NN; i++) {
			if (xx[i][j] != "NA") {
				itemDataCount[j]++;
			}
		}
	}

	//参加者ごとのデータ数（総項目数－欠損数）
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			if (xx[i][j] != "NA") {
				subjectDataCount[i]++;
			}
		}
	}

	//項目ごとの平均値計算
	var S = 0;
	for (j = 0; j < KK; j++) {
		for (i = 0; i < NN; i++) {
			if (xx[i][j] != "NA") {
				S += parseFloat(xx[i][j]);
			}
		}
		itemAvg[j] = S / itemDataCount[j];
		S = 0;
	}

	//項目ごとの中央値計算
	var wMedxx = new Array(NN); //各項目の値を入れるの配列（作業用）
	for (i = 0; i < NN; i++) {
		wMedxx[i] = new Array(KK);
	}

	// var wMedxx = new Array(KK); //各項目の値を入れるの配列（作業用）
	// for (j = 0; j < KK; j++) {
	// 	wMedxx[j] = new Array(NN);
	// }

	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			// wMedxx[i][j] = xx[i][j];
			wMedxx[j][i] = parseFloat(xx[i][j]);
			// wMedxx[j][i] = (xx[i][j]);
		}
	}

	var wCenter = 0;//各配列の中央番号（作業用）
	for (j = 0; j < KK; j++) {

		//配列をソート
		wMedxx[j].sort(
			function (a, b) {
				var a_nan = (a !== a);
				var b_nan = (b !== b);
				if (a_nan && b_nan) return 0;
				if (a_nan) return 1;
				if (b_nan) return -1;
				if (a < b) return -1;
				if (a > b) return 1;
				return 0;
			}
		);

		console.log(wMedxx[j]);

		wCenter = Math.floor(itemDataCount[j] / 2);
		if (itemDataCount[j] % 2 == 0) {
			//偶数
			itemMedian[j] = (parseFloat(wMedxx[j][wCenter - 1]) + parseFloat(wMedxx[j][wCenter])) / 2;
			console.log(wMedxx[j][wCenter - 1]);
			console.log(wMedxx[j][wCenter]);
		} else {
			//奇数
			itemMedian[j] = parseFloat(wMedxx[j][wCenter]);
			console.log(wMedxx[j][wCenter]);
		}
	}

	var outputMissingValue_number = parseInt(document.getElementById("outputMissingValue_select").value);
	for (j = 0; j < KK; j++) {
		for (i = 0; i < NN; i++) {
			if (xx[i][j] == "NA") {
				switch (outputMissingValue_number) {
					case 0: //平均値
						yy[i][j] = itemAvg[j].toFixed(4);
						break;
					case 1: //メディアン
						yy[i][j] = itemMedian[j].toFixed(4);
						break;
					case 2: //NA
						yy[i][j] = "NA";
						break;
					case 3: //ピリオド
						yy[i][j] = ".";
						break;
					case 4: //行削除
						yy[i][j] = xx[i][j];
						break;
					case 10:
						yy[i][j] = document.getElementById("etcOutMisValue").value;
						break;
				}

			} else {
				yy[i][j] = xx[i][j];
			}
		}
	}

	//結果の出力
	var rltArray = [];
	for (i = 0; i < NN; i++) {
		if (outputMissingValue_number == 4) {
			if (KK == subjectDataCount[i]) {
				for (j = 0; j < KK; j++) {
					rltArray.push(yy[i][j]);
					if (j != KK - 1) {
						rltArray.push("\t");
					}
				}
				rltArray.push("\n");
			}
		} else {
			for (j = 0; j < KK; j++) {
				rltArray.push(yy[i][j]);
				if (j != KK - 1) {
					rltArray.push("\t");
				}
			}
			rltArray.push("\n");
		}
	}

	document.getElementById("RltArea").value = rltArray.join("");
	strArray = null;

	//処理の出力
	var strArray = [];

	strArray.push("■欠損値処理情報\n\n");

	if (outputMissingValue_number == 4) { //行削除の場合

		strArray.push("・処理方法：行削除\n\n");
		strArray.push("＼\t");
		for (j = 0; j < KK; j++) {
			strArray.push("x" + (j + 1));
			if (j != KK - 1) {
				strArray.push("\t");
			}
		}
		strArray.push("\n");
		strArray.push("------------------------------------------------\n");

		var delCount = 0;
		for (i = 0; i < NN; i++) {
			if (outputMissingValue_number == 4) {
				if (KK != subjectDataCount[i]) {
					strArray.push("s" + (i + 1) + "\t");
					delCount++;
					for (j = 0; j < KK; j++) {
						strArray.push(yy[i][j]);
						if (j != KK - 1) {
							strArray.push("\t");
						}
					}
					strArray.push("\n");
				}
			}
		}
		strArray.push("\n");
		strArray.push("削除された行数：" + delCount);
	} else { //行削除でない場合

		strArray.push("・処理方法：");
		switch (outputMissingValue_number) {
			case 0: //平均値
				strArray.push("平均値\n");
				break;
			case 1: //メディアン
				strArray.push("メディアン\n");
				break;
			case 2: //NA
				strArray.push("NA\n");
				break;
			case 3: //ピリオド
				strArray.push("ピリオド\n");
				break;
			case 4: //行削除

				break;
			case 10:
				strArray.push("任意の値\n");
				break;
		}
		strArray.push("  ＼  ：\t");
		for (j = 0; j < KK; j++) {
			strArray.push("x" + (j + 1));
			if (j != KK - 1) {
				strArray.push("\t");
			}
		}
		strArray.push("\n");
		strArray.push("------------------------------------------------\n");

		strArray.push("処理後の値：\t");
		for (j = 0; j < KK; j++) {
			switch (outputMissingValue_number) {
				case 0: //平均値
					strArray.push(itemAvg[j].toFixed(4));
					break;
				case 1: //メディアン
					strArray.push(itemMedian[j].toFixed(4));
					break;
				case 2: //NA
					strArray.push("NA");
					break;
				case 3: //ピリオド
					strArray.push(".");
					break;
				case 4: //行削除

					break;
				case 10:
					strArray.push(document.getElementById("etcOutMisValue").value);
					break;
			}
			if (j != KK - 1) {
				strArray.push("\t");
			}
		}
		strArray.push("\n");

		strArray.push("処理した数：\t");
		for (j = 0; j < KK; j++) {
			strArray.push(NN - itemDataCount[j]);
			if (j != KK - 1) {
				strArray.push("\t");
			}
		}
		strArray.push("\n");
	}

	document.getElementById("RltArea2").value = strArray.join("");
	strArray = null;
}
function changeDefMisVal() {
	var defaultMissingValue = parseInt(document.getElementById("defaultMissingValue_select").value);
	var htmArray = [];

	if (defaultMissingValue == 10) {
		htmArray.push("<div class=\"freqdata3\">");
		htmArray.push("<table border=\"0\" class=\"codetb\">");
		htmArray.push("<tr>");
		htmArray.push("<td class=\"codetbL\">その他の記号：</td>");
		htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"etcDefMisValue\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\"></td>\n");
		htmArray.push("</tr>");
		htmArray.push("</table>");
		htmArray.push("</div>");
	}

	document.getElementById("etc_setting").innerHTML = htmArray.join("");
	htmArray = null;
}
function changeOutputMisVal() {
	var outputMissingValue = parseInt(document.getElementById("outputMissingValue_select").value);
	var htmArray = [];

	if (outputMissingValue == 10) {
		htmArray.push("<div class=\"freqdata3\">");
		htmArray.push("<table border=\"0\" class=\"codetb\">");
		htmArray.push("<tr>");
		htmArray.push("<td class=\"codetbL\">任意の値：</td>");
		htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"etcOutMisValue\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\"></td>\n");
		htmArray.push("</tr>");
		htmArray.push("</table>");
		htmArray.push("</div>");
	}

	document.getElementById("etc_setting2").innerHTML = htmArray.join("");
	htmArray = null;
}