/**
 * ユーティリティ
 * 乱数発生
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeRandomSetting();
	// ChangeAsInput(0);

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
/**
 * [checkData 相関係数の値をチェック]
 */
function checkData() {
	var rand_output = parseInt(document.getElementById("rand_output").value); //出力選択
	var corrCoefficient;
	switch (rand_output) {
		case 1:
			corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
			break;
		case 2:
			corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
			break;
		case 3:
			corrCoefficient = 0; //エラー処理のために相関係数を０にしておく
			break;
	}
	if (Math.abs(corrCoefficient) <= 1) {
		mainCalc_Random();
	} else {
		alert("相関係数は－１以上１以下です");
	}

}
function mainCalc_Random() {
	var i = 0;
	var j = 0;
	var ii = 0;
	var jj = 0;

	var NN = 0;
	var LA = 0;

	var DData = dataremake5("RltArea");
	var dd = [];
	dd = DData.split(" ");

	//値追加の場合の行数と列数の計算
	NN = countRowCol("RltArea")[0]; // 行数を取得
	LA = countRowCol("RltArea")[1]; // 列数を取得

	if (LA == -1) { //列数エラー -1
		alert("データが行列形式ではありません");
	} else {
		var rand_output = parseInt(document.getElementById("rand_output").value); //出力選択

		//出力別の値取得
		var tate, yoko;
		var min, max;
		var decimal;
		var corrCoefficient;
		var avg, sd;
		var start, end, dist;
		switch (rand_output) {
			case 1:
				tate = parseInt(document.getElementById("tate").value); //列数
				yoko = parseInt(document.getElementById("yoko").value); //行数

				min = parseInt(document.getElementById("min").value);
				max = parseInt(document.getElementById("max").value);
				decimal = parseInt(document.getElementById("decimal").value); //小数点以下

				corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
				break;
			case 2:
				tate = parseInt(document.getElementById("tate").value); //列数
				yoko = parseInt(document.getElementById("yoko").value); //行数

				avg = parseFloat(document.getElementById("avg").value); //平均
				sd = parseFloat(document.getElementById("sd").value); //標準偏差
				decimal = parseInt(document.getElementById("decimal").value); //小数点以下

				corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
				break;
			case 3:
				start = parseInt(document.getElementById("start").value); //開始値
				end = parseInt(document.getElementById("end").value); //終了値
				dist = parseInt(document.getElementById("dist").value); //間隔
				break;
		}

		//最小値（開始値）と最大値（終了値）の処理
		var dummy = 0;
		if (min > max) {
			dummy = max;
			max = min;
			min = dummy;
		}
		if (start > end) {
			dummy = end;
			end = start;
			start = dummy;
		}

		//乱数の出力
		var count = 0;
		var rand = 0;
		var randX = 0;
		var randY = 0;
		var randZ = 0;
		var r1 = 0;
		var r2 = 0;
		var z = 0;
		var num = 0;

		var strArray = [];

		var randXX = [];
		var randYY = new Array(tate);
		for (i = 0; i < tate; i++) {
			randYY[i] = new Array(10);
		}
		var randZZ = new Array(tate);
		for (i = 0; i < tate; i++) {
			randZZ[i] = new Array(10);
		}

		//最終的に作成される乱数列
		var randNum = new Array(tate);
		for (i = 0; i < tate; i++) {
			randNum[i] = new Array(yoko);
		}

		var M = [];
		var SD = [];
		var R = [];

		var M0 = 0;
		var SD0 = 0;
		var S = 0;
		var SS = 0;

		var sampleCount = 10; //相関データを作成する列数
		var corrCheckNum = 0;
		var corrMin;
		if (document.getElementById("RltAdd").checked) {
			if (NN == 0) { //行数が 0 の場合は結果を追加しない
				document.getElementById("RltAdd").checked = false;
			}
		}
		if (document.getElementById("RltAdd").checked) {
			switch (rand_output) {
				case 1:
					count = 0;
					if (document.getElementById("CorrCheck").checked === false) {
						for (i = 0; i < NN; i++) {
							for (jj = 0; jj < LA; jj++) {
								strArray.push(crDel(dd[count]));
								strArray.push("\t");
								count++;
							}
							for (j = 0; j < yoko; j++) {
								rand = (Math.random() * (max - min) + min).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					} else {
						// １列目の乱数を作成
						for (i = 0; i < NN; i++) {
							randXX[i] = (Math.random() * (max - min) + min);
							randNum[i][0] = randXX[i];
						}
						// １列目の乱数の平均と標準偏差を計算
						M0 = 0;
						SD0 = 0;
						S = 0;
						SS = 0;
						for (i = 0; i < NN; i++) {
							S += randXX[i];
							SS += Math.pow(randXX[i], 2);
						}
						M0 = S / NN;
						SD0 = Math.sqrt(SS / NN - Math.pow(M0, 2));

						// ２列目から指定列数の乱数を作成
						for (j = 0; j < yoko - 1; j++) {
							for (i = 0; i < NN; i++) {
								//10種類のサンプル乱数を作成
								for (k = 0; k < sampleCount; k++) {
									// randZZ[i][k] = (Math.random() * (max - min) + min);
									// randYY[i][k] = (corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k]);
									// if (randYY[i][k] > max) {
									// 	randYY[i][k] = max;
									// }
									randZZ[i][k] = (Math.random() * (max - min) + min);
									randYY[i][k] = (corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k]);
									while (randYY[i][k] > max) {
										randZZ[i][k] = (Math.random() * (max - min) + min);
										randYY[i][k] = (corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k]);
									}
								}
							}
							// ２列目以降の平均・標準偏差の計算
							S = 0;
							SS = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								SS = 0;
								for (i = 0; i < NN; i++) {
									S += randYY[i][k];
									SS += Math.pow(randYY[i][k], 2);
								}
								M[k] = S / NN;
								SD[k] = Math.sqrt(SS / NN - Math.pow(M[k], 2));
							}
							// 相関係数の計算
							S = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								for (i = 0; i < NN; i++) {
									S += (randXX[i] - M0) * (randYY[i][k] - M[k]);
								}
								R[k] = S / NN / SD0 / SD[k];
							}
							// 最も指定した相関係数に近いサンプル乱数を判断
							corrCheckNum = 0;
							corrMin = Math.abs(corrCoefficient - R[0]);
							for (k = 1; k < sampleCount; k++) {
								if (corrMin > Math.abs(corrCoefficient - R[k])) {
									corrMin = Math.abs(corrCoefficient - R[k]);
									corrCheckNum = k;
								}
							}
							for (i = 0; i < NN; i++) {
								randNum[i][j + 1] = randYY[i][corrCheckNum];
							}
						}
						for (i = 0; i < NN; i++) {
							for (jj = 0; jj < LA; jj++) {
								strArray.push(crDel(dd[count]));
								strArray.push("\t");
								count++;
							}
							for (j = 0; j < yoko; j++) {
								// if (randNum[i][j] > max) {
								// 	randNum[i][j] = max.toFixed(decimal);
								// }
								strArray.push(randNum[i][j].toFixed(decimal));
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}
					break;
				case 2:
					count = 0;
					if (document.getElementById("CorrCheck").checked === false) {
						for (ii = 0; ii < NN; ii++) {
							for (jj = 0; jj < LA; jj++) {
								strArray.push(crDel(dd[count]));
								strArray.push("\t");
								count++;
							}
							for (j = 0; j < yoko; j++) {
								r1 = Math.random();
								r2 = Math.random();
								z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
								rand = (z * sd + avg).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					} else {
						// １列目の乱数を作成
						for (i = 0; i < NN; i++) {
							r1 = Math.random();
							r2 = Math.random();
							z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
							randXX[i] = (z * sd + avg);
							randNum[i][0] = randXX[i];
						}
						// １列目の乱数の平均と標準偏差を計算
						M0 = 0;
						SD0 = 0;
						S = 0;
						SS = 0;
						for (i = 0; i < NN; i++) {
							S += randXX[i];
							SS += Math.pow(randXX[i], 2);
						}
						M0 = S / NN;
						SD0 = Math.sqrt(SS / NN - Math.pow(M0, 2));

						// ２列目から指定列数の乱数を作成
						for (j = 0; j < yoko - 1; j++) {
							for (i = 0; i < NN; i++) {
								//10種類のサンプル乱数を作成
								for (k = 0; k < sampleCount; k++) {
									r1 = Math.random();
									r2 = Math.random();
									z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
									randZZ[i][k] = z * sd + avg;
									randYY[i][k] = corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k];
									// if (randYY[i][k] > max) {
									// 	randYY[i][k] = max;
									// }
								}
							}
							// ２列目以降の平均・標準偏差の計算
							S = 0;
							SS = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								SS = 0;
								for (i = 0; i < NN; i++) {
									S += randYY[i][k];
									SS += Math.pow(randYY[i][k], 2);
								}
								M[k] = S / NN;
								SD[k] = Math.sqrt(SS / NN - Math.pow(M[k], 2));
							}
							// 相関係数の計算
							S = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								for (i = 0; i < NN; i++) {
									S += (randXX[i] - M0) * (randYY[i][k] - M[k]);
								}
								R[k] = S / NN / SD0 / SD[k];
							}
							// 最も指定した相関係数に近いサンプル乱数を判断
							corrCheckNum = 0;
							corrMin = Math.abs(corrCoefficient - R[0]);
							for (k = 1; k < sampleCount; k++) {
								if (corrMin > Math.abs(corrCoefficient - R[k])) {
									corrMin = Math.abs(corrCoefficient - R[k]);
									corrCheckNum = k;
								}
							}
							for (i = 0; i < NN; i++) {
								randNum[i][j + 1] = randYY[i][corrCheckNum];
							}
						}
						for (i = 0; i < NN; i++) {
							for (jj = 0; jj < LA; jj++) {
								strArray.push(crDel(dd[count]));
								strArray.push("\t");
								count++;
							}
							for (j = 0; j < yoko; j++) {
								// if (randNum[i][j] > max) {
								// 	randNum[i][j] = max.toFixed(decimal);
								// }
								strArray.push(randNum[i][j].toFixed(decimal));
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}
					break;
				case 3:
					count = 0;
					num = start;
					for (ii = 0; ii < NN; ii++) {
						for (jj = 0; jj < LA; jj++) {
							strArray.push(crDel(dd[count]));
							strArray.push("\t");
							count++;
						}
						strArray.push(num);
						strArray.push("\n");
						num = num + dist;
					}
					break;
			}
		} else {
			switch (rand_output) {
				case 1:
					if (document.getElementById("CorrCheck").checked === false) {
						for (i = 0; i < tate; i++) {
							for (j = 0; j < yoko; j++) {
								rand = (Math.random() * (max - min) + min).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					} else {
						// １列目の乱数を作成
						for (i = 0; i < tate; i++) {
							randXX[i] = (Math.random() * (max - min) + min);
							randNum[i][0] = randXX[i];
						}
						// １列目の乱数の平均と標準偏差を計算
						M0 = 0;
						SD0 = 0;
						S = 0;
						SS = 0;
						for (i = 0; i < tate; i++) {
							S += randXX[i];
							SS += Math.pow(randXX[i], 2);
						}
						M0 = S / tate;
						SD0 = Math.sqrt(SS / tate - Math.pow(M0, 2));

						// ２列目から指定列数の乱数を作成
						for (j = 0; j < yoko - 1; j++) {
							for (i = 0; i < tate; i++) {
								//10種類のサンプル乱数を作成
								for (k = 0; k < sampleCount; k++) {
									randZZ[i][k] = (Math.random() * (max - min) + min);
									randYY[i][k] = (corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k]);
									// if (randYY[i][k] > max) {
									// 	randYY[i][k] = max;
									// }
									while (randYY[i][k] > max) {
										randZZ[i][k] = (Math.random() * (max - min) + min);
										randYY[i][k] = (corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k]);
									}
								}
							}
							// ２列目以降の平均・標準偏差の計算
							S = 0;
							SS = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								SS = 0;
								for (i = 0; i < tate; i++) {
									S += randYY[i][k];
									SS += Math.pow(randYY[i][k], 2);
								}
								M[k] = S / tate;
								SD[k] = Math.sqrt(SS / tate - Math.pow(M[k], 2));
							}
							// 相関係数の計算
							S = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								for (i = 0; i < tate; i++) {
									S += (randXX[i] - M0) * (randYY[i][k] - M[k]);
								}
								R[k] = S / tate / SD0 / SD[k];
							}
							// 最も指定した相関係数に近いサンプル乱数を判断
							corrCheckNum = 0;
							corrMin = Math.abs(corrCoefficient - R[0]);
							for (k = 1; k < sampleCount; k++) {
								if (corrMin > Math.abs(corrCoefficient - R[k])) {
									corrMin = Math.abs(corrCoefficient - R[k]);
									corrCheckNum = k;
								}
							}
							for (i = 0; i < tate; i++) {
								randNum[i][j + 1] = randYY[i][corrCheckNum];
							}
						}

						for (i = 0; i < tate; i++) {
							for (j = 0; j < yoko; j++) {
								// if (randNum[i][j] > max) {
								// 	randNum[i][j] = max.toFixed(decimal);
								// }
								strArray.push(randNum[i][j].toFixed(decimal));
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}

					break;
				case 2:
					if (document.getElementById("CorrCheck").checked === false) {
						for (i = 0; i < tate; i++) {
							for (j = 0; j < yoko; j++) {
								r1 = Math.random();
								r2 = Math.random();
								z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
								rand = (z * sd + avg).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					} else {
						// １列目の乱数を作成
						for (i = 0; i < tate; i++) {
							r1 = Math.random();
							r2 = Math.random();
							z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
							randXX[i] = (z * sd + avg);
							randNum[i][0] = randXX[i];
						}
						// １列目の乱数の平均と標準偏差を計算
						M0 = 0;
						SD0 = 0;
						S = 0;
						SS = 0;
						for (i = 0; i < tate; i++) {
							S += randXX[i];
							SS += Math.pow(randXX[i], 2);
						}
						M0 = S / tate;
						SD0 = Math.sqrt(SS / tate - Math.pow(M0, 2));

						// ２列目から指定列数の乱数を作成
						for (j = 0; j < yoko - 1; j++) {
							for (i = 0; i < tate; i++) {
								//10種類のサンプル乱数を作成
								for (k = 0; k < sampleCount; k++) {
									r1 = Math.random();
									r2 = Math.random();
									z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
									randZZ[i][k] = z * sd + avg;
									randYY[i][k] = corrCoefficient * randXX[i] + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZZ[i][k];
									// if (randYY[i][k] > max) {
									// 	randYY[i][k] = max;
									// }
								}
							}
							// ２列目以降の平均・標準偏差の計算
							S = 0;
							SS = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								SS = 0;
								for (i = 0; i < tate; i++) {
									S += randYY[i][k];
									SS += Math.pow(randYY[i][k], 2);
								}
								M[k] = S / tate;
								SD[k] = Math.sqrt(SS / tate - Math.pow(M[k], 2));
							}
							// 相関係数の計算
							S = 0;
							for (k = 0; k < sampleCount; k++) {
								S = 0;
								for (i = 0; i < tate; i++) {
									S += (randXX[i] - M0) * (randYY[i][k] - M[k]);
								}
								R[k] = S / tate / SD0 / SD[k];
							}
							// 最も指定した相関係数に近いサンプル乱数を判断
							corrCheckNum = 0;
							corrMin = Math.abs(corrCoefficient - R[0]);
							for (k = 1; k < sampleCount; k++) {
								if (corrMin > Math.abs(corrCoefficient - R[k])) {
									corrMin = Math.abs(corrCoefficient - R[k]);
									corrCheckNum = k;
								}
							}
							for (i = 0; i < tate; i++) {
								randNum[i][j + 1] = randYY[i][corrCheckNum];
							}
						}

						for (i = 0; i < tate; i++) {
							for (j = 0; j < yoko; j++) {
								// if (randNum[i][j] > max) {
								// 	randNum[i][j] = max.toFixed(decimal);
								// }
								strArray.push(randNum[i][j].toFixed(decimal));
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}
					break;
				case 3:
					for (i = start; i <= end; i = i + dist) {
						strArray.push(i);
						strArray.push("\n");
					}
					break;
			}
		}

		document.getElementById("RltArea").value = strArray.join("");
		strArray = null;
	}
}

function changeRandomSetting() {
	var rand_output = parseInt(document.getElementById("rand_output").value);
	var htmArray = [];

	var thisBrowser = getBrowser();
	if (rand_output == 1) {
		htmArray.push("<div class=\"tateyoko\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("縦(N行)：<input type=\"number\" class=\"text9\" id=\"tate\" size=\"10\" min=\"1\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("縦(N行)：<select id=\"tate\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'縦(行)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\" selected>10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("×横(変数列)：<input type=\"number\" class=\"text9\" id=\"yoko\" size=\"10\" min=\"1\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("×横(変数列)：<select id=\"yoko\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'横(列)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\"selected>2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");
		htmArray.push("<div class=\"tateyoko\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("最小値：<input type=\"number\" class=\"text9\" id=\"min\" size=\"10\" min=\"0\" value=\"0\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("最小値：<select id=\"min\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'最小値')\">\n");
			htmArray.push("<option value=\"0\" selected>0</option>\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"20\">20</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　最大値：<input type=\"number\" class=\"text9\" id=\"max\" size=\"10\" min=\"0\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("最大値：<select id=\"max\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'最大値')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\" selected>1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"20\">20</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　小数点以下：<input type=\"number\" class=\"text9\" id=\"decimal\" size=\"10\" min=\"0\" value=\"3\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push(" 小数点以下：<select id=\"decimal\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'小数点以下')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\" selected>3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");

		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("<input type=\"checkbox\" id=\"CorrCheck\" name=\"CorrCheck\" onchange=\"checkCorr();\"> <label for=\"CorrCheck\" id=\"CorrStr\" class=\"lineThrough\">相関係数</label>：");
		htmArray.push("<input type=\"text\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"corrCoefficient\" value=\"0\" disabled=\"false\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("</div>\n");

	}
	if (rand_output == 2) {
		htmArray.push("<div class=\"tateyoko\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("縦(N行)：<input type=\"number\" class=\"text9\" id=\"tate\" size=\"10\" min=\"1\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("縦(N行)：<select id=\"tate\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'縦(行)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\" selected>10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("×横(変数列)：<input type=\"number\" class=\"text9\" id=\"yoko\" size=\"10\" min=\"1\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("×横(変数列)：<select id=\"yoko\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'横(列)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\"selected>2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");

		htmArray.push("<div class=\"tateyoko\">\n");

		htmArray.push("平均：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"avg\" value=\"0\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("　標準偏差：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"sd\" value=\"1\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　小数点以下：<input type=\"number\" class=\"text9\" id=\"decimal\" size=\"10\" min=\"0\" value=\"3\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push(" 小数点以下：<select id=\"decimal\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'小数点以下')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\" selected>3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");

		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("<input type=\"checkbox\" id=\"CorrCheck\" name=\"CorrCheck\" onchange=\"checkCorr();\"> <label for=\"CorrCheck\" id=\"CorrStr\" class=\"lineThrough\">相関係数</label>：");
		htmArray.push("<input type=\"text\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"corrCoefficient\" value=\"0\" disabled=\"false\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("</div>\n");
	}
	if (rand_output == 3) {
		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("開始：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"start\" value=\"1\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("　終了：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"end\" value=\"10\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　間隔：<input type=\"number\" class=\"text9\" id=\"dist\" size=\"10\" min=\"1\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push(" 間隔：<select id=\"dist\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'間隔')\">\n");
			htmArray.push("<option value=\"1\" selected>1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}
		htmArray.push("</div>\n");
	}

	document.getElementById("rand_setting").innerHTML = htmArray.join("");
	htmArray = null;
}
function checkCorr() {
	if (document.getElementById("CorrCheck").checked) {
		document.getElementById("corrCoefficient").disabled = false;
		document.getElementById("CorrStr").className = "lineNone";

	} else {
		document.getElementById("corrCoefficient").disabled = true;
		document.getElementById("CorrStr").className = "lineThrough";
	}
}