/**
 * 度数の検定
 * ｉ×ｊ×ｋ表(モデル選択)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	change3dSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var elmCount = iCount * jCount * kCount;

	var result = confirm("データを消去します");
	if (result === true) {
		for (var i = 1; i < elmCount + 1; i++) {
			document.getElementById("cell_" + i).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	// setFocus(0);
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	if (dd.length > iCount * jCount * kCount) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;
	var j = 0;
	var k = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	var err = false;

	var NN = countRowCol("CandPArea")[0]; // 行数を取得
	var KK = countRowCol("CandPArea")[1]; // 列数を取得

	// if (dd.length % 3 !== 0) {
	// 	err = true;
	// }

	if (NN === 3) {
		err = true;
	}

	if (KK === -1) { //データが行列形式でない
		err = true;
	}

	if (err === false) {
		for (i = 0; i < dd.length; i = i + 3) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < iCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 1]) > 0) && (parseInt(dd[i + 1]) < jCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 2]) > 0) && (parseInt(dd[i + 2]) < kCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var gunAtai = new Array(iCount);
			for (i = 0; i < iCount; i++) {
				gunAtai[i] = new Array(jCount);
				for (j = 0; j < jCount; j++) {
					gunAtai[i][j] = new Array(kCount);
				}
			}

			for (i = 0; i < iCount; i++) {
				for (j = 0; j < jCount; j++) {
					for (k = 0; k < kCount; k++) {
						gunAtai[i][j][k] = 0;
					}
				}
			}

			for (i = 0; i < dd.length; i = i + 3) {
				gunAtai[dd[i] - 1][dd[i + 1] - 1][dd[i + 2] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < iCount; i++) {
				for (j = 0; j < jCount; j++) {
					for (k = 0; k < kCount; k++) {
						strArray.push(gunAtai[i][j][k]);
						strArray.push("\t");
					}
				}
				strArray.push("\n");
			}
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = '';
		alert("データ形式が正しくありません。");
	}
}
// 入力チェック
function checkCellData() {
	var i = 1;
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var elmCount = iCount * jCount * kCount;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell_" + i).value === "") {
				errorCellNum = i;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_3d();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		copipe("CandPArea", "text");
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));

		if (isNaN(dd[elmCount - 1])) {
			alert("データを確認してください");
		} else {
			mainCalc_3d();
		}
	}
}
// メイン計算
function mainCalc_3d() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var h = 0;

	var ii = 0;
	var jj = 0;

	var TType = "kai";
	var TT = 1;
	var YY = 2;
	var NN;

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var hCount;
	var elmCount = iCount * jCount * kCount;
	var kaiData = [];

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray1 = [];
	var rcmArray2 = [];

	var wData = new Array(iCount);
	for (i = 0; i < iCount; i++) {
		wData[i] = new Array(jCount);
		for (j = 0; j < jCount; j++) {
			wData[i][j] = new Array(kCount);
		}
	}

	if (document.getElementById("CandPArea").value === "") {
		var cellId = 1;
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					wData[i][j][k] = parseInt(document.getElementById("cell_" + cellId).value);
					cellId++;
				}
			}
		}
	} else {
		var _DData = document.getElementById("CandPArea").value;
		var _dd = [];
		_dd = _DData.split(" ");

		var idata = 0;
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					wData[i][j][k] = parseInt(_dd[idata]);
					idata++;
				}
			}
		}
	} // セルとテキストエリアの分岐終了

	for (i = 0; i < iCount; i++) {
		var wkai = [];

		wkai.push("kai\n ");
		wkai.push(jCount + "\n ");
		wkai.push(kCount + "\n");

		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				wkai.push(" " + wData[i][j][k]);
			}
			wkai.push("\n");
		}
		kaiData[i] = wkai.join("");
		wkai = null;
	}
	hCount = iCount;

	strArray.push("[ｉ×Ｊ×Ｋ表(３元モデル選択)]\n\n");

	for (h = 0; h < hCount; h++) {
		// var N = 0;
		// var DF = 0;

		var dd = [];
		var DData = kaiData[h];
		dd = DData.split(" ");

		TType = dd[0];
		TT = parseInt(dd[1], 10);
		YY = parseInt(dd[2], 10);
		NN = TT * YY;

		var xx = new Array(TT);
		for (i = 0; i < TT; i++) {
			xx[i] = new Array(YY);
		}

		var _cellId = 1;
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				xx[i][j] = parseInt(dd[_cellId + 2]);
				_cellId++;
			}
		}

		var N = 0; //度数の総合計
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				N += xx[i][j];
			}
		}

		var T = new Array(YY); //列の合計
		var Y = new Array(TT); //行の合計
		for (i = 0; i < TT; i++) {
			Y[i] = 0;
			for (j = 0; j < YY; j++) {
				Y[i] += xx[i][j];
			}
		}
		for (j = 0; j < YY; j++) {
			T[j] = 0;
			for (i = 0; i < TT; i++) {
				T[j] += xx[i][j];
			}
		}

		var MC$;
		var EQ$;

		var x2 = 0;
		var DF = 0;
		var MA;
		var PHI;

		var E = new Array(TT);
		for (i = 0; i < TT; i++) {
			E[i] = new Array(YY);
		}
		var Z = new Array(TT);
		for (i = 0; i < TT; i++) {
			Z[i] = new Array(YY);
		}

		if (TT == 1) {
			for (j = 0; j < YY; j++) {
				E[0][j] = N / YY;
				x2 += Math.pow(xx[0][j] - E[0][j], 2) / E[0][j];
			}
			DF = YY - 1;
		} else {
			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					E[i][j] = Y[i] * T[j] / N;
					x2 += Math.pow(xx[i][j] - E[i][j], 2) / E[i][j];
				}
			}

			//２ｘ２とのき,イェーツの補正
			if ((TT == 2) && (YY == 2)) {
				x2 = N * Math.pow(Math.abs(xx[0][0] * xx[1][1] - xx[0][1] * xx[1][0]) - N / 2, 2) / (T[0] * T[1] * Y[0] * Y[1]);
			}

			DF = (TT - 1) * (YY - 1);

			MA = TT - 1;
			if (MA > YY - 1) MA = YY - 1;

			PHI = Math.sqrt(x2 / N / MA);
		}

		var loopStr = "i=";

		strArray.push("# " + loopStr + (h + 1) + "\n\n");
		// strArray.push("「カイ二乗検定の結果」\n（上段実測値,下段期待値）\n");
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				strArray.push("--------");
			}
			strArray.push("\n");

			for (j = 0; j < YY; j++) {
				strArray.push(xx[i][j] + "\t\t");
			}
			strArray.push("\n");
			for (j = 0; j < YY; j++) {
				strArray.push(using(E[i][j], 3, 3) + "\t");
			}
			strArray.push("\n");
		}

		var ppStr = pValue_Match_ChiSquareValue(x2, DF);

		strArray.push("\n");
		strArray.push("x2(" + DF + ")=" + using(x2, 4, 3) + "   ,  " + ppStr);

		strArray.push("\n");
		if (TT > 1) {
			if ((TT == 2) && (YY == 2)) {
				strArray.push("Phi = " + PHI.toFixed(3));
			} else {
				strArray.push("Cramer\'s V = " + PHI.toFixed(3));
			}
		}

		var MC1 = new Array(TT);
		for (i = 0; i < TT; i++) {
			MC1[i] = new Array(YY);
		}
		var MC2 = new Array(TT);
		for (i = 0; i < TT; i++) {
			MC2[i] = new Array(YY);
		}

		strArray.push("\n");
		if (ppStr != "ns") {
			if (TT == 1) {
				if (YY > 2) {
					strArray.push("==ライアンの名義水準を用いた多重比較==\n");
					strArray.push("  (有意水準 alpha = 0.05 とします)\n");
					strArray.push("----------------------------------------------------\n");
					strArray.push("セル比較\t臨界比\t\t検定\t\t名義水準\n");
					strArray.push("----------------------------------------------------\n");

					for (j = 0; j < YY; j++) {
						for (jj = j + 1; jj < YY; jj++) {
							CN = 0;
							for (l = 0; l < YY; l++) {
								if ((l == j) || (l == jj)) {
									CN = CN + 1;
								} else {
									if ((xx[0][j] > xx[0][l]) && (xx[0][jj] <= xx[0][l])) {
										CN = CN + 1;
									}
									if ((xx[0][j] < xx[0][l]) && (xx[0][jj] >= xx[0][l])) {
										CN = CN + 1;
									}
								}
							}
							NL = 0.1 / (YY * (CN - 1));
							CR = (Math.abs(xx[0][j] - xx[0][jj]) - 1) / Math.sqrt(xx[0][j] + xx[0][jj]);
							if (CR < 1.96) {
								MC$ = "ns  p>.05    ";
								EQ$ = "=";
							} else {
								if (CR > 3.62) {
									MC$ = "*   p<0.0002";
									if (xx[0][j] > xx[0][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									var wP = pValue_to_alphaDash(CR);
									if (wP >= NL) {
										// MC$ = "ns  p="+P[count];
										MC$ = "ns  p=" + wP;
										EQ$ = "=";
									}
									if (wP < NL) {
										MC$ = "*   p=" + wP;
										if (xx[0][j] > xx[0][jj]) {
											EQ$ = ">";
										} else {
											EQ$ = "<";
										}
									}
								}
							}
							strArray.push((j + 1) + " " + EQ$ + " " + (jj + 1) + " \t" + using(CR, 2, 2) + " \t" + MC$ + " \t" + using(NL, 1, 5) + "\n");
						}
					}
					strArray.push("----------------------------------------------------\n");
				}
			} else {
				for (i = 0; i < TT; i++) {
					for (j = 0; j < YY; j++) {
						Z[i][j] = (xx[i][j] - E[i][j]) / Math.sqrt(E[i][j]) / Math.sqrt((1 - Y[i] / N) * (1 - T[j] / N));

						if (Math.abs(Z[i][j]) > 2.5758) {
							MC1[i][j] = "  **  ";
							if (Z[i][j] > 0) {
								MC2[i][j] = "▲";
							} else {
								MC2[i][j] = "▽";
							}
						} else if (Math.abs(Z[i][j]) > 1.96) {
							MC1[i][j] = "   *  ";
							if (Z[i][j] > 0) {
								MC2[i][j] = "▲";
							} else {
								MC2[i][j] = "▽";
							}
						} else if (Math.abs(Z[i][j]) > 1.6449) {
							MC1[i][j] = "   +  ";
							MC2[i][j] = " ";
						} else {
							MC1[i][j] = "  ns  ";
							MC2[i][j] = " ";
						}
					}
				}

				strArray.push("\n");
				strArray.push("「 残差分析の結果 」\n（上段調整された残差,下段検定結果）\n");
				for (i = 0; i < TT; i++) {
					for (j = 0; j < YY; j++) {
						strArray.push("--------");
					}
					strArray.push("\n");
					for (j = 0; j < YY; j++) {
						strArray.push(using(Z[i][j], 3, 3) + "\t");
					}
					strArray.push("\n");
					for (j = 0; j < YY; j++) {
						strArray.push(MC1[i][j] + "\t");
					}
					strArray.push("\n");
				}

				strArray.push("\n");
				strArray.push(" +p<.10  *p<.05  **p<.01\n\n");

				strArray.push("\n");
				strArray.push("「 実測値と残差分析の結果 」\n");
				for (j = 0; j < YY; j++) {
					strArray.push("--------");
				}
				strArray.push("\n");

				for (i = 0; i < TT; i++) {
					for (j = 0; j < YY; j++) {
						strArray.push(xx[i][j] + "\t" + MC2[i][j] + "\t");
					}
					strArray.push("\n");
				}
				for (j = 0; j < YY; j++) {
					strArray.push("--------");
				}

				strArray.push("\n");
				strArray.push("（▲有意に多い,▽有意に少ない,p<.05）\n\n");
			}
		}

		//グラフ描画
		(function () {
			if (h === 0) {
				chartClear();
			}

			//ixj i群：j値：k層
			var gunStr;
			var ataiStr;
			var souStr;

			gunStr = "j";
			ataiStr = "k";
			souStr = "i";

			var i, j;
			var chartImg = document.createElement('canvas');
			chartImg.id = "ChartImg" + h;
			var ctx = document.getElementById("chart").appendChild(chartImg);

			var data = [];
			for (j = 0; j < YY; j++) {
				data[j] = [];
			}

			for (j = 0; j < YY; j++) {
				for (i = 0; i < TT; i++) {
					data[j][i] = ((xx[i][j] / Y[i]) * 100).toFixed(4);
				}
			}

			var datasetKey = [];
			for (j = 0; j < YY; j++) {
				datasetKey[j] = [];
			}
			var wC = 0;
			for (j = 0; j < YY; j++) {
				datasetKey[j].label = ataiStr + (j + 1);
				datasetKey[j].data = data[j];

				if (j === 0) {
					wC = 0; //最初の色は000000
				} else {
					wC = (parseInt("F0", 16) / (YY - 1) * j).toFixed(0); //最後の色はF0F0F0
					wC = parseInt(wC, 10);
				}
				datasetKey[j].backgroundColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';
				datasetKey[j].borderColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';

				datasetKey[j].borderWidth = 1;
			}

			var labelData = [];
			for (i = 0; i < TT; i++) {
				labelData.push(gunStr + (i + 1));
			}

			var datasetData = [];
			for (j = 0; j < YY; j++) {
				datasetData[j] = datasetKey[j];
			}

			var myChart = new Chart(ctx, {
				type: 'horizontalBar',
				data: {
					labels: labelData,
					datasets: datasetData
				},
				options: {
					title: {
						display: true,
						text: souStr + '=' + (h + 1) + '  :  ' + '各群の' + ataiStr + '1（黒）～ ' + ataiStr + YY + '（淡）の比率',
						position: 'top',
						fontSize: 12,
						fontColor: '#000000'
					},
					scales: {
						xAxes: [{
							stacked: true,
							ticks: {
								beginAtZero: true,
								min: 0,
								max: 100
							}
						}],
						yAxes: [{
							stacked: true
						}]
					},
					legend: {
						position: 'bottom'
					}
				}
			});
		}());

	} // h loop

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		rcmArray1.push("## ｉ×Ｊ×Ｋ表の分析\n");
		rcmArray1.push("\n");
		rcmArray1.push("# パッケージ car が必要\n");
		rcmArray1.push("\n");
		rcmArray1.push("## js-STARからの入力\n");
		rcmArray1.push("levI = " + iCount + "\n");
		rcmArray1.push("levJ = " + jCount + "\n");
		rcmArray1.push("levK = " + kCount + "\n");

		rcmArray1.push("\n");
		rcmArray1.push("dosu <- c(\n");
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					rcmArray1.push("  ");
					rcmArray1.push(wData[i][j][k]);
					if ((i == iCount - 1) && (j == jCount - 1) && (k == kCount - 1)) {
						rcmArray1.push(")");
					} else {
						rcmArray1.push(",");
					}
				}
				rcmArray1.push("\n");
			}
			rcmArray1.push("\n");
		}

		var shinrai = document.getElementById("shinrai").value;
		rcmArray1.push("shinrai= " + shinrai + " # 信頼水準\n");
		var JK = document.getElementById("JK").value;
		rcmArray1.push("JK=\"" + JK + "\" # 情報量規準\n");
		var taju = document.getElementById("taju").value;
		rcmArray1.push("taju=\"" + taju + "\" # BH, holm, b\n");

		rcmArray1.push("## js-STARからの入力おわり\n");
		rcmArray1.push("\n");

		rcmArray1.push("# main\n");
		rcmArray1.push("i= gl(levI, levJ*levK)\n");
		rcmArray1.push("J= gl(levJ, levK, levI*levJ*levK)\n");
		rcmArray1.push("K= gl(levK,    1, levI*levJ*levK)\n");
		rcmArray1.push("\n");
		rcmArray1.push("dset= data.frame(i, J, K, dosu)\n");
		rcmArray1.push("\n");
		rcmArray1.push("jk=c(); ik=c(); ij= c() # 作表\n");
		rcmArray1.push("for( i in 1:3 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("if(i==1){ levX=levJ;levY=levK;levZ=levI;X=\"Ｊ\";Y=\"Ｋ\";Z=\"ｉ\";hyo=xtabs(dosu~J+K+i,dset) }\n");
		rcmArray1.push("if(i==2){ levX=levI;levY=levK;levZ=levJ;X=\"ｉ\";Y=\"Ｋ\";Z=\"Ｊ\";hyo=xtabs(dosu~i+K+J,dset) }\n");
		rcmArray1.push("if(i==3){ levX=levI;levY=levJ;levZ=levK;X=\"ｉ\";Y=\"Ｊ\";Z=\"Ｋ\";hyo=xtabs(dosu~i+J+K,dset) }\n");
		rcmArray1.push("xyz=c(); hyohir=c()\n");
		rcmArray1.push("gyo= levX*levY\n");
		rcmArray1.push("for( z in 1:levZ )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" st=gyo*(z-1)+1; ed=gyo*z\n");
		rcmArray1.push(" tmp= matrix(as.numeric(hyo)[st:ed], nc=levY )\n");
		rcmArray1.push(" for(x in 1:levX) hyohir= c(hyohir, tmp[x,]/sum(tmp[x,]) )\n");
		rcmArray1.push(" xyz= rbind(xyz, tmp )\n");
		rcmArray1.push(" if( z<levZ ) xyz=rbind(xyz, rep(NA,levY) )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("xyz= cbind(xyz, apply(xyz, 1, sum) )\n");
		rcmArray1.push("mds= c()\n");
		rcmArray1.push("for(z in 1:levZ)\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" for(x in 1:levX) mds=c(mds, paste(Z,z,\"_\",X,x, sep=\"\") )\n");
		rcmArray1.push(" if( z<levZ ) mds=c(mds, \"\")\n");
		rcmArray1.push("}\n");
		rcmArray1.push("rownames(xyz)= mds\n");
		rcmArray1.push("colnames(xyz)= c(paste(Y,1:levY, sep=\"\"),\" 合計\" )\n");
		rcmArray1.push("if(i==1) JxK=xyz\n");
		rcmArray1.push("if(i==2) ixK=xyz\n");
		rcmArray1.push("if(i==3) ixJ=xyz\n");
		rcmArray1.push("\n");
		rcmArray1.push("zhyo=c(); mds=c() # 作図\n");
		rcmArray1.push("hmat= matrix(hyohir, nc=levY, by=1 )\n");
		rcmArray1.push("for(x in (levZ*levX):1) zhyo=rbind(zhyo, hmat[x,])\n");
		rcmArray1.push("for(z in levZ:1) mds=c(mds, paste(Z,z,\"_\",X,levX:1, sep=\"\") )\n");
		rcmArray1.push("rownames(zhyo)= mds\n");
		rcmArray1.push("space= rep( c( 1,rep(0,levX-1) ), time=levZ )\n");
		rcmArray1.push("maintitle= paste(X,\"×\",Y,\"の標本比率（バーの区分は \",Y,\"1～\",Y,levY,\")\", sep=\"\" )\n");
		rcmArray1.push("xjiklabel= paste(\"最上段 \",Z,\"1～ \",Z,levZ,\" まで\", sep=\"\" )\n");

		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray1.push("windows()\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray1.push("quartz()\n");
		}

		rcmArray1.push("barplot(t(zhyo),sp=space, las=1,hor=1, main=maintitle,cex.main=1.5,cex.ax=1,cex.na=1.3, xlab=xjiklabel,cex.lab=1.3 )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("\n");
		rcmArray1.push("# ３元\n");
		rcmArray1.push("Mful= c()\n");
		rcmArray1.push("Mful= glm(dosu~i*J*K, data=dset, fa=poisson )\n");
		rcmArray1.push("\n");
		rcmArray1.push("Maic= step(Mful)\n");
		rcmArray1.push("Mbic= step(Mful, k=log(nrow(dset)) )\n");
		rcmArray1.push("Msab= step(Mful, k=log(sum(dosu))  )\n");
		rcmArray1.push("pnlt= 2\n");
		rcmArray1.push("if( JK==\"AIC\" ) Msel=Maic\n");
		rcmArray1.push("if( JK==\"BIC\" ){ Msel=Mbic; pnlt=log(nrow(dset)) }\n");
		rcmArray1.push("if(JK==\"SABIC\"){ Msel=Msab; pnlt=log(sum(dosu)) }\n");
		rcmArray1.push("\n");
		rcmArray1.push("mds= c(\"項の増減\",\"df\",\"残差増分\",\"  df\",\"残差逸脱度\" )\n");
		rcmArray1.push("Aic=Maic$anova; if(nrow(Aic)<2) Amd=c() else Amd=Maic$form\n");
		rcmArray1.push("colnames(Aic)= c(mds, \"     AIC\")\n");
		rcmArray1.push("Bic=Mbic$anova; if(nrow(Bic)<2) Bmd=c() else  Bmd=Mbic$form\n");
		rcmArray1.push("colnames(Bic)= c(mds, \"     BIC\")\n");
		rcmArray1.push("Sab=Msab$anova; if(nrow(Sab)<2) Smd=c() else  Smd=Msab$form\n");
		rcmArray1.push("colnames(Sab)= c(mds, \"   SABIC\")\n");
		rcmArray1.push("Aic[1,5]=0; Bic[1,5]=0; Sab[1,5]=0\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 出力\n");
		rcmArray1.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray1.push("tx0= Mful$formula  # 初期モデル\n");
		rcmArray1.push("tx1= Msel$anova[,] # 選択ステップ\n");
		rcmArray1.push("tx1[1,5]=0\n");
		rcmArray1.push("colnames(tx1)= c(mds, JK)\n");
		rcmArray1.push("slct= nrow(tx1 )\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx2=c();tx3=c(); tx4=c();tx8=c()\n");
		rcmArray1.push("if( slct>1 & slct<8 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" tx2= Msel$form\n");
		rcmArray1.push(" tx3= matrix(c(Msel$null, Msel$df.null, Msel$dev, Msel$df.resid), nr=1 )\n");
		rcmArray1.push(" rownames(tx3)=\"Deviance\"\n");
		rcmArray1.push(" colnames(tx3)= c(\"独立逸脱度\",\"df\",\"  残差逸脱度\",\"残差df\")\n");
		rcmArray1.push("\n");
		rcmArray1.push(" library(car)\n");
		rcmArray1.push(" kx= Anova(Msel)[,1:3]\n");
		rcmArray1.push(" tx4= round(cbind(matrix(c(kx$LR,kx$Df,kx$Pr),nc=3),matrix(p.adjust(kx$Pr,me=taju),nc=1)), 4 )\n");
		rcmArray1.push(" koka= rownames(kx)\n");
		rcmArray1.push(" rownames(tx4)= koka\n");
		rcmArray1.push(" colnames(tx4)= c(\"   χ2値\",\" df\",\"   ｐ値\",\"adjust_p\")\n");
		rcmArray1.push("tx8= summary(Msel)$coef[ ,-2]\n");
		rcmArray1.push("tx8= round(cbind(tx8,matrix(c(0,p.adjust(tx8[2:nrow(tx8),3],me=taju)),nc=1),confint(Msel)), 4 )\n");
		rcmArray1.push("rownames(tx8)[1]=\"(Interc.)\"\n");
		rcmArray1.push("colnames(tx8)[1:4]= c(\"ｂ\",\"ｚ値\",\"ｐ値\",\"adj_p\" )\n");
		rcmArray1.push("} # if(slct)\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx5=c(); tx6=c()\n");
		rcmArray1.push("if( levJ==2 & levK==2)\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" mht= mantelhaen.test(xtabs(dosu~J+K+i,dset),cor=1,conf=shinrai)\n");
		rcmArray1.push(" tx5= matrix(round(c(mht$sta,mht$par,mht$p.v), 4), nr=1 )\n");
		rcmArray1.push(" rownames(tx5)=\"連続性修正値\"\n");
		rcmArray1.push(" colnames(tx5)= c(\" χ2 値\",\" df\",\"   ｐ値\")\n");
		rcmArray1.push(" tx6= matrix(round(c(mht$est,mht$conf[c(1,2)]),4), nr=1 )\n");
		rcmArray1.push(" rownames(tx6)= paste(shinrai*100,\"％信頼水準\", sep=\"\" )\n");
		rcmArray1.push(" colnames(tx6)= c(\"共通オッズ比\",\"CI lower\",\"upper\" )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("\n");
		rcmArray1.push("\n");
		rcmArray1.push("# ■結果の書き方\n");
		rcmArray1.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray1.push("YUDO= function(hyo,Nams, Gens, Kogo )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("Txt= c()\n");
		rcmArray1.push("kazu=0; Mkaz=sum( Gens>0 )\n");
		rcmArray1.push("for( md in 1:length(Nams) ){\n");
		rcmArray1.push(" gyo= Gens[md]\n");
		rcmArray1.push(" if( gyo>0 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" stat= hyo[gyo, ]\n");
		rcmArray1.push(" if( stat[4]<0.05 ) keko=\"\" else keko=\"傾向\"\n");
		rcmArray1.push(" kazu=kazu+1; if(kazu<Mkaz) goku=\"，\" else goku=\"。\"\n");
		rcmArray1.push(" fuki= paste(\" (χ2(\",stat[2],\")=\",round(stat[1],3),\", adjusted p=\",PV(stat[4]),\")\",goku, sep=\"\" )\n");
		rcmArray1.push(" if( kazu<Mkaz ) tmp=\"であり\" else tmp=\"であった\"\n");
		rcmArray1.push(" if( kazu==1 ) goku=Kogo else goku=\"\"\n");
		rcmArray1.push(" if( kazu==2 ) mata=\"また\" else mata=\"\"\n");
		rcmArray1.push(" Txt= paste(Txt, goku,mata,chartr(\":\",\"x\",Nams[md]),\"が有意\",keko,tmp,fuki, sep=\"\" )\n");
		rcmArray1.push("}  } # if(gyo) for(md)\n");
		rcmArray1.push("Txt\n");
		rcmArray1.push("} # 関数 YUDO ここまで\n");
		rcmArray1.push("\n");
		rcmArray1.push("\n");
		rcmArray1.push("txt=\"　Table(JxK)はｉの各水準におけるＪ×Ｋの度数集計表である。\"\n");
		rcmArray1.push("txt= paste(txt, \"\n　Table(JxK)の度数を従属変数とし，ポアソン分布を用いた一般化線形モデリングを行った。ステップワイズ増減法と情報量規準\",JK,\"によるモデル選択の結果 (Table(tx1)参照)，\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("if( slct==1 ) txt=paste(txt, \"選択ステップはｉ×Ｊ×Ｋの初期モデルで停止した。\n\n⇒STAR画面の第二枠『３元初期モデルで停止したとき…』のプログラムをＲにコピペしてください。\n  （ｉの水準別にＪxＫ，またはＪの水準別にｉxＫのカイ二乗検定を実行します。）\n\", sep=\"\" ) else\n");
		rcmArray1.push("if( slct==8 ) txt=paste(txt, \"初期モデルを含め有力なモデルは見いだされなかった。\n\", sep=\"\" ) else\n");
		rcmArray1.push("{  #■１\n");
		rcmArray1.push("\n");
		rcmArray1.push("zan=tx3[3]; zdf=tx3[4]\n");
		rcmArray1.push("fuki= paste(\" (deviance=\",round(zan,3),\", df=\",zdf,\")。\", sep=\"\" )\n");
		rcmArray1.push("tmp=\"といえる\"; susm=\"分析を進める。\"; yaya=\"\"; goku=\"\"\n");
		rcmArray1.push("if( zan-zdf<0 ){ tmp=\"ではない\"; susm=\"\" } else\n");
		rcmArray1.push("if( zan<zdf*2 ){ yaya=\"やや\"; goku=\"許容範囲とみて\" } else goku=\"参考までに\"\n");
		rcmArray1.push("txt= paste(txt, \"度数＝ \",chartr(\":\",\"x\",tx2[3]),\"が選出された。【過分散判定⇒】残差逸脱度は自由度に比べると\",yaya,\"過分散\",tmp,fuki,goku,susm,\"【尤度比検定⇒】尤度比検定によると (Table(tx4)参照)，\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("nam2=c(\"i:J\",\"i:K\",\"J:K\"); gen2=rep(0,3) # 次元有意\n");
		rcmArray1.push("nam1=c(\"i\",\"J\",\"K\"); gen1=rep(1,3)\n");
		rcmArray1.push("for( md in 1:3 ){ gyo=charmatch(nam2[md],koka); if(is.na(gyo)<1) if(tx4[gyo,4]<0.10){ gen2[md]=gyo; gen1[md-(3%%md)]=0; gen1[md+sign(2.5-md)]=0 } }\n");
		rcmArray1.push("txt= paste(txt, YUDO(tx4,nam2,gen2,\"一次の交互作用\"), sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("for( md in 1:3 ){ gyo=charmatch(nam1[md],koka); if(is.na(gyo)<1){ if( tx4[gyo,4]<0.10 & gen1[md]>0 ) gen1[md]=gyo else gen1[md]=0 } else gen1[md]=0 }\n");
		rcmArray1.push("if( sum(gen1)>0 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" if( sum(gen2)>0 ) goku=\"については，独立の効果として\" else goku=\"\"\n");
		rcmArray1.push(" Kogo= paste(\"主効果\",goku, sep=\"\" )\n");
		rcmArray1.push(" txt= paste(txt, YUDO(tx4,nam1,gen1,Kogo), sep=\"\" )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("if( sum(gen2)==0 & sum(gen1)==0 ) txt=paste(txt, \"有意な交互作用・主効果は見られなかった (adjusted ps>\",PV(min(tx4[,4])),\")。\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 偏回帰\n");
		rcmArray1.push("yuis= 0\n");
		rcmArray1.push("for( md in 1:3 ) # 一次作用\n");
		rcmArray1.push("{\n");
		rcmArray1.push("if(md==1){ levX=levI;levY=levJ;levZ=levK;X=\"i\";Y=\"J\";Z=\"K\" }\n");
		rcmArray1.push("if(md==2){ levX=levI;levY=levK;levZ=levJ;X=\"i\";Y=\"K\";Z=\"J\" }\n");
		rcmArray1.push("if(md==3){ levX=levJ;levY=levK;levZ=levI;X=\"J\";Y=\"K\";Z=\"i\" }\n");
		rcmArray1.push("\n");
		rcmArray1.push("if( gen2[md]>0 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("yuis= yuis+1\n");
		rcmArray1.push("if( yuis==1 ){ kaig=\"\n\n　偏回帰係数のWald検定の結果 (Table(tx8)参照)，\"; goku=\"\" } else { kaig=\"\n　\"; goku=\"は\" }\n");
		rcmArray1.push("txt= paste(txt, kaig,chartr(\":\",\"x\",nam2[md]),\"の交互作用において\",goku,\" (Fig.(\",X,\"x\",Y,\")参照)，\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("xkaz=0; minP=1; fgoB=matrix(rep(0,levX*levY), nc=levY )\n");
		rcmArray1.push("for(x in 2:levX){ ykaz=0; sjnY=c(); nons=0; mata=\"\"; tten=\"\"\n");
		rcmArray1.push("for(y in 2:levY){\n");
		rcmArray1.push("  act= paste(X,x,\":\",Y,y, sep=\"\" )\n");
		rcmArray1.push("  gyo= charmatch(act, rownames(tx8) )\n");
		rcmArray1.push("  if( is.na(gyo)<1 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("stat=round(tx8[gyo,], 3); pch=tx8[gyo,4]; if( minP>pch ) minP=pch\n");
		rcmArray1.push("dais=sign(stat[1]); fgoB[x,y]=dais\n");
		rcmArray1.push("if( pch<0.10 )\n");
		rcmArray1.push("{\n");

		rcmArray1.push(" keko=\"\"\n");
		rcmArray1.push(" if( pch>=0.05 ){ nons=nons+1; keko=\"傾向がある\" }\n");
		rcmArray1.push(" fgoB[x,y]= dais*2\n");
		rcmArray1.push(" ykaz=ykaz+1; if( ykaz==1 ) xkaz=xkaz+1\n");
		rcmArray1.push(" sjnY= c(sjnY, dais ) # 大=1, 小=-1\n");
		rcmArray1.push("\n");
		rcmArray1.push(" if( ykaz>1 ) tten=\"，\"\n");
		rcmArray1.push(" if( ykaz==1 ) mds=paste(Z,\"の水準に関わらず\", sep=\"\" ) else mds=\"\"\n");
		rcmArray1.push(" tmp= c(\"大きい\",\"\",\"小さい\" )\n");
		rcmArray1.push(" fuki= paste(\" (ｂ=\",stat[1],\", z=\",stat[2],\", adjusted p=\",PV(pch),\", \",shinrai*100,\"%CI \",stat[5],\" - \",stat[6],\") \", sep=\"\" )\n");
		rcmArray1.push(" if( xkaz==2 & ykaz==1 ) mata=\"また，\" else\n");
		rcmArray1.push(" if( xkaz==3 & ykaz==1 ) mata=\"さらに，\" else if( ykaz>1 ) mata=\"\"\n");
		rcmArray1.push("\n");
		rcmArray1.push(" txt= paste(txt, tten,mata,mds,X,1,\":\",Y,y,\"に比して\",act,\"の比率が有意に\",tmp[2-dais],keko,\"こと\",fuki, sep=\"\" )\n");

		// rcmArray1.push(" if( pch>=0.05 ) nons=nons+1 else\n");
		// rcmArray1.push("{\n");
		// rcmArray1.push(" fgoB[x,y]= dais*2\n");
		// rcmArray1.push(" ykaz=ykaz+1; if( ykaz==1 ) xkaz=xkaz+1\n");
		// rcmArray1.push(" sjnY= c(sjnY, dais ) # 大=1, 小=-1\n");
		// rcmArray1.push("\n");
		// rcmArray1.push(" if( ykaz>1 ) tten=\"，\"\n");
		// rcmArray1.push(" if( ykaz==1 ) mds=paste(Z,\"の水準に関わらず\", sep=\"\" ) else mds=\"\"\n");
		// rcmArray1.push(" tmp= c(\"大き\",\"\",\"小さ\" )\n");
		// rcmArray1.push(" fuki= paste(\" (ｂ=\",stat[1],\", z=\",stat[2],\", adjusted p=\",PV(pch),\", \",shinrai*100,\"%CI \",stat[5],\" - \",stat[6],\") \", sep=\"\" )\n");
		// rcmArray1.push(" if( xkaz==2 & ykaz==1 ) mata=\"また，\" else\n");
		// rcmArray1.push(" if( xkaz==3 & ykaz==1 ) mata=\"さらに，\" else if( ykaz>1 ) mata=\"\"\n");
		// rcmArray1.push("\n");
		// rcmArray1.push(" txt= paste(txt, tten,mata,mds,X,1,\":\",Y,y,\"に比して\",act,\"の比率が有意に\",tmp[2-dais],\"いこと\",fuki, sep=\"\" )\n");
		// rcmArray1.push("} # if(pch<0.05)\n");
		rcmArray1.push("} # if(pch<0.10)\n");
		rcmArray1.push("} # if(is.na\n");
		rcmArray1.push("} # for(y)\n");
		rcmArray1.push(" if( ykaz>0 )\n");
		rcmArray1.push("   {\n");
		rcmArray1.push("    dais= sign(sum(sjnY))\n");
		rcmArray1.push("    if( ( abs(sum(sjnY))-nons*0.5 )>=(levY-2) ){ txt=paste(txt, \"，したがって\",X,1,\":\",Y,\"1に比して\",X,x,\":\",Y,\"1の比率が相対的に\",tmp[2+dais],\"こと\", sep=\"\"); fgoB[x,1]=dais*-2 }\n");
		rcmArray1.push("   }\n");
		rcmArray1.push(" if( ykaz>0 ) txt=paste(txt, \"が見いだされた。\", sep=\"\" )\n");
		rcmArray1.push("} # for(x)\n");
		rcmArray1.push(" if( xkaz<1 ) txt=paste(txt, \"有意な偏回帰係数は見られなかった (adjusted ps>\",PV(minP),\")。\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("sumi= 0\n");
		rcmArray1.push("if( levX>2 )\n");
		rcmArray1.push("{ # fgoB\n");
		rcmArray1.push("for( x in 2:(levX-1) ){ for( z in (x+1):levX ){\n");
		rcmArray1.push("for( y in 1:levY )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("if( (fgoB[x,y]*fgoB[z,y])< -1 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" goku=\"なおまた偏回帰係数の正負と有意性から推測される結果として，\"\n");
		rcmArray1.push(" sumi= sumi+1\n");
		rcmArray1.push(" if( sumi>1 ) goku=\"，\"\n");
		rcmArray1.push(" if( fgoB[x,y]>0 ) tmp=\"大きい\" else tmp=\"小さい\"\n");
		rcmArray1.push(" txt= paste(txt, goku,X,x,\":\",Y,y,\"が\",X,z,\":\",Y,y,\"より\",tmp, sep=\"\" )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("}  }  } # for(y,z,x\n");
		rcmArray1.push("if( sumi>0 ) txt=paste(txt, \"という相対的な差が見いだされた。\", sep=\"\" )\n");
		rcmArray1.push("} # if(levX\n");
		rcmArray1.push("} # if(gen2)\n");
		rcmArray1.push("} # for(md)\n");
		rcmArray1.push("\n");
		rcmArray1.push("if( sum(gen1)>0 ) # 主効果\n");
		rcmArray1.push("{\n");
		rcmArray1.push("levs= c(levI,levJ,levK )\n");
		rcmArray1.push("Yuis= 0\n");
		rcmArray1.push("for( md in 1:3 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("if( gen1[md]>0 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" X=nam1[md]\n");
		rcmArray1.push(" Yuis= Yuis+1\n");
		rcmArray1.push(" if( sum(gen2)>0 ) kaig=\"\n\" else kaig=\"\"\n");
		rcmArray1.push(" if( Yuis==1 ) goku=\"選出された主効果について偏回帰係数のWald検定を行った結果 (Table(tx8)参照)，\" else if( Yuis==2 ) goku=\"また\" else goku=\"さらに\"\n");
		rcmArray1.push(" txt= paste(txt, kaig,\"\n　\",goku,\"主効果\",X,\"として\", sep=\"\" )\n");
		rcmArray1.push(" sumi=0; minP=1\n");
		rcmArray1.push(" for( x in 2:levs[md] )\n");
		rcmArray1.push(" {\n");
		rcmArray1.push("  act= paste(X,x, sep=\"\" )\n");
		rcmArray1.push("  gyo=charmatch(act, rownames(tx8) )\n");
		rcmArray1.push("  if( is.na(gyo)<1 )\n");
		rcmArray1.push("  {\n");
		rcmArray1.push("   stat=tx8[gyo,]; pch=stat[4]; if( pch<minP ) minP=pch\n");

		rcmArray1.push("   if( pch<0.10 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("if( pch<0.05 ) keko=\"\" else keko=\"傾向がある\"\n");
		rcmArray1.push("sumi= sumi+1\n");
		rcmArray1.push("if( sign(stat[1])>0 ) tmp=\"大きい\" else tmp=\"小さい\"\n");
		rcmArray1.push("fuki= paste(\" (ｂ=\",round(stat[1],3),\", z=\",round(stat[2],3),\", adjusted p=\",PV(pch),\", \",shinrai*100,\"%CI \",round(stat[5],3),\" - \",round(stat[6],3),\") \", sep=\"\" )\n");
		rcmArray1.push("txt= paste(txt, \"，\",X,\"1に比して\",act,\"の比率が有意に\",tmp,keko,\"こと\",fuki, sep=\"\" )\n");
		rcmArray1.push("}\n");
		// rcmArray1.push("   if( pch<0.05 )\n");
		// rcmArray1.push("{\n");
		// rcmArray1.push("sumi= sumi+1\n");
		// rcmArray1.push("if( sign(stat[1])>0 ) tmp=\"大き\" else tmp=\"小さ\"\n");
		// rcmArray1.push("fuki= paste(\" (ｂ=\",round(stat[1],3),\", z=\",round(stat[2],3),\", adjusted p=\",PV(pch),\", \",shinrai*100,\"%CI \",round(stat[5],3),\" - \",round(stat[6],3),\") \", sep=\"\" )\n");
		// rcmArray1.push("txt= paste(txt, \"，\",X,\"1に比して\",act,\"の比率が有意に\",tmp,\"いこと\",fuki, sep=\"\" )\n");
		// rcmArray1.push("}\n");
		rcmArray1.push("  } # if(is.na\n");
		rcmArray1.push(" } # for(x)\n");
		rcmArray1.push("if( levs[md]==2 ) Ps=\"p=\" else Ps=\"ps>\"\n");
		rcmArray1.push("if( sumi>0 ) txt=paste(txt, \"が見いだされた。\", sep=\"\" ) else txt=paste(txt, \"，有意な編回帰係数は見られなかった (adjusted \",Ps,PV(minP),\")。\", sep=\"\" )\n");
		rcmArray1.push("} # if(gen1)\n");
		rcmArray1.push("} # for(md)\n");
		rcmArray1.push("} # if(sum)\n");
		rcmArray1.push("\n");
		rcmArray1.push("if( gen2[3]>1 ) goku=\"の\" else goku=\"は選出されなかったが，\"\n");
		rcmArray1.push("if( levJ==2 & levK==2 ) txt=paste(txt, \"\n　なお，J×K\",goku,\"共通オッズ比は\",round(tx6[1],3),\"，その\",shinrai*100,\"％信頼区間は\",round(tx6[2],3),\" - \",round(tx6[3],3),\"と推定される。\n\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("}  #■1\n");
		rcmArray1.push("if(taju==\"BH\"){ TAJ=taju; tmp=\"Benjamini & Hochberg (1995) \" } else if(taju==\"b\") TAJ=\"Bonferroni\" else TAJ=\"Holm\"\n");
		rcmArray1.push("if(slct>1 & slct<8)\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" txt=paste(txt, \"\n　以上のｐ値の調整には\",TAJ,\"法を用いた。\n\", sep=\"\" )\n");
		rcmArray1.push(" if( taju==\"BH\" ) txt=paste(txt, \"\n\n［引用文献］\n\", \n");
		rcmArray1.push(" \"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("H=matrix(0,nr=1)\n");
		rcmArray1.push("rownames(H)=\"\"\n");
		rcmArray1.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("options(digits=5)\n");
		rcmArray1.push("options(scipen=5)\n");
		rcmArray1.push("###############################\n");
		rcmArray1.push("#    ｉ×Ｊ×Ｋ表の分析：\n");
		rcmArray1.push("#    ３元モデル選択\n");
		rcmArray1.push("#\n");
		rcmArray1.push("#    ポアソン回帰モデリング\n");
		rcmArray1.push("#    ステップワイズ増減法\n");
		rcmArray1.push("H##############################\n");
		rcmArray1.push("JxK # 度数集計表 ＪｘＫ at_ｉ\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx0 # 初期モデル(＊は主効果・交互作用を含む)\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx1 # モデル選択ステップの要約\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx2 # 選出されたモデル\n");
		rcmArray1.push("# NULL は選出モデルなし\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx3 # 過分散判定(残差逸脱度>>残差df なら過分散)\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx4 # 説明変数の尤度比検定\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx8 # 偏回帰係数のWald検定\n");
		rcmArray1.push("# ■ｂは非標準化偏回帰係数\n");
		rcmArray1.push("\n");
		rcmArray1.push("cat(txt) # 結果の書き方\n");
		rcmArray1.push("\n");
		rcmArray1.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray1.push("# tx6 # 共通オッズ比（２×２×Ｋ表のみ）\n");
		rcmArray1.push("# tx5 # マンテル・ヘンツェル検定（同上）\n");
		rcmArray1.push("# ixJ # 度数集計表 ixJ at_K\n");
		rcmArray1.push("# ixK # 度数集計表 ixK at_J\n");
		rcmArray1.push("# Aic;Amd  # AIC によるモデル選択\n");
		rcmArray1.push("# Bic;Bmd  # BIC によるモデル選択\n");
		rcmArray1.push("# Sab;Smd  # SABIC によるモデル選択\n");
		rcmArray1.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray1.push("\n");
		rcmArray1.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
		rcmArray1.push("\n");

		document.getElementById("RcmArea").value = rcmArray1.join("");
		rcmArray1 = null;

		// 第２枠の出力
		rcmArray2.push("## ３元停止モデル→水準別カイ二乗検定へ\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx6= c()\n");
		rcmArray2.push("kai=c(); df=c(); pch=c()\n");
		rcmArray2.push("for( I in 1:levI )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" kx= chisq.test(xtabs(dosu~J+K,subset(dset,i==I)) )\n");
		rcmArray2.push(" kai=c(kai,kx$stat); df=c(df,kx$para); pch=c(pch,kx$p.va)\n");
		rcmArray2.push("}\n");
		rcmArray2.push("pad= p.adjust(pch, me=taju )\n");
		rcmArray2.push("tx6= matrix(round(c(kai,df,pch,pad),4), nc=4 )\n");
		rcmArray2.push("rownames(tx6)= paste(\"ｉ=\",1:levI, sep=\"\" )\n");
		rcmArray2.push("colnames(tx6)= c(\"  χ2値\",\" df\",\"   ｐ値\",\"調整後ｐ値\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx7= c()\n");
		rcmArray2.push("kai=c(); df=c(); pch=c()\n");
		rcmArray2.push("for( j in 1:levJ )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" kx= chisq.test(xtabs(dosu~i+K,subset(dset,J==j)) )\n");
		rcmArray2.push(" kai=c(kai,kx$stat); df=c(df,kx$para); pch=c(pch,kx$p.va)\n");
		rcmArray2.push("}\n");
		rcmArray2.push("pad= p.adjust(pch, me=taju )\n");
		rcmArray2.push("tx7= matrix(round(c(kai,df,pch,pad),4), nc=4 )\n");
		rcmArray2.push("rownames(tx7)= paste(\"Ｊ=\",1:levJ, sep=\"\" )\n");
		rcmArray2.push("colnames(tx7)= c(\"  χ2値\",\" df\",\"   ｐ値\",\"調整後ｐ値\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("\n");
		rcmArray2.push("## 結果の書き方\n");
		rcmArray2.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"\n　初期モデルｉ×Ｊ×Ｋについて，ｉの水準別にＪ×Ｋのカイ二乗検定を行った。その結果，\", sep=\"\" )\n");
		rcmArray2.push("minP= min(tx6[,4] )\n");
		rcmArray2.push("if( minP>=0.10 ) txt=paste(txt, \"ｉのどの水準においても有意差は見いだされなかった (adjusted ps>\",PV(minP),\")。\",sep=\"\") else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("mae=0; ima=0; wamo=\"は\"\n");
		rcmArray2.push("for( I in 1:levI )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("pch= tx6[I,4]\n");
		rcmArray2.push("fuki= paste(\" (χ2(\",tx6[I,2],\")=\",round(tx6[I,1],3),\", adjusted p=\",PV(pch),\", w=\",round(sqrt(tx6[I,1]/sum(subset(dset,i==I)$dosu)),3),\")。\", sep=\"\" )\n");
		rcmArray2.push("keko=\"\"\n");
		rcmArray2.push("if( pch<0.10 ){ keko=\"傾向\"; tmp=\"であった\"; ima=1 } else { tmp=\"でなかった\"; ima=0 }\n");
		rcmArray2.push("if( pch<0.05 )  keko=\"\"\n");
		rcmArray2.push("if( I==1 ) kaig=\"\" else  kaig=\"\n　\"\n");
		rcmArray2.push("if( I>1 ) if( ima==mae ) wamo=\"も\" else wamo=\"は\"\n");
		rcmArray2.push("txt= paste(txt, kaig,\"ｉの第\",I,\"水準で\",wamo,\"，Ｊ×Ｋは有意\",tmp,fuki, sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( pch<0.10 ) # 残差\n");
		rcmArray2.push("{\n");
		rcmArray2.push("hyo= xtabs(dosu~J+K, subset(dset,i==I) )\n");
		rcmArray2.push("N= sum( hyo )\n");
		rcmArray2.push("kx= chisq.test( hyo )\n");
		rcmArray2.push("gyohir= rep(apply(hyo,1,sum),each=levK)/N  # 行比率\n");
		rcmArray2.push("rethir= rep(apply(hyo,2,sum)/N, levJ ) # 列比率\n");
		rcmArray2.push("zans= as.numeric(t(kx$resid))/sqrt((1-gyohir)*(1-rethir))\n");
		rcmArray2.push("\n");
		rcmArray2.push("Pch= c()\n");
		rcmArray2.push("for( x in 1:(levJ*levK) ) Pch=c(Pch, pnorm(zans[x], low=sign((sign(zans[x])-1)*(-1)))*2 )\n");
		rcmArray2.push("Pad= p.adjust(Pch, me=taju )\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"残差分析の結果 (α=0.05, 両側検定)，\", sep=\"\" )\n");
		rcmArray2.push("pkaz= sum(Pad<0.10 )\n");
		rcmArray2.push("if( pkaz==0 ) txt=paste(txt, \"どのセルの残差も有意ではなかった (adjusted ps>\",PV(min(Pad)),\")。\", sep=\"\") else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("sumi=0; junb=0\n");
		rcmArray2.push("for( j in 1:levJ ){ for( k in 1:levK ){ junb=junb+1\n");
		rcmArray2.push("  pad= Pad[junb]\n");
		rcmArray2.push("  if( pad<0.10 )\n");
		rcmArray2.push("  {\n");
		rcmArray2.push("   keko=\"い傾向があ\"; if( pad<0.05 ) keko=\"\"\n");
		rcmArray2.push("   sumi= sumi+1\n");
		rcmArray2.push("   zan= round(zans[junb],3)\n");
		rcmArray2.push("   if( sumi<pkaz ){ tmp=\"，\"; if( pad<0.05 ) goku=\"く\" else goku=\"り\" } else { tmp=\"。\"; if( pad<0.05 ) goku=\"かった\" else goku=\"った\" }\n");
		rcmArray2.push("   fuki= paste(\" (z=\",zan,\", adjusted p=\",PV(pad),\")\",tmp, sep=\"\" )\n");
		rcmArray2.push("   if( zan>0 ) tmp=\"多\" else tmp=\"少な\"\n");
		rcmArray2.push("   txt= paste(txt, \"セルJ\",j,\":K\",k,\"の度数が期待度数より有意に\",tmp,keko,goku,fuki, sep=\"\" )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("}  } # for(j,k)\n");
		rcmArray2.push("} # if(pkaz)\n");
		rcmArray2.push("} # if(pch)\n");
		rcmArray2.push(" mae= ima\n");
		rcmArray2.push("} # for(I)\n");
		rcmArray2.push("} # if(minP)\n");
		rcmArray2.push("\n");
		rcmArray2.push("# Ｊ別\n");
		rcmArray2.push("txt= paste(txt, \"\n\n　一方，Ｊの水準別にｉ×Ｋのカイ二乗検定を行った結果，\", sep=\"\" )\n");
		rcmArray2.push("minP= min(tx7[,4] )\n");
		rcmArray2.push("if( minP>=0.10 ) txt=paste(txt, \"Ｊのどの水準においても有意差は見いだされなかった (adjusted ps>\",PV(minP),\")。\",sep=\"\") else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("mae=0; ima=0; wamo=\"は\"\n");
		rcmArray2.push("for( j in 1:levJ )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("pch= tx7[j,4]\n");
		rcmArray2.push("fuki= paste(\" (χ2(\",tx7[j,2],\")=\",round(tx7[j,1],3),\", adjusted p=\",PV(pch),\", w=\",round(sqrt(tx7[j,1]/sum(subset(dset,J==j)$dosu)),3),\")。\", sep=\"\" )\n");
		rcmArray2.push("keko=\"\"\n");
		rcmArray2.push("if( pch<0.10 ){ keko=\"傾向\"; tmp=\"であった\"; ima=1 } else { tmp=\"でなかった\"; ima=0 }\n");
		rcmArray2.push("if( pch<0.05 )  keko=\"\"\n");
		rcmArray2.push("if( j==1 ) kaig=\"\" else  kaig=\"\n　\"\n");
		rcmArray2.push("if( j>1 ) if( ima==mae ) wamo=\"も\" else wamo=\"は\"\n");
		rcmArray2.push("txt= paste(txt, kaig,\"Ｊの第\",j,\"水準で\",wamo,\"，ｉ×Ｋは有意\",tmp,fuki, sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( pch<0.10 ) # 残差\n");
		rcmArray2.push("{\n");
		rcmArray2.push("hyo= xtabs(dosu~i+K, subset(dset,J==j) )\n");
		rcmArray2.push("N= sum( hyo )\n");
		rcmArray2.push("kx= chisq.test( hyo )\n");
		rcmArray2.push("gyohir= rep(apply(hyo,1,sum),each=levK)/N  # 行比率\n");
		rcmArray2.push("rethir= rep(apply(hyo,2,sum)/N, levI ) # 列比率\n");
		rcmArray2.push("zans= as.numeric(t(kx$resid))/sqrt((1-gyohir)*(1-rethir))\n");
		rcmArray2.push("\n");
		rcmArray2.push("Pch= c()\n");
		rcmArray2.push("for( x in 1:(levI*levK) ) Pch=c(Pch, pnorm(zans[x], low=sign((sign(zans[x])-1)*(-1)))*2 )\n");
		rcmArray2.push("Pad= p.adjust(Pch, me=taju )\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"残差分析の結果 (α=0.05, 両側検定)，\", sep=\"\" )\n");
		rcmArray2.push("pkaz= sum(Pad<0.10 )\n");
		rcmArray2.push("if( pkaz==0 ) txt=paste(txt, \"どのセルの残差も有意ではなかった (adjusted ps>\",PV(min(Pad)),\")。\", sep=\"\") else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("sumi=0; junb=0\n");
		rcmArray2.push("for( I in 1:levI ){ for( k in 1:levK ){ junb=junb+1\n");
		rcmArray2.push("  pad= Pad[junb]\n");
		rcmArray2.push("  if( pad<0.10 )\n");
		rcmArray2.push("  {\n");
		rcmArray2.push("   keko=\"い傾向があ\"; if( pad<0.05 ) keko=\"\"\n");
		rcmArray2.push("   sumi= sumi+1\n");
		rcmArray2.push("   zan= round(zans[junb],3)\n");
		rcmArray2.push("   if( sumi<pkaz ){ tmp=\"，\"; if( pad<0.05 ) goku=\"く\" else goku=\"り\" } else { tmp=\"。\"; if( pad<0.05 ) goku=\"かった\" else goku=\"った\" }\n");
		rcmArray2.push("   fuki= paste(\" (z=\",zan,\", adjusted p=\",PV(pad),\")\",tmp, sep=\"\" )\n");
		rcmArray2.push("   if( zan>0 ) tmp=\"多\" else tmp=\"少な\"\n");
		rcmArray2.push("   txt= paste(txt, \"セルi\",I,\":K\",k,\"の度数が期待度数より有意に\",tmp,keko,goku,fuki, sep=\"\" )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("}  } # for(I,k)\n");
		rcmArray2.push("} # if(pkaz)\n");
		rcmArray2.push("} # if(pch)\n");
		rcmArray2.push(" mae= ima\n");
		rcmArray2.push("} # for(j)\n");
		rcmArray2.push("} # if(minP)\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt=paste(txt, \"\n　以上のｐ値の調整には\",TAJ,\"法を用いた。\n\", sep=\"\" )\n");
		rcmArray2.push("if( taju==\"BH\" ) txt=paste(txt, \"\n\n［引用文献］\n\", \n");
		rcmArray2.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("################################\n");
		rcmArray2.push("#    ｉ×Ｊ×Ｋ表の分析：\n");
		rcmArray2.push("#    ポアソン回帰モデリング\n");
		rcmArray2.push("#    ステップワイズ増減法\n");
		rcmArray2.push("#\n");
		rcmArray2.push("#  ※初期モデルで停止したとき\n");
		rcmArray2.push("H###############################\n");
		rcmArray2.push("JxK # 度数集計表 ＪｘＫ at_ｉ\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx0 # 初期モデル ( * は主効果・交互作用を含む)\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx1 # モデル選択ステップの要約\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx2 # 選出されたモデル ( : は交互作用を示す)\n");
		rcmArray2.push("# ■ NULL は選出モデルなし\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx6 # ｉの水準別のＪ×Ｋのカイ二乗検定\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx7 # Ｊの水準別のｉ×Ｋのカイ二乗検定\n");
		rcmArray2.push("\n");
		rcmArray2.push("cat(txt) # 結果の書き方\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray2.push("# （表示手順：上向矢印→先頭の#消去→Enter）\n");
		rcmArray2.push("# tx6 # 共通オッズ比（２×２×Ｋ表のみ）\n");
		rcmArray2.push("# tx5 # マンテル・ヘンツェル検定（同上）\n");
		rcmArray2.push("# ixJ # 度数集計表 ixJ at_K\n");
		rcmArray2.push("# ixK # 度数集計表 ixK at_J\n");
		rcmArray2.push("# Aic;Amd  # AIC によるモデル選択\n");
		rcmArray2.push("# Bic;Bmd  # BIC によるモデル選択\n");
		rcmArray2.push("# Sab;Smd  # SABIC によるモデル選択\n");
		rcmArray2.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;

	}());	//Ｒプログラムここまで

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
/**
 * [change3dSetting セルなどの入力フォーム部分を作成]
 */
function change3dSetting() {
	var h = 2;
	var htmArray = [];

	htmArray.push("<div class=\"tateyoko\">\n");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("ｉ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"iCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change3dTable();\">");
		htmArray.push("Ｊ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"jCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change3dTable();\">");
		htmArray.push("Ｋ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"kCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change3dTable();\">");
	} else {
		htmArray.push("ｉ＝<select name=\"i\" id=\"iCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'i の値'); change3dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("Ｊ＝<select name=\"j\" id=\"jCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'j の値'); change3dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("Ｋ＝<select name=\"k\" id=\"kCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'k の値'); change3dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("</select>");
	}

	htmArray.push("</div>");

	document.getElementById("3d_setting").innerHTML = htmArray.join("");
	htmArray = null;

	change3dTable();
}
function change3dTable() {
	var i = 0;
	var j = 0;
	var k = 0;
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	var htmArray = [];
	var cellId = 1;
	var cellCount = iCount * jCount * kCount;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("i");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｊ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｋ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("度数");
	htmArray.push("</td>");
	htmArray.push("</tr>");
	for (i = 0; i < iCount; i++) {
		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				htmArray.push("<tr>");
				htmArray.push("<td class=\"hyou_midashi_3d\">");
				htmArray.push(i + 1);
				htmArray.push("</td>");
				htmArray.push("<td class=\"hyou_midashi_3d\">");
				htmArray.push(j + 1);
				htmArray.push("</td>");
				htmArray.push("<td class=\"hyou_midashi_3d\">");
				htmArray.push(k + 1);
				htmArray.push("</td>");
				htmArray.push("<td class=\"hyou_nyuryoku\">");
				htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxl=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
				htmArray.push("</td>");
				htmArray.push("</tr>");
				cellId++;
			}
		}
	}
	htmArray.push("</table>");

	// 横線がはいるので要検討！todo
	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("3d_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_3d() {
	var i, j, k;

	var strArray = [];

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	//#0
	strArray.push("ixjxk" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(iCount + "," + jCount + "," + kCount + "\n");
	//#2
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (i = 0; i < iCount; i++) {
		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				x = parseInt(document.getElementById("cell_" + cellId).value);
				strArray.push(x + "\n");
				cellId++;
			}
		}
	}

	var Stream = strArray.join("");
	var fineName = "ixjxk_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_ixjxk() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "ixjxk") {
		var ijk = dd[1];
		ijk = delTopCR(ijk);
		var ijk_data = [];
		ijk_data = ijk.split(",");
		document.getElementById("iCount").value = parseInt(ijk_data[0]);
		document.getElementById("jCount").value = parseInt(ijk_data[1]);
		document.getElementById("kCount").value = parseInt(ijk_data[2]);
		change3dTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}
function simulation_3d(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	var min, max;
	if ((iCount === 2) && (jCount === 2) && (kCount === 2)) {
		min = 2;
		max = 3;
		iCount = Math.floor(Math.random() * (max - min + 1) + min);
		jCount = Math.floor(Math.random() * (max - min + 1) + min);
		min = 2;
		max = 5;
		kCount = Math.floor(Math.random() * (max - min + 1) + min);
	}

	document.getElementById("iCount").value = iCount;
	document.getElementById("jCount").value = jCount;
	document.getElementById("kCount").value = kCount;
	var elmCount = iCount * jCount * kCount;

	change3dTable();

	var result = "rnd1:9*" + elmCount;

	document.getElementById("CandPArea").value = random_number_generation(result);

	conditionalBranch();
	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// inputBtnTextClear(this);

	mainCalc_3d();
}