/**
 * 相関分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	RoutputSelect();
	RoutputArea();

	// デフォルトのタブを選択
	ChangeTab(1, 5);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop2();

};
function checkData() {
	var err = false;
	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {

		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得
		if (KK === -1) {
			err = true;
			alert("データが行列形式ではありません");
		}

		if (err == false) {
			mainCalc_corr();
		}
	}
}
function mainCalc_corr() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	var strArray = [];
	bar = "--------------------------------------\n";
	var diaArray = [];
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	var ddCount = 0;
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			xx[i][j] = parseFloat(dd[ddCount]);
			ddCount++;
		}
	}

	var M = [];
	var SD = [];
	var MA = [];
	var MI = [];

	//基本統計量
	strArray.push(" == Means & SDs(SDは標本標準偏差) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (j = 0; j < KK; j++) {
		S = 0;
		SS = 0;
		MA[j] = xx[0][j];
		MI[j] = xx[0][j];

		for (i = 0; i < NN; i++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[j] < xx[i][j]) MA[j] = xx[i][j];
			if (MI[j] > xx[i][j]) MI[j] = xx[i][j];
		}

		M[j] = S / NN;
		SD[j] = Math.sqrt(SS / NN - Math.pow(M[j], 2));

		strArray.push((j + 1) + "\t" + using(M[j], 4, 3) + "\t" + using(SD[j], 4, 3) + "\t" + using(MI[j], 4, 3) + "\t" + using(MA[j], 4, 3) + "\n");
	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (j = 0; j < KK; j++) {
		strArray.push((j + 1) + "\t" + using(M[j] + SD[j], 4, 3) + "\t" + using(M[j] - SD[j], 4, 3) + "\n");
	}
	strArray.push(bar);

	var R = new Array(KK);
	for (j = 0; j < KK; j++) {
		R[j] = new Array(KK);
	}

	var FF = new Array(KK);
	for (j = 0; j < KK; j++) {
		FF[j] = new Array(KK);
	}

	var F$ = new Array(KK);
	for (j = 0; j < KK; j++) {
		F$[j] = new Array(KK);
	}

	var lineWidth = new Array(KK);
	for (j = 0; j < KK; j++) {
		lineWidth[j] = new Array(KK);
	}

	var corrStr = new Array(KK);
	for (j = 0; j < KK; j++) {
		corrStr[j] = new Array(KK);
	}

	var FF1, FF2, FF3;

	S = 0;
	for (j = 0; j < KK - 1; j++) {
		for (jj = j + 1; jj < KK; jj++) {
			S = 0;
			for (i = 0; i < NN; i++) {
				S += (xx[i][j] - M[j]) * (xx[i][jj] - M[jj]);
			}
			R[j][jj] = S / NN / SD[j] / SD[jj];
			if (R[j][jj] > 0.9999) {
				FF[j][jj] = 999.99;
			} else {
				if (Math.pow(R[j][jj], 2) == 1) {
					FF[j][jj] = 0;
				} else {
					FF[j][jj] = Math.pow(R[j][jj], 2) / (1 - Math.pow(R[j][jj], 2)) * (NN - 2);
				}
			}

			FF3 = f_tables(2, NN); //１％水準
			FF2 = f_tables(1, NN); //５％水準
			FF1 = f_tables(0, NN); //１０％水準

			if (NN > 2) {
				if (FF[j][jj] > FF3) { //１％水準
					F$[j][jj] = "**";
					if (Math.abs(R[j][jj]) >= 0.9) {
						lineWidth[j][jj] = 8;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.7) {
						lineWidth[j][jj] = 6;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.4) {
						lineWidth[j][jj] = 4;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.3) {
						lineWidth[j][jj] = 2;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
					} else {
						lineWidth[j][jj] = 1;
						corrStr[j][jj] = "";
					}
				} else if (FF[j][jj] > FF2) { //５％水準
					F$[j][jj] = " *";
					if (Math.abs(R[j][jj]) >= 0.9) {
						lineWidth[j][jj] = 8;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.7) {
						lineWidth[j][jj] = 6;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.4) {
						lineWidth[j][jj] = 4;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.3) {
						lineWidth[j][jj] = 2;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
					} else {
						lineWidth[j][jj] = 1;
						corrStr[j][jj] = "";
					}
				} else if (FF[j][jj] > FF1) { //１０％水準
					F$[j][jj] = " +";
					lineWidth[j][jj] = 1;
					corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "は弱く関連する可能性があります。\n";
				} else {
					F$[j][jj] = "ns";
					lineWidth[j][jj] = 0;
					corrStr[j][jj] = "";
				}
			} else {
				F$[j][jj] = "ns";
				lineWidth[j][jj] = 0;
				corrStr[j][jj] = "";
			}
		}
	}
	strArray.push("\n");
	strArray.push("\n Correlation Matrix\n");
	strArray.push("  df= 1 & " + (NN - 2) + "\n");

	var diagramData = KK + "\n";
	var wStr = "";

	strArray.push(bar);
	for (j = 0; j < KK; j++) {
		strArray.push("\tVar" + (j + 1));
	}
	strArray.push("\n");
	strArray.push(bar);

	for (j = 0; j < KK; j++) {
		strArray.push("Var" + (j + 1));
		for (jj = 0; jj < j + 1; jj++) {
			strArray.push("\t");
		}
		strArray.push("-");
		for (jj = j + 1; jj < KK; jj++) {
			strArray.push("\t" + using(R[j][jj], 2, 3) + " " + F$[j][jj]);
		}
		strArray.push("\n");
	}

	strArray.push("\nTest of Correlation\n");
	for (j = 0; j < KK - 1; j++) {
		strArray.push(bar);
		strArray.push("  Var.       r       F   Test\n");
		strArray.push(bar);
		for (jj = j + 1; jj < KK; jj++) {
			strArray.push(" Var" + (j + 1) + "xVar" + (jj + 1) + "\t");
			strArray.push(using(R[j][jj], 2, 3) + "\t" + using(FF[j][jj], 3, 2) + "\t" + F$[j][jj] + "\n");
			if (lineWidth[j][jj] != 0) {
				diagramData += (j + 1) + "," + (jj + 1) + "," + using(R[j][jj], 2, 3) + "," + lineWidth[j][jj] + "\n";
			}
			if (corrStr[j][jj] != "") {
				wStr += corrStr[j][jj];
			}
		}
	}

	strArray.push("\n" + bar + "\n" + wStr);
	// strArray.push("\n"+bar+"▽　視覚化データ\n");
	// strArray.push(diagramData);
	// strArray.push("\n"+"△　ここまで\n\n");

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	// ダイアグラム出力
	document.getElementById("corrDiaArea").value = diagramData;
	corrDiaDraw();

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	// var gResult = null;
	// if (key_shift) {
	// 	gResult = prompt("グラフの軸設定（最小値と最大値をカンマで区切る）　例： 0,100");
	// 	gResult.replace(/\s+/g, ""); //空白文字を全削除
	// }

	//出力
	// if (document.getElementById("RltAdd").checked) {
	// 	document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	// } else {
	document.getElementById("RltArea").value = strArray.join("");
	// }
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			for (i = 0; i < NN; i++) {
				for (j = 0; j < KK; j++) {
					rcmArray1.push(xx[i][j]);
					if ((j != KK - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			for (j = 0; j < KK; j++) {
				rcmArray.push("x" + (j + 1) + " <- c(");
				for (i = 0; i < NN; i++) {
					rcmArray.push(" " + xx[i][j]);
					if ((i != NN - 1)) rcmArray.push(",");
				}
				rcmArray.push(" )\n");
			}

			rcmArray.push("\n");
			rcmArray.push("dtab = data.frame(\n");
			for (j = 0; j < KK; j++) {
				rcmArray.push(" x" + (j + 1));
				if ((j != KK - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");
			for (j = 0; j < KK; j++) {
				rcmArray.push("x" + (j + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("#######  相関係数の計算と検定  #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# パッケージ psych が必要\n");
		rcmArray2.push("# dtab は読み込み済み\n");
		rcmArray2.push("\n");
		rcmArray2.push("## js-STARからの入力:Corr\n");

		var taju = document.getElementById("taju").value;
		rcmArray2.push("taju=\"" + taju + "\"  # BH, holm, b\n");
		rcmArray2.push("## js-STARの入力おわり\n");
		rcmArray2.push("\n");

		rcmArray2.push("# 基本統計\n");
		rcmArray2.push("N= nrow(dtab)\n");
		rcmArray2.push("hensu= ncol(dtab)\n");
		rcmArray2.push("colnames(dtab)= paste(\"x\",1:hensu, sep=\"\" )\n");
		rcmArray2.push("hk= apply(dtab, 2, mean)\n");
		rcmArray2.push("sd= apply(dtab, 2, sd  )\n");
		rcmArray2.push("mi= apply(dtab, 2, min )\n");
		rcmArray2.push("ma= apply(dtab, 2, max )\n");
		rcmArray2.push("tx1= matrix(round(c(rep(N,hensu),hk,sd,mi,ma,hk-sd,hk+sd), 4), nc=7 )\n");
		rcmArray2.push("rownames(tx1)= colnames(dtab)\n");
		rcmArray2.push("colnames(tx1)= c(\"   N\",\"Mean\",\"SD\",\" Min\",\"Max\",\"   M-SD\",\"M+SD\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 相関行列\n");
		rcmArray2.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray2.push("hoho= c(\"p\",\"s\",\"k\")\n");
		rcmArray2.push("mds= paste(\"x\",1:hensu, sep=\"\" )\n");
		rcmArray2.push("options( warn=-1 )\n");
		rcmArray2.push("\n");
		rcmArray2.push("for( L in 3:1 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("sok=c(); pch=c(); tesR=c(); tesX=c()\n");
		rcmArray2.push("rmat=c(); tmat=c()\n");
		rcmArray2.push("for( i in 1:hensu ){ for( j in 1:hensu ){\n");
		rcmArray2.push("  kx= cor.test(dtab[,i],dtab[,j], me=hoho[L] )\n");
		rcmArray2.push("  if(L==1){ rmat=c(rmat,kx$est); tmat=c(tmat,kx$sta) }\n");
		rcmArray2.push("if( i<j )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" sok=c(sok,kx$est); pch=c(pch,kx$p.v)\n");
		rcmArray2.push("} else {\n");
		rcmArray2.push(" sok=c(sok,NA); pch=c(pch,NA)\n");
		rcmArray2.push("}\n");
		rcmArray2.push("}  } # for(i)(j)\n");
		rcmArray2.push("sok= matrix(round(sok,3), nc=hensu,by=1 )\n");
		rcmArray2.push("adj= matrix(PV(p.adjust(pch,me=taju)), nc=hensu,by=1 )\n");
		rcmArray2.push("pch= matrix(PV(pch), nc=hensu,by=1 )\n");
		rcmArray2.push("dimnames(sok)= list(mds,mds)\n");
		rcmArray2.push("dimnames(pch)= list(mds,mds)\n");
		rcmArray2.push("dimnames(adj)= list(mds,mds)\n");
		rcmArray2.push("if( L==1 ){ Pea=sok; Pea2=pch; Pea3=adj }\n");
		rcmArray2.push("if( L==2 ){ Spr=sok; Spr2=pch; Spr3=adj }\n");
		rcmArray2.push("if( L==3 ){ Ken=sok; Ken2=pch; Ken3=adj }\n");
		rcmArray2.push("} # for(L)\n");
		rcmArray2.push("rmat= matrix(round(rmat,3), nc=hensu,by=1 )\n");
		rcmArray2.push("tmat= matrix(round(tmat,3), nc=hensu,by=1 )\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ｒの有意差：対応あり\n");
		rcmArray2.push("tx2=c(); mds=c()\n");
		rcmArray2.push("if( hensu>2 ){ #####\n");
		rcmArray2.push("gyo=c(); rez=c()\n");
		rcmArray2.push("for(i in 1:(hensu-1)) for(j in (i+1):hensu){ gyo=c(gyo,i); rez=c(rez,j) }\n");
		rcmArray2.push("\n");
		rcmArray2.push("kosu= length(gyo )\n");
		rcmArray2.push("Df= N-3\n");
		rcmArray2.push("for( i in 1:(kosu-1) ){ rx=rmat[gyo[i],rez[i] ]\n");
		rcmArray2.push("for( j in (i+1):kosu ){ ry=rmat[gyo[j],rez[j] ]\n");
		rcmArray2.push("  mds= c(mds,paste(\"x\",gyo[i],\":x\",rez[i],\"対x\",gyo[j],\":x\",rez[j],sep=\"\") )\n");
		rcmArray2.push("  if( gyo[i]==gyo[j] ) rz=rmat[rez[i],rez[j] ] else\n");
		rcmArray2.push("  if( rez[i]==rez[j] ) rz=rmat[gyo[i],gyo[j] ] else\n");
		rcmArray2.push("  if( rez[i]==gyo[j] ) rz=rmat[gyo[i],rez[j] ] else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("  rz= tanh(mean(atanh(c( # Fisher's Z\n");
		rcmArray2.push("rmat[gyo[i],gyo[j] ],\n");
		rcmArray2.push("rmat[gyo[i],rez[j] ],\n");
		rcmArray2.push("rmat[rez[i],gyo[j] ],\n");
		rcmArray2.push("rmat[rez[i],rez[j] ] ) )))\n");
		rcmArray2.push("}\n");
		rcmArray2.push("  Tch= abs(rx-ry)*sqrt((N-1)*(1+rz)) / sqrt( 2*( (1-rx^2-ry^2-rz^2)+2*rx*ry*rz )*(N-1)/Df+(rx+ry)^2*(1-rz)^3/4 )\n");
		rcmArray2.push("  Pch= pt(Tch,df=Df,low=0)*2 # 両側\n");
		rcmArray2.push("  tx2= c(tx2, rx,ry,Tch,PV(Pch) )\n");
		rcmArray2.push("}  } # for(i)(j)\n");
		rcmArray2.push("tx2= matrix(round(tx2,3),nc=4,by=1 )\n");
		rcmArray2.push("tx2= cbind(tx2, PV(p.adjust(tx2[,4],me=taju)) )\n");
		rcmArray2.push("rownames(tx2)= mds\n");
		rcmArray2.push("colnames(tx2)= c(\"左ｒ\",\"対 右ｒ\",\"  ｔ値\",\"ｐ値\",\"adj_ｐ\" )\n");
		rcmArray2.push("} #####\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 結果の書き方\n");
		rcmArray2.push("txt=\"　各変数の基本統計量をTable(tx1)に示す。\n　Pearsonの積率相関係数を計算した結果 (Table(Pea)参照)，\"\n");
		rcmArray2.push("maxR=max(abs(Pea),na.rm=1 ); minP=min(Pea2,na.rm=1 )\n");
		rcmArray2.push("if( hensu>2 ){ gok1=\"どの\"; gok2=\"も\"; gok3=\"|r|s<\"; gok4=\"s>\"; maxR=abs(maxR) } else { gok1=\"２\"; gok2=\"\"; gok3=\"r=\"; gok4=\"=\" }\n");
		rcmArray2.push("if( minP>0.10 ) txt=paste(txt, gok1,\"変数間に\",gok2,\"有意な相関は見られなかった (\",gok3,round(maxR,3),\", p\",gok4,PV(minP),\")。\", sep=\"\" ) else\n");
		rcmArray2.push("{\n");
		rcmArray2.push("txt= paste(txt, \"以下の変数間に有意な相関が見いだされた (両側検定, df=\",N-2,\") (付記のad.pは多数回検定の調整後p値)。\n\", sep=\"\" )\n");
		rcmArray2.push("for( i in 1:(hensu-1) ){ for( j in (i+1):hensu ){\n");
		rcmArray2.push("  pch= Pea2[i,j]\n");
		rcmArray2.push("  if( pch<0.10 ) txt=paste(txt, \"\n　変数\",i,\"×変数\",j,\" r=\",Pea[i,j],\" (t=\",abs(tmat[i,j]),\", p=\",pch,\", ad.p=\",Pea3[i,j],\")\", sep=\"\" )\n");
		rcmArray2.push("}  }\n");
		rcmArray2.push("} # if(pch)\n");
		rcmArray2.push("\n");
		rcmArray2.push("gyo=c(); rez=c(); keko=0; yuis=0\n");
		rcmArray2.push("for( i in 1:(hensu-1) ){ for( j in (i+1):hensu ){\n");
		rcmArray2.push("  pch= min(c(Spr2[i,j],Ken2[i,j]) )\n");
		rcmArray2.push("  if( pch<0.10 ){ keko=keko+1; gyo=c(gyo,i); rez=c(rez,j); if( pch<0.05 ) yuis=yuis+1 }\n");
		rcmArray2.push("}  }\n");
		rcmArray2.push("nsX=c(); nsY=c(); ari=0\n");
		rcmArray2.push("if( keko>0 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push("tmp=\"または有意傾向\"\n");
		rcmArray2.push("if( keko==yuis ) tmp=\"\"\n");
		rcmArray2.push("if( yuis==0 ) tmp=\"傾向\"\n");
		rcmArray2.push("txt= paste(txt, \"\n\n\n　なお，順位相関係数を計算した結果 (全体の相関行列はオプション参照)，次の変数間において有意\",tmp,\"であった (両側検定) (付記のrho, tauの値はそれぞれSpearman, Kendallの順位相関係数を表す)。\n\", sep=\"\" )\n");
		rcmArray2.push("for( k in 1:keko )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" i=gyo[k]; j=rez[k]\n");
		rcmArray2.push(" txt= paste(txt, \"\n　変数\",i,\"×変数\",j,\"  rho=\",Spr[i,j],\" (p=\",Spr2[i,j],\"), tau=\",Ken[i,j],\" (p=\",Ken2[i,j],\")\", sep=\"\" )\n");
		rcmArray2.push(" if( Pea2[i,j]>0.10 ){ ari=ari+1; nsX=c(nsX,i); nsY=c(nsY,j) }\n");
		rcmArray2.push("}\n");
		rcmArray2.push("} # if(yuis)\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"\n\n　Pearsonの積率相関が有意でなく順位相関が有意であったケース\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( ari==0 ) txt=paste(txt, \"は見られなかった。いずれの相関も曲線的ではなく直線的であると見られる。\", sep=\"\" ) else\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" txt= paste(txt, \"について，\", sep=\"\" )\n");
		rcmArray2.push(" goku=\"\"\n");
		rcmArray2.push(" for( k in 1:ari )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" if( k==2 ) goku=\"，及び\" else if( k>2 ) goku=\"，\"\n");
		rcmArray2.push(" txt= paste(txt, goku,\"変数\",nsX[k],\"×変数\",nsY[k], sep=\"\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push(" txt= paste(txt, \"の相関は直線的でなく曲線相関であるか，または極端な外れ値の存在することが示唆される。\", sep=\"\" )\n");
		rcmArray2.push("} # if(ari)\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( taju==\"BH\" ) TAJ=\"Benjamini & Hochberg (1995) の方\" else if(taju==\"b\") TAJ=\"Bonferroni\" else TAJ=\"Holm\"\n");
		rcmArray2.push("if( hensu<3 | minP>0.10 ) txt=paste(txt,\"\n\",sep=\"\") else\n");
		rcmArray2.push("{ txt=paste(txt, \"\n\n　以上の多数回検定のｐ値の調整には\",TAJ,\"法を用いた。\n\",sep=\"\"); if( taju==\"BH\" ) txt=paste(txt, \"\n［引用文献］\nBenjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\",sep=\"\")\n");
		rcmArray2.push("}\n");
		rcmArray2.push("\n");
		rcmArray2.push("TR= function(r,他r=0.456,他N=100)\n");
		rcmArray2.push("{\n");
		rcmArray2.push("Zch=(atanh(r)-atanh(他r))/sqrt( 1/(N-3)+1/(他N-3) )\n");
		rcmArray2.push("Pch= pnorm(abs(Zch),low=0)*2 # 両側\n");
		rcmArray2.push("cat(paste(\"ｚ=\",round(Zch,3),\", p=\",PV(Pch),\" (両側検定) \n\",sep=\"\") )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("散布図= function(Ｘ軸=1, Ｙ軸=2 )\n");
		rcmArray2.push("{\n");

		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("windows()\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("quartz()\n");
		}

		rcmArray2.push(" plot(dtab[,Ｘ軸],dtab[,Ｙ軸],pch=21,bg=3,cex=2,bty=\"l\",las=1,\n");
		rcmArray2.push(" xlab=colnames(dtab)[Ｘ軸],ylab=colnames(dtab)[Ｙ軸],cex.lab=1.3 )\n");
		rcmArray2.push(" abline(lm(dtab[,Ｙ軸]~dtab[,Ｘ軸]), lwd=2,col=2 )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("H=matrix(0,nr=1)\n");
		rcmArray2.push("rownames(H)=\"\"\n");
		rcmArray2.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("#############################\n");
		rcmArray2.push("#  相関係数の計算と検定：\n");
		rcmArray2.push("#\n");
		rcmArray2.push("#   相関係数の有意性検定\n");
		rcmArray2.push("#   相関係数の差の検定\n");
		rcmArray2.push("H############################\n");
		rcmArray2.push("tx1 # 基本統計量(SD=不偏分散の平方根)\n");
		rcmArray2.push("\n");
		rcmArray2.push("Pea # 相関行列(Pearsonの積率相関係数)\n");
		rcmArray2.push("# 順位相関係数は『オプション』参照\n");
		rcmArray2.push("\n");
		rcmArray2.push("Pea2 # 相関係数の有意性検定(両側ｐ値)\n");
		rcmArray2.push("# ■ 自由度df＝Ｎ－2\n");
		rcmArray2.push("\n");
		rcmArray2.push("Pea3 # 調整後ｐ値\n");
		rcmArray2.push("\n");
		rcmArray2.push("cat(txt) # 結果の書き方\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");

		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("windows();boxplot(dtab,las=1) # 箱ひげ図\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("quartz();boxplot(dtab,las=1) # 箱ひげ図\n");
		}

		rcmArray2.push("# library(psych);describe(dtab) # 尖度,歪度ほか\n");
		rcmArray2.push("# Spr;Spr2;Spr3 # スピアマン順位相関;ｐ値;調整後ｐ値\n");
		rcmArray2.push("# Ken;Ken2;Ken3 # ケンドール順位相関;ｐ値;調整後ｐ値\n");
		rcmArray2.push("# 散布図(Ｘ軸=1, Ｙ軸=2 ) # 任意の２変数の散布図\n");
		rcmArray2.push("# tx2  # 標本内ｒの差の検定(df=N-3)\n");
		rcmArray2.push("# TR(0.123, 他r=0.456, 他N=100) # 標本間ｒの差の検定\n");
		rcmArray2.push("# write(txt,file.choose(),ap=T)    # 結果のファイル保存\n");
		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで


	//グラフ描画
	(function () {
		// if (document.getElementById("RltAdd").checked === false) {
		chartClear();
		// }

		var i, j, jj;

		//軸の最大値と最小値の設定
		var max = xx[0][0];
		var min = xx[0][0];
		for (i = 0; i < NN; i++) {
			for (j = 0; j < KK; j++) {
				if (max < xx[i][j]) max = xx[i][j];
				if (min > xx[i][j]) min = xx[i][j];
			}
		}

		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min = parseFloat(myMin, 10);
		}
		// if (gResult !== null) {
		// 	var _max_min = gResult.split(",");
		// 	min = _max_min[0];
		// 	max = _max_min[1];
		// }

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		// var chartClrAry = ["#ff4b00", "#fff100", "#03af7a", "#005aff", "#4dc4ff", "#ff8082", "#f6aa00", "#990099", "#804000"];
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var titleText;

		var chartNum = 0;
		for (j = 0; j < KK - 1; j++) {
			for (jj = j + 1; jj < KK; jj++) {

				var chartImg = document.createElement('canvas');
				chartImg.id = "ChartImg" + chartNum;
				var ctx = document.getElementById("chart").appendChild(chartImg);

				var data = [];
				for (i = 0; i < NN; i++) {
					addData = { x: xx[i][j], y: xx[i][jj] };
					data.push(addData);
				}

				titleText = 'A' + (j + 1) + ':A' + (jj + 1);

				var datasetData = [{
					backgroundColor: chartClrAry[chartNum % chartClrAry.length],
					borderColor: chartClrAry[chartNum % chartClrAry.length],
					pointBorderWidth: 3,
					borderWidth: 1,
					lineTension: 0,
					data: data
				}];
				chartNum++;

				var myChart = new Chart(ctx, {
					type: 'scatter',
					data: {
						datasets: datasetData
					},
					options: {
						title: {
							display: true,
							text: titleText,
							position: 'top',
							fontSize: 12,
							fontColor: '#000000'
						},
						scales: {
							xAxes: [{
								ticks: {
									suggestedMin: min,
									suggestedMax: max
								}
							}],
							yAxes: [{
								ticks: {
									suggestedMin: min,
									suggestedMax: max
								}
							}]
						},
						legend: {
							display: false
						},
						tooltips: {
							mode: 'label'
						},
					}
				});
			}
		}
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
function corrDiaDraw() {
	var i = 0;
	var j = 0;
	var jj = 0;

	var canvas = document.getElementById("DiaCanvas");
	// var canvas = document.getElementById("corrDiaCanvas");
	if (!canvas || !canvas.getContext) {
		return false;
	}

	if (document.getElementById("corrDiaArea").value != "") {
		var diaData = document.getElementById("corrDiaArea").value;
		var rowStr = diaData.split("\n");

		//項目数
		var KK = parseInt(rowStr[0], 10);

		var columStr = [];
		var k1 = [];
		var k2 = [];
		var r = [];
		var lineWidth = [];

		for (i = 1; i < rowStr.length - 1; i++) {
			columStr = rowStr[i].split(",");
			k1[i] = parseInt(columStr[0], 10);        //項目１
			k2[i] = parseInt(columStr[1], 10);        //項目２
			r[i] = parseFloat(columStr[2]);          //相関係数
			lineWidth[i] = parseInt(columStr[3], 10); //線幅
		}

		var ctx = canvas.getContext('2d');

		//canvasを白で塗りつぶし
		ctx.beginPath();
		ctx.fillStyle = 'rgb(255,255,255)';
		ctx.fillRect(0, 0, 550, 450);

		// ダイアグラムの中心の座標
		var x1 = 275;
		var y1 = 200;

		// 項目番号0の座標
		var x2 = 275;
		var y2 = 30;

		// 項目番号の座標
		// var tx = 0;
		// var ty = 0;
		var tx = [];
		var ty = [];

		ctx.lineWidth = 1;

		var xx = [];
		var yy = [];

		var t = 0; //角度
		for (j = 0; j < KK; j++) {
			t = Math.PI / 180 * j * (360 / KK);
			xx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1;
			yy[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1;
		}

		for (j = 0; j < KK; j++) {
			t = Math.PI / 180 * j * (360 / KK);
			tx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1 - 4;
			ty[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1 + 4;
		}

		var diaPointNum = parseInt(document.getElementById("diaPointNum").value, 10);
		if (diaPointNum == 0) {
			for (i = 1; i < rowStr.length - 1; i++) {
				// 線種 線幅=1 ならば 破線
				if (lineWidth[i] == 1) {
					ctx.setLineDash([3, 3]); //破線
				} else {
					ctx.setLineDash([]); //実線
				}

				if (r[i] > 0) {
					// 相関係数>0 ならば 赤
					ctx.strokeStyle = 'rgb(255,0,0)';
				} else {
					// 相関係数<=0 ならば 青
					ctx.strokeStyle = 'rgb(0,0,255)';
				}
				ctx.lineWidth = lineWidth[i];
				ctx.beginPath();
				ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
				ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
				ctx.stroke();
			}
		} else {
			// グレーで描画
			for (i = 1; i < rowStr.length - 1; i++) {
				// 線種 線幅=1 ならば 破線
				if (lineWidth[i] == 1) {
					ctx.setLineDash([3, 3]); //破線
				} else {
					ctx.setLineDash([]); //実線
				}
				ctx.strokeStyle = 'rgb(169,169,169)';
				ctx.lineWidth = lineWidth[i];
				ctx.beginPath();
				ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
				ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
				ctx.stroke();
			}

			for (i = 1; i < rowStr.length - 1; i++) {
				// 線種 線幅=1 ならば 破線
				if (lineWidth[i] == 1) {
					ctx.setLineDash([3, 3]); //破線
				} else {
					ctx.setLineDash([]); //実線
				}

				if (r[i] > 0) {
					// 相関係数>0 ならば 赤
					if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
						ctx.strokeStyle = 'rgb(255,0,0)';
					}
				} else {
					// 相関係数<=0 ならば 青
					if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
						ctx.strokeStyle = 'rgb(0,0,255)';
					}
				}

				if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
					ctx.lineWidth = lineWidth[i];
					ctx.beginPath();
					ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
					ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
					ctx.stroke();
				}
			}
		}

		var wr = 10;
		//項目を示す○を描く（白で塗りつぶし）
		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.fillStyle = 'rgb(255,255,255)';
		for (j = 0; j < KK; j++) {
			ctx.beginPath();
			ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
			ctx.fill();
		}
		//項目を示す○を描く（線を黒く）
		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.strokeStyle = 'rgb(0,0,0)';
		for (j = 0; j < KK; j++) {
			ctx.beginPath();
			ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
			ctx.stroke();
		}

		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.font = "14px 'Times New Roman'";
		ctx.strokeStyle = 'rgb(0,0,0)';
		ctx.fillStyle = "rgb(0,0,0)";
		for (j = 0; j < KK; j++) {
			ctx.strokeText(j + 1, tx[j], ty[j]);
		}


		if (diaPointNum != 0) {
			//項目を示す○を描く（白で塗りつぶし）
			ctx.lineWidth = 1;
			ctx.setLineDash([]); //実線
			ctx.fillStyle = 'rgb(0,0,0)';
			ctx.beginPath();
			ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
			ctx.fill();
			//項目を示す○を描く（線を黒く）
			ctx.lineWidth = 1;
			ctx.setLineDash([]); //実線
			ctx.strokeStyle = 'rgb(0,0,0)';
			ctx.beginPath();
			ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
			ctx.stroke();

			ctx.lineWidth = 1;
			ctx.setLineDash([]); //実線
			ctx.font = "14px 'Times New Roman'";
			ctx.strokeStyle = 'rgb(255,255,255)';
			ctx.fillStyle = "rgb(255,255,255)";
			ctx.strokeText(diaPointNum, tx[diaPointNum - 1], ty[diaPointNum - 1]);
		}
	}

}
function saveData_Corr() {

	var Stream = document.getElementById("DataArea").value;
	var fineName = "Corr_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function simulation_Corr(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var NN = 50; // 行数
	var KK; // 列数

	var min = 2;
	var max = 9;
	KK = Math.floor(Math.random() * (max - min + 1) + min);

	var result = "rnd1:9*" + NN + "*" + KK;

	document.getElementById("DataArea").value = random_number_generation(result);

	mainCalc_corr();
}