/**
 * ｔ検定
 * sT(参加者内)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeStSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		// sAには要因名があるが，sTにはない
		// document.getElementById("factorA_name").value = "A";

		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_wilcoxon();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_wilcoxon() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = "A";
	var LA = 2;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var a = [[], []];
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			a[i].push(xx[i][j]);
		}
	}

	//平均，標準偏差  ＃＃現在は出力してはいない
	var M = [];
	var SD = [];

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		M[i] = parseFloat(M[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));
	}

	//最大値，最小値
	var MAX = [];
	var MIN = [];
	for (i = 0; i < LA; i++) {
		MAX[i] = xx[i][0];
		MIN[i] = xx[i][0];
		for (j = 0; j < NN; j++) {
			if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
			if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
		}
	}

	var N = 0;
	N = a[0].length;

	var addedArray = a[0].concat(a[1]);

	var diffencedArray = [];
	var diffencedArray2 = [];

	for (i = 0; i < N; i++) {
		diffencedArray.push(a[0][i] - a[1][i]);
	}

	diffencedArray2 = diffencedArray.filter(function (x) {
		if (x !== 0) {
			return true;
		}
	});

	// 差が0を除いたデータ数
	var wN = diffencedArray2.length;

	var diffencedArray3 = diffencedArray2.map(function (x) {
		return Math.abs(x);
	});

	var sortedArray = diffencedArray3.sort(compareNumbers);

	var rankedArray = [];
	for (i = 0; i < sortedArray.length; i++) {
		rankedArray[i] = i + 1;
	}

	for (i = 1; i < sortedArray.length; i++) {
		if (sortedArray[i] === sortedArray[i - 1]) {
			rankedArray[i] = rankedArray[i - 1];
		}
	}

	var countedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		countedArray[i] = 0;
		for (j = 0; j < rankedArray.length; j++) {
			if (rankedArray[i] === rankedArray[j]) {
				countedArray[i]++;
			}
		}
	}

	var rerankedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
	}

	var signrankedArray = [];
	for (j = 0; j < diffencedArray2.length; j++) {
		for (i = 0; i < sortedArray.length; i++) {
			if (sortedArray[i] == Math.abs(diffencedArray2[j])) {
				signrankedArray[j] = rerankedArray[i];
			}
		}
	}

	var signrankedArray2 = [[], []];
	for (i = 0; i < diffencedArray2.length; i++) {
		if (diffencedArray2[i] > 0) {
			signrankedArray2[0].push(signrankedArray[i]);
		} else {
			signrankedArray2[1].push(signrankedArray[i]);
		}
	}

	var T1 = 0;
	var T2 = 0;
	for (i = 0; i < signrankedArray2[0].length; i++) {
		T1 = T1 + signrankedArray2[0][i];
	}
	for (i = 0; i < signrankedArray2[1].length; i++) {
		T2 = T2 + signrankedArray2[1][i];
	}

	var T = T1;
	if (T1 > T2) T = T2;

	var wM = wN * (wN + 1) / 4;
	var wSD = Math.sqrt(wN * (wN + 1) * (2 * wN + 1) / 24);
	wSD = parseFloat(wSD.toFixed(2));

	var z = Math.abs((T - wM) / wSD);
	z = Math.floor((z * 100)) / 100;

	var strArray = [];
	strArray.push("[ウィルコクソン符号順位検定]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push("           N      Mean      S.D.       MAX       MIN\n");
	strArray.push("------------------------------------------------------\n");
	strArray.push(('水準１' + wN.format(" ", 6) + M[0].format(" ", 10) + SD[0].format(" ", 10) + MAX[0].format(" ", 10) + MIN[0].format(" ", 10) + "\n"));
	strArray.push(('水準２' + wN.format(" ", 6) + M[1].format(" ", 10) + SD[1].format(" ", 10) + MAX[1].format(" ", 10) + MIN[1].format(" ", 10) + "\n"));
	strArray.push("------------------------------------------------------\n\n");

	var ppStr = "";
	var PP2 = 0;

	strArray.push('データ数（差≠0）：' + wN.format(" ", 5) + '\n');
	strArray.push("-----------------------------------------\n");
	strArray.push('順位和（+）：' + T1.format(" ", 11) + '\n');
	strArray.push('順位和（-）：' + T2.format(" ", 11) + '\n');
	strArray.push('順位和：' + T.format(" ", 16) + '\n');
	strArray.push("-----------------------------------------\n");

	if (wN <= 25) {
		PP2 = W_tables(wN, T);
		if (PP2 === 9) {
			strArray.push("データ数が少ないため，計算できません\n");
		} else {
			if (PP2 === 0.01) {
				ppStr = "   ** (p<.01)";
			}
			if (PP2 === 0.05) {
				ppStr = "   *  (p<.05)";
			}
			if (PP2 === 1) {
				ppStr = "   ns (.10<p)";
			}
			strArray.push("両側検定  :" + ppStr + "\n");
		}

	} else {
		strArray.push('平均値：' + wM.format(" ", 15) + '\n');
		strArray.push('標準偏差：' + wSD.format(" ", 13) + '\n');
		strArray.push('統計量ｚ：' + z.format(" ", 13) + '\n');
		strArray.push("-----------------------------------------\n");

		PP2 = z_tables(z);
		if (PP2 < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP2 < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP2 < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}
		strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
	}

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	// //出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = parseFloat(M[i].toFixed(1), 10);
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = parseFloat(M[i].toFixed(1), 10);
			if (min_y > M[i]) min_y = parseFloat(M[i].toFixed(1), 10);
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		// var chartClrAry = ["#ff4b00", "#fff100", "#03af7a", "#005aff", "#4dc4ff", "#ff8082", "#f6aa00", "#990099", "#804000"];
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}

		// 複合グラフを作成する
		// 棒グラフ
		datasetKey[0].label = ''; //ラベルを空白にする

		// 折れ線グラフ
		datasetKey[1].label = '水準';
		datasetKey[1].data = data;
		datasetKey[1].backgroundColor = chartClrAry[0];
		datasetKey[1].borderColor = chartClrAry[0];
		datasetKey[1].pointBorderWidth = 3;
		datasetKey[1].borderWidth = 1;
		datasetKey[1].lineTension = 0;
		datasetKey[1].type = 'line'; //折れ線グラフを指定

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('水準' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < 2; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
function changeStSetting() {
	var h = 3;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeStTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeStTable();\">");
		// htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onfocus=\"setSelectNum(0);\" onchange=\"addSelectItem5(this,'参加者数');changeStTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">2</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("st_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeStTable();
}
function changeStTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");
	// htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("st_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_Wilcoxon() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	//#0
	strArray.push("Wilcoxon" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "Wilcoxon_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_Wilcoxon() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "Wilcoxon") {
		var NN = crDel(dd[1]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		changeStTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}

