/**
 * 分散分析
 * sAB(２要因参加者内)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeSabSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);
	var LB = parseInt(document.getElementById("factorB_number").value);

	var elmCount = NN * LA * LB;

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		document.getElementById("factorB_name").value = "B";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var BB = document.getElementById("factorB_name").value;
	var LB = parseInt(document.getElementById("factorB_number").value, 10);

	var elmCount = NN * LA * LB;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === '') {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sAB();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");
		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sAB() {
	var i = 0;
	var j = 0;
	var k = 0;
	var ii = 0;

	NN = parseInt(document.getElementById("subjNum").value, 10);
	AA = document.getElementById("factorA_name").value;
	LA = parseInt(document.getElementById("factorA_number").value, 10);
	BB = document.getElementById("factorB_name").value;
	LB = parseInt(document.getElementById("factorB_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";
	BB = BB.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (BB === '') BB = "B";

	var NA = NN * LB;
	var NB = NN * LA;
	var NAB = NN;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(LB);
		for (j = 0; j < LB; j++) {
			xx[i][j] = new Array(NN);
		}
	}

	var cellId = 1;
	for (k = 0; k < NN; k++) {
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				xx[i][j][k] = parseFloat(document.getElementById("cell_" + cellId).value);
				cellId++;
			}
		}
	}

	var M = new Array(LA);
	for (i = 0; i < LA; i++) {
		M[i] = new Array(LB);
	}
	var mm;

	var SD = new Array(LA);
	for (i = 0; i < LA; i++) {
		SD[i] = new Array(LB);
	}
	var sd;

	var ME = new Array(LA);
	for (i = 0; i < LA; i++) {
		ME[i] = new Array(LB);
	}
	var me;

	var AAA = [];
	var BBB = [];
	var FFA$ = [];
	var ADA = [];
	var FFB$ = [];
	var BDB = [];

	var MC$;
	var EQ$;

	var strArray = [];
	var bar = "-----------------------------------------------------\n";

	// 平均・標準偏差
	strArray.push("[ sAB-Type Design ]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push("  A= " + AA + "\n");
	strArray.push("  B= " + BB + "\n");
	strArray.push(bar);
	strArray.push("A\tB\tN\t\tMean\t\tS.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < LB; j++) {
			S = 0;
			SS = 0;
			for (k = 0; k < NN; k++) {
				S += xx[i][j][k];
				SS += Math.pow(xx[i][j][k], 2);
			}
			M[i][j] = S / NN;
			mm = using(M[i][j], 5, 4);
			SD[i][j] = Math.sqrt(SS / NN - Math.pow(M[i][j], 2));
			sd = using(SD[i][j], 5, 4);
			strArray.push((i + 1) + "\t" + (j + 1) + "\t" + NN + "\t" + mm + "\t" + sd + "\t\n");
		}
		if (i < LA - 1) {
			strArray.push("\n");
		} else {
			strArray.push(bar);
		}
	}

	S = 0;
	var DS = NN - 1;
	var OB = NN * LA * LB;
	var E = 0;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < LB; j++) {
			S = S + M[i][j];
			E = E + Math.pow(SD[i][j], 2) * NN;
		}
	}
	var DH = S / LA / LB;
	var SSUB = 0;
	var xxx;
	S = 0;
	SS = 0;
	for (k = 0; k < NN; k++) {
		xxx = 0;
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				xxx += xx[i][j][k];
			}
		}
		S += xxx;
		SS += Math.pow(xxx, 2);
	}
	SSUB = SS / LA / LB - Math.pow(S, 2) / OB;
	var MS = SSUB / DS;

	var ssub = using(SSUB, 11, 4);
	var ds = using(DS, 4, 0);
	var ms = using(MS, 8, 4);

	//分散分析
	// S.V    SS    df    MS   F
	// -----------------------------------
	// subj   SSUB  DS    MS
	// -----------------------------------
	//  A      A    DA    MA    FA    FA$
	// sxA     SA   DSA   MSA
	// -----------------------------------
	//  B      B    DB    MB    FB    FB$
	// sxB     SB   DSB   MSB
	// -----------------------------------
	// AxB     AB   DI    MI    FI    FI$
	// sxAxB   SAB  DSAB  MSAB
	// -----------------------------------
	// Total   T    DT

	// S.V    SS    df    MS    F     p
	// -----------------------------------
	//  A     SSa   DFa   MSa   Fa    Pa
	//  B     SSb   DFb   MSb   Fb    Pb
	// AxB    SSab  DFab  MSab  Fab   Pab
	// subj   SSe   DFe   MSe
	// -----------------------------------
	// Total  SSt   DFt

	//  主効果検定
	strArray.push("\n == Analysis of Variance ==\n\n");
	strArray.push(" A(" + LA + ") = " + AA + "\n");
	strArray.push(" B(" + LB + ") = " + BB + "\n");
	strArray.push(bar);
	strArray.push(" S.V          SS        df       MS        F\n");
	strArray.push(bar);
	strArray.push("subj" + ssub + " " + ds + " " + ms + "\n");
	strArray.push(bar);

	var A = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		for (j = 0; j < LB; j++) {
			S += M[i][j];
		}
		A = A + Math.pow(S / LB - DH, 2) * NN * LB;
	}
	var DA = LA - 1;
	var MA = A / DA;
	var SA = 0;
	S = 0;
	SS = 0;
	for (k = 0; k < NN; k++) {
		for (i = 0; i < LA; i++) {
			xxx = 0;
			for (j = 0; j < LB; j++) {
				xxx += xx[i][j][k];
			}
			S += xxx;
			SS += Math.pow(xxx, 2);
		}
	}
	SA = SS / LB - Math.pow(S, 2) / NN / LA / LB - SSUB - A;
	var MSA = SA / DS / DA;
	var D1 = DA;
	var D2 = DS * DA;
	var DSA = D2;
	var FA = MA / MSA;
	var Fdata = FA;
	var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var a = using(A,12,4);
	// var da = using(DA,4,0);
	// var ma = using(MA,8,4);
	// var fa = using(FA,3,2);
	// var sa = using(SA,11,4);
	// var dsa = using(DSA,4,0);
	// var msa = using(MSA,8,4);

	strArray.push("  A" + using(A, 12, 4) + " " + using(DA, 4, 0) + " " + using(MA, 8, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
	strArray.push(" sxA" + using(SA, 11, 4) + " " + using(DSA, 4, 0) + " " + using(MSA, 8, 4) + "\n");
	strArray.push(bar);
	// strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");
	// strArray.push(" sxA"+sa+" "+dsa+" "+msa+"\n");
	// strArray.push(bar);

	var B = 0;
	for (j = 0; j < LB; j++) {
		S = 0;
		for (i = 0; i < LA; i++) {
			S += M[i][j];
		}
		B = B + Math.pow(S / LA - DH, 2) * NN * LA;
	}
	var DB = LB - 1;
	var MB = B / DB;
	var SB = 0;
	S = 0;
	SS = 0;
	for (k = 0; k < NN; k++) {
		for (j = 0; j < LB; j++) {
			xxx = 0;
			for (i = 0; i < LA; i++) {
				xxx += xx[i][j][k];
			}
			S += xxx;
			SS += Math.pow(xxx, 2);
		}
	}
	SB = SS / LA - Math.pow(S, 2) / NN / LA / LB - SSUB - B;
	var MSB = SB / DS / DB;
	D1 = DB;
	D2 = DS * DB;
	var DSB = D2;
	var FB = MB / MSB;
	Fdata = FB;
	var FB$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var b = using(B,12,4);
	// var db = using(DB,4,0);
	// var mb = using(MB,8,4);
	// var fb = using(FB,3,2);
	// var sb = using(SB,11,4);
	// var dsb = using(DSB,4,0);
	// var msb = using(MSB,8,4);

	strArray.push("  B" + using(B, 12, 4) + " " + using(DB, 4, 0) + " " + using(MB, 8, 4) + " " + using(FB, 3, 2) + " " + FB$ + "\n");
	strArray.push(" sxB" + using(SB, 11, 4) + " " + using(DSB, 4, 0) + " " + using(MSB, 8, 4) + "\n");
	strArray.push(bar);
	// strArray.push("  B"+b+" "+db+" "+mb+" "+fb+" "+FB$+"\n");
	// strArray.push(" sxB"+sb+" "+dsb+" "+msb+"\n");
	// strArray.push(bar);

	var AB = 0;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < LB; j++) {
			AB += Math.pow(M[i][j] - DH, 2) * NN;
		}
	}
	AB = AB - A - B;
	var DI = DA * DB;
	var MI = AB / DI;
	var SAB = E - SSUB - SA - SB;
	var MSAB = SAB / DS / DA / DB;
	D1 = DI;
	// D2 = DB;
	D2 = DS * DA * DB;
	var DSAB = D2;
	var FI = MI / MSAB;
	Fdata = FI;
	var FI$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var ab = using(AB,11,4);
	// var di = using(DI,4,0);
	// var mi = using(MI,8,4);
	// var fi = using(FI,3,2);
	// var si = using(SAB,10,4);
	// var di = using(DI,4,0);
	// var msab = using(MSAB,8,4);
	// var dsab = using(DSAB,4,0);

	strArray.push(" AxB" + using(AB, 11, 4) + " " + using(DI, 4, 0) + " " + using(MI, 8, 4) + " " + using(FI, 3, 2) + " " + FI$ + "\n");
	strArray.push("sxAxB" + using(SAB, 10, 4) + " " + using(DSAB, 4, 0) + " " + using(MSAB, 8, 4) + "\n");
	strArray.push(bar);
	// strArray.push(" AxB"+ab+" "+di+" "+mi+" "+fi+" "+FI$+"\n");
	// strArray.push("sxAxB"+si+" "+dsab+" "+msab+"\n");
	// strArray.push(bar);

	var T = A + B + AB + E;
	// var t = using(T,10,4);
	var DT = OB - 1;
	// var dt = using(DT,4,0);

	strArray.push("Total" + using(T, 10, 4) + " " + using(DT, 4, 0));
	strArray.push("   +p<.10 *p<.05 **p<.01\n\n");
	// strArray.push("Total"+t+" "+dt);
	// strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	//効果量
	var eta2 = 0;
	var effectSizeF = 0;

	strArray.push("\n == EffectSize ==\n\n");
	strArray.push("\tpartial η2\teffectsize f\n");
	strArray.push(bar);

	eta2 = DA * FA / (DA * FA + DSA);
	effectSizeF = Math.sqrt(eta2 / (1 - eta2));
	strArray.push("  A\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

	eta2 = DB * FB / (DB * FB + DSB);
	effectSizeF = Math.sqrt(eta2 / (1 - eta2));
	strArray.push("  B\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

	eta2 = DI * FI / (DI * FI + DSAB);
	effectSizeF = Math.sqrt(eta2 / (1 - eta2));
	strArray.push(" AxB\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

	strArray.push(bar);
	strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

	//単純主効果検定
	if (FI$ != "ns") {
		strArray.push("\n == Analysis of AxB Interaction ==\n\n");
		strArray.push("     S.V          SS        df       MS          F\n");
		strArray.push(bar);

		D1 = DA;
		D2 = DS * DA;
		var ER = 0;
		for (j = 0; j < LB; j++) {
			S = 0;
			SS = 0;
			ER = 0;
			for (i = 0; i < LA; i++) {
				S += M[i][j];
				SS += Math.pow(M[i][j], 2);
				ER += Math.pow(SD[i][j], 2) * NN;
			}
			A = (SS - Math.pow(S, 2) / LA) * NN;

			S = 0;
			SS = 0;
			for (k = 0; k < NN; k++) {
				xxx = 0;
				for (i = 0; i < LA; i++) {
					xxx += xx[i][j][k];
				}
				S += xxx;
				SS += Math.pow(xxx, 2);
			}
			ER = ER - SS / LA + Math.pow(S, 2) / NN / LA;
			ME[0][j] = ER / D2;
			FF = A / DA / ME[0][j];
			Fdata = FF;
			FFA$[j] = pValue_Match_fRatio(D1, D2, Fdata);
			ADA[j] = A / DA;

			// var ss = using(A,6,4);
			// var df = using(DA,4,0);
			// var ms = using(ADA[j],6,4);
			// var ff = using(FF,6,2);

			strArray.push(" A  at B" + (j + 1) + ":\t" + using(A, 6, 4) + " " + using(DA, 4, 0) + " " + using(ADA[j], 6, 4) + " " + using(FF, 6, 2) + " " + FFA$[j] + "\n");
			// strArray.push(" A  at B"+(j+1)+":\t"+ss+" "+df+" "+ms+" "+ff+" "+FFA$[j]+"\n");

			// ss = using(ER,6,4);
			// df = using(D2,4,0);
			// me = using(ME[0][j],6,4);

			strArray.push("(sxA at B" + (j + 1) + ":\t" + using(ER, 6, 4) + " " + using(D2, 4, 0) + " " + using(ME[0][j], 6, 4) + " )\n");
			// strArray.push("(sxA at B"+(j+1)+":\t"+ss+" "+df+" "+me+" )\n");
			strArray.push(bar);
		}

		D1 = DB;
		D2 = DS * DB;
		for (i = 0; i < LA; i++) {
			S = 0;
			SS = 0;
			ER = 0;
			for (j = 0; j < LB; j++) {
				S += M[i][j];
				SS += Math.pow(M[i][j], 2);
				ER += Math.pow(SD[i][j], 2) * NN;
			}
			B = (SS - Math.pow(S, 2) / LB) * NN;
			S = 0;
			SS = 0;
			for (k = 0; k < NN; k++) {
				xxx = 0;
				for (j = 0; j < LB; j++) {
					xxx += xx[i][j][k];
				}
				S += xxx;
				SS += Math.pow(xxx, 2);
			}
			ER = ER - SS / LB + Math.pow(S, 2) / NN / LB;
			ME[1][i] = ER / D2;
			FF = B / DB / ME[1][i];
			Fdata = FF;
			FFB$[i] = pValue_Match_fRatio(D1, D2, Fdata);
			BDB[i] = B / DB;

			// ss = using(B,6,4);
			// df = using(DB,4,0);
			// ms = using(BDB[i],6,4);
			// ff = using(FF,6,2);

			strArray.push(" B  at A" + (i + 1) + ":\t" + using(B, 6, 4) + " " + using(DB, 4, 0) + " " + using(BDB[i], 6, 4) + " " + using(FF, 6, 2) + " " + FFB$[i] + "\n");
			// strArray.push(" B  at A"+(i+1)+":\t"+ss+" "+df+" "+ms+" "+ff+" "+FFB$[i]+"\n");

			ss = using(ER, 6, 4);
			df = using(D2, 4, 0);
			me = using(ME[1][i], 6, 4);

			strArray.push("(sxB at A" + (i + 1) + ":\t" + using(ER, 6, 4) + " " + using(D2, 4, 0) + " " + using(ME[1][i], 6, 4) + " )\n");
			// strArray.push("(sxB at A"+(i+1)+":\t"+ss+" "+df+" "+me+" )\n");
			if (i < LA) strArray.push(bar);
		}
	}


	//多重比較
	// 多重比較の出力メモ（すべての方法で）
	//  交互作用の有意性に関わらず,
	//  AとBの水準数が２より大きく,主効果が有意だった場合は出力する
	//  2013.1.15 改訂

	var checkedLsd = false;
	var checkedHsd = false;
	var checkedBonf = false;
	var checkedHolm = false;

	checkedLsd = document.getElementById("LSD").checked;
	checkedHsd = document.getElementById("HSD").checked;
	checkedBonf = document.getElementById("BONF").checked;
	checkedHolm = document.getElementById("HOLM").checked;

	//多重比較 LSD法
	if (checkedLsd) {
		var T2;
		var LSD;
		var lsdd;
		if (FI$ != "ns") {
			if (LA != 2) {
				D2 = DS * DA;
				T2 = tvalue(D2);
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {
						me = using(ME[0][j], 6, 4);
						LSD = T2 * Math.sqrt(2 * ME[0][j] / NN);
						lsdd = using(LSD, 8, 4);

						strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
						strArray.push(" A at B" + (j + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05)\n");
						strArray.push(" (LSD=" + lsdd + ")\n");
						strArray.push(bar);
						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								if (Math.abs(M[i][j] - M[ii][j]) > LSD) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[ii][j]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
							}
						}
						strArray.push(bar);
					}
				}
			}
			if (LB != 2) {
				D2 = DS * DB;
				T2 = tvalue(D2);
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						me = using(ME[1][i], 6, 4);
						LSD = T2 * Math.sqrt(2 * ME[1][i] / NN);
						lsdd = using(LSD, 8, 4);

						strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
						strArray.push(" B at A" + (i + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05)\n");
						strArray.push(" (LSD=" + lsdd + ")\n");
						strArray.push(bar);
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								if (Math.abs(M[i][j] - M[i][jj]) > LSD) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[i][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
							}
						}
						strArray.push(bar);
					}
				}
			}
		}
		if ((LA != 2) && (FA$ != "ns")) {
			m1 = using(MSA, 6, 4);
			D2 = DS * DA;
			T2 = tvalue(D2);
			LSD = T2 * Math.sqrt(2 * MSA / NA);
			lsdd = using(LSD, 8, 4);

			strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
			strArray.push(" (MSe=" + m1 + ", * p<.05)\n");
			strArray.push(" (LSD=" + lsdd + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor A]\n");
			strArray.push(" A     N   	       Mean\n");
			strArray.push(bar);
			for (i = 0; i < LA; i++) {
				S = 0;
				for (j = 0; j < LB; j++) {
					S = S + M[i][j];
				}
				AAA[i] = S / LB;
				// var aaa = using(AAA[i],6,4);
				//var na = using(NA,4,0);
				strArray.push(" " + (i + 1) + "\t" + using(NA, 4, 0) + "\t" + using(AAA[i], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					if (Math.abs(AAA[i] - AAA[ii]) > LSD) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (AAA[i] > AAA[ii]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
				}
			}
			strArray.push(bar);
		}
		if ((LB != 2) && (FB$ != "ns")) {
			m2 = using(MSB, 6, 4);
			D2 = DS * DB;
			T2 = tvalue(D2);
			LSD = T2 * Math.sqrt(2 * MSB / NB);
			lsdd = using(LSD, 8, 4);

			strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
			strArray.push(" (MSe=" + m2 + ", * p<.05)\n");
			strArray.push(" (LSD=" + lsdd + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor B]\n");
			strArray.push(" B     N   	       Mean\n");
			strArray.push(bar);
			for (j = 0; j < LB; j++) {
				S = 0;
				for (i = 0; i < LA; i++) {
					S = S + M[i][j];
				}
				BBB[j] = S / LA;
				// var bbb = using(BBB[j],6,4);
				//var nb = using(NB,4,0);
				strArray.push(" " + (j + 1) + "\t" + using(NB, 4, 0) + "\t" + using(BBB[j], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					if (Math.abs(BBB[j] - BBB[jj]) > LSD) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (BBB[j] > BBB[jj]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
				}
			}
			strArray.push(bar);
		}
	}

	//多重比較 HSD(Tukey-kramer)
	// HSD法は分析に用いない

	//多重比較 Bonferroni法
	if (checkedBonf) {
		var kumi = 0;
		var TB = 0;
		var alpha_d = 0;

		var BONF;
		var bonf;
		if (FI$ != "ns") {
			if (LA > 2) {
				D2 = DS * DA;
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {
						me = using(ME[0][j], 6, 4);

						kumi = kumiawase(LA, 2);
						TB = bonf_tValue(kumi, D2);
						alpha_d = using(0.05 / kumi, 2, 4);

						BONF = TB * Math.sqrt(2 * ME[0][j] / NAB);
						bonf = using(BONF, 7, 4);

						strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
						strArray.push(" A at B" + (j + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
						strArray.push(" (BONF=" + bonf + ")\n");
						strArray.push(bar);
						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								if (Math.abs(M[i][j] - M[ii][j]) > BONF) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[ii][j]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
							}
						}
						strArray.push(bar);
					}
				}
			}
			if (LB > 2) {
				D2 = DS * DB;
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						me = using(ME[1][i], 6, 4);

						kumi = kumiawase(LB, 2);
						TB = bonf_tValue(kumi, D2);
						alpha_d = using(0.05 / kumi, 2, 4);

						BONF = TB * Math.sqrt(2 * ME[1][i] / NAB);
						bonf = using(BONF, 7, 4);

						strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
						strArray.push(" B at A" + (i + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
						strArray.push(" (BONF=" + bonf + ")\n");
						strArray.push(bar);
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								if (Math.abs(M[i][j] - M[i][jj]) > BONF) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[i][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
							}
						}
						strArray.push(bar);
					}
				}
			}
		}
		if ((LA > 2) && (FA$ != "ns")) {
			m1 = using(MSA, 6, 4);

			D2 = DS * DA;
			kumi = kumiawase(LA, 2);
			TB = bonf_tValue(kumi, D2);
			alpha_d = using(0.05 / kumi, 2, 4);

			BONF = TB * Math.sqrt(2 * MSA / NA);
			bonf = using(BONF, 7, 4);

			strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
			strArray.push(" (MSe=" + m1 + ", * p<.05 , alpha'=" + alpha_d + ")\n");
			strArray.push(" (BONF=" + bonf + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor A]\n");
			strArray.push(" A     N   	       Mean\n");
			strArray.push(bar);
			for (i = 0; i < LA; i++) {
				S = 0;
				for (j = 0; j < LB; j++) {
					S = S + M[i][j];
				}
				AAA[i] = S / LB;
				// var aaa = using(AAA[i],6,4);
				// var na = using(NA,4,0);
				strArray.push(" " + (i + 1) + "\t" + using(NA, 4, 0) + "\t" + using(AAA[i], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					if (Math.abs(AAA[i] - AAA[ii]) > BONF) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (AAA[i] > AAA[ii]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
				}
			}
			strArray.push(bar);
		}
		if ((LB > 2) && (FB$ != "ns")) {
			m2 = using(MSB, 6, 4);

			D2 = DS * DB;
			kumi = kumiawase(LB, 2);
			TB = bonf_tValue(kumi, D2);
			alpha_d = using(0.05 / kumi, 2, 4);

			BONF = TB * Math.sqrt(2 * MSB / NB);
			bonf = using(BONF, 7, 4);

			strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
			strArray.push(" (MSe=" + m2 + ", * p<.05 , alpha'=" + alpha_d + ")\n");
			strArray.push(" (BONF=" + bonf + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor B]\n");
			strArray.push(" B     N   	       Mean\n");
			strArray.push(bar);
			for (j = 0; j < LB; j++) {
				S = 0;
				for (i = 0; i < LA; i++) {
					S = S + M[i][j];
				}
				BBB[j] = S / LA;
				// var bbb = using(BBB[j],6,4);
				// var nb = using(NB,4,0);
				strArray.push(" " + (j + 1) + "\t" + using(NB, 4, 0) + "\t" + using(BBB[j], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					if (Math.abs(BBB[j] - BBB[jj]) > BONF) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (BBB[j] > BBB[jj]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
				}
			}
			strArray.push(bar);
		}
	}

	//多重比較 Holm
	if (checkedHolm) {
		var TL = [];
		var TLN = []; //順番を保存
		var HMC$ = [];
		var alpha_d = [];

		var tlcount = 0;

		var kumi = 0;

		var temp, temp2, temp3, temp4;

		var kflag = 1; //１のとき棄却する 0だと検定終了

		if (FI$ != "ns") {
			if (LA > 2) {
				D2 = DS * DA;
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {
						me = using(ME[0][j], 6, 4);

						kumi = kumiawase(LA, 2);
						tlcount = 0;
						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								TL[tlcount] = Math.abs(M[i][j] - M[ii][j]) / Math.sqrt(2 * ME[0][j] / NAB);
								TLN[tlcount] = tlcount;
								tlcount++;
							}
						}

						//TL値の小さい順に並び替え（同時にTLN値も）
						// var temp,temp2;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TL[jk] < TL[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
								}
							}
						}

						//TL値を計算
						kflag = 1; //１のとき棄却する 0だと検定終了
						for (ik = kumi; ik > 0; ik--) {
							if (kflag) {
								if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
									HMC$[ik - 1] = " *  ";
								} else {
									HMC$[ik - 1] = "n.s.";
									kflag = 0; //検定終了 以降はすべて保留
								}
							} else {
								HMC$[ik - 1] = "n.s.";
							}
							alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
						}

						//TLN値の小さい順に並び替え
						// var temp3,temp4;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TLN[jk] < TLN[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									temp3 = HMC$[jk];
									temp4 = alpha_d[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									HMC$[jk] = HMC$[jk - 1];
									alpha_d[jk] = alpha_d[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
									HMC$[jk - 1] = temp3;
									alpha_d[jk - 1] = temp4;
								}
							}
						}

						strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
						strArray.push(" A at B" + (j + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05)\n");
						strArray.push(bar);
						tlcount = 0;
						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								if (HMC$[tlcount] == " *  ") {
									if (M[i][j] > M[ii][j]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									EQ$ = "=";
								}
								strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
								tlcount++;
							}
						}
						strArray.push(bar);
					}
				}
			}
			if (LB > 2) {
				D2 = DS * DB;
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						me = using(ME[1][i], 6, 4); //修正！！！
						kumi = kumiawase(LB, 2);
						tlcount = 0;
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								TL[tlcount] = Math.abs(M[i][j] - M[i][jj]) / Math.sqrt(2 * ME[1][i] / NAB);
								TLN[tlcount] = tlcount;
								tlcount++;
							}
						}

						//TL値の小さい順に並び替え（同時にTLN値も）
						// var temp,temp2;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TL[jk] < TL[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
								}
							}
						}

						//TL値を計算
						kflag = 1; //１のとき棄却する 0だと検定終了
						for (ik = kumi; ik > 0; ik--) {
							if (kflag) {
								if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
									HMC$[ik - 1] = " *  ";
								} else {
									HMC$[ik - 1] = "n.s.";
									kflag = 0; //検定終了 以降はすべて保留
								}
							} else {
								HMC$[ik - 1] = "n.s.";
							}
							alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
						}

						//TLN値の小さい順に並び替え
						// var temp3,temp4;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TLN[jk] < TLN[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									temp3 = HMC$[jk];
									temp4 = alpha_d[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									HMC$[jk] = HMC$[jk - 1];
									alpha_d[jk] = alpha_d[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
									HMC$[jk - 1] = temp3;
									alpha_d[jk - 1] = temp4;
								}
							}
						}

						strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
						strArray.push(" B at A" + (i + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05)\n");
						strArray.push(bar);
						tlcount = 0;
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								if (HMC$[tlcount] == " *  ") {
									if (M[i][j] > M[i][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									EQ$ = "=";
								}
								strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
								tlcount++;
							}
						}
						strArray.push(bar);
					}
				}
			}
		}
		if ((LA > 2) && (FA$ != "ns")) {
			m1 = using(MSA, 6, 4);

			D2 = DS * DA;
			kumi = kumiawase(LA, 2);
			tlcount = 0;

			strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
			strArray.push(" (MSe=" + m1 + ", * p<.05)\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor A]\n");
			strArray.push(" A     N   	       Mean\n");
			strArray.push(bar);
			for (i = 0; i < LA; i++) {
				S = 0;
				for (j = 0; j < LB; j++) {
					S = S + M[i][j];
				}
				AAA[i] = S / LB;
				var aaa = using(AAA[i], 6, 4);
				// var na = using(NA,4,0);
				strArray.push(" " + (i + 1) + "\t" + using(NA, 4, 0) + "\t" + using(AAA[i], 6, 4) + "\n");
			}
			strArray.push(bar);

			tlcount = 0;
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					TL[tlcount] = Math.abs(AAA[i] - AAA[ii]) / Math.sqrt(2 * MSA / NA);
					TLN[tlcount] = tlcount;
					tlcount++;
				}
			}

			//TL値の小さい順に並び替え（同時にTLN値も）
			// var temp;
			// var temp2;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TL[jk] < TL[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
					}
				}
			}

			//TL値を計算
			kflag = 1; //１のとき棄却する 0だと検定終了
			for (ik = kumi; ik > 0; ik--) {
				if (kflag) {
					if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
						HMC$[ik - 1] = " *  ";
					} else {
						HMC$[ik - 1] = "n.s.";
						kflag = 0; //検定終了 以降はすべて保留
					}
				} else {
					HMC$[ik - 1] = "n.s.";
				}
				alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
			}

			//TLN値の小さい順に並び替え
			// var temp3;
			// var temp4;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TLN[jk] < TLN[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						temp3 = HMC$[jk];
						temp4 = alpha_d[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						HMC$[jk] = HMC$[jk - 1];
						alpha_d[jk] = alpha_d[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
						HMC$[jk - 1] = temp3;
						alpha_d[jk - 1] = temp4;
					}
				}
			}

			tlcount = 0;
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					if (HMC$[tlcount] == " *  ") {
						if (AAA[i] > AAA[ii]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					} else {
						EQ$ = "=";
					}
					strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
					tlcount++;
				}
			}
			strArray.push(bar);
		}
		if ((LB > 2) && (FB$ != "ns")) {
			m2 = using(MSB, 6, 4);

			D2 = DS * DB;
			kumi = kumiawase(LB, 2);
			tlcount = 0;

			strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
			strArray.push(" (MSe=" + m2 + ", * p<.05)\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor B]\n");
			strArray.push(" B     N   	       Mean\n");
			strArray.push(bar);
			for (j = 0; j < LB; j++) {
				S = 0;
				for (i = 0; i < LA; i++) {
					S = S + M[i][j];
				}
				BBB[j] = S / LA;
				var bbb = using(BBB[j], 6, 4);
				// var nb = using(NB,4,0);
				strArray.push(" " + (j + 1) + "\t" + using(NB, 4, 0) + "\t" + using(BBB[j], 6, 4) + "\n");
			}
			strArray.push(bar);

			tlcount = 0;
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					TL[tlcount] = Math.abs(BBB[j] - BBB[jj]) / Math.sqrt(2 * MSB / NB);
					TLN[tlcount] = tlcount;
					tlcount++;
				}
			}

			//TL値の小さい順に並び替え（同時にTLN値も）
			// var temp;
			// var temp2;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TL[jk] < TL[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
					}
				}
			}

			//TL値を計算
			kflag = 1; //１のとき棄却する 0だと検定終了
			for (ik = kumi; ik > 0; ik--) {
				if (kflag) {
					if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
						HMC$[ik - 1] = " *  ";
					} else {
						HMC$[ik - 1] = "n.s.";
						kflag = 0; //検定終了 以降はすべて保留
					}
				} else {
					HMC$[ik - 1] = "n.s.";
				}
				alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
			}

			//TLN値の小さい順に並び替え
			// var temp3;
			// var temp4;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TLN[jk] < TLN[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						temp3 = HMC$[jk];
						temp4 = alpha_d[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						HMC$[jk] = HMC$[jk - 1];
						alpha_d[jk] = alpha_d[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
						HMC$[jk - 1] = temp3;
						alpha_d[jk - 1] = temp4;
					}
				}
			}

			tlcount = 0;
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					if (HMC$[tlcount] == " *  ") {
						if (BBB[j] > BBB[jj]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					} else {
						EQ$ = "=";
					}
					strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
					tlcount++;
				}
			}
			strArray.push(bar);
		}
	}

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var rcmArray1 = [];
		var rcmArray2 = [];
		var spc = "          ";

		rcmArray1.push("####### 分散分析ｓＡＢ(２要因参加者内) ：主分析#######\n");
		rcmArray1.push("\n");
		rcmArray1.push("# パッケージ psych が必要\n");
		rcmArray1.push("\n");
		rcmArray1.push("## js-STARからの入力\n");
		rcmArray1.push("levA = " + LA + spc + "# level of A\n");
		rcmArray1.push("levB = " + LB + spc + "# level of B\n");
		rcmArray1.push("n    = c( # データ数\n");
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				rcmArray1.push(" " + NN);
				if ((i != LA - 1) || (j != LB - 1)) {
					rcmArray1.push(",");
				}
			}
			if (i != LA - 1) {
				rcmArray1.push("\n");
			}
		}
		rcmArray1.push("\n )\n");
		rcmArray1.push("data = c(\n");
		for (k = 0; k < NN; k++) {
			for (i = 0; i < LA; i++) {
				for (j = 0; j < LB; j++) {
					rcmArray1.push(" " + xx[i][j][k]);
					if ((i != LA - 1) || (j != LB - 1) || (k != NN - 1)) rcmArray1.push(",");
				}
			}
			if ((k != NN - 1)) {
				rcmArray1.push("\n");
			}
		}
		rcmArray1.push("\n )\n");
		rcmArray1.push("\n");
		var taju = document.getElementById("taju").value;
		rcmArray1.push("taju=\"" + taju + "\"  # BH, holm, b\n");
		rcmArray1.push("\n");
		rcmArray1.push("## js-STARの入力おわり\n");
		rcmArray1.push("\n");

		rcmArray1.push("## スタック\n");
		rcmArray1.push("N= mean(n)\n");
		rcmArray1.push("s= gl(N, levA*levB )\n");
		rcmArray1.push("A= gl(levA,levB, N*levA*levB )\n");
		rcmArray1.push("B= gl(levB,1, N*levA*levB )\n");
		rcmArray1.push("sAB= data.frame(s,A,B, data )\n");
		rcmArray1.push("\n");
		rcmArray1.push("## 基本統計\n");
		rcmArray1.push("Title=\"ＡxＢの平均とSD(不偏分散の平方根)\"\n");
		rcmArray1.push("nams= matrix(c(\"A\",\"B\",\"B\",\"A\"),nc=2)\n");
		rcmArray1.push("levs= c(levA, levB )\n");
		rcmArray1.push("library( psych )\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx0=c(); txD=c(); mds=c()\n");
		rcmArray1.push("for( i in 1:levA ){ tx0=c(tx0,rep(NA,5)); txD=rbind(txD,rep(NA,5)); mds=c(mds,\"\")\n");
		rcmArray1.push("for( j in 1:levB ){\n");
		rcmArray1.push("  kx= describe(subset(sAB,A==i & B==j)$data )\n");
		rcmArray1.push("  tx0= c(tx0, kx$n,kx$mean,kx$sd,kx$min,kx$max )\n");
		rcmArray1.push("  mds= c(mds, paste(\"A.\",i,\"_B.\",j, sep=\"\") )\n");
		rcmArray1.push("  txD= rbind(txD, as.numeric(kx[1,c(5,10:13)]) )\n");
		rcmArray1.push("}  }\n");
		rcmArray1.push("tx0= matrix(round(tx0,4), nc=5,by=1 )\n");
		rcmArray1.push("tx0= tx0[-1,]\n");
		rcmArray1.push("rownames(tx0)= mds[-1]\n");
		rcmArray1.push("colnames(tx0)= c(\"   n\",\"    Mean\",\"     SD\",\"   Min\",\"   Max\" )\n");
		rcmArray1.push("txD= round(txD[-1,], 2)\n");
		rcmArray1.push("rownames(txD)= rownames(tx0)\n");
		rcmArray1.push("colnames(txD)= c(\"Median\",\"Range\",\"歪度\",\"尖度\",\"SE\" )\n");
		rcmArray1.push("hk= tx0[,2][ is.na(tx0[,2])==0 ]\n");
		rcmArray1.push("sd= tx0[,3][ is.na(tx0[,3])==0 ]\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 線グラフ\n");
		rcmArray1.push("ptc= c(rep(21,8), rep(23,8) )\n");
		rcmArray1.push("bgc= rep(c(1,8,7,6,5,4,3,2), 2 )\n");
		rcmArray1.push("clN= rep(c(\"黒\",\"灰\",\"黄\",\"紫\",\"水\",\"青\",\"緑\",\"赤\"), 2 )\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray1.push("windows()\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray1.push("quartz()\n");
		}
		rcmArray1.push("xjik= c(0.8, levB+0.2)\n");
		rcmArray1.push("yjik= c(min(hk-sd), max(hk+sd) )\n");
		rcmArray1.push("plot(1:levB, hk[1:levB],typ=\"n\",bty=\"l\",\n");
		rcmArray1.push("  xli=xjik, yli=yjik,\n");
		rcmArray1.push("  xlab=\"\", ylab=\"平　均\", xaxt=\"n\",\n");
		rcmArray1.push("  tck=0.03, las=1, # 目盛り突起\n");
		rcmArray1.push("  main=\"ＡxＢの平均のプロフィール\", cex.main=1.5,cex.lab=1.2 )\n");
		rcmArray1.push("axis(side=1,at=1:levB, labels=paste(\"B\",1:levB,sep=\"\"),cex.axis=1.2,tck=0.03,las=1 )\n");
		rcmArray1.push("for( i in 1:levA ) lines(1:levB, hk[ ((i-1)*levB+1):(i*levB) ] )\n");
		rcmArray1.push("bang= rep(1:levA, each=levB )\n");
		rcmArray1.push("points(rep(1:levB,levA),hk,pc=ptc[bang],bg=bgc[bang],cex=3 )\n");
		rcmArray1.push("legend(\"topright\", paste(\"A\",1:levA,\"_\",clN[1:levA],sep=\"\"),cex=1.2 )\n");
		rcmArray1.push("# topleft,topright,center,bottomleft,bottomright\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 棒グラフ\n");
		rcmArray1.push("mitsdo= c(0:(levB-1))*10*log(1:levB) # バーの斜線密度\n");
		rcmArray1.push("mitsdo= rep( mitsdo, levA )          # Ａ水準数だけ反復\n");
		rcmArray1.push("kankak= c( 1, rep(0, levB-1) ) # バーの間隔（左端=1, 以下=0）\n");
		rcmArray1.push("kankak= rep( kankak, levA )    # Ａ水準の数だけ反復\n");
		rcmArray1.push("bai = 2\n");
		rcmArray1.push("shoh= min(min(hk),0) # 最小平均か,ゼロ\n");
		rcmArray1.push("dais= max(sd)        # 最大ＳＤ\n");
		rcmArray1.push("yjik=c(shoh+dais*bai*sign(shoh), max(hk)+dais*bai) # ｙ軸の範囲\n");
		rcmArray1.push("for( L in 1:2 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("if( L==1 ) Sd=sd else { Sd=txD[,5][is.na(txD[,5])==0]; Title=\"ＡxＢの平均とSE(標準誤差)\" }\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray1.push("windows()\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray1.push("quartz()\n");
		}
		rcmArray1.push("antx= barplot(hk, yli=yjik, # ｘ軸の範囲指定しない\n");
		rcmArray1.push("  las=1, tck=0.02, # ｙ軸の目盛デザイン\n");
		rcmArray1.push("  col=1, den=mitsdo,\n");
		rcmArray1.push("  spa=kankak,      # バーの間隔\n");
		rcmArray1.push("  names.arg=c( rep(paste(\"B\",1:levB,sep=\"\"),levA) ),\n");
		rcmArray1.push("  xlab=\"\", ylab=\"平　均\",\n");
		rcmArray1.push("  main=Title, sub=paste(\"Ｂ1(左端) ～Ｂ\",levB,\"　in　Ａ1(左端から\",levB,\"本で１水準) ～Ａ\",levA, sep=\"\" ),\n");
		rcmArray1.push("  cex.main=1.5, cex.sub=1.2, cex.lab=1.2 )\n");
		rcmArray1.push("arrows(antx,hk, antx,hk+Sd*sign(hk), lwd=L,ang=90,len=0.12 ) # len=水平長さ\n");
		rcmArray1.push("if(L==2) arrows(antx,hk,antx,hk-Sd*sign(hk),lwd=L,ang=90,len=0.12 )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("\n");
		rcmArray1.push("# ANOVA\n");
		rcmArray1.push("TsF= function(ss,d1,d2,MS,adj=0)\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" ms=ss/d1; fc=ms/MS\n");
		rcmArray1.push(" pc= pf(fc,d1,d2,low=0)\n");
		rcmArray1.push(" if(adj==1) pc=p.adjust(pc,me=taju)\n");
		rcmArray1.push(" et= fc*d1/(fc*d1+d2)\n");
		rcmArray1.push(" matrix(round(c(ss,d1,ms,fc,pc,et),4),nc=6 )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("NAM= c(\"主効果Ａ\",\"主効果Ｂ\",\"交互作用ＡxＢ\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("kx= anova(lm(data~s+A*B+s:A+s:B,sAB) )\n");
		rcmArray1.push("jbn= c(1,2,5,3,6,4,7 )\n");
		rcmArray1.push("SS=kx$S[jbn]; DF=kx$D[jbn]; MS=kx$M[jbn]\n");
		rcmArray1.push("tx1= c()\n");
		rcmArray1.push("jbn= c(NA,3,NA,5,NA,7,NA )\n");
		rcmArray1.push("tx1= TsF(SS,DF,DF[jbn],MS[jbn] )\n");
		rcmArray1.push("jbn= c(2, 4, 6 )\n");
		rcmArray1.push("Fch=tx1[jbn,4]; Pch=tx1[jbn,5]; eta=tx1[jbn,6]\n");
		rcmArray1.push("rownames(tx1)= c(\"   ｓ\",NAM[1],\" ｓｘＡ\",NAM[2],\" ｓ×Ｂ\",\" ＡｘＢ\",\"ｓxＡxＢ\")\n");
		rcmArray1.push("colnames(tx1)= c(\"SS \",\"df\", \"MS\", \"Ｆ\", \"ｐ\",\"  ηp2\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 平均相関\n");
		rcmArray1.push("HSOK= function()\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" Lev= ncol(dmat)\n");
		rcmArray1.push(" keis= c()\n");
		rcmArray1.push(" for(x in 1:(Lev-1)){ for(y in (x+1):Lev) keis=c(keis,rmat[x,y] ) }\n");
		rcmArray1.push(" tanh( sum(nrow(dmat)*atanh(keis)) /( nrow(dmat)*length(keis) ) ) # Fisher.Z\n");
		rcmArray1.push("}\n");
		rcmArray1.push("MIXR= function(){ Lev=ncol(rmat);if(sum(rmat<0)==0 | (sum(rmat<0)>0 & sum(rmat>0)==Lev) ) 0 else 1 }\n");
		rcmArray1.push("\n");
		rcmArray1.push("hkR=c(); mixR=c()\n");
		rcmArray1.push("for( L in 1:2 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" dmat=c(); cols=levs[L]\n");
		rcmArray1.push(" for(x in 1:cols) dmat=c(dmat, subset(sAB$data,sAB[,L+1]==x) )\n");
		rcmArray1.push(" dmat= matrix(dmat,nc=cols, by=1 )\n");
		rcmArray1.push(" rmat= cor(dmat)\n");
		rcmArray1.push(" hkR=c(hkR, HSOK() ); mixR=c(mixR, MIXR() )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("dmat= matrix(data,nc=levA*levB, by=1 )\n");
		rcmArray1.push("rmat= cor(dmat)\n");
		rcmArray1.push("hkR=c(hkR,HSOK() ); mixR=c(mixR,MIXR() )\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 球面性\n");
		rcmArray1.push("idat= data.frame(\n");
		rcmArray1.push("   sB=gl(levB,1,levA*levB),\n");
		rcmArray1.push("   sA=gl(levA, levB) ) # 逆階層\n");
		rcmArray1.push("\n");
		rcmArray1.push("lmod= lm(dmat~1)\n");
		rcmArray1.push("MsW=c();MsP=c(); eps=c();tmp=c(\"Spherical\")\n");
		rcmArray1.push("for( L in 1:3 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" if(L==1) kx=mauchly.test(lmod,M=~sB+sA,X=~sB,idata=idat )\n");
		rcmArray1.push(" if(L==2) kx=mauchly.test(lmod,M=~sB+sA,X=~sA,idata=idat )\n");
		rcmArray1.push(" if(L==3) kx=mauchly.test(lmod,X=~sB+sA,idata=idat )\n");
		rcmArray1.push(" MsW=c(MsW,kx$st); MsP=c(MsP,kx$p.v)\n");
		rcmArray1.push(" if(L==1) kx=anova(lmod,M=~sB+sA,X=~sB,test=tmp,idata=idat )\n");
		rcmArray1.push(" if(L==2) kx=anova(lmod,M=~sB+sA,X=~sA,test=tmp,idata=idat )\n");
		rcmArray1.push(" if(L==3) kx=anova(lmod,X=~sB+sA,test=tmp,idata=idat )\n");
		rcmArray1.push(" if(L<3) jbn=c(8,9) else jbn=c(5,6)\n");
		rcmArray1.push(" eps= c(eps, as.numeric(substr(attributes(kx)$head[jbn],29,34)) )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("\n");
		rcmArray1.push("epGG=eps[c(1,3,5)]; epHF=eps[c(2,4,6)]\n");
		rcmArray1.push("tx9= c()\n");
		rcmArray1.push("tx9= matrix(round(c(MsW,MsP,epGG,epHF), 4), nc=4 )\n");
		rcmArray1.push("rownames(tx9)= c(\"要因Ａ\",\"要因Ｂ\",\"Ａ×Ｂ\" )\n");
		rcmArray1.push("colnames(tx9)= c(\"Mauchly's W\",\"   ｐ値\",\"  G-G_ε\",\" H-F_ε\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("crP= c()\n");
		rcmArray1.push("epHF[ epHF>1 ]=1\n");
		rcmArray1.push("jbn= c(2,4,6)\n");
		rcmArray1.push("GGp= pf(Fch,DF[jbn]*epGG,DF[jbn+1]*epGG,low=0 )\n");
		rcmArray1.push("HFp= pf(Fch,DF[jbn]*epHF,DF[jbn+1]*epHF,low=0 )\n");
		rcmArray1.push("crP= matrix(round(c(DF[jbn],Fch,Pch,GGp,HFp),4),nc=5 )\n");
		rcmArray1.push("rownames(crP)= rownames(tx1)[c(2,4,6)]\n");
		rcmArray1.push("colnames(crP)= c(\"df\",\"     Ｆ\",\"     ｐ\",\" G-G_ｐ\",\" H-F_ｐ\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("# パワ\n");
		rcmArray1.push("ESf= sqrt(eta/(1-eta) )\n");
		rcmArray1.push("PWz=c(); PWr=c()\n");
		rcmArray1.push("for( L in 1:3 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" d1=DF[L*2]; d2=DF[L*2+1]\n");
		rcmArray1.push(" NCP= ESf[L]^2*N*(d1+1)\n");
		rcmArray1.push(" crF= qf(0.95,d1,d2)\n");
		rcmArray1.push(" PWz= c(PWz,1-pf(crF,d1,d2,NCP) )\n");
		rcmArray1.push(" NCP= ESf[L]^2*N*(d1+1)*( 1/(1-abs(hkR[L])) )\n");
		rcmArray1.push(" PWr= c(PWr,1-pf(crF,d1,d2,NCP) )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("tx2= c()\n");
		rcmArray1.push("tx2= matrix(round(c(ESf,PWz,PWr,hkR),4), nc=4 )\n");
		rcmArray1.push("rownames(tx2)= rownames(crP)\n");
		rcmArray1.push("colnames(tx2)= c(\"効果量ｆ\",\" 検出力0\",\" 検出力r\",\" 水準間相関\")\n");
		rcmArray1.push("\n");
		rcmArray1.push("## 主効果\n");
		rcmArray1.push("hkA=c();hkB=c();mcA=c();mcB=c()\n");
		rcmArray1.push("for( L in 1:2 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" hyo1=c(); hyo2=c(); nam=nams[L,]\n");
		rcmArray1.push(" x=c(); y=c(); u=c()\n");
		rcmArray1.push(" for( i in 1:levs[L] )\n");
		rcmArray1.push("   {\n");
		rcmArray1.push("    dt= subset(sAB$data,sAB[,L+1]==i )\n");
		rcmArray1.push("    u=c(u, length(dt) )\n");
		rcmArray1.push("    x=c(x, mean(dt) )\n");
		rcmArray1.push("    y=c(y, sd(dt) )\n");
		rcmArray1.push("   }\n");
		rcmArray1.push(" hyo1= rbind(matrix(round(c(u,x,y),4),nr=3,by=1),rep(NA,levs[L]) )\n");
		rcmArray1.push(" rownames(hyo1)= c(\"N\",\"Mean\",\"S.D.\",\"-----\" )\n");
		rcmArray1.push(" colnames(hyo1)= paste(nam[1],1:levs[L], sep=\"\" )\n");
		rcmArray1.push(" if( levs[L]>2 )\n");
		rcmArray1.push("   {\n");
		rcmArray1.push("    hyo2=round(pairwise.t.test(sAB$data,sAB[,L+1],p.ad=taju,pair=1)$p.v, 4 )\n");
		rcmArray1.push("    rownames(hyo2)= paste(nam[1],2:levs[L], sep=\"\" )\n");
		rcmArray1.push("    colnames(hyo2)= paste(nam[1],1:(levs[L]-1), sep=\"\" )\n");
		rcmArray1.push("   }\n");
		rcmArray1.push(" if(L==1){ hkA=hyo1; mcA=hyo2 } else { hkB=hyo1; mcB=hyo2 }\n");
		rcmArray1.push("} # for(L)\n");
		rcmArray1.push("\n");
		rcmArray1.push("\n");
		rcmArray1.push("# ■結果の書き方\n");
		rcmArray1.push("PV= function(x) floor(x*1000)/1000\n");
		rcmArray1.push("TesA= function(水準=1,相手=2)\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" tx=t.test(data~A,subset(sAB,A==水準 | A==相手),pair=1)\n");
		rcmArray1.push(" tch=abs(tx$stat); df2=tx$para; nPV=tx$p.va\n");
		rcmArray1.push(" cat(paste(\"t(\",df2,\")=\",round(tch,4),\", non-adjusted p=\",round(nPV,4),\"(両側)\n\", sep=\"\") )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("TesB= function(水準=1,相手=2)\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" tx=t.test(data~B,subset(sAB,B==水準 | B==相手),pair=1)\n");
		rcmArray1.push(" tch=abs(tx$stat); df2=tx$para; nPV=tx$p.va\n");
		rcmArray1.push(" cat(paste(\"t(\",df2,\")=\",round(tch,4),\", non-adjusted p=\",round(nPV,4),\"(両側)\n\", sep=\"\") )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("txt=c()\n");
		rcmArray1.push("if( sum(sd==0)>0 ) txt=c(\"※分散=0 の群があります。全データが同じ値です。以下の分析は信頼性がありません。\n\n\")\n");
		rcmArray1.push("txt= paste(txt, \"　各水準における○○得点について基本統計量をTable(tx0)に示す。\n　２要因の参加者内分散分析を行った結果 (Table(tx1)参照)，\", sep=\"\" )\n");
		rcmArray1.push("Tari=0 # 多重あり\n");
		rcmArray1.push("\n");
		rcmArray1.push("Pow= c()\n");
		rcmArray1.push("for(L in 1:3) if( mixR[L]<1 ) Pow=c(Pow,PWr[L]) else Pow=c(Pow,PWz[L])\n");
		rcmArray1.push("\n");
		rcmArray1.push("yui=c()\n");
		rcmArray1.push("for( L in 1:3 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" pch= Pch[L]\n");
		rcmArray1.push(" if( L<3 ) goku=c(\"，\") else goku=c(\"。\")\n");
		rcmArray1.push(" fuki= paste(\" (F(\",DF[L*2],\",\",DF[L*2+1],\")=\",round(Fch[L],3),\", p=\",PV(pch),\", ηp2=\",round(eta[L],3),\", 1-β=\",PV(Pow[L]),\")\",goku, sep=\"\" )\n");
		rcmArray1.push(" if(pch<0.05){ yui=c(yui,L); if(L<3) tmp=c(\"であり\") else tmp=c(\"であった\") } else\n");
		rcmArray1.push(" if(pch<0.10){ yui=c(yui,L); if(L<3) tmp=c(\"傾向であり\") else tmp=c(\"傾向であった\") } else\n");
		rcmArray1.push("             { if(L<3) tmp=c(\"でなく\") else tmp=c(\"でなかった\") }\n");
		rcmArray1.push(" txt= paste(txt, NAM[L],\"が有意\",tmp,fuki, sep=\"\" )\n");
		rcmArray1.push("}\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 検出力\n");
		rcmArray1.push("kazu=length(yui); yosh=0; mae=9\n");
		rcmArray1.push("if( kazu>0 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push("for( x in 1:kazu )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" pwr= Pow[yui[x]]\n");
		rcmArray1.push(" if( pwr>0.80 ){ tmp=c(\"十分である。\"); yosh=1 } else\n");
		rcmArray1.push(" if( pwr>0.76 ){ tmp=c(\"ほぼ十分といえる。\"); yosh=1 } else\n");
		rcmArray1.push(" if( pwr>0.70 ){ tmp=c(\"やや低いが0.70以上あり不十分ではない。\"); yosh=0 } else { tmp=c(\"不十分であり，信頼性が低い。\"); yosh=0 }\n");
		rcmArray1.push(" if( mae==yosh ) goku=c(\"も\") else goku=c(\"は\")\n");
		rcmArray1.push(" mae= yosh\n");
		rcmArray1.push(" if( x==1 ){ mata=c(\"\n　\"); fuki=c(\" (1-β) \") } else { mata=c(\"\"); fuki=c(\"\") }\n");
		rcmArray1.push(" txt= paste(txt, mata,NAM[yui[x]],\"の検出力\",fuki,goku,tmp, sep=\"\" )\n");
		rcmArray1.push("}  }\n");
		rcmArray1.push("tmp=c(\"正負が混在している場合は平均相関を0と仮定し，それ以外はFisherの重み付きZ変換値による平均相関を\" )\n");
		rcmArray1.push("if( sum(levs>2)>0 ) goku=c(\"に\") else { goku=c(\"を\"); tmp=c(\"\") }\n");
		rcmArray1.push("txt= paste(txt, \"なお検出力の値は水準間の相関係数\",goku,tmp,\"用いて算出した。\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 球面性\n");
		rcmArray1.push("if( kazu>0 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" sumi=0; shus=0\n");
		rcmArray1.push(" for( x in 1:kazu )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" L= yui[x]\n");
		rcmArray1.push(" if( DF[L*2]>1 )\n");
		rcmArray1.push("   {\n");
		rcmArray1.push("    sumi= sumi+1\n");
		rcmArray1.push("    if( sumi==1 ) txt=paste(txt, \"\n　有意性を示した自由度2以上の効果についてMauchlyの球面性検定を行った結果 (Table(tx9)参照)，\", sep=\"\" )\n");
		rcmArray1.push("    if( is.nan(MsP[L])==1 ){ tmp=c(\"計算不能であった\"); pch=NA; shus=shus+1 } else\n");
		rcmArray1.push("{\n");
		rcmArray1.push("  pch= MsP[L]\n");
		rcmArray1.push("  if( pch>1 ){ tmp=c(\"計算不能であった\"); pch=NA; shus=shus+1 } else\n");
		rcmArray1.push("  if( pch>0.05 ) tmp=c(\"有意でなかったことを確認した\") else { tmp=c(\"有意であった\"); shus=shus+1 }\n");
		rcmArray1.push("}\n");
		rcmArray1.push("    if(sumi>1 & shus<1) goku=c(\"も\") else goku=c(\"は\")\n");
		rcmArray1.push("    fuki= paste(\" (Mauchly's W=\",round(MsW[L],3),\", p=\",PV(pch),\")。\", sep=\"\" )\n");
		rcmArray1.push("    txt= paste(txt, NAM[L],\"について\",goku,tmp,fuki, sep=\"\" )\n");
		rcmArray1.push("    if( (pch<0.05 | is.na(pch)>0) & shus>0 )\n");
		rcmArray1.push("    {\n");
		rcmArray1.push("     if( shus==1 ) goku=c(\"このため，Greenhouse-Geisserの自由度調整係数による修正検定を行った (Table(crP)参照)。結果として，\")　else goku=c(\"修正検定の結果，\")\n");
		rcmArray1.push("     crp=crP[L,4]; fuki=c(\"\"); ika=c(\"\")\n");
		rcmArray1.push("     if( crp<0.10 ){ tmp=c(\"であることを確認した\"); if(crp>0.05) fuki=c(\"傾向\") } else { tmp=c(\"性を得られなかった\"); ika=c(\"以下，参考までに分析を進めることにする。\") }\n");
		rcmArray1.push("     txt= paste(txt, goku,NAM[L],\"は有意\",fuki,tmp,\" (G-G corrected p=\",PV(crp),\")。\",ika, sep=\"\" )\n");
		rcmArray1.push("    }\n");
		rcmArray1.push("   }\n");
		rcmArray1.push("} # for(x)\n");
		rcmArray1.push("} # if(kazu)\n");
		rcmArray1.push("\n");
		rcmArray1.push("# 主効果\n");
		rcmArray1.push("Pari=0; Mari=0; Tari=0\n");
		rcmArray1.push("for( L in 1:2 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" pch= Pch[L]\n");
		rcmArray1.push(" if( L==1 ){ levL=levA; hk=hkA[2,]; hyo=mcA }\n");
		rcmArray1.push(" if( L==2 ){ levL=levB; hk=hkB[2,]; hyo=mcB }\n");
		rcmArray1.push(" nam= nams[L,]\n");
		rcmArray1.push(" if( pch<0.10 & Pch[3]>0.05 )\n");
		rcmArray1.push("{\n");
		rcmArray1.push(" Pari= Pari+1\n");
		rcmArray1.push(" if( Pari==1 ){ mata=c(\"\n　有意性を示した\");goku=c(\"\") } else { mata=c(\"\"); goku=c(\"は\"); if(Pari==2) mata=c(\"また，\") }\n");
		rcmArray1.push(" txt= paste(txt, mata,NAM[L],\"について\",goku,\"，\", sep=\"\" )\n");
		rcmArray1.push(" hk=round(hk, 3 )\n");
		rcmArray1.push(" if( levL==2 )\n");
		rcmArray1.push("   {\n");
		rcmArray1.push("    if( hk[1]>hk[2] ) tmp=c(\"大きい\") else tmp=c(\"小さい\")\n");
		rcmArray1.push("    if( pch>0.05 ) goku=c(\"傾向がある\") else goku=c(\"\")\n");
		rcmArray1.push("    txt= paste(txt, nam[1],\"1の平均\",hk[1],\"が\",nam[1],\"2の平均\",hk[2],\"よりも有意に\",tmp,goku,\"ことが見いだされた。\", sep=\"\" )\n");
		rcmArray1.push("   } else {\n");
		rcmArray1.push("    Tari=1\n");
		rcmArray1.push("    txt= paste(txt, \"対応のあるｔ検定による多重比較 (α=0.05, 両側検定) を行った結果，\", sep=\"\" )\n");
		rcmArray1.push("    kazu= sum(hyo<0.10,na.rm=1 )\n");
		rcmArray1.push("    if( kazu<1 ) txt=paste(txt,\"どの２水準の平均の差も有意でなかった (adjusted ps>\",PV(min(hyo,na.rm=1)),\")。\", sep=\"\" ) else\n");
		rcmArray1.push("      {\n");
		rcmArray1.push("##\n");
		rcmArray1.push("sumi= 0\n");
		rcmArray1.push("for(x in 1:(levL-1)){ for(y in (x+1):levL){\n");
		rcmArray1.push("  adP= hyo[ y-1, x ]\n");
		rcmArray1.push("  if( adP<0.10 )\n");
		rcmArray1.push("    {\n");
		rcmArray1.push("     keko=\"傾向がある\"; if( adP<0.05 ) keko=\"\"\n");
		rcmArray1.push("     dt= subset(sAB,sAB[,L+1]==x | sAB[,L+1]==y )\n");
		rcmArray1.push("     tx= t.test(dt[,4]~dt[,L+1], pair=1 )\n");
		rcmArray1.push("     sumi= sumi+1\n");
		rcmArray1.push("     if( sumi==2 ) mata=c(\"また\") else mata=c(\"\")\n");
		rcmArray1.push("     if( sumi<kazu ){ tmp=c(\"\"); goku=c(\"，\") } else { tmp=c(\"が見いだされた\"); goku=c(\"。\") }\n");
		rcmArray1.push("     fuki= paste(\" (t(\",tx$para,\")=\",round(abs(tx$stat),3),\", adjusted p=\",PV(adP),\")\",goku, sep=\"\" )\n");
		rcmArray1.push("     if( hk[x]>hk[y] ) mds=c(\"大きい\") else mds=c(\"小さい\")\n");
		rcmArray1.push("     txt= paste(txt, mata,nam[1],x,\"の平均\",hk[x],\"が\",nam[1],y,\"の平均\",hk[y],\"よりも有意に\",mds,keko,\"こと\",tmp,fuki, sep=\"\" )\n");
		rcmArray1.push("    }\n");
		rcmArray1.push("}  } # for(x)(y)\n");
		rcmArray1.push("##\n");
		rcmArray1.push("      }\n");
		rcmArray1.push("   } # if(levL)\n");
		rcmArray1.push("} # if(pch)\n");
		rcmArray1.push("} # for(L)\n");
		rcmArray1.push("\n");
		rcmArray1.push("if( taju==\"BH\" ) TAJ=c(\"Benjamini & Hochberg (1995) \" )\n");
		rcmArray1.push("if( taju==\"holm\" ) TAJ=c(\"Holm\")\n");
		rcmArray1.push("if( taju==\"b\" ) TAJ=c(\"Bonferroni\")\n");
		rcmArray1.push("if( Tari>0 ) txt=paste(txt, \"\n　以上のp値の調整には\",TAJ,\"の方法を用いた。\n\", sep=\"\" ) else txt=paste(txt,\"\n\",sep=\"\")\n");
		rcmArray1.push("if( Tari>0 & taju==\"BH\" ) txt= paste(txt, \"\n［引用文献］\n\",\n");
		rcmArray1.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("txt= paste(txt,\"\n\",sep=\"\" )\n");
		rcmArray1.push("if( Pch[3]<0.10 ){ tmp=c(\"するか判断\");if( Pch[3]<0.05 ) tmp=c(\"\")\n");
		rcmArray1.push("txt=paste(txt,\"\n⇒js-STARの第二枠『\",NAM[3],\"が有意のときに…』を実行\",tmp,\"してください。\n\",sep=\"\" ) }\n");
		rcmArray1.push("H=matrix(0,nr=1)\n");
		rcmArray1.push("rownames(H)=c(\"\")\n");
		rcmArray1.push("colnames(H)=paste(\" (多数回検定時のｐ値調整は\",taju,\"法による) \", sep=\"\" )\n");
		rcmArray1.push("\n");
		rcmArray1.push("options(digits=5)\n");
		rcmArray1.push("options(scipen=5)\n");
		rcmArray1.push("###############################\n");
		rcmArray1.push("#\n");
		rcmArray1.push("#   分散分析 ｓＡＢ-design\n");
		rcmArray1.push("#   ２要因  参加者内計画\n");
		rcmArray1.push("#\n");
		rcmArray1.push("H##############################\n");
		rcmArray1.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray1.push("# 歪度,尖度,SEなどは『オプション』参照\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx1 # 分散分析ｓＡＢ\n");
		rcmArray1.push("    # 効果量ηp2 は偏イータ２乗\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx2 # 効果量ｆと検出力(1-β)\n");
		rcmArray1.push("# 検出力0：水準間相関=0 (正負混在の場合)\n");
		rcmArray1.push("# 検出力r：水準間相関=r (標本値から算出)\n");
		rcmArray1.push("\n");
		rcmArray1.push("tx9 # 球面性検定（df=1は不要）と自由度調整係数ε\n");
		rcmArray1.push("crP # 球面性検定が有意のときの修正ｐ値\n");
		rcmArray1.push("    # ■参加者数Ｎ≦10ならH-F_ｐ参照可\n");
		rcmArray1.push("\n");
		rcmArray1.push("hkA;mcA # 主効果Ａの平均と多重比較の調整後ｐ値\n");
		rcmArray1.push("\n");
		rcmArray1.push("hkB;mcB # 主効果Ｂの平均と多重比較の調整後ｐ値\n");
		rcmArray1.push("\n");
		rcmArray1.push("cat(txt) # 結果の書き方\n");
		rcmArray1.push("\n");
		rcmArray1.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray1.push("windows();boxplot(data~A*B,sAB) # 箱ひげ図\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray1.push("quartz();boxplot(data~A*B,sAB) # 箱ひげ図\n");
		}
		rcmArray1.push("# txD # Median,歪度,尖度,SEなど\n");
		rcmArray1.push("# TesA(水準=1, 相手=2 ) # 主効果Aの２水準ｔ検定\n");
		rcmArray1.push("# TesB(水準=1, 相手=2 ) # 主効果Bの２水準ｔ検定\n");
		rcmArray1.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray1.push("\n");
		rcmArray1.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
		rcmArray1.push("\n");

		document.getElementById("RcmArea").value = rcmArray1.join("");
		rcmArray1 = null;

		rcmArray2.push("####### 分散分析ｓＡＢ(２要因参加者内) ：交互作用#######\n");
		rcmArray2.push("tkAB=c();AatB=c();BatA=c()\n");
		rcmArray2.push("if( Pch[3]<0.10 ){\n");
		rcmArray2.push("\n");
		rcmArray2.push("ss=c();d1=c();d2=c();ms=c()\n");
		rcmArray2.push("for(j in 1:levB) ss=c(ss,anova(lm(data~A,subset(sAB,B==j) ))$S[1] )\n");
		rcmArray2.push("for(i in 1:levA) ss=c(ss,anova(lm(data~B,subset(sAB,A==i) ))$S[1] )\n");
		rcmArray2.push("d1= c(rep(DF[2],levB), rep(DF[4],levA) )\n");
		rcmArray2.push("d2= c(rep(DF[3],levB), rep(DF[5],levA) )\n");
		rcmArray2.push("ms= c(rep(MS[3],levB), rep(MS[5],levA) )\n");
		rcmArray2.push("hx= TsF(ss,d1,d2,ms, adj=1 )\n");
		rcmArray2.push("\n");
		rcmArray2.push("mds= c()\n");
		rcmArray2.push("for(j in 1:levB) tkAB=rbind(tkAB, hx[j,] )\n");
		rcmArray2.push("tkAB= rbind(tkAB, tx1[3,], rep(NA,6) )\n");
		rcmArray2.push("for(i in 1:levA) tkAB=rbind(tkAB, hx[levB+i,] )\n");
		rcmArray2.push("tkAB= rbind(tkAB, tx1[5,] )\n");
		rcmArray2.push("rownames(tkAB)= c( paste(\"A at B\",1:levB,sep=\"\"), \" ｓxＡ\",\"\",paste(\"B at_A\",1:levA,sep=\"\"),\" ｓxＢ\" )\n");
		rcmArray2.push("colnames(tkAB)[5]=\"adjust_p\"\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 多重比較\n");
		rcmArray2.push("yuiA=c(); yuiB=c()\n");
		rcmArray2.push("for(j in 1:levB) if(hx[j,5]<0.15) yuiA=c(yuiA, j )\n");
		rcmArray2.push("for(i in 1:levA) if(hx[(levB+i),5]<0.15) yuiB=c(yuiB, i )\n");
		rcmArray2.push("kazA=length(yuiA); mds=c()\n");
		rcmArray2.push("if( kazA>0 & levA>2 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" for( y in 1:kazA )\n");
		rcmArray2.push("   {\n");
		rcmArray2.push("    sjn= yuiA[y]\n");
		rcmArray2.push("    dt= subset(sAB,B==sjn)\n");
		rcmArray2.push("    pc= pairwise.t.test(dt$data,dt$A,p.ad=taju,pair=1)$p.va\n");
		rcmArray2.push("    AatB= rbind(AatB, round(pc,4) )\n");
		rcmArray2.push("    mds= c(mds, paste(\"A\",2:levA,\" at_B\",sjn,sep=\"\") )\n");
		rcmArray2.push("    if( y<kazA ){ AatB=rbind(AatB, rep(NA,levA-1) ); mds=c(mds,\"\") }\n");
		rcmArray2.push("   }\n");
		rcmArray2.push(" rownames(AatB)= mds\n");
		rcmArray2.push(" colnames(AatB)= paste(\"A\",1:(levA-1), sep=\"\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("\n");
		rcmArray2.push("kazB=length(yuiB); mds=c()\n");
		rcmArray2.push("if( kazB>0 & levB>2 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" for( x in 1:kazB )\n");
		rcmArray2.push("   {\n");
		rcmArray2.push("    sjn= yuiB[x]\n");
		rcmArray2.push("    dt= subset(sAB,A==sjn)\n");
		rcmArray2.push("    pc= pairwise.t.test(dt$data,dt$B,p.ad=taju,pair=1)$p.va\n");
		rcmArray2.push("    BatA= rbind(BatA, round(pc,4) )\n");
		rcmArray2.push("    mds= c(mds, paste(\"B\",2:levB,\" at_A\",sjn,sep=\"\") )\n");
		rcmArray2.push("    if( x<kazB ){ BatA=rbind(BatA, rep(NA,levB-1) ); mds=c(mds,\"\") }\n");
		rcmArray2.push("   }\n");
		rcmArray2.push(" rownames(BatA)= mds\n");
		rcmArray2.push(" colnames(BatA)= paste(\"B\",1:(levB-1), sep=\"\" )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■結果の書き方\n");
		rcmArray2.push("HKx= function(a,b) round(tx0[(a-1)*(levB+1)+b,2], 3 )\n");
		rcmArray2.push("TstT=function(A水準=0,A相手=0,atB=0, B水準=0,B相手=0,atA=0)\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" if(A水準>0 & A相手>0) tx=t.test(data~A,subset(sAB,B==atB & (A==A水準 | A==A相手)),pair=1)\n");
		rcmArray2.push(" if(B水準>0 & B相手>0) tx=t.test(data~B,subset(sAB,A==atA & (B==B水準 | B==B相手)),pair=1)\n");
		rcmArray2.push(" tch=abs(tx$stat); df2=tx$para; nPV=tx$p.va\n");
		rcmArray2.push(" cat(paste(\"t(\",df2,\")=\",round(tch,4),\", non-adjusted p=\",round(nPV,4),\"(両側)\n\", sep=\"\") )\n");
		rcmArray2.push("}\n");
		rcmArray2.push("mds=\"単純主効果\"\n");
		rcmArray2.push("Tari= 1\n");
		rcmArray2.push("txt= paste(txt, \"\n　有意性を示した\",NAM[3],\"について\",mds,\"検定 (α=0.15) を行った (Table(tkAB)参照)。その結果，\",mds,\"Aは，\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( kazA<1 ) txt=paste(txt,\"Bのいずれの水準においても有意でなかった (adjusted ps>\",PV(min(hx[1:levB,5])),\")。\", sep=\"\" ) else\n");
		rcmArray2.push("{ #####\n");
		rcmArray2.push("for(j in 1:kazA)\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" sjn= yuiA[j]\n");
		rcmArray2.push(" tmp= hx[sjn, 4:6]\n");
		rcmArray2.push(" fuki= paste(\" (F(\",DF[2],\",\",DF[3],\")=\",round(tmp[1],3),\", adjusted p=\",PV(tmp[2]),\", ηp2=\",round(tmp[3],3),\")\", sep=\"\" )\n");
		rcmArray2.push(" if( j==2 ) mata=\"また\" else mata=\"\"\n");
		rcmArray2.push(" if(j<kazA){ gok1=\"であり\"; gok2=\"，\" } else { gok1=\"であった\"; gok2=\"。\" }\n");
		rcmArray2.push(" txt= paste(txt, mata,\"B\",sjn,\"において有意\",gok1,fuki,gok2, sep=\"\" )\n");
		rcmArray2.push("} # for(j)\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( levA==2 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" for(j in 1:kazA)\n");
		rcmArray2.push("   {\n");
		rcmArray2.push("    sjn= yuiA[j]\n");
		rcmArray2.push("    hk1= HKx(1,sjn); hk2=HKx(2,sjn)\n");
		rcmArray2.push("    if( hk1>hk2 ) tmp=\"大きい\" else tmp=\"小さい\"\n");
		rcmArray2.push("    if(j==1) mata=\"\n　したがって，\" else if(j==2) mata=\"また\" else mata=\"\"\n");
		rcmArray2.push("    if(j<kazA) goku=\"，\" else goku=\"が見いだされた。\"\n");
		rcmArray2.push("    txt= paste(txt, mata,\"B\",sjn,\"においてA1の平均\",hk1,\"がA2の平均\",hk2,\"よりも\",tmp,\"こと\",goku, sep=\"\" )\n");
		rcmArray2.push("   }\n");
		rcmArray2.push("} else { # if(levA)\n");
		rcmArray2.push(" txt= paste(txt, \"\n　対応のあるｔ検定による多重比較 (α=0.05, 両側検定) を行った結果，\", sep=\"\" )\n");
		rcmArray2.push(" yuis= sum(AatB<0.10, na.rm=1 )\n");
		rcmArray2.push(" sumi= 0\n");
		rcmArray2.push(" for(j in 1:kazA)\n");
		rcmArray2.push("   {\n");
		rcmArray2.push("    sjn= yuiA[j]\n");
		rcmArray2.push("    if(j==2) mata=\"また，\" else mata=\"\"\n");
		rcmArray2.push("    txt= paste(txt, mata,\"B\",sjn,\"において，\", sep=\"\" )\n");
		rcmArray2.push("    st=(j-1)*levA+1; ed=st+levA-2\n");
		rcmArray2.push("    minP= min(AatB[st:ed,], na.rm=1 )\n");
		rcmArray2.push("    if( minP>=0.10 ) txt=paste(txt, \"どの水準の間にも有意な平均の差は見られなかった (adjusted ps>\",PV(minP),\")。\", sep=\"\" ) else\n");
		rcmArray2.push("      {\n");
		rcmArray2.push("       for(x in 1:(levA-1)){ for(y in (x+1):levA){\n");
		rcmArray2.push("       adP= AatB[ levA*(j-1)+y-1, x ]\n");
		rcmArray2.push("       if( adP<0.10 )\n");
		rcmArray2.push("      {\n");
		rcmArray2.push("keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"\"\n");
		rcmArray2.push("       dt= subset(sAB, B==sjn & (A==x | A==y) )\n");
		rcmArray2.push("       kx= t.test(data~A, dt, pair=1 )\n");
		rcmArray2.push("       fuki= paste(\" t(\",kx$para,\")=\",abs(round(kx$stat,3)),\", adjusted p=\",PV(adP),\")\", sep=\"\" )\n");
		rcmArray2.push("       sumi= sumi+1\n");
		rcmArray2.push("       hk1=HKx(x,sjn); hk2=HKx(y,sjn)\n");
		rcmArray2.push("       if( hk1>hk2 ) tmp=\"大き\" else tmp=\"小さ\"\n");
		rcmArray2.push("       if( sumi<yuis ){ gok1=\"り\"; gok2=\"，\" } else { gok1=\"った\"; gok2=\"。\" }\n");
		rcmArray2.push("if( adP<0.05 ) if( sumi<yuis ) gok1=\"く\" else gok1=\"かった\"\n");
		rcmArray2.push("       txt= paste(txt, \"A\",x,\"の平均\",hk1,\"がA\",y,\"の平均\",hk2,\"よりも有意に\",tmp,keko,gok1,fuki,gok2, sep=\"\" )\n");
		rcmArray2.push("      }\n");
		rcmArray2.push("      }  } # for(x)(y)\n");
		rcmArray2.push("      } # if(minP)\n");
		rcmArray2.push("   } # for(j)\n");
		rcmArray2.push("} # if(levA)\n");
		rcmArray2.push("} # if(kazA)\n");
		rcmArray2.push("\n");
		rcmArray2.push("\n");
		rcmArray2.push("txt= paste(txt, \"\n　一方，\",mds,\"Bは，\", sep=\"\" )\n");
		rcmArray2.push("if( kazB<1 ) txt=paste(txt,\"Aのいずれの水準においても有意でなかった (adjusted ps>\",PV(min(hx[(levB+1):(levB+levA),5])),\")。\", sep=\"\" ) else\n");
		rcmArray2.push("{ #####\n");
		rcmArray2.push("for(j in 1:kazB)\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" sjn= yuiB[j]\n");
		rcmArray2.push(" tmp= hx[sjn+levB, 4:6]\n");
		rcmArray2.push(" fuki= paste(\" (F(\",DF[3],\",\",DF[5],\")=\",round(tmp[1],3),\", adjusted p=\",PV(tmp[2]),\", ηp2=\",round(tmp[3],3),\")\", sep=\"\" )\n");
		rcmArray2.push(" if( j==2 ) mata=\"また\" else mata=\"\"\n");
		rcmArray2.push(" if(j<kazB){ gok1=\"であり\"; gok2=\"，\" } else { gok1=\"であった\"; gok2=\"。\" }\n");
		rcmArray2.push(" txt= paste(txt, mata,\"A\",sjn,\"において有意\",gok1,fuki,gok2, sep=\"\" )\n");
		rcmArray2.push("} # for(j)\n");
		rcmArray2.push("\n");
		rcmArray2.push("if( levB==2 )\n");
		rcmArray2.push("{\n");
		rcmArray2.push(" for(j in 1:kazB)\n");
		rcmArray2.push("   {\n");
		rcmArray2.push("    sjn= yuiB[j]\n");
		rcmArray2.push("    hk1=HKx(sjn,1); hk2=HKx(sjn,2)\n");
		rcmArray2.push("    if( hk1>hk2 ) tmp=\"大きい\" else tmp=\"小さい\"\n");
		rcmArray2.push("    if(j==1) mata=\"\n　したがって，\" else if(j==2) mata=\"また\" else mata=\"\"\n");
		rcmArray2.push("    if(j<kazB) goku=\"，\" else goku=\"が見いだされた。\"\n");
		rcmArray2.push("    txt= paste(txt, mata,\"A\",sjn,\"においてB1の平均\",hk1,\"がB2の平均\",hk2,\"よりも\",tmp,\"こと\",goku, sep=\"\" )\n");
		rcmArray2.push("   }\n");
		rcmArray2.push("} else { # if(levB)\n");
		rcmArray2.push(" txt= paste(txt, \"\n　対応のあるｔ検定を用いた多重比較 (α=0.05, 両側検定) を行った結果，\", sep=\"\" )\n");
		rcmArray2.push(" yuis= sum(BatA<0.10, na.rm=1 )\n");
		rcmArray2.push(" sumi= 0\n");
		rcmArray2.push(" for(j in 1:kazB)\n");
		rcmArray2.push("   {\n");
		rcmArray2.push("    sjn= yuiB[j]\n");
		rcmArray2.push("    if(j==2) mata=\"また，\" else mata=\"\"\n");
		rcmArray2.push("    txt= paste(txt, mata,\"A\",sjn,\"において，\", sep=\"\" )\n");
		rcmArray2.push("    st=(j-1)*levB+1; ed=st+levB-2\n");
		rcmArray2.push("    minP= min(BatA[st:ed,], na.rm=1 )\n");
		rcmArray2.push("    if( minP>=0.10 ) txt=paste(txt, \"どの水準の間にも有意な平均の差は見られなかった (adjusted ps>\",PV(minP),\")。\", sep=\"\" ) else\n");
		rcmArray2.push("      {\n");
		rcmArray2.push("       for(x in 1:(levB-1)){ for(y in (x+1):levB){\n");
		rcmArray2.push("       adP= BatA[ levB*(j-1)+y-1, x ]\n");
		rcmArray2.push("       if( adP<0.10 )\n");
		rcmArray2.push("      {\n");
		rcmArray2.push("keko=\"い傾向があ\"; if( adP<0.05 ) keko=\"\"\n");
		rcmArray2.push("       dt= subset(sAB, A==sjn & (B==x | B==y) )\n");
		rcmArray2.push("       kx= t.test(data~B, dt, pair=1 )\n");
		rcmArray2.push("       fuki= paste(\" t(\",kx$para,\")=\",abs(round(kx$stat,3)),\", adjusted p=\",PV(adP),\")\", sep=\"\" )\n");
		rcmArray2.push("       sumi= sumi+1\n");
		rcmArray2.push("       hk1=HKx(sjn,x); hk2=HKx(sjn,y)\n");
		rcmArray2.push("       if( hk1>hk2 ) tmp=\"大き\" else tmp=\"小さ\"\n");
		rcmArray2.push("       if( sumi<yuis ){ gok1=\"り\"; gok2=\"，\" } else { gok1=\"った\"; gok2=\"。\" }\n");
		rcmArray2.push("if( adP<0.05 ) if( sumi<yuis ) gok1=\"く\" else gok1=\"かった\"\n");
		rcmArray2.push("       txt= paste(txt, \"B\",x,\"の平均\",hk1,\"がB\",y,\"の平均\",hk2,\"よりも有意に\",tmp,keko,gok1,fuki,gok2, sep=\"\" )\n");
		rcmArray2.push("      }\n");
		rcmArray2.push("      }  } # for(x)(y)\n");
		rcmArray2.push("      } # if(minP)\n");
		rcmArray2.push("   } # for(j)\n");
		rcmArray2.push("} # if(levA)\n");
		rcmArray2.push("} # if(kazB)\n");
		rcmArray2.push("if( Tari>0 ) txt=paste(txt, \"\n　以上のp値の調整には\",TAJ,\"の方法を用いた。\n\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("} # if(Pch)\n");
		rcmArray2.push("if( Tari>0 & taju==\"BH\" ) txt= paste(txt, \"\n\n［引用文献］\n\",\n");
		rcmArray2.push("\"Benjamini, Y., & Hochberg (1995). Controlling the false discovery rate: A practical and powerful approach to multiple testing. Journal of the Royal Statistical Society Series B, 58, 289-300.\n\", sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("################################\n");
		rcmArray2.push("#   分散分析 ｓＡＢ-design\n");
		rcmArray2.push("#   ２要因  参加者内計画\n");
		rcmArray2.push("#\n");
		rcmArray2.push("#    交互作用Ａ×Ｂの分析\n");
		rcmArray2.push("H###############################\n");
		rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray2.push("# 歪度,尖度,SEなどは『オプション』参照\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx1 # 分散分析ｓＡＢ\n");
		rcmArray2.push("    # 効果量ηp2 は偏イータ２乗\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx2 # 効果量ｆと検出力(1-β)\n");
		rcmArray2.push("# 検出力0：水準間相関=0 (正負混在の場合)\n");
		rcmArray2.push("# 検出力r：水準間相関=r (標本値から算出)\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx9 # 球面性検定（df=1は不要）と自由度調整係数ε\n");
		rcmArray2.push("crP # 球面性検定が有意のときの修正ｐ値\n");
		rcmArray2.push("    # ■参加者数Ｎ≦10ならH-F_ｐ参照可\n");
		rcmArray2.push("\n");
		rcmArray2.push("hkA;mcA # 主効果Ａの平均と多重比較の調整後ｐ値\n");
		rcmArray2.push("\n");
		rcmArray2.push("hkB;mcB # 主効果Ｂの平均と多重比較の調整後ｐ値\n");
		rcmArray2.push("\n");
		rcmArray2.push("###### ここから一次の交互作用の分析 ######\n");
		rcmArray2.push("\n");
		rcmArray2.push("tkAB # ＡxＢの単純主効果検定（α=0.15推奨）\n");
		rcmArray2.push("\n");
		rcmArray2.push("AatB # A at_B の多重比較の調整後ｐ値\n");
		rcmArray2.push("\n");
		rcmArray2.push("BatA # B at_A の多重比較の調整後ｐ値\n");
		rcmArray2.push("\n");
		rcmArray2.push("cat(txt) # 結果の書き方\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		if (navigator.platform.indexOf("Win") != -1) {
			rcmArray2.push("windows();boxplot(data~A*B,sAB) # 箱ひげ図\n");
		}
		if (navigator.platform.indexOf("Mac") != -1) {
			rcmArray2.push("quartz();boxplot(data~A*B,sAB) # 箱ひげ図\n");
		}
		rcmArray2.push("# txD  # Median,歪度,尖度,SEなど\n");
		rcmArray2.push("# TstT(A水準=1, A相手=2, atB=1 ) # A at_B のｔ検定\n");
		rcmArray2.push("# TstT(B水準=1, B相手=2, atA=1 ) # B at_A のｔ検定\n");
		rcmArray2.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/\n");
		rcmArray2.push("\n");

		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;

	}());	//Ｒプログラムここまで

	(function () {
		chartClear();

		var i, j;
		var g;

		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var graphType = document.getElementById("graphSelect").value;
		var legendName = document.getElementById("legendSelect").value;

		var data;
		var datasetKey = [];
		if (legendName === 'A') {
			data = new Array(LA);
			for (i = 0; i < LA; i++) {
				data[i] = new Array(LB);
			}
			for (i = 0; i < LA; i++) {
				for (j = 0; j < LB; j++) {
					data[i][j] = Math.round(M[i][j] * 10) / 10;
				}
			}

			for (i = 0; i < LA + 1; i++) {
				datasetKey[i] = [];
			}
		}
		if (legendName === 'B') {
			data = new Array(LB);
			for (j = 0; j < LB; j++) {
				data[j] = new Array(LA);
			}
			for (j = 0; j < LB; j++) {
				for (i = 0; i < LA; i++) {
					data[j][i] = Math.round(M[i][j] * 10) / 10;
				}
			}

			for (j = 0; j < LB + 1; j++) {
				datasetKey[j] = [];
			}
		}

		var max_y = M[0][0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				if (max_y < M[i][j]) max_y = Math.round(M[i][j] * 10) / 10;
				if (min_y > M[i][j]) min_y = Math.round(M[i][j] * 10) / 10;
			}
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];


		// 複合グラフを作成する
		datasetKey[0].label = ''; //ラベルを空白にする

		var start;
		var end;

		// 折れ線グラフ
		if (graphType === 'line') {
			if (legendName === 'A') {
				start = 1;
				end = LA + 1;
			}
			if (legendName === 'B') {
				start = 1;
				end = LB + 1;
			}
			for (g = start; g < end; g++) {
				datasetKey[g].label = legendName + g;
				datasetKey[g].data = data[g - 1];
				datasetKey[g].backgroundColor = chartClrAry[(g - 1) % chartClrAry.length];
				datasetKey[g].borderColor = chartClrAry[(g - 1) % chartClrAry.length];
				datasetKey[g].pointBorderWidth = 3;
				datasetKey[g].borderWidth = 1;
				datasetKey[g].lineTension = 0;
				datasetKey[g].type = graphType; //折れ線グラフを指定				// datasetKey[i].type = 'line'; //折れ線グラフを指定
			}
		}

		// 棒グラフ
		if (graphType === 'bar') {
			if (legendName === 'A') {
				start = 0;
				end = LA;
			}
			if (legendName === 'B') {
				start = 0;
				end = LB;
			}
			for (g = start; g < end; g++) {
				datasetKey[g].label = legendName + (g + 1);
				datasetKey[g].data = data[g];
				datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length];
				datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
				datasetKey[g].pointBorderWidth = 3;
				datasetKey[g].borderWidth = 1;
				datasetKey[g].lineTension = 0;
				datasetKey[g].type = graphType; //折れ線グラフを指定
			}
		}

		var labelData = [];
		if (legendName === 'A') {
			for (j = 0; j < LB; j++) {
				labelData.push('B' + (j + 1));
			}
		}
		if (legendName === 'B') {
			for (i = 0; i < LA; i++) {
				labelData.push('A' + (i + 1));
			}
		}

		var datasetData = [];
		for (g = 0; g < end; g++) {
			datasetData[g] = datasetKey[g];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];
		var arrayCol = [];

		if (legendName === 'A') {
			for (i = 0; i < LA; i++) {
				myData[i] = [];
			}

			for (j = 0; j < LB; j++) {
				for (i = 0; i < LA; i++) {
					arrayCol = [];
					for (k = 0; k < NN; k++) {
						arrayCol.push(xx[i][j][k]);
					}
					myData[i].push(arrayCol);
				}
			}
		}
		if (legendName === 'B') {
			for (j = 0; j < LB; j++) {
				myData[j] = [];
			}

			for (i = 0; i < LA; i++) {
				for (j = 0; j < LB; j++) {
					arrayCol = [];
					for (k = 0; k < NN; k++) {
						arrayCol.push(xx[i][j][k]);
					}
					myData[j].push(arrayCol);
				}
			}
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		if (legendName === 'A') {
			start = 0;
			end = LA;
		} else {
			start = 0;
			end = LB;
		}

		datasetKey = [];
		for (g = 0; g < end; g++) {
			datasetKey[g] = [];
		}

		for (g = 0; g < end; g++) {
			datasetKey[g].label = legendName + (g + 1);
			datasetKey[g].data = myData[g];
			datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length] + '33';
			datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
			datasetKey[g].borderWidth = 1;
			datasetKey[g].outlierRadius = 3;
			datasetKey[g].itemRadius = 3;
			datasetKey[g].outlierColor = '#999999';
		}

		labelData = [];
		if (legendName === 'A') {
			for (j = 0; j < LB; j++) {
				labelData.push('B' + (j + 1));
			}
		}
		if (legendName === 'B') {
			for (i = 0; i < LA; i++) {
				labelData.push('A' + (i + 1));
			}
		}

		datasetData = [];
		for (g = 0; g < end; g++) {
			datasetData[g] = datasetKey[g];
		}

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}

/**
 * [changeSabSetting id="sab_setting"の書き換え]
 *
 * 要因Aの名前 1行テキストボックスのid factorA_name
 * 要因Aの水準数1行テキストボックスのid factorA_number
 * 要因Bの名前 1行テキストボックスのid factorB_name
 * 要因Bの水準数1行テキストボックスのid factorB_number
 *
 */
function changeSabSetting() {
	var h = 3;
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");

	htmArray.push("<table border=\"0\" class=\"codetb4\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSabTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSabTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	htmArray.push("<table border=\"0\" class=\"codetb3\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因A 名＿前：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");

	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因A 水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSabTable();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 水準数');changeSabTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因B 名＿前：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorB_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"B\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn2');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn2');\"><span id=\"cellClrBtn2\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorB_name','cellClrBtn2');\" >×</span></td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");

	htmArray.push("<td class=\"codetbL\">要因B 水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorB_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSabTable();\">");
	} else {
		htmArray.push("<select id=\"factorB_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因B 水準数');changeSabTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	htmArray.push("</div>");

	document.getElementById("sab_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeSabTable();
}
function changeSabTable() {
	var i = 0;
	var j = 0;
	var k = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("factorA_number").value);
	var LB = parseInt(document.getElementById("factorB_number").value);

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * LA * LB;

	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td ROWSPAN=\"2\" class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td COLSPAN=\"" + LB + "\" class=\"hyou_midashi_3d_title2\">");
		htmArray.push("A" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	for (i = 0; i < LA; i++) {
		for (j = 0; j < LB; j++) {
			htmArray.push("<td class=\"hyou_midashi_3d_title2\">");
			htmArray.push("B" + (j + 1));
			htmArray.push("</td>");
		}
	}
	htmArray.push("</tr>");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		if (k === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				htmArray.push("<td class=\"hyou_nyuryoku\">");
				htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
				htmArray.push("</td>");
				cellId++;
			}
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sab_table").innerHTML = htmArray.join("");
	htmArray = null;
}
function saveData_sAB() {
	var i, j, k;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value);
	var BB = document.getElementById("factorB_name").value;
	var LB = parseInt(document.getElementById("factorB_number").value);

	//#0
	strArray.push("sAB" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#3
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#4
	strArray.push("#" + "\n");
	strArray.push(BB + "\n");
	//#5
	strArray.push("#" + "\n");
	strArray.push(LB + "\n");
	//#6
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (k = 0; k < NN; k++) {
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				x = document.getElementById("cell_" + cellId).value;
				if ((j !== LB - 1) || (i !== LA - 1)) {
					strArray.push(x + "\t");
				} else {
					strArray.push(x);
				}
				cellId++;
			}
		}
		strArray.push("\n");
	}

	var Stream = strArray.join("");
	var fineName = "sAB_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sAB() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sAB") {
		var NN = crDel(dd[1]);
		var AA = crDel(dd[2]);
		var LA = crDel(dd[3]);
		var BB = crDel(dd[4]);
		var LB = crDel(dd[5]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		document.getElementById("factorB_name").value = BB;
		document.getElementById("factorB_number").value = parseInt(LB, 10);
		changeSabTable();

		document.getElementById("CandPArea").value = delTopCR(dd[6]);
	}
}
function simulation_sAB(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var nCount = NN;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var LB = parseInt(document.getElementById("factorB_number").value, 10);

	var min, max;
	if ((LA === 2) && (LB === 2) && (NN === 2)) {
		min = 5;
		max = 30;
		var rndN = 2;
		rndN = Math.floor(Math.random() * (max - min + 1) + min);
		document.getElementById("subjNum").value = rndN;
		nCount = rndN;

		min = 2;
		max = 5;
		LA = Math.floor(Math.random() * (max - min + 1) + min);
		LB = Math.floor(Math.random() * (max - min + 1) + min);

		document.getElementById("factorA_number").value = LA;
		document.getElementById("factorB_number").value = LB;

		changeSabTable();
	}

	var result = "rnd1:9*" + (LA * LB * nCount);

	document.getElementById("CandPArea").value = random_number_generation(result);

	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);

	mainCalc_sAB();
}