
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 10; //群（点）の数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PN; i++) {
    images[i] = new Image();
    var str = '?var=' + _rnd;
    images[i].src = '../image/point_puma.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

//確率密度
// var probabilityDensity = [
//     0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.01, 0.01, 0.02, 0.04,
//     0.05, 0.08, 0.11, 0.15, 0.19, 0.24, 0.29, 0.33, 0.37, 0.39,
//     0.40, 0.39, 0.37, 0.33, 0.29, 0.24, 0.19, 0.15, 0.11, 0.08,
//     0.05, 0.04, 0.02, 0.01, 0.01, 0.00, 0.00, 0.00, 0.00, 0.00,
//     0.00
// ];

var probabilityDensity = [
    0.000, 0.000, 0.000, 0.000, 0.001, 0.001, 0.001, 0.002, 0.002,
    0.003, 0.004, 0.006, 0.008, 0.010, 0.014, 0.018, 0.022, 0.028,
    0.035, 0.044, 0.054, 0.066, 0.079, 0.094, 0.111, 0.130, 0.150,
    0.171, 0.194, 0.218, 0.242, 0.266, 0.290, 0.312, 0.333, 0.352,
    0.368, 0.381, 0.391, 0.397, 0.399, 0.397, 0.391, 0.381, 0.368,
    0.352, 0.333, 0.312, 0.290, 0.266, 0.242, 0.218, 0.194, 0.171,
    0.150, 0.130, 0.111, 0.094, 0.079, 0.066, 0.054, 0.044, 0.035,
    0.028, 0.022, 0.018, 0.014, 0.010, 0.008, 0.006, 0.004, 0.003,
    0.002, 0.002, 0.001, 0.001, 0.001, 0.000, 0.000, 0.000, 0.000
];
//分散分析のための設定
var AA = 'A';
var LA = 3;

var NN = new Array(LA);
var NA = new Array(LA);

var M = new Array(LA);

var SD = new Array(LA);

function setData() {
    for (var i = 0; i < PN; i++) {
        // x[i] = ox + a * (i + 1.5);
        // y[i] = oy - a * Math.floor(Math.random() * (9 - 1) + 1);
        // x[i] = ox + a * Math.floor(Math.random() * (9 - 1) + 1);
        x[i] = ox + a * Math.floor(Math.random() * (100 - 0) + 0) / 10;
        y[i] = oy;
    }
}
function DrawAxis() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 2, oy);
    ctx.lineTo(ox + a * 2, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 8, oy);
    ctx.lineTo(ox + a * 8, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    for (i = 1; i < 11; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * i, oy);
        ctx.lineTo(ox + a * i, oy - a * 10);
        ctx.stroke();
    }

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    ctx.fillText(0, ox + a * 0 + 10 - 8, oy + 20);

    for (j = 1; j < 11; j++) {
        ctx.fillText(j / 10, ox - 5, oy - a * j + 10);
    }

    for (i = 1; i < 11; i++) {
        ctx.fillText(i, ox + a * i + 10 - 5, oy + 20);
    }
}
function DrawLine() {
    var i;
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    var S = 0;
    // var tY = 0;
    // for (i = 0; i < PN; i++) {
    //     tY = 10 - Math.floor(y[i] / a);
    //     S = S + tY;
    // }
    var tX = 0;
    for (i = 0; i < PN; i++) {
        tX = (x[i] - ox) / a;
        S = S + tX;
    }
    var MM = S / PN;

    var SS = 0;
    tX = 0;
    for (i = 0; i < PN; i++) {
        tX = (x[i] - ox) / a;
        SS = SS + Math.pow(MM - tX, 2);
    }
    var SSD = Math.sqrt(SS / PN);

    var gx = [];
    var gy = [];
    var scale = Math.abs(MM - (MM - SSD)) / 20;
    var StartPoint = MM - scale * 40;
    var mmPoint = 0;
    var cutPoint1 = 0;
    var cutPoint2 = 0;
    for (i = 0; i < 81; i++) {
        gx[i] = StartPoint + i * scale;
        gy[i] = probabilityDensity[i] * 10;
        if (gx[i] < MM) mmPoint = i + 1;
        if (gx[i] < MM - SSD) cutPoint1 = i;
        if (gx[i] < MM + SSD) cutPoint2 = i;
    }

    //正規分布を描画
    ctx.lineWidth = 3;
    ctx.strokeStyle = 'rgb(255,165,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox + a * gx[0], oy - a * gy[0]);
    for (i = 1; i < 81; i++) {
        ctx.lineTo(ox + a * gx[i], oy - a * gy[i]);
    }
    ctx.stroke();

    ctx.lineWidth = 2;
    ctx.strokeStyle = 'rgb(255,165,0)';
    ctx.setLineDash([6, 2]);
    ctx.beginPath();
    ctx.moveTo(ox + a * gx[mmPoint], oy);
    ctx.lineTo(ox + a * gx[mmPoint], oy - a * gy[mmPoint]);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * gx[cutPoint1], oy);
    ctx.lineTo(ox + a * gx[cutPoint1], oy - a * gy[cutPoint1]);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * gx[cutPoint2], oy);
    ctx.lineTo(ox + a * gx[cutPoint2], oy - a * gy[cutPoint2]);
    ctx.stroke();
}
function DrawPoint() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
    }
}
// function printData() {
//     var tY = [];
//     for (i = 0; i < PN; i++) {
//         tY[i] = 10 - Math.floor(y[i] / a);
//     }

//     var S = 0;
//     for (i = 0; i < PN; i++) {
//         S = S + tY[i];
//     }
//     var MM = S / PN;

//     var name = ["A", "B", "C", "D", "E", "F", "G", "H"];
//     for (i = 0; i < PN; i++) {
//         document.getElementById(name[i] + '_x').innerHTML = tY[i];
//         document.getElementById(name[i] + '_S').innerHTML = (tY[i] - MM).toFixed(1);
//         document.getElementById(name[i] + '_SS').innerHTML = Math.pow(tY[i] - MM, 2).toFixed(1);
//     }
// }
function printData() {
    var tX = [];
    for (i = 0; i < PN; i++) {
        // tX[i] = 10 - Math.floor(x[i] / a);
        //tX[i] = Math.floor(x[i] / a) - 4;
        // tX[i] = x[i] / a - 5;
        // tX[i] = x[i] / a - 4.8;
        tX[i] = (x[i] - ox) / a;
        // tX[i] = (x[i] - 3 * a / 4) / a - 4;
    }

    var S = 0;
    for (i = 0; i < PN; i++) {
        S = S + tX[i];
    }
    var MM = S / PN;

    var name = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J"];
    for (i = 0; i < PN; i++) {
        document.getElementById(name[i] + '_x').innerHTML = tX[i].toFixed(1);
        document.getElementById(name[i] + '_S').innerHTML = (tX[i] - MM).toFixed(1);
        document.getElementById(name[i] + '_SS').innerHTML = Math.pow(tX[i] - MM, 2).toFixed(1);
    }
}
function mainMean() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    printData();
    s_calc_mean();

    // ドラッグ開始
    var mouseDown = function (e) {
        // ドラッグ開始位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;

        // for (var i = images.length - 1; i >= 0; i--) {
        //     // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
        //     if (posX >= images[i].drawOffsetX &&
        //         posX <= (images[i].drawOffsetX + images[i].drawWidth) &&
        //         posY >= images[i].drawOffsetY &&
        //         posY <= (images[i].drawOffsetY + images[i].drawHeight)
        //     ) {
        //         dragTarget = i;
        //         isDragging = true;
        //         break;
        //     }
        // }

        for (var i = images.length - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX - 5 &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth + 5) &&
                posY >= images[i].drawOffsetY - 5 &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight + 5)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に，ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        // ドラッグ終了位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;


        // if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10 + h / 2) || (posY > oy + h / 2)) {
        //     isDragging = false;
        // }

        if ((posX < ox + a / 4) || (posX > ox + a * 10 + a / 4)) {
            isDragging = false;
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (var i in images) {
                if (i == dragTarget) {
                    // mx = images[i].drawOffsetX;
                    mx = posX - images[i].drawWidth / 2;
                    // mx = Math.floor((mx - 20) / 28) * 28 + 20;
                    // my = posY - images[i].drawHeight / 2;
                    my = images[i].drawOffsetY;
                    // my = Math.floor((my - 20) / 28) * 28 + 20;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            DrawAxis();
            DrawLine();
            DrawPoint();
            printData();

            s_calc_mean();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

}
function s_calc_mean() {
    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var S = 0;
    // var tY = [];
    // for (i = 0; i < PN; i++) {
    //     tY[i] = 10 - Math.floor(y[i] / a);
    //     S = S + tY[i];
    // }
    var tX = [];
    for (i = 0; i < PN; i++) {
        // tX[i] = Math.floor(y[i] / a) - 4.8;
        tX[i] = (x[i] - ox) / a;
        S = S + tX[i];
    }
    var MM = S / PN;

    var SS = 0;
    for (i = 0; i < PN; i++) {
        SS = SS + Math.pow(MM - tX[i], 2);
    }
    var SSD = Math.sqrt(SS / PN);

    document.getElementById("result").value = "平均=" + MM.toFixed(2) + "  標準偏差=" + SSD.toFixed(2);
    strArray = null;
}