/**
 * ユーティリティ
 * 単独集計
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得

		if (KK == -1) {
			err = true;
			alert("データが行列形式ではありません");
		}
		// if (KK < 2) {
		// 	err = true;
		// 	alert("列数が２未満です");
		// }

		if (err == false) {
			mainCalc_questionnaire();
		}
	}
}
function mainCalc_questionnaire() {
	var i = 0;
	var j = 0;
	var k = 0;
	var h = 0;

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var strArray = [];
	var bar = "------------------------------------------------------\n";

	var ddCount = 0;
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			xx[i][j] = parseFloat(dd[ddCount], 10);
			ddCount++;
		}
	}

	//各項目（列）の度数（0-9,10以上の数,エラーの数の全12種類）
	var counter = new Array(KK);
	for (j = 0; j < KK; j++) {
		counter[j] = new Array(12);
	}
	for (j = 0; j < KK; j++) {
		for (k = 0; k < 12; k++) {
			counter[j][k] = 0;
		}
	}

	var N = []; //各項目の回答数
	var M = []; //平均
	var V = []; //分散
	var SD = []; //標準偏差

	var MAX = []; //最大値
	var MIN = []; //最小値
	var MEDIAN = []; //メディアン
	var MEDIAN_str = []; //メディアン
	var RangeMax70 = []; //70%レンジ
	var RangeMin70 = []; //
	var percent70 = [];
	var RangeMax50 = []; //50%レンジ
	var RangeMin50 = []; //
	var percent50 = [];
	var skewness = []; //歪度
	var kurtosis = []; //尖度

	for (j = 0; j < KK; j++) {
		N[j] = 0;
	}

	//数字のみカウント
	for (j = 0; j < KK; j++) {
		for (i = 0; i < NN; i++) {
			if (!isNaN(xx[i][j])) {
				N[j]++;
			}
		}
	}

	//度数集計
	if (document.getElementById("frequencySubtotal").checked) {
		var intCount = 0;
		for (j = 0; j < KK; j++) {
			intCount = 0;
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) { //数字
					if (xx[i][j] >= 0 && xx[i][j] <= 10) { //0以上10以下
						for (h = 0; h < 11; h++) {
							if (xx[i][j] === h) {
								counter[j][h]++;
								intCount++;
							}
						}
					}
				}
			}
			counter[j][11] = NN - intCount;
		}

		strArray.push("[度数集計]\n");
		strArray.push(bar);
		strArray.push("回答：\t");
		for (h = 0; h < 11; h++) {
			strArray.push(h + "\t");
		}
		strArray.push("Err\tN\n");
		strArray.push(bar);

		for (j = 0; j < KK; j++) {
			strArray.push("項目" + (j + 1) + "：\t");
			for (h = 0; h < 12; h++) {
				strArray.push(counter[j][h] + "\t");
			}
			strArray.push(NN + "\n");
		}
		strArray.push(bar);
		strArray.push("\n");
	}


	//数字のみ基本統計量を計算
	if (document.getElementById("basicStatistics").checked) {
		var S = 0;
		var SS = 0;
		var SSS = 0;
		var SSSS = 0;
		for (j = 0; j < KK; j++) {
			//平均
			S = 0;
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) {
					S = S + xx[i][j];
				}
			}
			M[j] = S / N[j];

			//分散
			//標準偏差
			SS = 0;
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) {
					SS = SS + Math.pow(M[j] - xx[i][j], 2);
				}
			}
			V[j] = SS / (N[j] - 1);
			SD[j] = Math.sqrt(V[j]);

			//歪度
			SSS = 0;
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) {
					SSS = SSS + Math.pow((xx[i][j] - M[j]) / SD[j], 3);
				}
			}
			skewness[j] = N[j] / (N[j] - 1) / (N[j] - 2) * SSS;

			//尖度
			SSSS = 0;
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) {
					SSSS = SSSS + Math.pow((xx[i][j] - M[j]), 4) / Math.pow(SD[j], 4);
				}
			}
			kurtosis[j] = N[j] * (N[j] + 1) / ((N[j] - 1) * (N[j] - 2) * (N[j] - 3)) * SSSS - 3 * Math.pow(N[j] - 1, 2) / ((N[j] - 2) * (N[j] - 3));
		}

		//最大値,最小値
		for (j = 0; j < KK; j++) {
			MIN[j] = xx[0][j];
			MAX[j] = xx[0][j];
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) {
					if (xx[i][j] < MIN[j]) MIN[j] = xx[i][j];
					if (xx[i][j] > MAX[j]) MAX[j] = xx[i][j];
				}
			}
		}

		var xxx = new Array(KK);
		for (j = 0; j < KK; j++) {
			xxx[j] = new Array(NN);
		}

		for (j = 0; j < KK; j++) {
			xxx[j].splice(0);
			for (i = 0; i < NN; i++) {
				if (!isNaN(xx[i][j])) {
					xxx[j].push(xx[i][j]);
				}
			}
		}
		for (j = 0; j < KK; j++) {
			xxx[j].sort(function (a, b) { return a - b; });
		}

		//レンジ
		for (j = 0; j < KK; j++) {
			percent70[j] = 100;
			jj = 0;
			while (percent70[j] >= 70) {
				percent70[j] = (xxx[j].length - jj * 2) / xxx[j].length * 100;
				jj = jj + 1;
			}
			jj = jj - 2;
			percent70[j] = (xxx[j].length - jj * 2) / xxx[j].length * 100;
			RangeMin70[j] = xxx[j][jj];
			RangeMax70[j] = xxx[j][xxx[j].length - 1 - jj];

			// str += 'レンジ(' + using(percent70[j], 3, 1) + '%)：' + RangeMin70[j] + '-' + RangeMax70[j] + '\n';
			percent50[j] = 100;
			jj = 0;
			while (percent50[j] >= 50) {
				percent50[j] = (xxx[j].length - jj * 2) / xxx[j].length * 100;
				jj = jj + 1;
			}
			jj = jj - 2;
			percent50[j] = (xxx[j].length - jj * 2) / xxx[j].length * 100;
			RangeMin50[j] = xxx[j][jj];
			RangeMax50[j] = xxx[j][xxx[j].length - 1 - jj];
			// str += 'レンジ(' + using(percent50[j], 3, 1) + '%)：' + RangeMin50[j] + '-' + RangeMax50[j] + '\n';
		}

		//メジアン
		var Me1 = 0;
		var Me2 = 0;
		for (j = 0; j < KK; j++) {
			if (xxx[j].length % 2 == 1) {
				MEDIAN[j] = xxx[j][Math.ceil(xxx[j].length / 2 - 1)];
				MEDIAN_str[j] = MEDIAN[j];
			} else {
				Me1 = xxx[j][xxx[j].length / 2 - 1];
				Me2 = xxx[j][xxx[j].length / 2];
				MEDIAN[j] = (Me1 + Me2) / 2;
				MEDIAN_str[j] = MEDIAN[j] + "(" + Me1 + "," + Me2 + ")";
				// str += 'メジアン：' + Me + '(' + Me1 + ',' + Me2 + ')' + '\n';
			}
		}

		strArray.push("[基本統計量]\n");
		strArray.push(bar);
		strArray.push("\t");
		strArray.push("N\t平均\t分散\tSD\t最大値\t最小値\t中央値\t尖度\t歪度\n");
		strArray.push(bar);
		for (j = 0; j < KK; j++) {
			strArray.push("項目" + (j + 1) + "：\t");
			strArray.push(N[j] + "\t" + M[j].toFixed(2) + "\t" + V[j].toFixed(2) + "\t" + SD[j].toFixed(2) + "\t" + MAX[j] + "\t" + MIN[j] + "\t");
			strArray.push(MEDIAN_str[j] + "\t" + skewness[j].toFixed(2) + "\t" + kurtosis[j].toFixed(2));
			strArray.push("\n");
		}
	}
	strArray.push(bar);
	strArray.push("※分散は不偏分散。SDは不偏分散の平方根。\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");
	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;
}
